************************************************************************
*
*     counterterms for H->WW->4f
*
************************************************************************
      subroutine HWW4f_count_bos(F,pw12,pw34)
      implicit none
      complex*16 F(13,-1:1,-1:1),pw12,pw34
      complex*16 pre,ct,ct12,ct34,ca2,ca3,cz2(-1:1),cz3(-1:1)
      include 'COMMON/model.inc'
      include 'COMMON/xparam.inc'
c bosonic renormalization constants
      complex*16 dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,dZh
      complex*16 dZeer,dZeel,dZnnl,dZffr(4),dZffl(4)
      complex*16 ct_aww,ct_zww,ct_wen,ct_wf1f2,ct_wf3f4
      complex*16 ct_annl,ct_aeer,ct_aeel,ct_affr(4),ct_affl(4)
      complex*16 ct_znnl,ct_zeer,ct_zeel,ct_zffr(4),ct_zffl(4)
      complex*16 ct_hww,ct_hzz,ct_hza
      common/xrenc/dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,dZh,
     &                  dZeer,dZeel,dZnnl,dZffr,dZffl,
     &                  ct_aww,ct_zww,ct_wen,ct_wf1f2,ct_wf3f4,
     &                  ct_annl,ct_aeer,ct_aeel,ct_affr,ct_affl,
     &                  ct_znnl,ct_zeer,ct_zeel,ct_zffr,ct_zffl,
     &                  ct_hww,ct_hzz,ct_hza
c mandelstam variables
      real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14

	if (model.eq.1) then
	  if (hboson.eq.1) then
	    call  h0toWW4f_count_bos_sesm(F,pw12,pw34)
	  elseif (hboson.eq.2) then
	    call  HHtoWW4f_count_bos_sesm(F,pw12,pw34)
	  endif
	  return
	elseif (model.eq.2) then
	  if (hboson.eq.1) then
	    call  h0toWW4f_count_bos_thdm(F,pw12,pw34)
	  elseif (hboson.eq.2) then
	    call  HHtoWW4f_count_bos_thdm(F,pw12,pw34)
	  endif
	  return
	endif

c counterterms for self energies
      ct =  dmw2/(s12-xmw2) - dZw
     &     +dmw2/(s34-xmw2) - dZw

      PRE = (PW12*PW34*XMW)/(2D0*XSW*XSW2) *ct

      F(1,-1,-1) = F(1,-1,-1)+PRE

c counterterms for vertex diagrams
      ct = ct_hww + ct_wf1f2 + ct_wf3f4

      PRE = (PW12*PW34*XMW)/(2D0*XSW*XSW2) *ct

      F(1,-1,-1) = F(1,-1,-1)+PRE

      end

************************************************************************
*
*     counterterms for H->WW->4f
*
************************************************************************
      subroutine HWW4f_count_ferm(F,pw12,pw34)
      implicit none
      complex*16 F(13,-1:1,-1:1),pw12,pw34
      complex*16 pre,ct,ct12,ct34,ca2,ca3,cz2(-1:1),cz3(-1:1)
      include 'COMMON/model.inc'
      include 'COMMON/xparam.inc'
c fermionic renormalization constants
      complex*16 dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,dZh
      complex*16 dZeer,dZeel,dZnnl,dZffr(4),dZffl(4)
      complex*16 ct_aww,ct_zww,ct_wen,ct_wf1f2,ct_wf3f4
      complex*16 ct_annl,ct_aeer,ct_aeel,ct_affr(4),ct_affl(4)
      complex*16 ct_znnl,ct_zeer,ct_zeel,ct_zffr(4),ct_zffl(4)
      complex*16 ct_hww,ct_hzz,ct_hza
      common/xrenc_ferm/dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,dZh,
     &                  dZeer,dZeel,dZnnl,dZffr,dZffl,
     &                  ct_aww,ct_zww,ct_wen,ct_wf1f2,ct_wf3f4,
     &                  ct_annl,ct_aeer,ct_aeel,ct_affr,ct_affl,
     &                  ct_znnl,ct_zeer,ct_zeel,ct_zffr,ct_zffl,
     &                  ct_hww,ct_hzz,ct_hza
c mandelstam variables
      real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14

	if (model.eq.1) then
	  if (hboson.eq.1) then
	    call  h0toWW4f_count_ferm_sesm(F,pw12,pw34)
	  elseif (hboson.eq.2) then
	    call  HHtoWW4f_count_ferm_sesm(F,pw12,pw34)
	  endif
	  return
	elseif (model.eq.2) then
	  if (hboson.eq.1) then
	    call  h0toWW4f_count_ferm_thdm(F,pw12,pw34)
	  elseif (hboson.eq.2) then
	    call  HHtoWW4f_count_ferm_thdm(F,pw12,pw34)
	  endif
	  return
	endif

c counterterms for self energies
      ct =  dmw2/(s12-xmw2) - dZw
     &     +dmw2/(s34-xmw2) - dZw

      PRE = (PW12*PW34*XMW)/(2D0*XSW*XSW2) *ct

      F(1,-1,-1) = F(1,-1,-1)+PRE

c counterterms for vertex diagrams
      ct = ct_hww + ct_wf1f2 + ct_wf3f4

      PRE = (PW12*PW34*XMW)/(2D0*XSW*XSW2) *ct

      F(1,-1,-1) = F(1,-1,-1)+PRE

      end

************************************************************************
*
*     bosonic self energies for H->WW->4f
*
************************************************************************
      subroutine HWW4f_self_bos(F,pw12,pw34)
      implicit none
      complex*16 F(13,-1:1,-1:1),pw12,pw34
      complex*16 A0,xA0_,B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
      complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
      complex*16 pre
      include 'COMMON/model.inc'
      include 'COMMON/param.inc'
      include 'COMMON/xparam.inc'
c mandelstam variables
      real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion masses as flag (i*1d-20)
      complex*16 cme2,cmf2(5)
      real*8 me2,rme2,mf2(5),rmf2(5)
      common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2

	if (model.eq.1) then
	  if (hboson.eq.1) then
	    call  h0toWW4f_self_bos_sesm(F,pw12,pw34)
	  elseif (hboson.eq.2) then
	    call  HHtoWW4f_self_bos_sesm(F,pw12,pw34)
	  endif
	  return
	elseif (model.eq.2) then
	  if (hboson.eq.1) then
	    call  h0toWW4f_self_bos_thdm(F,pw12,pw34)
	  elseif (hboson.eq.2) then
	    call  HHtoWW4f_self_bos_thdm(F,pw12,pw34)
	  endif
	  return
	endif

C       Process: S1F21aF22F23aF24,   Model: SM4f

C       G(T1,N5,FULL)+G(T2,N11,FULL)

C       G(T1,N2,FULL)+G(T2,N8,FULL)
        A0 = xA0_(XMH2)

        PRE = -((A0*ALPHA*PW12*PW34*(PW12+PW34)*XMW*XSW2**(-2))/
     &  (32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T1,N1,FULL)+G(T1,N4,FULL)+G(T2,N10,FULL)+G(T2,N7,FULL)
        A0 = xA0_(XMW2)

        PRE = -((ALPHA*PW12*PW34*(PW12+PW34)*XMW*(7D0*A0-4D0*XMW2)*
     &  XSW2**(-2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T1,N3,FULL)+G(T1,N6,FULL)+G(T2,N12,FULL)+G(T2,N9,FULL)
        A0 = xA0_(XMZ2)

        PRE = -((ALPHA*PW12*PW34*(PW12+PW34)*XMW*(A0*(1D0+12D0*
     &  XCW2)-8D0*XCW2*XMZ2)*XSW2**(-2))/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T3,N14,FULL)+G(T3,N18,FULL)+G(T3,N20,FULL)+G(T3,N28,FULL)+
C       G(T3,N32,FULL)+G(T3,N34,FULL)+G(T3,N35,FULL)
        CALL xB012345_(S12,NULL,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*PW12**2*PW34*XMW*(16D0*B2(0,0)+S12+2D0*B1(1)*
     &  S12+2D0*B2(1,1)*S12-3D0*XMW2+B0*(5D0*S12-XMW2)))/(8D0*PI*
     &  XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T3,N13,FULL)+G(T3,N16,FULL)+G(T3,N26,FULL)+G(T3,N30,FULL)
        CALL xB012345_(S12,XMW2,XMH2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = -((ALPHA*PW12**2*PW34*XMW*(-(B2(0,0))+B0*XMW2)*XSW2**
     &  (-2))/(8D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T3,N15,FULL)+G(T3,N17,FULL)+G(T3,N21,FULL)+G(T3,N27,FULL)+
C       G(T3,N29,FULL)+G(T3,N31,FULL)+G(T3,N33,FULL)+G(T3,N36,FULL)
        CALL xB012345_(S12,XMW2,XMZ2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*PW12**2*PW34*XMW*XSW2**(-2)*(2D0*B1(1)*S12*
     &  XCW2+2D0*B2(1,1)*S12*XCW2+B2(0,0)*(1D0+16D0*XCW2)+XCW2*(S12-
     &  3D0*XMW2-3D0*XMZ2)+(B0*(5D0*S12*XCW2**2-XMW2*XSW2**2))/
     &  XCW2))/(8D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T3,N19,FULL)

C       G(T4,N38,FULL)+G(T4,N43,FULL)+G(T4,N44,FULL)+G(T4,N52,FULL)+
C       G(T4,N56,FULL)+G(T4,N58,FULL)+G(T4,N59,FULL)
        CALL xB012345_(S34,NULL,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*PW12*PW34**2*XMW*(16D0*B2(0,0)+S34+2D0*B1(1)*
     &  S34+2D0*B2(1,1)*S34-3D0*XMW2+B0*(5D0*S34-XMW2)))/(8D0*PI*
     &  XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T4,N37,FULL)+G(T4,N40,FULL)+G(T4,N50,FULL)+G(T4,N54,FULL)
        CALL xB012345_(S34,XMW2,XMH2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = -((ALPHA*PW12*PW34**2*XMW*(-(B2(0,0))+B0*XMW2)*XSW2**
     &  (-2))/(8D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T4,N39,FULL)+G(T4,N42,FULL)+G(T4,N45,FULL)+G(T4,N51,FULL)+
C       G(T4,N53,FULL)+G(T4,N55,FULL)+G(T4,N57,FULL)+G(T4,N60,FULL)
        CALL xB012345_(S34,XMW2,XMZ2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*PW12*PW34**2*XMW*XSW2**(-2)*(2D0*B1(1)*S34*
     &  XCW2+2D0*B2(1,1)*S34*XCW2+B2(0,0)*(1D0+16D0*XCW2)+XCW2*(S34-
     &  3D0*XMW2-3D0*XMZ2)+(B0*(5D0*S34*XCW2**2-XMW2*XSW2**2))/
     &  XCW2))/(8D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T4,N41,FULL)

      end

************************************************************************
*
*     test routine
*       bosonic self energies
*
************************************************************************
      subroutine HWW4f_self_bos2(F,pw12,pw34)
      implicit none
      complex*16 F(13,-1:1,-1:1),pw12,pw34
      complex*16 pre,ct,ct12,ct34,ca2,ca3,cz2(-1:1),cz3(-1:1)
      complex*16 fact,xseww
      include 'COMMON/model.inc'
      include 'COMMON/xparam.inc'
c mandelstam variables
      real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14

	if (model.eq.1) then
	  if (hboson.eq.1) then
	    call  h0toWW4f_self_bos2_sesm(F,pw12,pw34)
	  elseif (hboson.eq.2) then
	    call  HHtoWW4f_self_bos2_sesm(F,pw12,pw34)
	  endif
	  return
	elseif (model.eq.2) then
	  if (hboson.eq.1) then
	    call  h0toWW4f_self_bos2_thdm(F,pw12,pw34)
	  elseif (hboson.eq.2) then
	    call  HHtoWW4f_self_bos2_thdm(F,pw12,pw34)
	  endif
	  return
	endif

      fact = - xseww(s12)*pw12 - xseww(s34)*pw34

      PRE = (PW12*PW34*XMW)/(2D0*XSW*XSW2) *fact

      F(1,-1,-1) = F(1,-1,-1)+PRE

      end

************************************************************************
*
*     fermionic self energies for H->WW->4f
*
************************************************************************
      subroutine HWW4f_self_ferm(F,pw12,pw34)
      implicit none
      integer i,ngen
      complex*16 F(13,-1:1,-1:1),pw12,pw34
      complex*16 B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
      complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
      complex*16 pre
      complex*16 ymn2(4),yml2(4),ymqm2(4),ymqp2(4)
      include 'COMMON/model.inc'
      include 'COMMON/param.inc'
      include 'COMMON/xparam.inc'
c mandelstam variables
      real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion masses as flag (i*1d-20)
      complex*16 cme2,cmf2(5)
      real*8 me2,rme2,mf2(5),rmf2(5)
      common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2

	if (model.eq.1) then
	  if (hboson.eq.1) then
	    call  h0toWW4f_self_ferm_sesm(F,pw12,pw34)
	  elseif (hboson.eq.2) then
	    call  HHtoWW4f_self_ferm_sesm(F,pw12,pw34)
	  endif
	  return
	elseif (model.eq.2) then
	  if (hboson.eq.1) then
	    call  h0toWW4f_self_ferm_thdm(F,pw12,pw34)
	  elseif (hboson.eq.2) then
	    call  HHtoWW4f_self_ferm_thdm(F,pw12,pw34)
	  endif
	  return
	endif

        if ((qsm4.eq.1).or.(qsm4.eq.2)) then
          ngen = 4
        else
          ngen = 3
        endif

      do i = 1,ngen

        if (i.le.3) then
          ymn2(i)  = null
          yml2(i)  = xml2(i)
          ymqm2(i) = xmqm2(i)
          ymqp2(i) = xmqp2(i)
        else
          ymn2(4)  = mn4**2
          yml2(4)  = ml4**2
          ymqm2(4) = md4**2
          ymqp2(4) = mu4**2
        endif

C       Process: S1F21aF22F23aF24,   Model: SM4f

C       G(T3,N25,FULL)
        CALL xB012345_(S12,yMN2(I),yML2(I),B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*PW12**2*PW34*XMW*XSW2**(-2)*(12D0*B2(0,0)+S12+
     &  6D0*B1(1)*S12+6D0*B2(1,1)*S12-3D0*yML2(I)-3D0*yMN2(I)
     &	))/(48D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T3,N24,FULL)
        CALL xB012345_(S12,yMQP2(I),yMQM2(I),B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*PW12**2*PW34*XMW*XSW2**(-2)*(12D0*B2(0,0)+S12+
     &  6D0*B1(1)*S12+6D0*B2(1,1)*S12-3D0*yMQM2(I)-3D0*yMQP2(I)))/
     &  (16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T4,N49,FULL)
        CALL xB012345_(S34,yMN2(I),yML2(I),B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*PW12*PW34**2*XMW*XSW2**(-2)*(12D0*B2(0,0)+S34+
     &  6D0*B1(1)*S34+6D0*B2(1,1)*S34-3D0*yML2(I)-3D0*yMN2(I)
     &	))/(48D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T4,N48,FULL)
        CALL xB012345_(S34,yMQM2(I),yMQP2(I),B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*PW12*PW34**2*XMW*XSW2**(-2)*(12D0*B2(0,0)+S34+
     &  6D0*B1(1)*S34+6D0*B2(1,1)*S34-3D0*yMQM2(I)-3D0*yMQP2(I)))/
     &  (16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

      enddo

      end

************************************************************************
*
*     test routine
*       fermionic self energies
*
************************************************************************
      subroutine HWW4f_self_ferm2(F,pw12,pw34)
      implicit none
      complex*16 F(13,-1:1,-1:1),pw12,pw34
      complex*16 pre,ct,ct12,ct34,ca2,ca3,cz2(-1:1),cz3(-1:1)
      complex*16 fact,xseww_ferm
      include 'COMMON/model.inc'
      include 'COMMON/xparam.inc'
c mandelstam variables
      real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14

	if (model.eq.1) then
	  if (hboson.eq.1) then
	    call  h0toWW4f_self_ferm2_sesm(F,pw12,pw34)
	  elseif (hboson.eq.2) then
	    call  HHtoWW4f_self_ferm2_sesm(F,pw12,pw34)
	  endif
	  return
	elseif (model.eq.2) then
	  if (hboson.eq.1) then
	    call  h0toWW4f_self_ferm2_thdm(F,pw12,pw34)
	  elseif (hboson.eq.2) then
	    call  HHtoWW4f_self_ferm2_thdm(F,pw12,pw34)
	  endif
	  return
	endif

      fact = - xseww_ferm(s12)*pw12 - xseww_ferm(s34)*pw34

      PRE = (PW12*PW34*XMW)/(2D0*XSW*XSW2) *fact

      F(1,-1,-1) = F(1,-1,-1)+PRE

      end

************************************************************************
*
*     vertex diagrams (bosonic) for H->WW->4f
*
************************************************************************
      subroutine HWW4f_vert_bos(F,pw12,pw34)
      implicit none
      complex*16 B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
      complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
      complex*16   C0,  C1(2),  C2(0:2,0:2),  C3(0:2,0:2,2)
      complex*16   C4(0:2,0:2,0:2,0:2)
      complex*16 F(13,-1:1,-1:1),pw12,pw34
      complex*16 pre,K(3)
      include 'COMMON/model.inc'
      include 'COMMON/param.inc'
      include 'COMMON/xparam.inc'
c fermion charges of isospin duplets
      real*8 qf(4)
      common/fcharge/qf
c mandelstam variables
      real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion masses as flag (i*1d-20)
      complex*16 cme2,cmf2(5)
      real*8 me2,rme2,mf2(5),rmf2(5)
      common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2

	if (model.eq.1) then
	  if (hboson.eq.1) then
	    call  h0toWW4f_vert_bos_sesm(F,pw12,pw34)
	  elseif (hboson.eq.2) then
	    call  HHtoWW4f_vert_bos_sesm(F,pw12,pw34)
	  endif
	  return
	elseif (model.eq.2) then
	  if (hboson.eq.1) then
	    call  h0toWW4f_vert_bos_thdm(F,pw12,pw34)
	  elseif (hboson.eq.2) then
	    call  HHtoWW4f_vert_bos_thdm(F,pw12,pw34)
	  endif
	  return
	endif

C       Process: S1F21aF22F23aF24,   Model: SM4f

C       G(T8,N56,FULL)
        CALL xB012345_(MH2,XMH2,XMH2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((3D0*ALPHA*B0*PW12*PW34*XMH2*XSW2**(-2))/(64D0*PI*
     &  XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T8,N55,FULL)+G(T8,N58,FULL)
        CALL xB012345_(MH2,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*PW12*PW34*(-(8D0*XMW)+(B0*(XMH2+12D0*XMW2))/
     &  XMW)*XSW2**(-2))/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T8,N57,FULL)+G(T8,N59,FULL)
        CALL xB012345_(MH2,XMZ2,XMZ2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*PW12*PW34*(-(16D0*XMW)+(B0*(XMH2+24D0*XMW2))/
     &  XMW)*XSW2**(-2))/(64D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T10,N63,FULL)
        CALL xB012345_(S12,NULL,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12*PW34*XMW)/(16D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T10,N65,FULL)
        CALL xB012345_(S12,XMW2,XMH2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12*PW34*XMW*XSW2**(-2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T10,N64,FULL)
        CALL xB012345_(S12,XMW2,XMZ2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12*PW34*XMW)/(16D0*PI*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T9,N60,FULL)
        CALL xB012345_(S34,NULL,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12*PW34*XMW)/(16D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T9,N62,FULL)
        CALL xB012345_(S34,XMW2,XMH2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12*PW34*XMW*XSW2**(-2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T9,N61,FULL)
        CALL xB012345_(S34,XMW2,XMZ2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12*PW34*XMW)/(16D0*PI*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T3,N14,FULL)
      CALL xC01234_(RMF2(1),MH2,T11,CMF2(1),XMZ2,XMZ2,C0,C1,C2,C3,C4,B0,
     &  B1,B2,B3,1,1)

        PRE = (C1(2)*ALPHA*PW34*XCW2**(-2)*XMW*XSW2**(-2)*(1D0-2D0*
     &  QF(1)*XSW2)**2)/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T3,N13,FULL)
      CALL xC01234_(RMF2(1),MH2,T11,CMF2(2),XMW2,XMW2,C0,C1,C2,C3,C4,B0,
     &  B1,B2,B3,1,1)

        PRE = (C1(2)*ALPHA*PW34*XMW*XSW2**(-2))/(8D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

      if (qf(1).ne.0d0) then
C       G(T1,N3,FULL)+G(T1,N7,FULL)
        CALL xC01234_(RMF2(1),S12,RMF2(2),CMF2(1),NULL,XMW2,C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,1)

        PRE = -((QF(1)*ALPHA*PW12*PW34*(1D0-6D0*C2(0,0)+C1(1)*S12+
     &  C1(2)*S12+C2(1,2)*S12)*XMW)/(4D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE
      endif

C       G(T1,N4,FULL)+G(T1,N8,FULL)
        CALL xC01234_(RMF2(1),S12,RMF2(2),CMF2(1),XMZ2,XMW2,C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,1)

        PRE = -((ALPHA*PW12*PW34*(1D0-6D0*C2(0,0)+C1(1)*S12+C1(2)*
     &  S12+C2(1,2)*S12)*XMW*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2))/(8D0*
     &  PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T1,N2,FULL)+G(T1,N6,FULL)
        CALL xC01234_(RMF2(1),S12,RMF2(2),CMF2(2),XMW2,XMZ2,C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,1)

        PRE = -((ALPHA*PW12*PW34*(1D0-6D0*C2(0,0)+C1(1)*S12+C1(2)*
     &  S12+C2(1,2)*S12)*XMW*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2))/(8D0*
     &  PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

      if (qf(2).ne.0d0) then
C       G(T1,N1,FULL)+G(T1,N5,FULL)
        CALL xC01234_(RMF2(2),RMF2(1),S12,NULL,CMF2(2),XMW2,C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,1)

        PRE = (QF(2)*ALPHA*PW12*PW34*(1D0-6D0*C2(0,0)-C1(1)*S12-
     &  C1(2)*S12-C2(1,2)*S12-C2(2,2)*S12-C0*S12)*XMW)/(4D0*PI*XSW*
     &  XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE
      endif

C       G(T2,N12,FULL)
      CALL xC01234_(RMF2(2),MH2,T12,CMF2(1),XMW2,XMW2,C0,C1,C2,C3,C4,B0,
     &  B1,B2,B3,1,1)

        PRE = (C1(2)*ALPHA*PW34*XMW*XSW2**(-2))/(8D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

      if (qf(1).ne.0d0.and.qf(2).ne.0d0) then
C       G(T1,N9,FULL)
        CALL xC01234_(RMF2(2),S12,RMF2(1),NULL,CMF2(2),CMF2(1),C0,C1,C2,
     &  C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((QF(1)*QF(2)*ALPHA*PW12*PW34*(1D0-2D0*C2(0,0)+C1(1)*
     &  S12+C1(2)*S12+C2(1,2)*S12+C0*S12)*XMW)/(4D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE
      endif

C       G(T4,N15,FULL)
      CALL xC01234_(RMF2(3),MH2,T13,CMF2(4),XMW2,XMW2,C0,C1,C2,C3,C4,B0,
     &  B1,B2,B3,1,1)

        PRE = (C1(2)*ALPHA*PW12*XMW*XSW2**(-2))/(8D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

      if (qf(3).ne.0d0.and.qf(4).ne.0d0) then
C       G(T7,N53,FULL)
        CALL xC01234_(RMF2(3),S34,RMF2(4),NULL,CMF2(3),CMF2(4),C0,C1,C2,
     &  C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((QF(3)*QF(4)*ALPHA*PW12*PW34*(1D0-2D0*C2(0,0)+C1(1)*
     &  S34+C1(2)*S34+C2(1,2)*S34+C0*S34)*XMW)/(4D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE
      endif

      if (qf(3).ne.0d0) then
C       G(T7,N45,FULL)+G(T7,N49,FULL)
        CALL xC01234_(RMF2(3),S34,RMF2(4),CMF2(3),NULL,XMW2,C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,1)

        PRE = (QF(3)*ALPHA*PW12*PW34*(1D0-6D0*C2(0,0)+C1(1)*S34+
     &  C1(2)*S34+C2(1,2)*S34)*XMW)/(4D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE
      endif

C       G(T7,N46,FULL)+G(T7,N50,FULL)
        CALL xC01234_(RMF2(3),S34,RMF2(4),CMF2(3),XMZ2,XMW2,C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,1)

        PRE = -((ALPHA*PW12*PW34*(1D0-6D0*C2(0,0)+C1(1)*S34+C1(2)*
     &  S34+C2(1,2)*S34)*XMW*XSW2**(-2)*(1D0+2D0*QF(3)*XSW2))/(8D0*
     &  PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T7,N48,FULL)+G(T7,N52,FULL)
        CALL xC01234_(RMF2(3),S34,RMF2(4),CMF2(4),XMW2,XMZ2,C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,1)

        PRE = -((ALPHA*PW12*PW34*(1D0-6D0*C2(0,0)+C1(1)*S34+C1(2)*
     &  S34+C2(1,2)*S34)*XMW*XSW2**(-2)*(1D0-2D0*QF(4)*XSW2))/(8D0*
     &  PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

      if (qf(4).ne.0d0) then
C       G(T7,N47,FULL)+G(T7,N51,FULL)
        CALL xC01234_(RMF2(4),RMF2(3),S34,NULL,CMF2(4),XMW2,C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,1)

        PRE = -((QF(4)*ALPHA*PW12*PW34*(1D0-6D0*C2(0,0)-C1(1)*S34-
     &  C1(2)*S34-C2(1,2)*S34-C2(2,2)*S34-C0*S34)*XMW)/(4D0*PI*XSW*
     &  XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE
      endif

C       G(T1,N10,FULL)
        CALL xC01234_(S12,RMF2(1),RMF2(2),CMF2(2),CMF2(1),XMZ2,C0,C1,C2,
     &  C3,C4,B0,B1,B2,B3,2,1)

        PRE = (ALPHA*PW12*PW34*(1D0-2D0*C2(0,0)-C1(1)*S12-C1(2)*S12-
     &  C2(1,1)*S12-C2(1,2)*S12)*XMW*XSW2**(-2)*(1D0-2D0*QF(1)*
     &  XSW2)*(1D0+2D0*QF(2)*XSW2))/(16D0*PI*XCW2*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T5,N25,FULL)+G(T5,N26,FULL)+G(T5,N31,FULL)+G(T5,N34,FULL)+
C       G(T5,N37,FULL)+G(T5,N41,FULL)
       CALL xC01234_(S12,MH2,S34,NULL,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = C1(1)+C1(2)+2D0*C2(1,2)

        PRE = -((ALPHA*PW12*PW34*XMW)/(16D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(7D0-40D0*C2(0,0)-6D0*C2(1,1)*
     &  S12+6D0*C2(1,2)*(S13+S14+S23+S24)-C1(1)*(2D0*S12-S13-S14-
     &  S23-S24)-6D0*C2(2,2)*S34+C1(2)*(S13+S14+S23+S24-2D0*S34)+C0*
     &  (5D0*S13+4D0*S14+4D0*S23+3D0*S24-T12-T14+XMH2))
        F(5,-1,-1) = F(5,-1,-1)+8D0*K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)+8D0*K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+8D0*K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+8D0*K(1)*PRE

C       G(T5,N30,FULL)+G(T5,N33,FULL)+G(T5,N36,FULL)+G(T5,N39,FULL)
       CALL xC01234_(S12,MH2,S34,XMH2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 2D0*C1(1)*XMW+2D0*C1(2)*XMW+(C2(1,2)*(XMH2+2D0*
     &  XMW2))/XMW

        PRE = -((ALPHA*PW12*PW34*XSW2**(-2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(2D0*C0*XMW*XMW2-(C2(0,0)*(XMH2+
     &  2D0*XMW2))/XMW)
        F(5,-1,-1) = F(5,-1,-1)+K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)+K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+K(1)*PRE

C       G(T5,N22,FULL)+G(T5,N23,FULL)
       CALL xC01234_(S12,MH2,S34,XMW2,XMH2,XMH2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)

        PRE = -((3D0*ALPHA*PW12*PW34*XMH2*XSW2**(-2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(C0*XMW-(C2(0,0))/XMW)
        F(5,-1,-1) = F(5,-1,-1)+(C2(1,2)*PRE)/XMW
        F(6,-1,-1) = F(6,-1,-1)+(C2(1,2)*PRE)/XMW
        F(7,-1,-1) = F(7,-1,-1)+(C2(1,2)*PRE)/XMW
        F(8,-1,-1) = F(8,-1,-1)+(C2(1,2)*PRE)/XMW

C       G(T5,N17,FULL)+G(T5,N18,FULL)+G(T5,N19,FULL)+G(T5,N20,FULL)+
C       G(T5,N21,FULL)+G(T5,N28,FULL)+G(T5,N29,FULL)
       CALL xC01234_(S12,MH2,S34,XMW2,XMZ2,XMZ2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = XCW2+XSW2
        K(2) = XCW2*XMH2+18D0*XCW2*XMW2+2D0*XMW2*XSW2
        K(3) = 8D0*C0*XMW-(2D0*C1(1)*XMW*(XCW2+XSW2))/XCW2-(2D0*
     &  C1(2)*XMW*(XCW2+XSW2))/XCW2-(C2(1,2)*(XCW2*XMH2+18D0*XCW2*
     &  XMW2+2D0*XMW2*XSW2))/(XCW2*XMW)

        PRE = -((ALPHA*PW12*PW34*XSW2**(-2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(6D0*XMW-4D0*C2(1,1)*S12*XMW+
     &  4D0*C2(1,2)*(S13+S14+S23+S24)*XMW-C1(1)*(2D0*S12-S13-S14-
     &  S23-S24)*XMW-4D0*C2(2,2)*S34*XMW+C1(2)*(S13+S14+S23+S24-2D0*
     &  S34)*XMW-(C2(0,0)*(XCW2*XMH2+34D0*XCW2*XMW2+2D0*XMW2*XSW2))/
     &  (XCW2*XMW)+C0*XCW2**(-2)*XMW*(5D0*S13*XCW2**2+5D0*S14*XCW2**
     &  2+5D0*S23*XCW2**2+5D0*S24*XCW2**2+2D0*XMW2*XSW2**2))
        F(5,-1,-1) = F(5,-1,-1)-K(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)-K(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)-K(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)-K(3)*PRE

C       G(T5,N24,FULL)+G(T5,N27,FULL)+G(T5,N32,FULL)+G(T5,N35,FULL)+
C       G(T5,N38,FULL)+G(T5,N40,FULL)+G(T5,N42,FULL)
       CALL xC01234_(S12,MH2,S34,XMZ2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = XCW2-3D0*XSW2
        K(2) = XMH2+18D0*XCW2*XMW2+2D0*XMW2*XSW2
        K(3) = 8D0*C0*XMW*(XCW2+XSW2)-2D0*C1(1)*XMW*(XCW2-3D0*XSW2)-
     &  2D0*C1(2)*XMW*(XCW2-3D0*XSW2)-(C2(1,2)*(XMH2+18D0*XCW2*XMW2+
     &  2D0*XMW2*XSW2))/XMW

        PRE = -((ALPHA*PW12*PW34*XSW2**(-2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(C1(1)*(2D0*S12-S13-S14-S23-
     &  S24)*XCW2*XMW)+C1(2)*(S13+S14+S23+S24-2D0*S34)*XCW2*XMW-2D0*
     &  C2(1,1)*S12*XMW*(2D0*XCW2-XSW2)+2D0*C2(1,2)*(S13+S14+S23+
     &  S24)*XMW*(2D0*XCW2-XSW2)-2D0*C2(2,2)*S34*XMW*(2D0*XCW2-
     &  XSW2)+XMW*(6D0*XCW2-XSW2)-(C2(0,0)*(XMH2+34D0*XCW2*XMW2-6D0*
     &  XMW2*XSW2))/XMW+(C0*XMW*(5D0*S13*XCW2**2+5D0*S14*XCW2**2+
     &  5D0*S23*XCW2**2+5D0*S24*XCW2**2+S14*XCW2*XSW2+S23*XCW2*XSW2+
     &  2D0*S24*XCW2*XSW2+T12*XCW2*XSW2+T14*XCW2*XSW2+XMH2*XSW2**
     &  2))/XCW2)
        F(5,-1,-1) = F(5,-1,-1)-K(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)-K(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)-K(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)-K(3)*PRE

C       G(T7,N54,FULL)
        CALL xC01234_(S34,RMF2(4),RMF2(3),CMF2(3),CMF2(4),XMZ2,C0,C1,C2,
     &  C3,C4,B0,B1,B2,B3,2,1)

        PRE = (ALPHA*PW12*PW34*(1D0-2D0*C2(0,0)-C1(1)*S34-C1(2)*S34-
     &  C2(1,1)*S34-C2(1,2)*S34)*XMW*XSW2**(-2)*(1D0+2D0*QF(3)*
     &  XSW2)*(1D0-2D0*QF(4)*XSW2))/(16D0*PI*XCW2*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T2,N11,FULL)
      CALL xC01234_(T12,MH2,RMF2(2),CMF2(2),XMZ2,XMZ2,C0,C1,C2,C3,C4,B0,
     &  B1,B2,B3,1,1)

        PRE = (C1(1)*ALPHA*PW34*XCW2**(-2)*XMW*XSW2**(-2)*(1D0+2D0*
     &  QF(2)*XSW2)**2)/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T4,N16,FULL)
      CALL xC01234_(T13,MH2,RMF2(3),CMF2(3),XMZ2,XMZ2,C0,C1,C2,C3,C4,B0,
     &  B1,B2,B3,1,1)

        PRE = (C1(1)*ALPHA*PW12*XCW2**(-2)*XMW*XSW2**(-2)*(1D0+2D0*
     &  QF(3)*XSW2)**2)/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T6,N43,FULL)
      CALL xC01234_(T14,MH2,RMF2(4),CMF2(3),XMW2,XMW2,C0,C1,C2,C3,C4,B0,
     &  B1,B2,B3,1,1)

        PRE = (C1(1)*ALPHA*PW12*XMW*XSW2**(-2))/(8D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T6,N44,FULL)
      CALL xC01234_(T14,MH2,RMF2(4),CMF2(4),XMZ2,XMZ2,C0,C1,C2,C3,C4,B0,
     &  B1,B2,B3,1,1)

        PRE = (C1(1)*ALPHA*PW12*XCW2**(-2)*XMW*XSW2**(-2)*(1D0-2D0*
     &  QF(4)*XSW2)**2)/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

      end

************************************************************************
*
*     vertex diagrams (fermionic) for H->WW->4f
*
************************************************************************
      subroutine HWW4f_vert_ferm(F,pw12,pw34)
      implicit none
      integer i,ngen
      real*8 qeps
      complex*16 B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
      complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
      complex*16   C0,  C1(2),  C2(0:2,0:2),  C3(0:2,0:2,2)
      complex*16   C4(0:2,0:2,0:2,0:2)
      complex*16 F(13,-1:1,-1:1),pw12,pw34
      complex*16 pre
      complex*16 ymn2(4),yml2(4),ymqm2(4),ymqp2(4)
      include 'COMMON/model.inc'
      include 'COMMON/param.inc'
      include 'COMMON/xparam.inc'
c mandelstam variables
      real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion masses as flag (i*1d-20)
      complex*16 cme2,cmf2(5)
      real*8 me2,rme2,mf2(5),rmf2(5)
      common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2

	if (model.eq.1) then
	  if (hboson.eq.1) then
	    call  h0toWW4f_vert_ferm_sesm(F,pw12,pw34)
	  elseif (hboson.eq.2) then
	    call  HHtoWW4f_vert_ferm_sesm(F,pw12,pw34)
	  endif
	  return
	elseif (model.eq.2) then
	  if (hboson.eq.1) then
	    call  h0toWW4f_vert_ferm_thdm(F,pw12,pw34)
	  elseif (hboson.eq.2) then
	    call  HHtoWW4f_vert_ferm_thdm(F,pw12,pw34)
	  endif
	  return
	endif

      qeps = 1d0

        if ((qsm4.eq.1).or.(qsm4.eq.2)) then
          ngen = 4
        else
          ngen = 3
        endif

      do i = 1,ngen

        if (i.le.3) then
          ymn2(i)  = null
          yml2(i)  = xml2(i)
          ymqm2(i) = xmqm2(i)
          ymqp2(i) = xmqp2(i)
        else
          ymn2(4)  = mn4**2
          yml2(4)  = ml4**2
          ymqm2(4) = md4**2
          ymqp2(4) = mu4**2
        endif

C       Process: S1F21aF22F23aF24,   Model: SM4f

C       graphs with Higgs couplings to neutrinos added by hand
       CALL xC01234_(S12,MH2,S34,yML2(I),yMN2(I),yMN2(I),C0,C1,C2,C3,C4,B0,
     &  B1,B2,B3,2,0)

        PRE = -((ALPHA*PW12*PW34*XSW2**(-2)*yMN2(I))/(32D0*PI*XMW*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(2D0-8D0*C2(0,0)-4D0*C2(1,1)*
     &  S12+4D0*C2(1,2)*(S13+S14+S23+S24)-C1(1)*(2D0*S12-S13-QEPS*
     &  S13-S14-QEPS*S14-S23+QEPS*S23-S24+QEPS*S24)-4D0*C2(2,2)*S34+
     &  C1(2)*(S13-QEPS*S13+S14-QEPS*S14+S23+QEPS*S23+S24+QEPS*S24-
     &  2D0*S34))
        F(5,-1,-1) = F(5,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(1)*(1D0+
     &  QEPS)+C1(2)*(1D0-QEPS))
        F(6,-1,-1) = F(6,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(2)*(1D0+
     &  QEPS)+C1(1)*(1D0-QEPS))
        F(7,-1,-1) = F(7,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(1)*(1D0+
     &  QEPS)+C1(2)*(1D0-QEPS))
        F(8,-1,-1) = F(8,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(2)*(1D0+
     &  QEPS)+C1(1)*(1D0-QEPS))

C       G(T9,N310,FULL)+G(T9,N324,FULL)+G(T9,N336,FULL)+G(T9,N348,
C       FULL)
       CALL xC01234_(S12,MH2,S34,yMN2(I),yML2(I),yML2(I),C0,C1,C2,C3,C4,B0,
     &  B1,B2,B3,2,0)

        PRE = -((ALPHA*PW12*PW34*XSW2**(-2)*yML2(I))/(32D0*PI*XMW*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(2D0-8D0*C2(0,0)-4D0*C2(1,1)*
     &  S12+4D0*C2(1,2)*(S13+S14+S23+S24)-C1(1)*(2D0*S12-S13-QEPS*
     &  S13-S14-QEPS*S14-S23+QEPS*S23-S24+QEPS*S24)-4D0*C2(2,2)*S34+
     &  C1(2)*(S13-QEPS*S13+S14-QEPS*S14+S23+QEPS*S23+S24+QEPS*S24-
     &  2D0*S34))
        F(5,-1,-1) = F(5,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(1)*(1D0+
     &  QEPS)+C1(2)*(1D0-QEPS))
        F(6,-1,-1) = F(6,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(2)*(1D0+
     &  QEPS)+C1(1)*(1D0-QEPS))
        F(7,-1,-1) = F(7,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(1)*(1D0+
     &  QEPS)+C1(2)*(1D0-QEPS))
        F(8,-1,-1) = F(8,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(2)*(1D0+
     &  QEPS)+C1(1)*(1D0-QEPS))

C       G(T9,N311,FULL)+G(T9,N325,FULL)+G(T9,N337,FULL)+G(T9,N349,
C       FULL)
       CALL xC01234_(S12,MH2,S34,yMQM2(I),yMQP2(I),yMQP2(I),C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,0)

        PRE = -((3D0*ALPHA*PW12*PW34*XSW2**(-2)*yMQP2(I))/(32D0*PI*
     &  XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(2D0-8D0*C2(0,0)-4D0*C2(1,1)*
     &  S12+4D0*C2(1,2)*(S13+S14+S23+S24)-C1(1)*(2D0*S12-S13+QEPS*
     &  S13-S14+QEPS*S14-S23-QEPS*S23-S24-QEPS*S24)-4D0*C2(2,2)*S34+
     &  C1(2)*(S13+QEPS*S13+S14+QEPS*S14+S23-QEPS*S23+S24-QEPS*S24-
     &  2D0*S34))
        F(5,-1,-1) = F(5,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(2)*(1D0+
     &  QEPS)+C1(1)*(1D0-QEPS))
        F(6,-1,-1) = F(6,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(1)*(1D0+
     &  QEPS)+C1(2)*(1D0-QEPS))
        F(7,-1,-1) = F(7,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(2)*(1D0+
     &  QEPS)+C1(1)*(1D0-QEPS))
        F(8,-1,-1) = F(8,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(1)*(1D0+
     &  QEPS)+C1(2)*(1D0-QEPS))

C       G(T9,N309,FULL)+G(T9,N323,FULL)+G(T9,N335,FULL)+G(T9,N347,
C       FULL)
       CALL xC01234_(S12,MH2,S34,yMQP2(I),yMQM2(I),yMQM2(I),C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,0)

        PRE = -((3D0*ALPHA*PW12*PW34*XSW2**(-2)*yMQM2(I))/(32D0*PI*
     &  XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(2D0-8D0*C2(0,0)-4D0*C2(1,1)*
     &  S12+4D0*C2(1,2)*(S13+S14+S23+S24)-C1(1)*(2D0*S12-S13-QEPS*
     &  S13-S14-QEPS*S14-S23+QEPS*S23-S24+QEPS*S24)-4D0*C2(2,2)*S34+
     &  C1(2)*(S13-QEPS*S13+S14-QEPS*S14+S23+QEPS*S23+S24+QEPS*S24-
     &  2D0*S34))
        F(5,-1,-1) = F(5,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(1)*(1D0+
     &  QEPS)+C1(2)*(1D0-QEPS))
        F(6,-1,-1) = F(6,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(2)*(1D0+
     &  QEPS)+C1(1)*(1D0-QEPS))
        F(7,-1,-1) = F(7,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(1)*(1D0+
     &  QEPS)+C1(2)*(1D0-QEPS))
        F(8,-1,-1) = F(8,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(2)*(1D0+
     &  QEPS)+C1(1)*(1D0-QEPS))

      enddo

      end

************************************************************************
*
*     boxes for H->WW->4f
*
************************************************************************
      subroutine HWW4f_box(F,pw12,pw34)
      implicit none
      complex*16 F(13,-1:1,-1:1),pw12,pw34
      complex*16   C0,  C1(2),  C2(0:2,0:2),  C3(0:2,0:2,2)
      complex*16   C4(0:2,0:2,0:2,0:2)
      complex*16 D0,D1(3),D2(0:3,0:3),D3(0:3,0:3,3)
      complex*16 D4(0:3,0:3,0:3,0:3),D5(0:3,0:3,0:3,0:3,3)
      complex*16 pre,K(1)
      include 'COMMON/model.inc'
      include 'COMMON/param.inc'
      include 'COMMON/xparam.inc'
c fermion charges of isospin duplets
      real*8 qf(4)
      common/fcharge/qf
c mandelstam variables
      real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion masses as flag (i*1d-20)
      complex*16 cme2,cmf2(5)
      real*8 me2,rme2,mf2(5),rmf2(5)
      common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2

	if (model.eq.1) then
	  if (hboson.eq.1) then
	    call  h0toWW4f_box_sesm(F,pw12,pw34)
	  elseif (hboson.eq.2) then
	    call  HHtoWW4f_box_sesm(F,pw12,pw34)
	  endif
	  return
	elseif (model.eq.2) then
	  if (hboson.eq.1) then
	    call  h0toWW4f_box_thdm(F,pw12,pw34)
	  elseif (hboson.eq.2) then
	    call  HHtoWW4f_box_thdm(F,pw12,pw34)
	  endif
	  return
	endif

C       Process: S1F21aF22F23aF24,   Model: SM4f

      if (qf(1).ne.0d0) then
C       G(T1,N2,FULL)+G(T1,N4,FULL)
        CALL xD012345_(RMF2(1),RMF2(2),MH2,S34,T12,S12,NULL,CMF2(1),
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((QF(1)*ALPHA*PW34*XMW)/(16D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(28D0*D2(0,0))-5D0*D2(1,2)*
     &  S12-5D0*D2(2,2)*S12+4D0*D1(1)*(S13+S14)+5D0*D2(1,3)*(S13+
     &  S14)+4D0*D0*(S13+S14)+5D0*D2(2,3)*(S13+S14+S23+S24)-5D0*
     &  D2(3,3)*S34+D1(3)*(S13+S14-4D0*S34)-D1(2)*(2D0*MH2-S12-4D0*
     &  S13-4D0*S14-2D0*S23-2D0*S24-2D0*T12))
        F(5,-1,-1) = F(5,-1,-1)+8D0*(D1(3)+D2(1,3)+D2(2,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)+8D0*(D1(2)+D2(2,3))*PRE
        F(7,-1,-1) = F(7,-1,-1)+8D0*(D1(3)+D2(1,3)+D2(2,3))*PRE
        F(8,-1,-1) = F(8,-1,-1)+8D0*(D1(2)+D2(2,3))*PRE
      endif

C       G(T6,N14,FULL)
        CALL xD012345_(RMF2(1),MH2,S34,RMF2(2),S12,T11,CMF2(1),XMZ2,
     &  XMZ2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((ALPHA*PW34*XMW*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2))/
     &  (16D0*PI*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(12D0*D2(0,0))+2D0*D2(1,3)*
     &  S12+D1(1)*(S12-S13-S14)-2D0*D1(3)*(S23+S24)-2D0*D2(2,3)*
     &  (S23+S24)-D1(2)*(3D0*S23+3D0*S24+S34)-2D0*D2(2,2)*T11+2D0*
     &  D2(1,2)*(MH2-T11))
        F(5,-1,-1) = F(5,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)+2D0*(D1(3)-2D0*D2(2,2)-2D0*D2(2,3))*
     &  PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE
        F(8,-1,-1) = F(8,-1,-1)+2D0*(D1(3)-2D0*D2(2,2)-2D0*D2(2,3))*
     &  PRE

C       G(T6,N16,FULL)+G(T6,N18,FULL)
        CALL xD012345_(RMF2(1),MH2,S34,RMF2(2),S12,T11,CMF2(2),XMW2,
     &  XMW2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = (ALPHA*PW34*XMW*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2))/
     &  (32D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE*(4D0*D1(3)*(S23+S24)+(D2(1,3)*
     &  S12*(-(2D0*XCW)+XSW)*(2D0*XCW+XSW))/XCW2-(D2(2,3)*(S23+S24)*
     &  (-(2D0*XCW)+XSW)*(2D0*XCW+XSW))/XCW2-(D2(2,2)*T11*(-(2D0*
     &  XCW)+XSW)*(2D0*XCW+XSW))/XCW2+(D2(1,2)*(MH2-T11)*(-(2D0*
     &  XCW)+XSW)*(2D0*XCW+XSW))/XCW2-(4D0*D2(0,0)*(-(6D0*XCW2)+
     &  XSW2))/XCW2-(2D0*D1(1)*(S12*XCW2-S13*XCW2-S14*XCW2-MH2*XSW2+
     &  T11*XSW2))/XCW2+(2D0*D1(2)*(3D0*S23*XCW2+3D0*S24*XCW2+S34*
     &  XCW2-T11*XSW2))/XCW2)
        F(5,-1,-1) = F(5,-1,-1)-8D0*(D1(1)+D2(1,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)-4D0*PRE*(-(2D0*D2(2,2))-2D0*D2(2,3)+
     &  (D1(3)*(XCW2+XSW2))/XCW2)
        F(7,-1,-1) = F(7,-1,-1)-8D0*(D1(1)+D2(1,2))*PRE
        F(8,-1,-1) = F(8,-1,-1)-4D0*PRE*(-(2D0*D2(2,2))-2D0*D2(2,3)+
     &  (D1(3)*(XCW2+XSW2))/XCW2)

      if (qf(2).ne.0d0) then
C       G(T6,N15,FULL)+G(T6,N17,FULL)
        CALL xD012345_(RMF2(2),RMF2(1),MH2,S34,T11,S12,NULL,CMF2(2),
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = (QF(2)*ALPHA*PW34*XMW)/(16D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(28D0*D2(0,0))-5D0*D2(1,2)*
     &  S12-5D0*D2(2,2)*S12+4D0*D1(1)*(S23+S24)+5D0*D2(1,3)*(S23+
     &  S24)+4D0*D0*(S23+S24)+5D0*D2(2,3)*(S13+S14+S23+S24)-5D0*
     &  D2(3,3)*S34+D1(3)*(S23+S24-4D0*S34)-D1(2)*(2D0*MH2-S12-2D0*
     &  S13-2D0*S14-4D0*S23-4D0*S24-2D0*T11))
        F(5,-1,-1) = F(5,-1,-1)+8D0*(D1(2)+D2(2,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)+8D0*(D1(3)+D2(1,3)+D2(2,3))*PRE
        F(7,-1,-1) = F(7,-1,-1)+8D0*(D1(2)+D2(2,3))*PRE
        F(8,-1,-1) = F(8,-1,-1)+8D0*(D1(3)+D2(1,3)+D2(2,3))*PRE
      endif

C       G(T1,N3,FULL)+G(T1,N5,FULL)
        CALL xD012345_(RMF2(2),MH2,S34,RMF2(1),S12,T12,CMF2(1),XMW2,
     &  XMW2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = (ALPHA*PW34*XMW*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2))/
     &  (32D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE*(4D0*D1(3)*(S13+S14)+(D2(1,3)*
     &  S12*(-(2D0*XCW)+XSW)*(2D0*XCW+XSW))/XCW2-(D2(2,3)*(S13+S14)*
     &  (-(2D0*XCW)+XSW)*(2D0*XCW+XSW))/XCW2-(D2(2,2)*T12*(-(2D0*
     &  XCW)+XSW)*(2D0*XCW+XSW))/XCW2+(D2(1,2)*(MH2-T12)*(-(2D0*
     &  XCW)+XSW)*(2D0*XCW+XSW))/XCW2-(4D0*D2(0,0)*(-(6D0*XCW2)+
     &  XSW2))/XCW2-(2D0*D1(1)*(S12*XCW2-S23*XCW2-S24*XCW2-MH2*XSW2+
     &  T12*XSW2))/XCW2+(2D0*D1(2)*(3D0*S13*XCW2+3D0*S14*XCW2+S34*
     &  XCW2-T12*XSW2))/XCW2)
        F(5,-1,-1) = F(5,-1,-1)-4D0*PRE*(-(2D0*D2(2,2))-2D0*D2(2,3)+
     &  (D1(3)*(XCW2+XSW2))/XCW2)
        F(6,-1,-1) = F(6,-1,-1)-8D0*(D1(1)+D2(1,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)-4D0*PRE*(-(2D0*D2(2,2))-2D0*D2(2,3)+
     &  (D1(3)*(XCW2+XSW2))/XCW2)
        F(8,-1,-1) = F(8,-1,-1)-8D0*(D1(1)+D2(1,2))*PRE

C       G(T1,N1,FULL)
        CALL xD012345_(RMF2(2),MH2,S34,RMF2(1),S12,T12,CMF2(2),XMZ2,
     &  XMZ2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((ALPHA*PW34*XMW*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2))/
     &  (16D0*PI*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(12D0*D2(0,0))+2D0*D2(1,3)*
     &  S12-2D0*D1(3)*(S13+S14)-2D0*D2(2,3)*(S13+S14)+D1(1)*(S12-
     &  S23-S24)-D1(2)*(3D0*S13+3D0*S14+S34)-2D0*D2(2,2)*T12+2D0*
     &  D2(1,2)*(MH2-T12))
        F(5,-1,-1) = F(5,-1,-1)+2D0*(D1(3)-2D0*D2(2,2)-2D0*D2(2,3))*
     &  PRE
        F(6,-1,-1) = F(6,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)+2D0*(D1(3)-2D0*D2(2,2)-2D0*D2(2,3))*
     &  PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE

C       G(T7,N23,FULL)
        CALL xD012345_(RMF2(3),MH2,S12,RMF2(4),S34,T13,CMF2(3),XMZ2,
     &  XMZ2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = (ALPHA*PW12*XMW*XSW2**(-2)*(1D0+2D0*QF(3)*XSW2))/
     &  (16D0*PI*XCW2*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE*(12D0*D2(0,0)+2D0*D1(3)*(S14+
     &  S24)+2D0*D2(2,3)*(S14+S24)+D1(2)*(S12+3D0*S14+3D0*S24)-2D0*
     &  D2(1,3)*S34+D1(1)*(S13+S23-S34)+2D0*D2(2,2)*T13-2D0*D2(1,2)*
     &  (MH2-T13))
        F(5,-1,-1) = F(5,-1,-1)-4D0*(D1(1)+D2(1,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)-4D0*(D1(1)+D2(1,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)-2D0*(D1(3)-2D0*D2(2,2)-2D0*D2(2,3))*
     &  PRE
        F(8,-1,-1) = F(8,-1,-1)-2D0*(D1(3)-2D0*D2(2,2)-2D0*D2(2,3))*
     &  PRE

C       G(T7,N20,FULL)+G(T7,N22,FULL)
        CALL xD012345_(RMF2(3),MH2,S12,RMF2(4),S34,T13,CMF2(4),XMW2,
     &  XMW2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = (ALPHA*PW12*XMW*XSW2**(-2)*(1D0-2D0*QF(4)*XSW2))/
     &  (32D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE*(4D0*D1(3)*(S14+S24)-(D2(2,3)*
     &  (S14+S24)*(-(2D0*XCW)+XSW)*(2D0*XCW+XSW))/XCW2+(D2(1,3)*S34*
     &  (-(2D0*XCW)+XSW)*(2D0*XCW+XSW))/XCW2-(D2(2,2)*T13*(-(2D0*
     &  XCW)+XSW)*(2D0*XCW+XSW))/XCW2+(D2(1,2)*(MH2-T13)*(-(2D0*
     &  XCW)+XSW)*(2D0*XCW+XSW))/XCW2-(4D0*D2(0,0)*(-(6D0*XCW2)+
     &  XSW2))/XCW2+(2D0*D1(2)*(S12*XCW2+3D0*S14*XCW2+3D0*S24*XCW2-
     &  T13*XSW2))/XCW2+(2D0*D1(1)*(S13*XCW2+S23*XCW2-S34*XCW2+MH2*
     &  XSW2-T13*XSW2))/XCW2)
        F(5,-1,-1) = F(5,-1,-1)-8D0*(D1(1)+D2(1,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)-8D0*(D1(1)+D2(1,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)-4D0*PRE*(-(2D0*D2(2,2))-2D0*D2(2,3)+
     &  (D1(3)*(XCW2+XSW2))/XCW2)
        F(8,-1,-1) = F(8,-1,-1)-4D0*PRE*(-(2D0*D2(2,2))-2D0*D2(2,3)+
     &  (D1(3)*(XCW2+XSW2))/XCW2)

      if (qf(3).ne.0d0) then
C       G(T9,N27,FULL)+G(T9,N29,FULL)
        CALL xD012345_(RMF2(3),S12,MH2,RMF2(4),S34,T14,CMF2(3),NULL,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = (QF(3)*ALPHA*PW12*XMW)/(16D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(28D0*D2(0,0))-4D0*D1(1)*(S13+
     &  S23)-5D0*D2(1,2)*(S13+S23)+5D0*D2(1,3)*S34-5D0*D2(2,2)*T14-
     &  2D0*D1(2)*(S12+3D0*S13+3D0*S23+T14)+5D0*D2(2,3)*(MH2-T14)+
     &  2D0*D1(3)*(MH2-S14-S24+S34-T14))
        F(5,-1,-1) = F(5,-1,-1)-8D0*(D2(1,2)+D2(2,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)-8D0*(D2(1,2)+D2(2,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)+8D0*(D1(3)+D2(2,3))*PRE
        F(8,-1,-1) = F(8,-1,-1)+8D0*(D1(3)+D2(2,3))*PRE
      endif

C       G(T9,N28,FULL)+G(T9,N30,FULL)
        CALL xD012345_(RMF2(3),S12,MH2,RMF2(4),S34,T14,CMF2(3),XMZ2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = (ALPHA*PW12*XMW*XSW2**(-2)*(1D0+2D0*QF(3)*XSW2))/
     &  (32D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE*(4D0*D1(1)*(S13+S23)-(D2(1,2)*
     &  (S13+S23)*(-(2D0*XCW)+XSW)*(2D0*XCW+XSW))/XCW2+(D2(1,3)*S34*
     &  (-(2D0*XCW)+XSW)*(2D0*XCW+XSW))/XCW2-(D2(2,2)*T14*(-(2D0*
     &  XCW)+XSW)*(2D0*XCW+XSW))/XCW2+(D2(2,3)*(MH2-T14)*(-(2D0*
     &  XCW)+XSW)*(2D0*XCW+XSW))/XCW2-(4D0*D2(0,0)*(-(6D0*XCW2)+
     &  XSW2))/XCW2+(2D0*D1(2)*(S12*XCW2+3D0*S13*XCW2+3D0*S23*XCW2-
     &  T14*XSW2))/XCW2+(2D0*D1(3)*(S14*XCW2+S24*XCW2-S34*XCW2+MH2*
     &  XSW2-T14*XSW2))/XCW2)
        F(5,-1,-1) = F(5,-1,-1)-4D0*PRE*(-(2D0*D2(1,2))-2D0*D2(2,2)+
     &  (D1(1)*(XCW2+XSW2))/XCW2)
        F(6,-1,-1) = F(6,-1,-1)-4D0*PRE*(-(2D0*D2(1,2))-2D0*D2(2,2)+
     &  (D1(1)*(XCW2+XSW2))/XCW2)
        F(7,-1,-1) = F(7,-1,-1)-8D0*(D1(3)+D2(2,3))*PRE
        F(8,-1,-1) = F(8,-1,-1)-8D0*(D1(3)+D2(2,3))*PRE

C       G(T9,N31,FULL)
        CALL xD012345_(RMF2(3),S12,MH2,RMF2(4),S34,T14,CMF2(4),XMW2,
     &  XMZ2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((ALPHA*PW12*XMW*XSW2**(-2)*(1D0-2D0*QF(4)*XSW2))/
     &  (16D0*PI*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(12D0*D2(0,0))-2D0*D1(1)*(S13+
     &  S23)-2D0*D2(1,2)*(S13+S23)-D1(2)*(S12+3D0*S13+3D0*S23)+2D0*
     &  D2(1,3)*S34-D1(3)*(S14+S24-S34)-2D0*D2(2,2)*T14+2D0*D2(2,3)*
     &  (MH2-T14))
        F(5,-1,-1) = F(5,-1,-1)+2D0*(D1(1)-2D0*D2(1,2)-2D0*D2(2,2))*
     &  PRE
        F(6,-1,-1) = F(6,-1,-1)+2D0*(D1(1)-2D0*D2(1,2)-2D0*D2(2,2))*
     &  PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*(D1(3)+D2(2,3))*PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(D1(3)+D2(2,3))*PRE

      if (qf(4).ne.0d0) then
C       G(T7,N19,FULL)+G(T7,N21,FULL)
        CALL xD012345_(RMF2(4),RMF2(3),MH2,S12,T13,S34,NULL,CMF2(4),
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((QF(4)*ALPHA*PW12*XMW)/(16D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(28D0*D2(0,0))-5D0*D2(3,3)*
     &  S12+4D0*D1(1)*(S14+S24)+5D0*D2(1,3)*(S14+S24)+4D0*D0*(S14+
     &  S24)+5D0*D2(2,3)*(S13+S14+S23+S24)-D1(3)*(4D0*S12-S14-S24)-
     &  5D0*D2(1,2)*S34-5D0*D2(2,2)*S34-D1(2)*(2D0*MH2-2D0*S13-4D0*
     &  S14-2D0*S23-4D0*S24-S34-2D0*T13))
        F(5,-1,-1) = F(5,-1,-1)+8D0*(D1(2)+D2(2,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)+8D0*(D1(2)+D2(2,3))*PRE
        F(7,-1,-1) = F(7,-1,-1)+8D0*(D1(3)+D2(1,3)+D2(2,3))*PRE
        F(8,-1,-1) = F(8,-1,-1)+8D0*(D1(3)+D2(1,3)+D2(2,3))*PRE
      endif

C       G(T5,N13,FULL)
        CALL xD012345_(S12,RMF2(3),MH2,RMF2(4),T13,T14,CMF2(4),
     &  CMF2(3),XMZ2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((ALPHA*PW12*XCW2**(-2)*XMW*XSW2**(-2)*(1D0+2D0*
     &  QF(3)*XSW2)*(1D0-2D0*QF(4)*XSW2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(2D0*D2(0,0)+D1(1)*S12+D1(2)*
     &  S12+D2(1,1)*S12+D2(1,2)*(2D0*S12+S13+S23)-D1(3)*(S14+S24)-
     &  D2(1,3)*(S14+S24)+D2(2,2)*T14-D2(2,3)*(MH2-T14))
        F(5,-1,-1) = F(5,-1,-1)-2D0*(D2(1,2)+D2(2,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)-2D0*(D2(1,2)+D2(2,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)+2D0*(D1(3)+D2(1,3)+D2(2,3))*PRE
        F(8,-1,-1) = F(8,-1,-1)+2D0*(D1(3)+D2(1,3)+D2(2,3))*PRE

C       G(T4,N12,FULL)
        CALL xD012345_(S34,RMF2(2),MH2,RMF2(1),T12,T11,CMF2(1),
     &  CMF2(2),XMZ2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((ALPHA*PW34*XCW2**(-2)*XMW*XSW2**(-2)*(1D0-2D0*
     &  QF(1)*XSW2)*(1D0+2D0*QF(2)*XSW2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(2D0*D2(0,0)-D1(3)*(S13+S14)-
     &  D2(1,3)*(S13+S14)+D1(1)*S34+D1(2)*S34+D2(1,1)*S34+D2(1,2)*
     &  (S23+S24+2D0*S34)+D2(2,2)*T11-D2(2,3)*(MH2-T11))
        F(5,-1,-1) = F(5,-1,-1)+2D0*(D1(3)+D2(1,3)+D2(2,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)-2D0*(D2(1,2)+D2(2,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)+2D0*(D1(3)+D2(1,3)+D2(2,3))*PRE
        F(8,-1,-1) = F(8,-1,-1)-2D0*(D2(1,2)+D2(2,2))*PRE

      end

************************************************************************
*
*     pentagons for H->WW->4f
*
************************************************************************
      subroutine HWW4f_pent(F,pw12,pw34)
      implicit none
      complex*16 F(13,-1:1,-1:1),pw12,pw34
      complex*16 D0,D1(3),D2(0:3,0:3),D3(0:3,0:3,3)
      complex*16 E0n,E1n(4),E2n(0:4,0:4),E3n(0:4,0:4,4)
      complex*16 E4n(0:4,0:4,0:4,0:4)
      complex*16 pre,k(1)
      include 'COMMON/model.inc'
      include 'COMMON/param.inc'
      include 'COMMON/xparam.inc'
c fermion charges of isospin duplets
      real*8 qf(4)
      common/fcharge/qf
c mandelstam variables
      real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion masses as flag (i*1d-20)
      complex*16 cme2,cmf2(5)
      real*8 me2,rme2,mf2(5),rmf2(5)
      common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2

	if (model.eq.1) then
	  if (hboson.eq.1) then
	    call  h0toWW4f_pent_sesm(F,pw12,pw34)
	  elseif (hboson.eq.2) then
	    call  HHtoWW4f_pent_sesm(F,pw12,pw34)
	  endif
	  return
	elseif (model.eq.2) then
	  if (hboson.eq.1) then
	    call  h0toWW4f_pent_thdm(F,pw12,pw34)
	  elseif (hboson.eq.2) then
	    call  HHtoWW4f_pent_thdm(F,pw12,pw34)
	  endif
	  return
	endif

C       Process: S1F21aF22F23aF24,   Model: SM4f

      if (qf(1).ne.0d0.and.qf(4).ne.0d0) then
C       G(T3,N9,FULL)
        CALL xE01234_NEW(RMF2(1),RMF2(4),RMF2(3),MH2,RMF2(2),S14,S34,
     &  T13,T12,S12,CMF2(1),NULL,CMF2(4),XMW2,XMW2,E0N,E1N,E2N,E3N,
     &  E4N,D0,D1,D2,D3,2,1)
        K(1) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = -((QF(1)*QF(4)*ALPHA*XMW)/(8D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)-2D0*PRE*(10D0*E2N(0,0)-E1N(4)*S12-
     &  2D0*E2N(1,4)*S12+E1N(1)*S14+2D0*E1N(2)*S14+2D0*E2N(1,2)*S14+
     &  2D0*E2N(1,3)*S14+2D0*E2N(2,2)*S14-2D0*E2N(2,4)*(S12+S24)+
     &  2D0*E2N(3,3)*(S14+S34)+E1N(3)*(2D0*S14+S34)+2D0*E2N(2,3)*
     &  (2D0*S14+S34)-2D0*E2N(3,4)*(MH2-T12))
        F(2,-1,-1) = F(2,-1,-1)-2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(3,-1,-1) = F(3,-1,-1)+2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(5,-1,-1) = F(5,-1,-1)-4D0*(2D0*E1N(3)+3D0*E2N(1,3)+3D0*
     &  E2N(2,3)+3D0*E2N(3,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)+4D0*E2N(3,4)*PRE
        F(7,-1,-1) = F(7,-1,-1)-4D0*K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(E1N(4)+E2N(2,4)+E2N(3,4))*PRE
        F(9,-1,-1) = F(9,-1,-1)+(E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3))*
     &  PRE
        F(10,-1,-1) = F(10,-1,-1)-E2N(3,4)*PRE
        F(11,-1,-1) = F(11,-1,-1)+K(1)*PRE
        F(12,-1,-1) = F(12,-1,-1)+(-(E2N(2,4))-E2N(3,4))*PRE
        F(13,-1,-1) = F(13,-1,-1)+E2N(0,0)*PRE
      endif

C       G(T3,N10,FULL)
        CALL xE01234_NEW(RMF2(1),RMF2(4),RMF2(3),MH2,RMF2(2),S14,S34,
     &  T13,T12,S12,CMF2(1),XMZ2,CMF2(4),XMW2,XMW2,E0N,E1N,E2N,E3N,
     &  E4N,D0,D1,D2,D3,2,1)
        K(1) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = -((ALPHA*XMW*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*(1D0-2D0*
     &  QF(4)*XSW2))/(32D0*PI*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)-2D0*PRE*(10D0*E2N(0,0)-E1N(4)*S12-
     &  2D0*E2N(1,4)*S12+E1N(1)*S14+2D0*E1N(2)*S14+2D0*E2N(1,2)*S14+
     &  2D0*E2N(1,3)*S14+2D0*E2N(2,2)*S14-2D0*E2N(2,4)*(S12+S24)+
     &  2D0*E2N(3,3)*(S14+S34)+E1N(3)*(2D0*S14+S34)+2D0*E2N(2,3)*
     &  (2D0*S14+S34)-2D0*E2N(3,4)*(MH2-T12))
        F(2,-1,-1) = F(2,-1,-1)-2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(3,-1,-1) = F(3,-1,-1)+2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(5,-1,-1) = F(5,-1,-1)-4D0*(2D0*E1N(3)+3D0*E2N(1,3)+3D0*
     &  E2N(2,3)+3D0*E2N(3,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)+4D0*E2N(3,4)*PRE
        F(7,-1,-1) = F(7,-1,-1)-4D0*K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(E1N(4)+E2N(2,4)+E2N(3,4))*PRE
        F(9,-1,-1) = F(9,-1,-1)+(E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3))*
     &  PRE
        F(10,-1,-1) = F(10,-1,-1)-E2N(3,4)*PRE
        F(11,-1,-1) = F(11,-1,-1)+K(1)*PRE
        F(12,-1,-1) = F(12,-1,-1)+(-(E2N(2,4))-E2N(3,4))*PRE
        F(13,-1,-1) = F(13,-1,-1)+E2N(0,0)*PRE

C       G(T3,N11,FULL)
        CALL xE01234_NEW(RMF2(1),RMF2(4),RMF2(3),MH2,RMF2(2),S14,S34,
     &  T13,T12,S12,CMF2(2),XMW2,CMF2(3),XMZ2,XMZ2,E0N,E1N,E2N,E3N,
     &  E4N,D0,D1,D2,D3,2,1)
        K(1) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = -((ALPHA*XCW2**(-2)*XMW*XSW2**(-2)*(1D0+2D0*QF(2)*
     &  XSW2)*(1D0+2D0*QF(3)*XSW2))/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-2D0*PRE*(10D0*E2N(0,0)-E1N(4)*S12-
     &  2D0*E2N(1,4)*S12+E1N(1)*S14+2D0*E1N(2)*S14+2D0*E2N(1,2)*S14+
     &  2D0*E2N(1,3)*S14+2D0*E2N(2,2)*S14-2D0*E2N(2,4)*(S12+S24)+
     &  2D0*E2N(3,3)*(S14+S34)+E1N(3)*(2D0*S14+S34)+2D0*E2N(2,3)*
     &  (2D0*S14+S34)-2D0*E2N(3,4)*(MH2-T12))
        F(2,-1,-1) = F(2,-1,-1)-2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(3,-1,-1) = F(3,-1,-1)+2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(5,-1,-1) = F(5,-1,-1)-4D0*(2D0*E1N(3)+3D0*E2N(1,3)+3D0*
     &  E2N(2,3)+3D0*E2N(3,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)+4D0*E2N(3,4)*PRE
        F(7,-1,-1) = F(7,-1,-1)-4D0*K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(E1N(4)+E2N(2,4)+E2N(3,4))*PRE
        F(9,-1,-1) = F(9,-1,-1)+(E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3))*
     &  PRE
        F(10,-1,-1) = F(10,-1,-1)-E2N(3,4)*PRE
        F(11,-1,-1) = F(11,-1,-1)+K(1)*PRE
        F(12,-1,-1) = F(12,-1,-1)+(-(E2N(2,4))-E2N(3,4))*PRE
        F(13,-1,-1) = F(13,-1,-1)+E2N(0,0)*PRE

C       G(T8,N26,FULL)
        CALL xE01234_NEW(RMF2(2),RMF2(4),RMF2(3),MH2,RMF2(1),S24,S34,
     &  T13,T11,S12,CMF2(1),XMW2,CMF2(3),XMZ2,XMZ2,E0N,E1N,E2N,E3N,
     &  E4N,D0,D1,D2,D3,2,1)

        PRE = -((ALPHA*XCW2**(-2)*XMW*XSW2**(-2)*(1D0-2D0*QF(1)*
     &  XSW2)*(1D0+2D0*QF(3)*XSW2))/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-2D0*PRE*(-(2D0*E2N(3,4)*S13)+E1N(1)*
     &  S24)
        F(2,-1,-1) = F(2,-1,-1)+2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(3,-1,-1) = F(3,-1,-1)-2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(5,-1,-1) = F(5,-1,-1)-8D0*E2N(3,4)*PRE
        F(6,-1,-1) = F(6,-1,-1)+4D0*E1N(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*E1N(4)*PRE
        F(9,-1,-1) = F(9,-1,-1)+E2N(3,4)*PRE
        F(10,-1,-1) = F(10,-1,-1)+(-(E1N(3))-E2N(1,3)-E2N(2,3)-
     &  E2N(3,3))*PRE
        F(11,-1,-1) = F(11,-1,-1)+(E2N(2,4)+E2N(3,4))*PRE
        F(12,-1,-1) = F(12,-1,-1)+(-(E1N(2))-E1N(3)-E2N(1,2)-E2N(1,
     &  3)-E2N(2,2)-2D0*E2N(2,3)-E2N(3,3))*PRE
        F(13,-1,-1) = F(13,-1,-1)-E2N(0,0)*PRE

      if (qf(2).ne.0d0.and.qf(4).ne.0d0) then
C       G(T8,N24,FULL)
        CALL xE01234_NEW(RMF2(2),RMF2(4),RMF2(3),MH2,RMF2(1),S24,S34,
     &  T13,T11,S12,CMF2(2),NULL,CMF2(4),XMW2,XMW2,E0N,E1N,E2N,E3N,
     &  E4N,D0,D1,D2,D3,2,1)

        PRE = (QF(2)*QF(4)*ALPHA*XMW)/(8D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)-2D0*PRE*(-(2D0*E2N(3,4)*S13)+E1N(1)*
     &  S24)
        F(2,-1,-1) = F(2,-1,-1)+2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(3,-1,-1) = F(3,-1,-1)-2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(5,-1,-1) = F(5,-1,-1)-8D0*E2N(3,4)*PRE
        F(6,-1,-1) = F(6,-1,-1)+4D0*E1N(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*E1N(4)*PRE
        F(9,-1,-1) = F(9,-1,-1)+E2N(3,4)*PRE
        F(10,-1,-1) = F(10,-1,-1)+(-(E1N(3))-E2N(1,3)-E2N(2,3)-
     &  E2N(3,3))*PRE
        F(11,-1,-1) = F(11,-1,-1)+(E2N(2,4)+E2N(3,4))*PRE
        F(12,-1,-1) = F(12,-1,-1)+(-(E1N(2))-E1N(3)-E2N(1,2)-E2N(1,
     &  3)-E2N(2,2)-2D0*E2N(2,3)-E2N(3,3))*PRE
        F(13,-1,-1) = F(13,-1,-1)-E2N(0,0)*PRE
      endif

C       G(T8,N25,FULL)
        CALL xE01234_NEW(RMF2(2),RMF2(4),RMF2(3),MH2,RMF2(1),S24,S34,
     &  T13,T11,S12,CMF2(2),XMZ2,CMF2(4),XMW2,XMW2,E0N,E1N,E2N,E3N,
     &  E4N,D0,D1,D2,D3,2,1)

        PRE = -((ALPHA*XMW*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2)*(1D0-2D0*
     &  QF(4)*XSW2))/(32D0*PI*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)-2D0*PRE*(-(2D0*E2N(3,4)*S13)+E1N(1)*
     &  S24)
        F(2,-1,-1) = F(2,-1,-1)+2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(3,-1,-1) = F(3,-1,-1)-2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(5,-1,-1) = F(5,-1,-1)-8D0*E2N(3,4)*PRE
        F(6,-1,-1) = F(6,-1,-1)+4D0*E1N(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*E1N(4)*PRE
        F(9,-1,-1) = F(9,-1,-1)+E2N(3,4)*PRE
        F(10,-1,-1) = F(10,-1,-1)+(-(E1N(3))-E2N(1,3)-E2N(2,3)-
     &  E2N(3,3))*PRE
        F(11,-1,-1) = F(11,-1,-1)+(E2N(2,4)+E2N(3,4))*PRE
        F(12,-1,-1) = F(12,-1,-1)+(-(E1N(2))-E1N(3)-E2N(1,2)-E2N(1,
     &  3)-E2N(2,2)-2D0*E2N(2,3)-E2N(3,3))*PRE
        F(13,-1,-1) = F(13,-1,-1)-E2N(0,0)*PRE

      if (qf(1).ne.0d0.and.qf(3).ne.0d0) then
C       G(T2,N6,FULL)
        CALL xE01234_NEW(RMF2(3),RMF2(1),RMF2(2),MH2,RMF2(4),S13,S12,
     &  T12,T14,S34,CMF2(3),NULL,CMF2(1),XMW2,XMW2,E0N,E1N,E2N,E3N,
     &  E4N,D0,D1,D2,D3,2,1)
        K(1) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = -((QF(1)*QF(3)*ALPHA*XMW)/(8D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+2D0*(E1N(1)+2D0*E1N(2)+2D0*E1N(3)+
     &  2D0*E2N(1,2)+2D0*E2N(1,3)+2D0*E2N(2,2)+4D0*E2N(2,3)+2D0*
     &  E2N(3,3))*PRE*S13
        F(2,-1,-1) = F(2,-1,-1)+2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(3,-1,-1) = F(3,-1,-1)-2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(5,-1,-1) = F(5,-1,-1)-8D0*K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)-4D0*E1N(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)-4D0*E1N(4)*PRE
        F(9,-1,-1) = F(9,-1,-1)+K(1)*PRE
        F(10,-1,-1) = F(10,-1,-1)+(E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,
     &  3))*PRE
        F(11,-1,-1) = F(11,-1,-1)+(-(E2N(2,4))-E2N(3,4))*PRE
        F(12,-1,-1) = F(12,-1,-1)-E2N(3,4)*PRE
        F(13,-1,-1) = F(13,-1,-1)+E2N(0,0)*PRE
      endif

C       G(T2,N7,FULL)
        CALL xE01234_NEW(RMF2(3),RMF2(1),RMF2(2),MH2,RMF2(4),S13,S12,
     &  T12,T14,S34,CMF2(3),XMZ2,CMF2(1),XMW2,XMW2,E0N,E1N,E2N,E3N,
     &  E4N,D0,D1,D2,D3,2,1)
        K(1) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = (ALPHA*XMW*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(32D0*PI*XCW2*XSW)

        F(1,-1,-1) = F(1,-1,-1)+2D0*(E1N(1)+2D0*E1N(2)+2D0*E1N(3)+
     &  2D0*E2N(1,2)+2D0*E2N(1,3)+2D0*E2N(2,2)+4D0*E2N(2,3)+2D0*
     &  E2N(3,3))*PRE*S13
        F(2,-1,-1) = F(2,-1,-1)+2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(3,-1,-1) = F(3,-1,-1)-2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(5,-1,-1) = F(5,-1,-1)-8D0*K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)-4D0*E1N(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)-4D0*E1N(4)*PRE
        F(9,-1,-1) = F(9,-1,-1)+K(1)*PRE
        F(10,-1,-1) = F(10,-1,-1)+(E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,
     &  3))*PRE
        F(11,-1,-1) = F(11,-1,-1)+(-(E2N(2,4))-E2N(3,4))*PRE
        F(12,-1,-1) = F(12,-1,-1)-E2N(3,4)*PRE
        F(13,-1,-1) = F(13,-1,-1)+E2N(0,0)*PRE

C       G(T2,N8,FULL)
        CALL xE01234_NEW(RMF2(3),RMF2(1),RMF2(2),MH2,RMF2(4),S13,S12,
     &  T12,T14,S34,CMF2(4),XMW2,CMF2(2),XMZ2,XMZ2,E0N,E1N,E2N,E3N,
     &  E4N,D0,D1,D2,D3,2,1)
        K(1) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = (ALPHA*XCW2**(-2)*XMW*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2)*
     &  (1D0-2D0*QF(4)*XSW2))/(32D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+2D0*(E1N(1)+2D0*E1N(2)+2D0*E1N(3)+
     &  2D0*E2N(1,2)+2D0*E2N(1,3)+2D0*E2N(2,2)+4D0*E2N(2,3)+2D0*
     &  E2N(3,3))*PRE*S13
        F(2,-1,-1) = F(2,-1,-1)+2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(3,-1,-1) = F(3,-1,-1)-2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(5,-1,-1) = F(5,-1,-1)-8D0*K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)-4D0*E1N(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)-4D0*E1N(4)*PRE
        F(9,-1,-1) = F(9,-1,-1)+K(1)*PRE
        F(10,-1,-1) = F(10,-1,-1)+(E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,
     &  3))*PRE
        F(11,-1,-1) = F(11,-1,-1)+(-(E2N(2,4))-E2N(3,4))*PRE
        F(12,-1,-1) = F(12,-1,-1)-E2N(3,4)*PRE
        F(13,-1,-1) = F(13,-1,-1)+E2N(0,0)*PRE

      if (qf(2).ne.0d0.and.qf(3).ne.0d0) then
C       G(T10,N32,FULL)
        CALL xE01234_NEW(RMF2(3),RMF2(2),RMF2(1),MH2,RMF2(4),S23,S12,
     &  T11,T14,S34,CMF2(3),NULL,CMF2(2),XMW2,XMW2,E0N,E1N,E2N,E3N,
     &  E4N,D0,D1,D2,D3,2,1)
        K(1) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = -((QF(2)*QF(3)*ALPHA*XMW)/(8D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)-2D0*PRE*(10D0*E2N(0,0)+E1N(1)*S23+
     &  2D0*E1N(2)*S23+2D0*E2N(1,2)*S23+2D0*E2N(1,3)*S23+2D0*E2N(2,
     &  2)*S23+2D0*E2N(3,3)*(S12+S23)+E1N(3)*(S12+2D0*S23)+2D0*
     &  E2N(2,3)*(S12+2D0*S23)-E1N(4)*S34-2D0*E2N(1,4)*S34-2D0*
     &  E2N(2,4)*(S24+S34)-2D0*E2N(3,4)*(MH2-T14))
        F(2,-1,-1) = F(2,-1,-1)+2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(3,-1,-1) = F(3,-1,-1)-2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(5,-1,-1) = F(5,-1,-1)-4D0*(2D0*E1N(3)+3D0*E2N(1,3)+3D0*
     &  E2N(2,3)+3D0*E2N(3,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)-4D0*K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*E2N(3,4)*PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(E1N(4)+E2N(2,4)+E2N(3,4))*PRE
        F(9,-1,-1) = F(9,-1,-1)+(E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3))*
     &  PRE
        F(10,-1,-1) = F(10,-1,-1)+K(1)*PRE
        F(11,-1,-1) = F(11,-1,-1)-E2N(3,4)*PRE
        F(12,-1,-1) = F(12,-1,-1)+(-(E2N(2,4))-E2N(3,4))*PRE
        F(13,-1,-1) = F(13,-1,-1)+E2N(0,0)*PRE
      endif

C       G(T10,N33,FULL)
        CALL xE01234_NEW(RMF2(3),RMF2(2),RMF2(1),MH2,RMF2(4),S23,S12,
     &  T11,T14,S34,CMF2(3),XMZ2,CMF2(2),XMW2,XMW2,E0N,E1N,E2N,E3N,
     &  E4N,D0,D1,D2,D3,2,1)
        K(1) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = -((ALPHA*XMW*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(32D0*PI*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)-2D0*PRE*(10D0*E2N(0,0)+E1N(1)*S23+
     &  2D0*E1N(2)*S23+2D0*E2N(1,2)*S23+2D0*E2N(1,3)*S23+2D0*E2N(2,
     &  2)*S23+2D0*E2N(3,3)*(S12+S23)+E1N(3)*(S12+2D0*S23)+2D0*
     &  E2N(2,3)*(S12+2D0*S23)-E1N(4)*S34-2D0*E2N(1,4)*S34-2D0*
     &  E2N(2,4)*(S24+S34)-2D0*E2N(3,4)*(MH2-T14))
        F(2,-1,-1) = F(2,-1,-1)+2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(3,-1,-1) = F(3,-1,-1)-2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(5,-1,-1) = F(5,-1,-1)-4D0*(2D0*E1N(3)+3D0*E2N(1,3)+3D0*
     &  E2N(2,3)+3D0*E2N(3,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)-4D0*K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*E2N(3,4)*PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(E1N(4)+E2N(2,4)+E2N(3,4))*PRE
        F(9,-1,-1) = F(9,-1,-1)+(E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3))*
     &  PRE
        F(10,-1,-1) = F(10,-1,-1)+K(1)*PRE
        F(11,-1,-1) = F(11,-1,-1)-E2N(3,4)*PRE
        F(12,-1,-1) = F(12,-1,-1)+(-(E2N(2,4))-E2N(3,4))*PRE
        F(13,-1,-1) = F(13,-1,-1)+E2N(0,0)*PRE

C       G(T10,N34,FULL)
        CALL xE01234_NEW(RMF2(3),RMF2(2),RMF2(1),MH2,RMF2(4),S23,S12,
     &  T11,T14,S34,CMF2(4),XMW2,CMF2(1),XMZ2,XMZ2,E0N,E1N,E2N,E3N,
     &  E4N,D0,D1,D2,D3,2,1)
        K(1) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = -((ALPHA*XCW2**(-2)*XMW*XSW2**(-2)*(1D0-2D0*QF(1)*
     &  XSW2)*(1D0-2D0*QF(4)*XSW2))/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-2D0*PRE*(10D0*E2N(0,0)+E1N(1)*S23+
     &  2D0*E1N(2)*S23+2D0*E2N(1,2)*S23+2D0*E2N(1,3)*S23+2D0*E2N(2,
     &  2)*S23+2D0*E2N(3,3)*(S12+S23)+E1N(3)*(S12+2D0*S23)+2D0*
     &  E2N(2,3)*(S12+2D0*S23)-E1N(4)*S34-2D0*E2N(1,4)*S34-2D0*
     &  E2N(2,4)*(S24+S34)-2D0*E2N(3,4)*(MH2-T14))
        F(2,-1,-1) = F(2,-1,-1)+2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(3,-1,-1) = F(3,-1,-1)-2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(5,-1,-1) = F(5,-1,-1)-4D0*(2D0*E1N(3)+3D0*E2N(1,3)+3D0*
     &  E2N(2,3)+3D0*E2N(3,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)-4D0*K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*E2N(3,4)*PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(E1N(4)+E2N(2,4)+E2N(3,4))*PRE
        F(9,-1,-1) = F(9,-1,-1)+(E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3))*
     &  PRE
        F(10,-1,-1) = F(10,-1,-1)+K(1)*PRE
        F(11,-1,-1) = F(11,-1,-1)-E2N(3,4)*PRE
        F(12,-1,-1) = F(12,-1,-1)+(-(E2N(2,4))-E2N(3,4))*PRE
        F(13,-1,-1) = F(13,-1,-1)+E2N(0,0)*PRE

      end

************************************************************************
*
*     QCD vertices (only corrections to diagonal terms in |M|^2)
*           for H->WW->4f
*           quark=1:f1,f2 are quarks, quark=2:f3,f4 are quarks,
*           quark=3:hadronic
************************************************************************
      subroutine HWW4f_vert_qcd_bos1(F,pw12,pw34,had,m21,m22,m23,m24)
      implicit none
      integer had
      real*8 m21,m22,m23,m24,dZqq1,dZqq2
      complex*16 F(13,-1:1,-1:1),pw12,pw34
      complex*16 B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
      complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
      complex*16   C0,  C1(2),  C2(0:2,0:2),  C3(0:2,0:2,2)
      complex*16   C4(0:2,0:2,0:2,0:2)
      complex*16 pre
      include 'COMMON/model.inc'
      include 'COMMON/param_bsm.inc'
      include 'COMMON/param.inc'
      include 'COMMON/xparam.inc'
c IR
      real*8 lambda,lambda2
      common/ir/lambda,lambda2
c renormalization scale
      real*8 mudim2
      common/uv/mudim2
c fermion charges of isospin duplets
      real*8 qf(4)
      common/fcharge/qf
c mandelstam variables
      real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion masses as flag (i*1d-20)
      complex*16 cme2,cmf2(5)
      real*8 me2,rme2,mf2(5),rmf2(5)
      common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2

C       Process: S1F21aF22F23aF24,   Model: SM4f

      if (had.eq.1.or.had.eq.3) then
C       G(T1,N72,FULL)
        CALL xC01234_(RMF2(2),S12,RMF2(1),NULL,CMF2(2),CMF2(1),C0,C1,C2,
     &  C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((ALPHAS*PW12*PW34*(1D0-2D0*C2(0,0)+C1(1)*S12+C1(2)*
     &  S12+C2(1,2)*S12+C0*S12)*XMW)/(3D0*PI*XSW*XSW2))

	if ((model.eq.1).or.(model.eq.2)) pre = pre*CVH

        F(1,-1,-1) = F(1,-1,-1)+PRE

c counterterms
        dZqq1 = -alphas/3D0/PI*(log(mudim2/m21)+4d0
     &         +2d0*log(lambda2/m21))
        dZqq2 = -alphas/3D0/PI*(log(mudim2/m22)+4d0
     &         +2d0*log(lambda2/m22))

        PRE = (PW12*PW34*XMW)/(2D0*XSW*XSW2) *(dZqq1+dZqq2)/2d0

	if ((model.eq.1).or.(model.eq.2)) pre = pre*CVH

        F(1,-1,-1) = F(1,-1,-1)+PRE

      endif

      if (had.eq.2.or.had.eq.3) then
C       G(T13,N630,FULL)
        CALL xC01234_(RMF2(3),S34,RMF2(4),NULL,CMF2(3),CMF2(4),C0,C1,C2,
     &  C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((ALPHAS*PW12*PW34*(1D0-2D0*C2(0,0)+C1(1)*S34+C1(2)*
     &  S34+C2(1,2)*S34+C0*S34)*XMW)/(3D0*PI*XSW*XSW2))

	if ((model.eq.1).or.(model.eq.2)) pre = pre*CVH

        F(1,-1,-1) = F(1,-1,-1)+PRE

c counterterms
        dZqq1 = -alphas/3D0/PI*(log(mudim2/m23)+4d0
     &         +2d0*log(lambda2/m23))
        dZqq2 = -alphas/3D0/PI*(log(mudim2/m24)+4d0
     &         +2d0*log(lambda2/m24))

        PRE = (PW12*PW34*XMW)/(2D0*XSW*XSW2) *(dZqq1+dZqq2)/2d0

	if ((model.eq.1).or.(model.eq.2)) pre = pre*CVH

        F(1,-1,-1) = F(1,-1,-1)+PRE

      endif

      end

************************************************************************
*
*     QCD pentagons for H->WW->4f
*
************************************************************************
      subroutine HWW4f_pent_qcd(F,pw12,pw34)
      implicit none
      complex*16 F(13,-1:1,-1:1),pw12,pw34
      complex*16 B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
      complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
      complex*16   C0,  C1(2),  C2(0:2,0:2),  C3(0:2,0:2,2)
      complex*16   C4(0:2,0:2,0:2,0:2)
      complex*16 D0,D1(3),D2(0:3,0:3),D3(0:3,0:3,3)
      complex*16 E0n,E1n(4),E2n(0:4,0:4),E3n(0:4,0:4,4)
      complex*16 E4n(0:4,0:4,0:4,0:4)
      complex*16 pre,K(10)
      include 'COMMON/model.inc'
      include 'COMMON/param_bsm.inc'
      include 'COMMON/param.inc'
      include 'COMMON/xparam.inc'
c fermion charges of isospin duplets
      real*8 qf(4)
      common/fcharge/qf
c mandelstam variables
      real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion masses as flag (i*1d-20)
      complex*16 cme2,cmf2(5)
      real*8 me2,rme2,mf2(5),rmf2(5)
      common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2

C       Process: S1F21aF22F23aF24,   Model: SM4f

C       G(T3,N10,FULL)
        CALL xE01234_NEW(RMF2(1),RMF2(4),RMF2(3),MH2,RMF2(2),S14,S34,
     &  T13,T12,S12,CMF2(1),NULL,CMF2(4),XMW2,XMW2,E0N,E1N,E2N,E3N,
     &  E4N,D0,D1,D2,D3,2,1)
        K(1) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = -((ALPHAS*XMW)/(8D0*PI*XSW*XSW2))

	if ((model.eq.1).or.(model.eq.2)) pre = pre*CVH

        F(1,-1,-1) = F(1,-1,-1)-2D0*PRE*(10D0*E2N(0,0)-E1N(4)*S12-
     &  2D0*E2N(1,4)*S12+E1N(1)*S14+2D0*E1N(2)*S14+2D0*E2N(1,2)*S14+
     &  2D0*E2N(1,3)*S14+2D0*E2N(2,2)*S14-2D0*E2N(2,4)*(S12+S24)+
     &  2D0*E2N(3,3)*(S14+S34)+E1N(3)*(2D0*S14+S34)+2D0*E2N(2,3)*
     &  (2D0*S14+S34)-2D0*E2N(3,4)*(MH2-T12))
        F(2,-1,-1) = F(2,-1,-1)-2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(3,-1,-1) = F(3,-1,-1)+2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(5,-1,-1) = F(5,-1,-1)-4D0*(2D0*E1N(3)+3D0*E2N(1,3)+3D0*
     &  E2N(2,3)+3D0*E2N(3,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)+4D0*E2N(3,4)*PRE
        F(7,-1,-1) = F(7,-1,-1)-4D0*K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(E1N(4)+E2N(2,4)+E2N(3,4))*PRE
        F(9,-1,-1) = F(9,-1,-1)+(E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3))*
     &  PRE
        F(10,-1,-1) = F(10,-1,-1)-E2N(3,4)*PRE
        F(11,-1,-1) = F(11,-1,-1)+K(1)*PRE
        F(12,-1,-1) = F(12,-1,-1)+(-(E2N(2,4))-E2N(3,4))*PRE
        F(13,-1,-1) = F(13,-1,-1)+E2N(0,0)*PRE

C       G(T8,N26,FULL)
        CALL xE01234_NEW(RMF2(2),RMF2(4),RMF2(3),MH2,RMF2(1),S24,S34,
     &  T13,T11,S12,CMF2(2),NULL,CMF2(4),XMW2,XMW2,E0N,E1N,E2N,E3N,
     &  E4N,D0,D1,D2,D3,2,1)

        PRE = (ALPHAS*XMW)/(8D0*PI*XSW*XSW2)

	if ((model.eq.1).or.(model.eq.2)) pre = pre*CVH

        F(1,-1,-1) = F(1,-1,-1)-2D0*PRE*(-(2D0*E2N(3,4)*S13)+E1N(1)*
     &  S24)
        F(2,-1,-1) = F(2,-1,-1)+2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(3,-1,-1) = F(3,-1,-1)-2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(5,-1,-1) = F(5,-1,-1)-8D0*E2N(3,4)*PRE
        F(6,-1,-1) = F(6,-1,-1)+4D0*E1N(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*E1N(4)*PRE
        F(9,-1,-1) = F(9,-1,-1)+E2N(3,4)*PRE
        F(10,-1,-1) = F(10,-1,-1)+(-(E1N(3))-E2N(1,3)-E2N(2,3)-
     &  E2N(3,3))*PRE
        F(11,-1,-1) = F(11,-1,-1)+(E2N(2,4)+E2N(3,4))*PRE
        F(12,-1,-1) = F(12,-1,-1)+(-(E1N(2))-E1N(3)-E2N(1,2)-E2N(1,
     &  3)-E2N(2,2)-2D0*E2N(2,3)-E2N(3,3))*PRE
        F(13,-1,-1) = F(13,-1,-1)-E2N(0,0)*PRE

C       G(T2,N6,FULL)
        CALL xE01234_NEW(RMF2(3),RMF2(1),RMF2(2),MH2,RMF2(4),S13,S12,
     &  T12,T14,S34,CMF2(3),NULL,CMF2(1),XMW2,XMW2,E0N,E1N,E2N,E3N,
     &  E4N,D0,D1,D2,D3,2,1)
        K(1) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = -((ALPHAS*XMW)/(8D0*PI*XSW*XSW2))

	if ((model.eq.1).or.(model.eq.2)) pre = pre*CVH

        F(1,-1,-1) = F(1,-1,-1)+2D0*(E1N(1)+2D0*E1N(2)+2D0*E1N(3)+
     &  2D0*E2N(1,2)+2D0*E2N(1,3)+2D0*E2N(2,2)+4D0*E2N(2,3)+2D0*
     &  E2N(3,3))*PRE*S13
        F(2,-1,-1) = F(2,-1,-1)+2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(3,-1,-1) = F(3,-1,-1)-2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(5,-1,-1) = F(5,-1,-1)-8D0*K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)-4D0*E1N(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)-4D0*E1N(4)*PRE
        F(9,-1,-1) = F(9,-1,-1)+K(1)*PRE
        F(10,-1,-1) = F(10,-1,-1)+(E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,
     &  3))*PRE
        F(11,-1,-1) = F(11,-1,-1)+(-(E2N(2,4))-E2N(3,4))*PRE
        F(12,-1,-1) = F(12,-1,-1)-E2N(3,4)*PRE
        F(13,-1,-1) = F(13,-1,-1)+E2N(0,0)*PRE

C       G(T10,N35,FULL)
        CALL xE01234_NEW(RMF2(3),RMF2(2),RMF2(1),MH2,RMF2(4),S23,S12,
     &  T11,T14,S34,CMF2(3),NULL,CMF2(2),XMW2,XMW2,E0N,E1N,E2N,E3N,
     &  E4N,D0,D1,D2,D3,2,1)
        K(1) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = -((ALPHAS*XMW)/(8D0*PI*XSW*XSW2))

	if ((model.eq.1).or.(model.eq.2)) pre = pre*CVH

        F(1,-1,-1) = F(1,-1,-1)-2D0*PRE*(10D0*E2N(0,0)+E1N(1)*S23+
     &  2D0*E1N(2)*S23+2D0*E2N(1,2)*S23+2D0*E2N(1,3)*S23+2D0*E2N(2,
     &  2)*S23+2D0*E2N(3,3)*(S12+S23)+E1N(3)*(S12+2D0*S23)+2D0*
     &  E2N(2,3)*(S12+2D0*S23)-E1N(4)*S34-2D0*E2N(1,4)*S34-2D0*
     &  E2N(2,4)*(S24+S34)-2D0*E2N(3,4)*(MH2-T14))
        F(2,-1,-1) = F(2,-1,-1)+2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(3,-1,-1) = F(3,-1,-1)-2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(5,-1,-1) = F(5,-1,-1)-4D0*(2D0*E1N(3)+3D0*E2N(1,3)+3D0*
     &  E2N(2,3)+3D0*E2N(3,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)-4D0*K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*E2N(3,4)*PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(E1N(4)+E2N(2,4)+E2N(3,4))*PRE
        F(9,-1,-1) = F(9,-1,-1)+(E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3))*
     &  PRE
        F(10,-1,-1) = F(10,-1,-1)+K(1)*PRE
        F(11,-1,-1) = F(11,-1,-1)-E2N(3,4)*PRE
        F(12,-1,-1) = F(12,-1,-1)+(-(E2N(2,4))-E2N(3,4))*PRE
        F(13,-1,-1) = F(13,-1,-1)+E2N(0,0)*PRE

      end
