************************************************************************
*
*     counterterms for H->WW->4f
*
************************************************************************
      subroutine HWW4f_count_bgf(F,pw12,pw34)
      implicit none
      integer sym42
      complex*16 F(13,-1:1,-1:1),pw12,pw34
      complex*16 pre,ct,ct12,ct34,ca2,ca3,cz2(-1:1),cz3(-1:1)
      include 'COMMON/xparam.inc'
c bosonic renormalization constants
      complex*16 dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,dZh
      complex*16 dZeer,dZeel,dZnnl,dZffr(4),dZffl(4)
      complex*16 ct_aww,ct_zww,ct_wen,ct_wf1f2,ct_wf3f4
      complex*16 ct_annl,ct_aeer,ct_aeel,ct_affr(4),ct_affl(4)
      complex*16 ct_znnl,ct_zeer,ct_zeel,ct_zffr(4),ct_zffl(4)
      complex*16 ct_hww,ct_hzz,ct_hza
      common/xrenc_bgf/dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,dZh,
     &                  dZeer,dZeel,dZnnl,dZffr,dZffl,
     &                  ct_aww,ct_zww,ct_wen,ct_wf1f2,ct_wf3f4,
     &                  ct_annl,ct_aeer,ct_aeel,ct_affr,ct_affl,
     &                  ct_znnl,ct_zeer,ct_zeel,ct_zffr,ct_zffl,
     &                  ct_hww,ct_hzz,ct_hza
c mandelstam variables
      real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14

c counterterms for self energies
      ct =  dmw2/(s12-xmw2) - dZw
     &     +dmw2/(s34-xmw2) - dZw

      PRE = (PW12*PW34*XMW)/(2D0*XSW*XSW2) *ct

      F(1,-1,-1) = F(1,-1,-1)+PRE

c counterterms for vertex diagrams
      ct = ct_hww + ct_wf1f2 + ct_wf3f4

      PRE = (PW12*PW34*XMW)/(2D0*XSW*XSW2) *ct

      F(1,-1,-1) = F(1,-1,-1)+PRE

      end

************************************************************************
*
*     bosonic self energies for H->WW->4f
*
************************************************************************
      subroutine HWW4f_self_bos_bgf(F,pw12,pw34)
      implicit none
      complex*16 F(13,-1:1,-1:1),pw12,pw34
      complex*16 A0,xA0_,B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
      complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
      complex*16 pre
      include 'COMMON/param.inc'
      include 'COMMON/xparam.inc'
c mandelstam variables
      real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion masses as flag (i*1d-20)
      complex*16 cme2,cmf2(5)
      real*8 me2,rme2,mf2(5),rmf2(5)
      common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2

C       Process: S10F2100aF2200F2300aF2400,   Model: SMbgf4f

C       G(T1,N7,FULL)+G(T1,N9,FULL)+G(T2,N17,FULL)+G(T2,N19,FULL)

C       G(T1,N2,FULL)+G(T2,N12,FULL)
        A0 = xA0_(XMH2)

        PRE = -((A0*ALPHA*PW12*PW34*(PW12+PW34)*XMW*XSW2**(-2))/
     &  (32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T1,N1,FULL)+G(T1,N4,FULL)+G(T1,N5,FULL)+G(T1,N8,FULL)+
C       G(T2,N11,FULL)+G(T2,N14,FULL)+G(T2,N15,FULL)+G(T2,N18,FULL)
        A0 = xA0_(XMW2)

        PRE = -((ALPHA*PW12*PW34*(PW12+PW34)*XMW*(5D0*A0-4D0*XMW2)*
     &  XSW2**(-2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T1,N10,FULL)+G(T1,N3,FULL)+G(T1,N6,FULL)+G(T2,N13,FULL)+
C       G(T2,N16,FULL)+G(T2,N20,FULL)
        A0 = xA0_(XMZ2)

        PRE = -((ALPHA*PW12*PW34*(PW12+PW34)*XMW*(A0*(1D0+8D0*XCW2)-
     &  8D0*XCW2*XMZ2)*XSW2**(-2))/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T3,N23,FULL)+G(T3,N28,FULL)+G(T3,N30,FULL)+G(T3,N31,FULL)+
C       G(T3,N39,FULL)+G(T3,N44,FULL)+G(T3,N46,FULL)+G(T3,N47,FULL)
        CALL xB012345_(S12,NULL,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*PW12**2*PW34*XMW*(12D0*B2(0,0)+S12-3D0*XMW2+
     &  6D0*B0*(2D0*S12-XMW2)))/(12D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T3,N21,FULL)+G(T3,N25,FULL)+G(T3,N37,FULL)+G(T3,N41,FULL)
        CALL xB012345_(S12,XMW2,XMH2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = -((ALPHA*PW12**2*PW34*XMW*(-(B2(0,0))+B0*XMW2)*XSW2**
     &  (-2))/(8D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T3,N22,FULL)+G(T3,N24,FULL)+G(T3,N26,FULL)+G(T3,N27,FULL)+
C       G(T3,N29,FULL)+G(T3,N32,FULL)+G(T3,N38,FULL)+G(T3,N40,FULL)+
C       G(T3,N42,FULL)+G(T3,N43,FULL)+G(T3,N45,FULL)+G(T3,N48,FULL)
        CALL xB012345_(S12,XMW2,XMZ2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*PW12**2*PW34*XMW*XSW2**(-2)*(3D0*B2(0,0)*(1D0+
     &  8D0*XCW2)+2D0*XCW2*(S12-3D0*XMW2-3D0*XMZ2)+(3D0*B0*(8D0*S12*
     &  XCW2**2-XCW2*XMW2-XCW2**2*XMW2+2D0*XCW2*XMW2*XSW2-XMW2*
     &  XSW2**2))/XCW2))/(24D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T4,N51,FULL)+G(T4,N56,FULL)+G(T4,N58,FULL)+G(T4,N59,FULL)+
C       G(T4,N67,FULL)+G(T4,N72,FULL)+G(T4,N74,FULL)+G(T4,N75,FULL)
        CALL xB012345_(S34,NULL,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*PW12*PW34**2*XMW*(12D0*B2(0,0)+S34-3D0*XMW2+
     &  6D0*B0*(2D0*S34-XMW2)))/(12D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T4,N49,FULL)+G(T4,N53,FULL)+G(T4,N65,FULL)+G(T4,N69,FULL)
        CALL xB012345_(S34,XMW2,XMH2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = -((ALPHA*PW12*PW34**2*XMW*(-(B2(0,0))+B0*XMW2)*XSW2**
     &  (-2))/(8D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T4,N50,FULL)+G(T4,N52,FULL)+G(T4,N54,FULL)+G(T4,N55,FULL)+
C       G(T4,N57,FULL)+G(T4,N60,FULL)+G(T4,N66,FULL)+G(T4,N68,FULL)+
C       G(T4,N70,FULL)+G(T4,N71,FULL)+G(T4,N73,FULL)+G(T4,N76,FULL)
        CALL xB012345_(S34,XMW2,XMZ2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*PW12*PW34**2*XMW*XSW2**(-2)*(3D0*B2(0,0)*(1D0+
     &  8D0*XCW2)+2D0*XCW2*(S34-3D0*XMW2-3D0*XMZ2)+(3D0*B0*(8D0*S34*
     &  XCW2**2-XCW2*XMW2-XCW2**2*XMW2+2D0*XCW2*XMW2*XSW2-XMW2*
     &  XSW2**2))/XCW2))/(24D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

      end

************************************************************************
*
*     test routine
*       self energies
*
************************************************************************
      subroutine HWW4f_self_bos_bgf2(F,pw12,pw34)
      implicit none
      complex*16 F(13,-1:1,-1:1),pw12,pw34
      complex*16 pre,ct,ct12,ct34,ca2,ca3,cz2(-1:1),cz3(-1:1)
      complex*16 fact,xseww_bgf
      include 'COMMON/xparam.inc'
c mandelstam variables
      real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14

      fact = - xseww_bgf(s12)*pw12 - xseww_bgf(s34)*pw34

      PRE = (PW12*PW34*XMW)/(2D0*XSW*XSW2) *fact

      F(1,-1,-1) = F(1,-1,-1)+PRE

      end

************************************************************************
*
*     vertex diagrams (bosonic) for H->WW->4f
*
************************************************************************
      subroutine HWW4f_vert_bos_bgf(F,pw12,pw34)
      implicit none
      complex*16 B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
      complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
      complex*16   C0,  C1(2),  C2(0:2,0:2),  C3(0:2,0:2,2)
      complex*16   C4(0:2,0:2,0:2,0:2)
      complex*16 F(13,-1:1,-1:1),pw12,pw34
      complex*16 pre,K(3)
      include 'COMMON/param.inc'
      include 'COMMON/xparam.inc'
c fermion charges of isospin duplets
      real*8 qf(4)
      common/fcharge/qf
c mandelstam variables
      real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion masses as flag (i*1d-20)
      complex*16 cme2,cmf2(5)
      real*8 me2,rme2,mf2(5),rmf2(5)
      common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2

C       Process: S10F2100aF2200F2300aF2400,   Model: SMbgf4f

C       G(T8,N62,FULL)
        CALL xB012345_(MH2,XMH2,XMH2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((3D0*ALPHA*B0*PW12*PW34*XMH2*XSW2**(-2))/(64D0*PI*
     &  XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T8,N61,FULL)+G(T8,N64,FULL)+G(T8,N65,FULL)+G(T8,N67,FULL)
        CALL xB012345_(MH2,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*PW12*PW34*(-(8D0*XMW)+(B0*(XMH2+10D0*XMW2))/
     &  XMW)*XSW2**(-2))/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T8,N63,FULL)+G(T8,N66,FULL)+G(T8,N68,FULL)
        CALL xB012345_(MH2,XMZ2,XMZ2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*PW12*PW34*(-(16D0*XMW)+(B0*(XCW2*XMH2+2D0*
     &  XMW2+16D0*XCW2*XMW2))/(XCW2*XMW))*XSW2**(-2))/(64D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T10,N73,FULL)
        CALL xB012345_(S12,NULL,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12*PW34*XMW)/(4D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T10,N75,FULL)
        CALL xB012345_(S12,XMW2,XMH2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12*PW34*XMW*XSW2**(-2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T10,N74,FULL)+G(T10,N76,FULL)
        CALL xB012345_(S12,XMW2,XMZ2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12*PW34*XMW*XSW2**(-2)*(XCW2+XCW2**2-
     &  2D0*XCW2*XSW2+XSW2**2))/(16D0*PI*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T9,N69,FULL)
        CALL xB012345_(S34,NULL,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12*PW34*XMW)/(4D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T9,N71,FULL)
        CALL xB012345_(S34,XMW2,XMH2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12*PW34*XMW*XSW2**(-2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T9,N70,FULL)+G(T9,N72,FULL)
        CALL xB012345_(S34,XMW2,XMZ2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12*PW34*XMW*XSW2**(-2)*(XCW2+XCW2**2-
     &  2D0*XCW2*XSW2+XSW2**2))/(16D0*PI*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T3,N14,FULL)
      CALL xC01234_(RMF2(1),MH2,T11,CMF2(1),XMZ2,XMZ2,C0,C1,C2,C3,C4,B0,
     &  B1,B2,B3,1,1)

        PRE = (C1(2)*ALPHA*PW34*XCW2**(-2)*XMW*XSW2**(-2)*(1D0-2D0*
     &  QF(1)*XSW2)**2)/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T3,N13,FULL)
      CALL xC01234_(RMF2(1),MH2,T11,CMF2(2),XMW2,XMW2,C0,C1,C2,C3,C4,B0,
     &  B1,B2,B3,1,1)

        PRE = (C1(2)*ALPHA*PW34*XMW*XSW2**(-2))/(8D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

      if (qf(1).ne.0d0) then
C       G(T1,N3,FULL)+G(T1,N7,FULL)
        CALL xC01234_(RMF2(1),S12,RMF2(2),CMF2(1),NULL,XMW2,C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,1)

        PRE = -((QF(1)*ALPHA*PW12*PW34*(1D0-4D0*C2(0,0)+2D0*C1(1)*
     &  S12+2D0*C1(2)*S12)*XMW)/(8D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE
      endif

C       G(T1,N4,FULL)+G(T1,N8,FULL)
        CALL xC01234_(RMF2(1),S12,RMF2(2),CMF2(1),XMZ2,XMW2,C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,1)

        PRE = -((ALPHA*PW12*PW34*(1D0-4D0*C2(0,0)+2D0*C1(1)*S12+2D0*
     &  C1(2)*S12)*XMW*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2))/(16D0*PI*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T1,N2,FULL)+G(T1,N6,FULL)
        CALL xC01234_(RMF2(1),S12,RMF2(2),CMF2(2),XMW2,XMZ2,C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,1)

        PRE = -((ALPHA*PW12*PW34*(1D0-4D0*C2(0,0)+2D0*C1(1)*S12+2D0*
     &  C1(2)*S12)*XMW*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2))/(16D0*PI*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

      if (qf(2).ne.0d0) then
C       G(T1,N1,FULL)+G(T1,N5,FULL)
        CALL xC01234_(RMF2(2),RMF2(1),S12,NULL,CMF2(2),XMW2,C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,1)

        PRE = (QF(2)*ALPHA*PW12*PW34*(1D0-4D0*C2(0,0)-2D0*C1(1)*S12-
     &  2D0*C0*S12)*XMW)/(8D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE
      endif

C       G(T2,N12,FULL)
      CALL xC01234_(RMF2(2),MH2,T12,CMF2(1),XMW2,XMW2,C0,C1,C2,C3,C4,B0,
     &  B1,B2,B3,1,1)

        PRE = (C1(2)*ALPHA*PW34*XMW*XSW2**(-2))/(8D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

      if (qf(1).ne.0d0.and.qf(2).ne.0d0) then
C       G(T1,N9,FULL)
        CALL xC01234_(RMF2(2),S12,RMF2(1),NULL,CMF2(2),CMF2(1),C0,C1,C2,
     &  C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((QF(1)*QF(2)*ALPHA*PW12*PW34*(1D0-2D0*C2(0,0)+C1(1)*
     &  S12+C1(2)*S12+C2(1,2)*S12+C0*S12)*XMW)/(4D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE
      endif

C       G(T4,N15,FULL)
      CALL xC01234_(RMF2(3),MH2,T13,CMF2(4),XMW2,XMW2,C0,C1,C2,C3,C4,B0,
     &  B1,B2,B3,1,1)

        PRE = (C1(2)*ALPHA*PW12*XMW*XSW2**(-2))/(8D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

      if (qf(3).ne.0d0.and.qf(4).ne.0d0) then
C       G(T7,N59,FULL)
        CALL xC01234_(RMF2(3),S34,RMF2(4),NULL,CMF2(3),CMF2(4),C0,C1,C2,
     &  C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((QF(3)*QF(4)*ALPHA*PW12*PW34*(1D0-2D0*C2(0,0)+C1(1)*
     &  S34+C1(2)*S34+C2(1,2)*S34+C0*S34)*XMW)/(4D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE
      endif

      if (qf(3).ne.0d0) then
C       G(T7,N51,FULL)+G(T7,N55,FULL)
        CALL xC01234_(RMF2(3),S34,RMF2(4),CMF2(3),NULL,XMW2,C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,1)

        PRE = (QF(3)*ALPHA*PW12*PW34*(1D0-4D0*C2(0,0)+2D0*C1(1)*S34+
     &  2D0*C1(2)*S34)*XMW)/(8D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE
      endif

C       G(T7,N52,FULL)+G(T7,N56,FULL)
        CALL xC01234_(RMF2(3),S34,RMF2(4),CMF2(3),XMZ2,XMW2,C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,1)

        PRE = -((ALPHA*PW12*PW34*(1D0-4D0*C2(0,0)+2D0*C1(1)*S34+2D0*
     &  C1(2)*S34)*XMW*XSW2**(-2)*(1D0+2D0*QF(3)*XSW2))/(16D0*PI*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T7,N54,FULL)+G(T7,N58,FULL)
        CALL xC01234_(RMF2(3),S34,RMF2(4),CMF2(4),XMW2,XMZ2,C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,1)

        PRE = -((ALPHA*PW12*PW34*(1D0-4D0*C2(0,0)+2D0*C1(1)*S34+2D0*
     &  C1(2)*S34)*XMW*XSW2**(-2)*(1D0-2D0*QF(4)*XSW2))/(16D0*PI*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

      if (qf(4).ne.0d0) then
C       G(T7,N53,FULL)+G(T7,N57,FULL)
        CALL xC01234_(RMF2(4),RMF2(3),S34,NULL,CMF2(4),XMW2,C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,1)

        PRE = -((QF(4)*ALPHA*PW12*PW34*(1D0-4D0*C2(0,0)-2D0*C1(1)*
     &  S34-2D0*C0*S34)*XMW)/(8D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE
      endif

C       G(T1,N10,FULL)
        CALL xC01234_(S12,RMF2(1),RMF2(2),CMF2(2),CMF2(1),XMZ2,C0,C1,C2,
     &  C3,C4,B0,B1,B2,B3,2,1)

        PRE = (ALPHA*PW12*PW34*(1D0-2D0*C2(0,0)-C1(1)*S12-C1(2)*S12-
     &  C2(1,1)*S12-C2(1,2)*S12)*XMW*XSW2**(-2)*(1D0-2D0*QF(1)*
     &  XSW2)*(1D0+2D0*QF(2)*XSW2))/(16D0*PI*XCW2*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T5,N26,FULL)+G(T5,N27,FULL)+G(T5,N35,FULL)+G(T5,N39,FULL)+
C       G(T5,N43,FULL)+G(T5,N47,FULL)
       CALL xC01234_(S12,MH2,S34,NULL,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = C1(1)+C1(2)+2D0*C2(1,2)

        PRE = -((ALPHA*PW12*PW34*XMW)/(4D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(1D0-4D0*C2(0,0)-C0*(2D0*S12+
     &  2D0*S34-XMH2-2D0*XMW2))
        F(5,-1,-1) = F(5,-1,-1)+2D0*K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)+2D0*K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+2D0*K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+2D0*K(1)*PRE

C       G(T5,N33,FULL)+G(T5,N37,FULL)+G(T5,N41,FULL)+G(T5,N45,FULL)
       CALL xC01234_(S12,MH2,S34,XMH2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 2D0*C1(1)*XMW+2D0*C1(2)*XMW+(C2(1,2)*(XMH2+2D0*
     &  XMW2))/XMW

        PRE = -((ALPHA*PW12*PW34*XSW2**(-2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(2D0*C0*XMW*XMW2-(C2(0,0)*(XMH2+
     &  2D0*XMW2))/XMW)
        F(5,-1,-1) = F(5,-1,-1)+K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)+K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+K(1)*PRE

C       G(T5,N19,FULL)+G(T5,N20,FULL)
       CALL xC01234_(S12,MH2,S34,XMW2,XMH2,XMH2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)

        PRE = -((3D0*ALPHA*PW12*PW34*XMH2*XSW2**(-2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(C0*XMW-(C2(0,0))/XMW)
        F(5,-1,-1) = F(5,-1,-1)+(C2(1,2)*PRE)/XMW
        F(6,-1,-1) = F(6,-1,-1)+(C2(1,2)*PRE)/XMW
        F(7,-1,-1) = F(7,-1,-1)+(C2(1,2)*PRE)/XMW
        F(8,-1,-1) = F(8,-1,-1)+(C2(1,2)*PRE)/XMW

C       G(T5,N17,FULL)+G(T5,N18,FULL)+G(T5,N21,FULL)+G(T5,N22,FULL)+
C       G(T5,N23,FULL)+G(T5,N24,FULL)+G(T5,N29,FULL)+G(T5,N30,FULL)+
C       G(T5,N31,FULL)+G(T5,N32,FULL)
       CALL xC01234_(S12,MH2,S34,XMW2,XMZ2,XMZ2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = XCW2+XSW2
        K(2) = XCW2*XMH2+2D0*XMW2+16D0*XCW2*XMW2
        K(3) = 8D0*C0*XMW-(C2(1,2)*(XCW2*XMH2+2D0*XMW2+16D0*XCW2*
     &  XMW2))/(XCW2*XMW)-(2D0*C1(1)*XMW*(XCW2+XSW2))/XCW2-(2D0*
     &  C1(2)*XMW*(XCW2+XSW2))/XCW2

        PRE = (ALPHA*PW12*PW34*XSW2**(-2))/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(4D0*XMW)+(C2(0,0)*K(2))/
     &  (XCW2*XMW)+C0*XCW2**(-2)*XMW*(4D0*S12*XCW2**2-4D0*S13*XCW2**
     &  2-4D0*S14*XCW2**2-4D0*S23*XCW2**2-4D0*S24*XCW2**2+4D0*S34*
     &  XCW2**2-XCW2**2*XMH2-2D0*XCW2*XMW2-2D0*XCW2**2*XMW2+4D0*
     &  XCW2*XMW2*XSW2-2D0*XMW2*XSW2**2))
        F(5,-1,-1) = F(5,-1,-1)+K(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+K(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+K(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+K(3)*PRE

C       G(T5,N25,FULL)+G(T5,N28,FULL)+G(T5,N34,FULL)+G(T5,N36,FULL)+
C       G(T5,N38,FULL)+G(T5,N40,FULL)+G(T5,N42,FULL)+G(T5,N44,FULL)+
C       G(T5,N46,FULL)+G(T5,N48,FULL)
       CALL xC01234_(S12,MH2,S34,XMZ2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*XCW2+2D0*XSW2
        K(2) = XMH2+2D0*XMW2+16D0*XCW2*XMW2
        K(3) = -((C2(1,2)*(XMH2+2D0*XMW2+16D0*XCW2*XMW2))/XMW)+8D0*
     &  C0*XMW*(XCW2+XSW2)+2D0*C1(1)*XMW*(1D0-2D0*XCW2+2D0*XSW2)+
     &  2D0*C1(2)*XMW*(1D0-2D0*XCW2+2D0*XSW2)

        PRE = (ALPHA*PW12*PW34*XSW2**(-2))/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(4D0*XCW2*XMW)+(C2(0,0)*K(2))/
     &  XMW+(C0*XMW*(4D0*S12*XCW2**2-4D0*S13*XCW2**2-4D0*S14*XCW2**
     &  2-4D0*S23*XCW2**2-4D0*S24*XCW2**2+4D0*S34*XCW2**2-XCW2**2*
     &  XMH2-2D0*XCW2*XMW2-2D0*XCW2**2*XMW2-4D0*S12*XCW2*XSW2-4D0*
     &  S13*XCW2*XSW2-4D0*S14*XCW2*XSW2-4D0*S23*XCW2*XSW2-4D0*S24*
     &  XCW2*XSW2-4D0*S34*XCW2*XSW2+2D0*XCW2*XMH2*XSW2+4D0*XCW2*
     &  XMW2*XSW2-XMH2*XSW2**2-2D0*XMW2*XSW2**2))/XCW2)
        F(5,-1,-1) = F(5,-1,-1)+K(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+K(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+K(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+K(3)*PRE

C       G(T7,N60,FULL)
        CALL xC01234_(S34,RMF2(4),RMF2(3),CMF2(3),CMF2(4),XMZ2,C0,C1,C2,
     &  C3,C4,B0,B1,B2,B3,2,1)

        PRE = (ALPHA*PW12*PW34*(1D0-2D0*C2(0,0)-C1(1)*S34-C1(2)*S34-
     &  C2(1,1)*S34-C2(1,2)*S34)*XMW*XSW2**(-2)*(1D0+2D0*QF(3)*
     &  XSW2)*(1D0-2D0*QF(4)*XSW2))/(16D0*PI*XCW2*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T2,N11,FULL)
      CALL xC01234_(T12,MH2,RMF2(2),CMF2(2),XMZ2,XMZ2,C0,C1,C2,C3,C4,B0,
     &  B1,B2,B3,1,1)

        PRE = (C1(1)*ALPHA*PW34*XCW2**(-2)*XMW*XSW2**(-2)*(1D0+2D0*
     &  QF(2)*XSW2)**2)/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T4,N16,FULL)
      CALL xC01234_(T13,MH2,RMF2(3),CMF2(3),XMZ2,XMZ2,C0,C1,C2,C3,C4,B0,
     &  B1,B2,B3,1,1)

        PRE = (C1(1)*ALPHA*PW12*XCW2**(-2)*XMW*XSW2**(-2)*(1D0+2D0*
     &  QF(3)*XSW2)**2)/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T6,N49,FULL)
      CALL xC01234_(T14,MH2,RMF2(4),CMF2(3),XMW2,XMW2,C0,C1,C2,C3,C4,B0,
     &  B1,B2,B3,1,1)

        PRE = (C1(1)*ALPHA*PW12*XMW*XSW2**(-2))/(8D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T6,N50,FULL)
      CALL xC01234_(T14,MH2,RMF2(4),CMF2(4),XMZ2,XMZ2,C0,C1,C2,C3,C4,B0,
     &  B1,B2,B3,1,1)

        PRE = (C1(1)*ALPHA*PW12*XCW2**(-2)*XMW*XSW2**(-2)*(1D0-2D0*
     &  QF(4)*XSW2)**2)/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

      end

************************************************************************
*
*     boxes for H->WW->4f
*
************************************************************************
      subroutine HWW4f_box_bgf(F,pw12,pw34)
      implicit none
      complex*16 F(13,-1:1,-1:1),pw12,pw34
      complex*16   C0,  C1(2),  C2(0:2,0:2),  C3(0:2,0:2,2)
      complex*16   C4(0:2,0:2,0:2,0:2)
      complex*16 D0,D1(3),D2(0:3,0:3),D3(0:3,0:3,3)
      complex*16 D4(0:3,0:3,0:3,0:3),D5(0:3,0:3,0:3,0:3,3)
      complex*16 pre
      include 'COMMON/param.inc'
      include 'COMMON/xparam.inc'
c fermion charges of isospin duplets
      real*8 qf(4)
      common/fcharge/qf
c mandelstam variables
      real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion masses as flag (i*1d-20)
      complex*16 cme2,cmf2(5)
      real*8 me2,rme2,mf2(5),rmf2(5)
      common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2

C       Process: S10F2100aF2200F2300aF2400,   Model: SMbgf4f

      if (qf(1).ne.0d0) then
C       G(T1,N3,FULL)+G(T1,N5,FULL)
        CALL xD012345_(RMF2(1),RMF2(2),MH2,S34,T12,S12,NULL,CMF2(1),
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((QF(1)*ALPHA*PW34*XMW)/(4D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(2D0*D2(0,0))+D1(1)*(S13+S14)+
     &  D0*(S13+S14)-D1(3)*T12+D1(2)*(MH2+S13+S14-S23-S24-T12))
        F(5,-1,-1) = F(5,-1,-1)+2D0*(D1(3)+D2(1,3)+D2(2,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)+2D0*(D1(2)+D2(2,3))*PRE
        F(7,-1,-1) = F(7,-1,-1)+2D0*(D1(3)+D2(1,3)+D2(2,3))*PRE
        F(8,-1,-1) = F(8,-1,-1)+2D0*(D1(2)+D2(2,3))*PRE
      endif

C       G(T6,N15,FULL)+G(T6,N16,FULL)
        CALL xD012345_(RMF2(1),MH2,S34,RMF2(2),S12,T11,CMF2(1),XMZ2,
     &  XMZ2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((ALPHA*PW34*XMW*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2))/
     &  (16D0*PI*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(4D0*D2(0,0))-2D0*D1(3)*(S23+
     &  S24)-D1(2)*(2D0*S23+2D0*S24+T11)+D1(1)*(MH2-2D0*S13-2D0*S14-
     &  T11))
        F(5,-1,-1) = F(5,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)+2D0*(D1(3)-2D0*D2(2,2)-2D0*D2(2,3))*
     &  PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE
        F(8,-1,-1) = F(8,-1,-1)+2D0*(D1(3)-2D0*D2(2,2)-2D0*D2(2,3))*
     &  PRE

C       G(T6,N18,FULL)+G(T6,N20,FULL)
        CALL xD012345_(RMF2(1),MH2,S34,RMF2(2),S12,T11,CMF2(2),XMW2,
     &  XMW2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((ALPHA*PW34*XMW*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2))/
     &  (16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(4D0*D2(0,0))-2D0*D1(3)*(S23+
     &  S24)+(D1(1)*(MH2*XCW2-2D0*S13*XCW2-2D0*S14*XCW2-T11*XCW2-
     &  MH2*XSW2+T11*XSW2))/XCW2-(D1(2)*(2D0*S23*XCW2+2D0*S24*XCW2+
     &  T11*XCW2-T11*XSW2))/XCW2)
        F(5,-1,-1) = F(5,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)+2D0*PRE*(-(2D0*D2(2,2))-2D0*D2(2,3)+
     &  (D1(3)*(XCW2+XSW2))/XCW2)
        F(7,-1,-1) = F(7,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE
        F(8,-1,-1) = F(8,-1,-1)+2D0*PRE*(-(2D0*D2(2,2))-2D0*D2(2,3)+
     &  (D1(3)*(XCW2+XSW2))/XCW2)

      if (qf(2).ne.0d0) then
C       G(T6,N17,FULL)+G(T6,N19,FULL)
        CALL xD012345_(RMF2(2),RMF2(1),MH2,S34,T11,S12,NULL,CMF2(2),
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = (QF(2)*ALPHA*PW34*XMW)/(4D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(2D0*D2(0,0))+D1(1)*(S23+S24)+
     &  D0*(S23+S24)-D1(3)*T11+D1(2)*(MH2-S13-S14+S23+S24-T11))
        F(5,-1,-1) = F(5,-1,-1)+2D0*(D1(2)+D2(2,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)+2D0*(D1(3)+D2(1,3)+D2(2,3))*PRE
        F(7,-1,-1) = F(7,-1,-1)+2D0*(D1(2)+D2(2,3))*PRE
        F(8,-1,-1) = F(8,-1,-1)+2D0*(D1(3)+D2(1,3)+D2(2,3))*PRE
      endif

C       G(T1,N4,FULL)+G(T1,N6,FULL)
        CALL xD012345_(RMF2(2),MH2,S34,RMF2(1),S12,T12,CMF2(1),XMW2,
     &  XMW2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((ALPHA*PW34*XMW*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2))/
     &  (16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(4D0*D2(0,0))-2D0*D1(3)*(S13+
     &  S14)+(D1(1)*(MH2*XCW2-2D0*S23*XCW2-2D0*S24*XCW2-T12*XCW2-
     &  MH2*XSW2+T12*XSW2))/XCW2-(D1(2)*(2D0*S13*XCW2+2D0*S14*XCW2+
     &  T12*XCW2-T12*XSW2))/XCW2)
        F(5,-1,-1) = F(5,-1,-1)+2D0*PRE*(-(2D0*D2(2,2))-2D0*D2(2,3)+
     &  (D1(3)*(XCW2+XSW2))/XCW2)
        F(6,-1,-1) = F(6,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)+2D0*PRE*(-(2D0*D2(2,2))-2D0*D2(2,3)+
     &  (D1(3)*(XCW2+XSW2))/XCW2)
        F(8,-1,-1) = F(8,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE

C       G(T1,N1,FULL)+G(T1,N2,FULL)
        CALL xD012345_(RMF2(2),MH2,S34,RMF2(1),S12,T12,CMF2(2),XMZ2,
     &  XMZ2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((ALPHA*PW34*XMW*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2))/
     &  (16D0*PI*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(4D0*D2(0,0))-2D0*D1(3)*(S13+
     &  S14)-D1(2)*(2D0*S13+2D0*S14+T12)+D1(1)*(MH2-2D0*S23-2D0*S24-
     &  T12))
        F(5,-1,-1) = F(5,-1,-1)+2D0*(D1(3)-2D0*D2(2,2)-2D0*D2(2,3))*
     &  PRE
        F(6,-1,-1) = F(6,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)+2D0*(D1(3)-2D0*D2(2,2)-2D0*D2(2,3))*
     &  PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE

C       G(T7,N23,FULL)+G(T7,N26,FULL)
        CALL xD012345_(RMF2(3),MH2,S12,RMF2(4),S34,T13,CMF2(3),XMZ2,
     &  XMZ2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((ALPHA*PW12*XMW*XSW2**(-2)*(1D0+2D0*QF(3)*XSW2))/
     &  (16D0*PI*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(4D0*D2(0,0))-2D0*D1(3)*(S14+
     &  S24)-D1(2)*(2D0*S14+2D0*S24+T13)+D1(1)*(MH2-2D0*S13-2D0*S23-
     &  T13))
        F(5,-1,-1) = F(5,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)+2D0*(D1(3)-2D0*D2(2,2)-2D0*D2(2,3))*
     &  PRE
        F(8,-1,-1) = F(8,-1,-1)+2D0*(D1(3)-2D0*D2(2,2)-2D0*D2(2,3))*
     &  PRE

C       G(T7,N22,FULL)+G(T7,N25,FULL)
        CALL xD012345_(RMF2(3),MH2,S12,RMF2(4),S34,T13,CMF2(4),XMW2,
     &  XMW2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((ALPHA*PW12*XMW*XSW2**(-2)*(1D0-2D0*QF(4)*XSW2))/
     &  (16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(4D0*D2(0,0))-2D0*D1(3)*(S14+
     &  S24)+(D1(1)*(MH2*XCW2-2D0*S13*XCW2-2D0*S23*XCW2-T13*XCW2-
     &  MH2*XSW2+T13*XSW2))/XCW2-(D1(2)*(2D0*S14*XCW2+2D0*S24*XCW2+
     &  T13*XCW2-T13*XSW2))/XCW2)
        F(5,-1,-1) = F(5,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)+2D0*PRE*(-(2D0*D2(2,2))-2D0*D2(2,3)+
     &  (D1(3)*(XCW2+XSW2))/XCW2)
        F(8,-1,-1) = F(8,-1,-1)+2D0*PRE*(-(2D0*D2(2,2))-2D0*D2(2,3)+
     &  (D1(3)*(XCW2+XSW2))/XCW2)

      if (qf(3).ne.0d0) then
C       G(T9,N30,FULL)+G(T9,N33,FULL)
        CALL xD012345_(RMF2(3),S12,MH2,RMF2(4),S34,T14,CMF2(3),NULL,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((QF(3)*ALPHA*PW12*XMW)/(4D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(2D0*D2(0,0)+D1(1)*(S13+S23)+
     &  D1(2)*(S13+S23+T14)-D1(3)*(MH2-S14-S24-T14))
        F(5,-1,-1) = F(5,-1,-1)+2D0*(D2(1,2)+D2(2,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)+2D0*(D2(1,2)+D2(2,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)-2D0*(D1(3)+D2(2,3))*PRE
        F(8,-1,-1) = F(8,-1,-1)-2D0*(D1(3)+D2(2,3))*PRE
      endif

C       G(T9,N31,FULL)+G(T9,N34,FULL)
        CALL xD012345_(RMF2(3),S12,MH2,RMF2(4),S34,T14,CMF2(3),XMZ2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = (ALPHA*PW12*XMW*XSW2**(-2)*(1D0+2D0*QF(3)*XSW2))/
     &  (16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE*(4D0*D2(0,0)+2D0*D1(1)*(S13+
     &  S23)-(D1(3)*(MH2*XCW2-2D0*S14*XCW2-2D0*S24*XCW2-T14*XCW2-
     &  MH2*XSW2+T14*XSW2))/XCW2+(D1(2)*(2D0*S13*XCW2+2D0*S23*XCW2+
     &  T14*XCW2-T14*XSW2))/XCW2)
        F(5,-1,-1) = F(5,-1,-1)-2D0*PRE*(-(2D0*D2(1,2))-2D0*D2(2,2)+
     &  (D1(1)*(XCW2+XSW2))/XCW2)
        F(6,-1,-1) = F(6,-1,-1)-2D0*PRE*(-(2D0*D2(1,2))-2D0*D2(2,2)+
     &  (D1(1)*(XCW2+XSW2))/XCW2)
        F(7,-1,-1) = F(7,-1,-1)-4D0*(D1(3)+D2(2,3))*PRE
        F(8,-1,-1) = F(8,-1,-1)-4D0*(D1(3)+D2(2,3))*PRE

C       G(T9,N32,FULL)+G(T9,N35,FULL)
        CALL xD012345_(RMF2(3),S12,MH2,RMF2(4),S34,T14,CMF2(4),XMW2,
     &  XMZ2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = (ALPHA*PW12*XMW*XSW2**(-2)*(1D0-2D0*QF(4)*XSW2))/
     &  (16D0*PI*XCW2*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE*(4D0*D2(0,0)+2D0*D1(1)*(S13+
     &  S23)+D1(2)*(2D0*S13+2D0*S23+T14)-D1(3)*(MH2-2D0*S14-2D0*S24-
     &  T14))
        F(5,-1,-1) = F(5,-1,-1)-2D0*(D1(1)-2D0*D2(1,2)-2D0*D2(2,2))*
     &  PRE
        F(6,-1,-1) = F(6,-1,-1)-2D0*(D1(1)-2D0*D2(1,2)-2D0*D2(2,2))*
     &  PRE
        F(7,-1,-1) = F(7,-1,-1)-4D0*(D1(3)+D2(2,3))*PRE
        F(8,-1,-1) = F(8,-1,-1)-4D0*(D1(3)+D2(2,3))*PRE

      if (qf(4).ne.0d0) then
C       G(T7,N21,FULL)+G(T7,N24,FULL)
        CALL xD012345_(RMF2(4),RMF2(3),MH2,S12,T13,S34,NULL,CMF2(4),
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((QF(4)*ALPHA*PW12*XMW)/(4D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(2D0*D2(0,0))+D1(1)*(S14+S24)+
     &  D0*(S14+S24)-D1(3)*T13+D1(2)*(MH2-S13+S14-S23+S24-T13))
        F(5,-1,-1) = F(5,-1,-1)+2D0*(D1(2)+D2(2,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)+2D0*(D1(2)+D2(2,3))*PRE
        F(7,-1,-1) = F(7,-1,-1)+2D0*(D1(3)+D2(1,3)+D2(2,3))*PRE
        F(8,-1,-1) = F(8,-1,-1)+2D0*(D1(3)+D2(1,3)+D2(2,3))*PRE
      endif

C       G(T5,N14,FULL)
        CALL xD012345_(S12,RMF2(3),MH2,RMF2(4),T13,T14,CMF2(4),
     &  CMF2(3),XMZ2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((ALPHA*PW12*XCW2**(-2)*XMW*XSW2**(-2)*(1D0+2D0*
     &  QF(3)*XSW2)*(1D0-2D0*QF(4)*XSW2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(2D0*D2(0,0)+D1(1)*S12+D1(2)*
     &  S12+D2(1,1)*S12+D2(1,2)*(2D0*S12+S13+S23)-D1(3)*(S14+S24)-
     &  D2(1,3)*(S14+S24)+D2(2,2)*T14-D2(2,3)*(MH2-T14))
        F(5,-1,-1) = F(5,-1,-1)-2D0*(D2(1,2)+D2(2,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)-2D0*(D2(1,2)+D2(2,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)+2D0*(D1(3)+D2(1,3)+D2(2,3))*PRE
        F(8,-1,-1) = F(8,-1,-1)+2D0*(D1(3)+D2(1,3)+D2(2,3))*PRE

C       G(T4,N13,FULL)
        CALL xD012345_(S34,RMF2(2),MH2,RMF2(1),T12,T11,CMF2(1),
     &  CMF2(2),XMZ2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((ALPHA*PW34*XCW2**(-2)*XMW*XSW2**(-2)*(1D0-2D0*
     &  QF(1)*XSW2)*(1D0+2D0*QF(2)*XSW2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(2D0*D2(0,0)-D1(3)*(S13+S14)-
     &  D2(1,3)*(S13+S14)+D1(1)*S34+D1(2)*S34+D2(1,1)*S34+D2(1,2)*
     &  (S23+S24+2D0*S34)+D2(2,2)*T11-D2(2,3)*(MH2-T11))
        F(5,-1,-1) = F(5,-1,-1)+2D0*(D1(3)+D2(1,3)+D2(2,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)-2D0*(D2(1,2)+D2(2,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)+2D0*(D1(3)+D2(1,3)+D2(2,3))*PRE
        F(8,-1,-1) = F(8,-1,-1)-2D0*(D2(1,2)+D2(2,2))*PRE

      end
