**********************************************************************
        subroutine  h0toWW4f_tree_thdm(F,pw12,pw34)
**********************************************************************
*       LO formfactors for h0 -> WW -> 4f in the THDM
*---------------------------------------------------------------------
*       24.4.16 Stefan Dittmaier
**********************************************************************
	implicit none
	complex*16 pre,F(13,-1:1,-1:1),pw12,pw34

c mandelstam variables
      	real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      	common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion charges of isospin duplets
	real*8 qf(4)
	common/fcharge/qf
c fermion masses as flag (i*1d-20)
      	complex*16 cme2,cmf2(5)
      	real*8 me2,rme2,mf2(5),rmf2(5)
      	common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
	include '../COMMON/param.inc'
	include '../COMMON/xparam.inc'
        include '../COMMON/param_thdm.inc'
        include '../COMMON/param_bsm.inc'

C       Process: S1F21aF22F23aF24,   Model: THDM

C       G(T1,N9,FULL)

        PRE = (PW12*PW34*SBA*XMW)/(2D0*XSW*XSW2) 

        F(1,-1,-1) = F(1,-1,-1)+PRE

	end

**********************************************************************
        subroutine  h0toWW4f_count_bos_thdm(F,pw12,pw34)
**********************************************************************
*       h0 -> WW -> 4f in the THDM
*	bosonic counterterms
*---------------------------------------------------------------------
*       27.5.16 Stefan Dittmaier
**********************************************************************
	implicit none
	complex*16 pre,F(13,-1:1,-1:1),pw12,pw34,ct

c mandelstam variables
      	real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      	common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion charges of isospin duplets
	real*8 qf(4)
	common/fcharge/qf
c fermion masses as flag (i*1d-20)
      	complex*16 cme2,cmf2(5)
      	real*8 me2,rme2,mf2(5),rmf2(5)
      	common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
	include '../COMMON/param.inc'
	include '../COMMON/xparam.inc'
        include '../COMMON/param_thdm.inc'
        include '../COMMON/param_bsm.inc'
c ren. constants
        complex*16 dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw
        complex*16 dmh02,dmHH2,dma02,dmhp2,dZh0,dZHH,dZh0HH,dZHHh0
        complex*16 dtb,dsa,dmh0HH2,dlam3,dlam5,dlam35
        complex*16 dZeer,dZeel,dZnnl,dZffr(4),dZffl(4)
        complex*16 ct_aww,ct_zww,ct_wen,ct_wf1f2,ct_wf3f4
        complex*16 ct_annl,ct_aeer,ct_aeel,ct_affr(4),ct_affl(4)
        complex*16 ct_znnl,ct_zeer,ct_zeel,ct_zffr(4),ct_zffl(4)
        complex*16 ct_h0ww,ct_HHww,ct_h0zz,ct_HHzz,ct_h0za,ct_HHza
        common/xrenc_thdm/
     &         dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,
     &         dmh02,dmHH2,dma02,dmhp2,dZh0,dZHH,dZh0HH,dZHHh0,
     &         dtb,dsa,dmh0HH2,dlam3,dlam5,
     &         dZeer,dZeel,dZnnl,dZffr,dZffl,
     &         ct_aww,ct_zww,ct_wen,ct_wf1f2,ct_wf3f4,
     &         ct_annl,ct_aeer,ct_aeel,ct_affr,ct_affl,
     &         ct_znnl,ct_zeer,ct_zeel,ct_zffr,ct_zffl,
     &         ct_h0ww,ct_HHww,ct_h0zz,ct_HHzz,ct_h0za,ct_HHza

c counterterms for self energies
      	ct =  dmw2/(s12-xmw2) - dZw
     &	     +dmw2/(s34-xmw2) - dZw

      	PRE = (PW12*PW34*SBA*XMW)/(2D0*XSW*XSW2) *ct

      	F(1,-1,-1) = F(1,-1,-1)+PRE

c Vff vertex counterterms
      	ct = ct_wf1f2 + ct_wf3f4

      	PRE = (PW12*PW34*SBA*XMW)/(2D0*XSW*XSW2) *ct 

      	F(1,-1,-1) = F(1,-1,-1)+PRE

c HVV vertex counterterm
      	ct = ct_h0ww 

      	PRE = (PW12*PW34*SBA*XMW)/(2D0*XSW*XSW2) *ct 

      	F(1,-1,-1) = F(1,-1,-1)+PRE

	end

**********************************************************************
        subroutine  h0toWW4f_count_ferm_thdm(F,pw12,pw34)
**********************************************************************
*       h0 -> WW -> 4f in the THDM
*	bosonic counterterms
*---------------------------------------------------------------------
*       27.5.16 Stefan Dittmaier
**********************************************************************
	implicit none
	complex*16 pre,F(13,-1:1,-1:1),pw12,pw34,ct

c mandelstam variables
      	real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      	common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion charges of isospin duplets
	real*8 qf(4)
	common/fcharge/qf
c fermion masses as flag (i*1d-20)
      	complex*16 cme2,cmf2(5)
      	real*8 me2,rme2,mf2(5),rmf2(5)
      	common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
	include '../COMMON/param.inc'
	include '../COMMON/xparam.inc'
        include '../COMMON/param_thdm.inc'
        include '../COMMON/param_bsm.inc'
c ren. constants
        complex*16 dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw
        complex*16 dmh02,dmHH2,dma02,dmhp2,dZh0,dZHH,dZh0HH,dZHHh0
        complex*16 dtb,dsa,dmh0HH2,dlam3,dlam5,dlam35
        complex*16 dZeer,dZeel,dZnnl,dZffr(4),dZffl(4)
        complex*16 ct_aww,ct_zww,ct_wen,ct_wf1f2,ct_wf3f4
        complex*16 ct_annl,ct_aeer,ct_aeel,ct_affr(4),ct_affl(4)
        complex*16 ct_znnl,ct_zeer,ct_zeel,ct_zffr(4),ct_zffl(4)
        complex*16 ct_h0ww,ct_HHww,ct_h0zz,ct_HHzz,ct_h0za,ct_HHza
        common/xrenc_ferm_thdm/
     &         dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,
     &         dmh02,dmHH2,dma02,dmhp2,dZh0,dZHH,dZh0HH,dZHHh0,
     &         dtb,dsa,dmh0HH2,dlam3,dlam5,
     &         dZeer,dZeel,dZnnl,dZffr,dZffl,
     &         ct_aww,ct_zww,ct_wen,ct_wf1f2,ct_wf3f4,
     &         ct_annl,ct_aeer,ct_aeel,ct_affr,ct_affl,
     &         ct_znnl,ct_zeer,ct_zeel,ct_zffr,ct_zffl,
     &         ct_h0ww,ct_HHww,ct_h0zz,ct_HHzz,ct_h0za,ct_HHza

c counterterms for self energies
      	ct =  dmw2/(s12-xmw2) - dZw
     &	     +dmw2/(s34-xmw2) - dZw

      	PRE = (PW12*PW34*SBA*XMW)/(2D0*XSW*XSW2) *ct

      	F(1,-1,-1) = F(1,-1,-1)+PRE

c Vff vertex counterterms
      	ct = ct_wf1f2 + ct_wf3f4

      	PRE = (PW12*PW34*SBA*XMW)/(2D0*XSW*XSW2) *ct 

      	F(1,-1,-1) = F(1,-1,-1)+PRE

c HVV vertex counterterm
      	ct = ct_h0ww 

      	PRE = (PW12*PW34*SBA*XMW)/(2D0*XSW*XSW2) *ct 

      	F(1,-1,-1) = F(1,-1,-1)+PRE

	end

**********************************************************************
        subroutine  h0toWW4f_self_bos2_thdm(F,pw12,pw34)
**********************************************************************
*       self-energy contributions for h0 -> WW -> 4f in the THDM
*       bosonic loops
*---------------------------------------------------------------------
*       24.4.16 Stefan Dittmaier
**********************************************************************
	implicit none
	complex*16 pre,F(13,-1:1,-1:1),pw12,pw34

c mandelstam variables
      	real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      	common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion charges of isospin duplets
	real*8 qf(4)
	common/fcharge/qf
c fermion masses as flag (i*1d-20)
      	complex*16 cme2,cmf2(5)
      	real*8 me2,rme2,mf2(5),rmf2(5)
      	common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
      	complex*16 fact,xseww_thdm
	include '../COMMON/param.inc'
	include '../COMMON/xparam.inc'
        include '../COMMON/param_thdm.inc'
        include '../COMMON/param_bsm.inc'

C       Process: S1F21aF22F23aF24,   Model: THDM

C       G(T1,N9,FULL)

        fact = - xseww_thdm(s12)*pw12 - xseww_thdm(s34)*pw34

        PRE = (PW12*PW34*SBA*XMW)/(2D0*XSW*XSW2) * fact

        F(1,-1,-1) = F(1,-1,-1)+PRE

	end

**********************************************************************
        subroutine  h0toWW4f_self_bos_thdm(F,pw12,pw34)
**********************************************************************
*       self-energy contributions for h0 -> WW -> 4f in the THDM
*       bosonic loops
*---------------------------------------------------------------------
*       24.4.16 Stefan Dittmaier
**********************************************************************
	implicit none
	complex*16 pre,F(13,-1:1,-1:1),pw12,pw34
	complex*16 A0,xA0_,B0_,xB0_,DB0_,xDB0_,B1_,xB1_,DB1_,xDB1_
        complex*16 B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 C0_,C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,2)
        complex*16 C4(0:2,0:2,0:2,0:2)
	complex*16 D0,D1(3),D2(0:3,0:3),D3(0:3,0:3,3)
        complex*16 D4(0:3,0:3,0:3,0:3),D5(0:3,0:3,0:3,0:3,3)
	complex*16 E0n,E1n(4),E2n(0:4,0:4),E3n(0:4,0:4,4)
	complex*16 E4n(0:4,0:4,0:4,0:4)

c mandelstam variables
      	real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      	common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion charges of isospin duplets
	real*8 qf(4)
	common/fcharge/qf
c fermion masses as flag (i*1d-20)
      	complex*16 cme2,cmf2(5)
      	real*8 me2,rme2,mf2(5),rmf2(5)
      	common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
	include '../COMMON/param.inc'
	include '../COMMON/xparam.inc'
        include '../COMMON/param_thdm.inc'
        include '../COMMON/param_bsm.inc'

C       Process: S1F21aF22F23aF24,   Model: THDM

C       G(T1,N109,FULL)
        A0 = xA0_(XMW2)

        PRE = -((A0*ALPHA*PW12**2*PW34*SBA*XMW*XSW2**(-2))/(16D0*PI*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T1,N110,FULL)
        A0 = xA0_(XMHP2)

        PRE = -((A0*ALPHA*PW12**2*PW34*SBA*XMW*XSW2**(-2))/(16D0*PI*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T1,N111,FULL)
        A0 = xA0_(XMH02)

        PRE = -((A0*ALPHA*PW12**2*PW34*SBA*XMW*XSW2**(-2))/(32D0*PI*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T1,N112,FULL)
        A0 = xA0_(XMHH2)

        PRE = -((A0*ALPHA*PW12**2*PW34*SBA*XMW*XSW2**(-2))/(32D0*PI*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T1,N113,FULL)
        A0 = xA0_(XMA02)

        PRE = -((A0*ALPHA*PW12**2*PW34*SBA*XMW*XSW2**(-2))/(32D0*PI*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T1,N114,FULL)
        A0 = xA0_(XMZ2)

        PRE = -((A0*ALPHA*PW12**2*PW34*SBA*XMW*XSW2**(-2))/(32D0*PI*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T1,N115,FULL)
        A0 = xA0_(XMW2)

        PRE = -((ALPHA*PW12**2*PW34*SBA*XMW*(3D0*A0-2D0*XMW2)*XSW2**
     &  (-2))/(8D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T1,N116,FULL)

C       G(T1,N117,FULL)
        A0 = xA0_(XMZ2)

        PRE = -((ALPHA*PW12**2*PW34*SBA*XCW2*XMW*(3D0*A0-2D0*XMZ2)*
     &  XSW2**(-2))/(8D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T2,N226,FULL)
        A0 = xA0_(XMW2)

        PRE = -((A0*ALPHA*PW12*PW34**2*SBA*XMW*XSW2**(-2))/(16D0*PI*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T2,N227,FULL)
        A0 = xA0_(XMHP2)

        PRE = -((A0*ALPHA*PW12*PW34**2*SBA*XMW*XSW2**(-2))/(16D0*PI*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T2,N228,FULL)
        A0 = xA0_(XMH02)

        PRE = -((A0*ALPHA*PW12*PW34**2*SBA*XMW*XSW2**(-2))/(32D0*PI*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T2,N229,FULL)
        A0 = xA0_(XMHH2)

        PRE = -((A0*ALPHA*PW12*PW34**2*SBA*XMW*XSW2**(-2))/(32D0*PI*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T2,N230,FULL)
        A0 = xA0_(XMA02)

        PRE = -((A0*ALPHA*PW12*PW34**2*SBA*XMW*XSW2**(-2))/(32D0*PI*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T2,N231,FULL)
        A0 = xA0_(XMZ2)

        PRE = -((A0*ALPHA*PW12*PW34**2*SBA*XMW*XSW2**(-2))/(32D0*PI*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T2,N232,FULL)
        A0 = xA0_(XMW2)

        PRE = -((ALPHA*PW12*PW34**2*SBA*XMW*(3D0*A0-2D0*XMW2)*XSW2**
     &  (-2))/(8D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T2,N233,FULL)

C       G(T2,N234,FULL)
        A0 = xA0_(XMZ2)

        PRE = -((ALPHA*PW12*PW34**2*SBA*XCW2*XMW*(3D0*A0-2D0*XMZ2)*
     &  XSW2**(-2))/(8D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T3,N359,FULL)

C       G(T3,N360,FULL)

C       G(T3,N361,FULL)

C       G(T3,N362,FULL)

C       G(T3,N363,FULL)

C       G(T3,N364,FULL)

C       G(T3,N365,FULL)

C       G(T3,N366,FULL)

C       G(T3,N367,FULL)

C       G(T3,N368,FULL)

C       G(T3,N369,FULL)

C       G(T3,N370,FULL)

C       G(T3,N371,FULL)

C       G(T3,N372,FULL)

C       G(T3,N469,FULL)

C       G(T3,N470,FULL)

C       G(T3,N471,FULL)

C       G(T3,N472,FULL)

C       G(T3,N473,FULL)

C       G(T3,N474,FULL)

C       G(T3,N603,FULL)
        CALL xB012345_(S12,XMW2,XMH02,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (B2(0,0)*ALPHA*PW12**2*PW34*SBA**3*XMW*XSW2**(-2))/
     &  (8D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T3,N604,FULL)
        CALL xB012345_(S12,XMW2,XMHH2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (B2(0,0)*ALPHA*CBA**2*PW12**2*PW34*SBA*XMW*XSW2**(-
     &  2))/(8D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T3,N605,FULL)
        CALL xB012345_(S12,XMW2,XMZ2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (B2(0,0)*ALPHA*PW12**2*PW34*SBA*XMW*XSW2**(-2))/(8D0*
     &  PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T3,N606,FULL)
        CALL xB012345_(S12,NULL,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12**2*PW34*SBA*XMW*XMW2)/(8D0*PI*XSW*
     &  XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T3,N607,FULL)
        CALL xB012345_(S12,XMW2,XMZ2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12**2*PW34*SBA*XMW*XMZ2)/(8D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T3,N608,FULL)
        CALL xB012345_(S12,XMH02,XMHP2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (B2(0,0)*ALPHA*CBA**2*PW12**2*PW34*SBA*XMW*XSW2**(-
     &  2))/(8D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T3,N609,FULL)
        CALL xB012345_(S12,XMHH2,XMHP2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (B2(0,0)*ALPHA*PW12**2*PW34*SBA**3*XMW*XSW2**(-2))/
     &  (8D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T3,N610,FULL)
        CALL xB012345_(S12,XMHP2,XMA02,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (B2(0,0)*ALPHA*PW12**2*PW34*SBA*XMW*XSW2**(-2))/(8D0*
     &  PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T3,N611,FULL)
        CALL xB012345_(S12,XMW2,XMH02,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12**2*PW34*SBA**3*XMW*XMW2*XSW2**(-2))/
     &  (8D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T3,N612,FULL)
        CALL xB012345_(S12,XMW2,XMHH2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*CBA**2*PW12**2*PW34*SBA*XMW*XMW2*XSW2**(-
     &  2))/(8D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T3,N613,FULL)
        CALL xB012345_(S12,XMW2,XMZ2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = -((B2(0,0)*ALPHA*PW12**2*PW34*SBA*XCW2*XMW*XSW2**(-
     &  2))/(8D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T3,N614,FULL)
        CALL xB012345_(S12,NULL,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = -((B2(0,0)*ALPHA*PW12**2*PW34*SBA*XMW)/(8D0*PI*XSW*
     &  XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T3,N615,FULL)
        CALL xB012345_(S12,XMW2,XMZ2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = -((B2(0,0)*ALPHA*PW12**2*PW34*SBA*XCW2*XMW*XSW2**(-
     &  2))/(8D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T3,N616,FULL)
        CALL xB012345_(S12,NULL,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = -((B2(0,0)*ALPHA*PW12**2*PW34*SBA*XMW)/(8D0*PI*XSW*
     &  XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T3,N617,FULL)
        CALL xB012345_(S12,NULL,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*PW12**2*PW34*SBA*XMW*(18D0*B2(0,0)+S12+2D0*
     &  B1(1)*S12+2D0*B2(1,1)*S12+5D0*B0*S12-3D0*XMW2))/(8D0*PI*XSW*
     &  XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T3,N618,FULL)
        CALL xB012345_(S12,XMW2,XMZ2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*PW12**2*PW34*SBA*XCW2*XMW*(18D0*B2(0,0)+S12+
     &  2D0*B1(1)*S12+2D0*B2(1,1)*S12+5D0*B0*S12-3D0*XMW2-3D0*XMZ2)*
     &  XSW2**(-2))/(8D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T4,N743,FULL)

C       G(T4,N744,FULL)

C       G(T4,N745,FULL)

C       G(T4,N746,FULL)

C       G(T4,N747,FULL)

C       G(T4,N748,FULL)

C       G(T4,N749,FULL)

C       G(T4,N750,FULL)

C       G(T4,N751,FULL)

C       G(T4,N752,FULL)

C       G(T4,N753,FULL)

C       G(T4,N754,FULL)

C       G(T4,N755,FULL)

C       G(T4,N756,FULL)

C       G(T4,N853,FULL)

C       G(T4,N854,FULL)

C       G(T4,N855,FULL)

C       G(T4,N856,FULL)

C       G(T4,N857,FULL)

C       G(T4,N858,FULL)

C       G(T4,N987,FULL)
        CALL xB012345_(S34,XMW2,XMH02,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (B2(0,0)*ALPHA*PW12*PW34**2*SBA**3*XMW*XSW2**(-2))/
     &  (8D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T4,N988,FULL)
        CALL xB012345_(S34,XMW2,XMHH2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (B2(0,0)*ALPHA*CBA**2*PW12*PW34**2*SBA*XMW*XSW2**(-
     &  2))/(8D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T4,N989,FULL)
        CALL xB012345_(S34,XMW2,XMZ2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (B2(0,0)*ALPHA*PW12*PW34**2*SBA*XMW*XSW2**(-2))/(8D0*
     &  PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T4,N990,FULL)
        CALL xB012345_(S34,NULL,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12*PW34**2*SBA*XMW*XMW2)/(8D0*PI*XSW*
     &  XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T4,N991,FULL)
        CALL xB012345_(S34,XMW2,XMZ2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12*PW34**2*SBA*XMW*XMZ2)/(8D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T4,N992,FULL)
        CALL xB012345_(S34,XMHP2,XMH02,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (B2(0,0)*ALPHA*CBA**2*PW12*PW34**2*SBA*XMW*XSW2**(-
     &  2))/(8D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T4,N993,FULL)
        CALL xB012345_(S34,XMHP2,XMHH2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (B2(0,0)*ALPHA*PW12*PW34**2*SBA**3*XMW*XSW2**(-2))/
     &  (8D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T4,N994,FULL)
        CALL xB012345_(S34,XMHP2,XMA02,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (B2(0,0)*ALPHA*PW12*PW34**2*SBA*XMW*XSW2**(-2))/(8D0*
     &  PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T4,N995,FULL)
        CALL xB012345_(S34,XMW2,XMH02,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12*PW34**2*SBA**3*XMW*XMW2*XSW2**(-2))/
     &  (8D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T4,N996,FULL)
        CALL xB012345_(S34,XMW2,XMHH2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*CBA**2*PW12*PW34**2*SBA*XMW*XMW2*XSW2**(-
     &  2))/(8D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T4,N997,FULL)
        CALL xB012345_(S34,XMW2,XMZ2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = -((B2(0,0)*ALPHA*PW12*PW34**2*SBA*XCW2*XMW*XSW2**(-
     &  2))/(8D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T4,N998,FULL)
        CALL xB012345_(S34,NULL,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = -((B2(0,0)*ALPHA*PW12*PW34**2*SBA*XMW)/(8D0*PI*XSW*
     &  XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T4,N999,FULL)
        CALL xB012345_(S34,XMW2,XMZ2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = -((B2(0,0)*ALPHA*PW12*PW34**2*SBA*XCW2*XMW*XSW2**(-
     &  2))/(8D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T4,N1000,FULL)
        CALL xB012345_(S34,NULL,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = -((B2(0,0)*ALPHA*PW12*PW34**2*SBA*XMW)/(8D0*PI*XSW*
     &  XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T4,N1001,FULL)
        CALL xB012345_(S34,NULL,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*PW12*PW34**2*SBA*XMW*(18D0*B2(0,0)+S34+2D0*
     &  B1(1)*S34+2D0*B2(1,1)*S34+5D0*B0*S34-3D0*XMW2))/(8D0*PI*XSW*
     &  XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T4,N1002,FULL)
        CALL xB012345_(S34,XMW2,XMZ2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*PW12*PW34**2*SBA*XCW2*XMW*(18D0*B2(0,0)+S34+
     &  2D0*B1(1)*S34+2D0*B2(1,1)*S34+5D0*B0*S34-3D0*XMW2-3D0*XMZ2)*
     &  XSW2**(-2))/(8D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

	end

**********************************************************************
        subroutine  h0toWW4f_vert_bos_thdm(F,pw12,pw34)
**********************************************************************
*       vertex corrections for h0 -> WW -> 4f in the THDM
*       bosonic loops
*---------------------------------------------------------------------
*       24.4.16 Stefan Dittmaier
**********************************************************************
	implicit none
	complex*16 pre,F(13,-1:1,-1:1),pw12,pw34
	complex*16 A0,xA0_,B0_,xB0_,DB0_,xDB0_,B1_,xB1_,DB1_,xDB1_
        complex*16 B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 C0_,C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,2)
        complex*16 C4(0:2,0:2,0:2,0:2)
	complex*16 D0,D1(3),D2(0:3,0:3),D3(0:3,0:3,3)
        complex*16 D4(0:3,0:3,0:3,0:3),D5(0:3,0:3,0:3,0:3,3)
	complex*16 E0n,E1n(4),E2n(0:4,0:4),E3n(0:4,0:4,4)
	complex*16 E4n(0:4,0:4,0:4,0:4)
        COMPLEX*16 K(1)

c mandelstam variables
      	real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      	common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion charges of isospin duplets
	real*8 qf(4)
	common/fcharge/qf
c fermion masses as flag (i*1d-20)
      	complex*16 cme2,cmf2(5)
      	real*8 me2,rme2,mf2(5),rmf2(5)
      	common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
	include '../COMMON/param.inc'
	include '../COMMON/xparam.inc'
        include '../COMMON/param_thdm.inc'
        include '../COMMON/param_bsm.inc'

C       Process: S1F21aF22F23aF24,   Model: THDM

C       G(T1,N50,FULL)

C       G(T1,N53,FULL)

C       G(T1,N55,FULL)

C       G(T1,N56,FULL)

C       G(T1,N57,FULL)

C       G(T1,N58,FULL)

C       G(T1,N118,FULL)

C       G(T1,N121,FULL)

C       G(T1,N123,FULL)

C       G(T1,N124,FULL)

C       G(T1,N125,FULL)

C       G(T1,N126,FULL)

C       G(T1,N127,FULL)

C       G(T1,N128,FULL)

C       G(T1,N130,FULL)

C       G(T1,N132,FULL)

C       G(T1,N191,FULL)

C       G(T1,N194,FULL)

C       G(T1,N197,FULL)

C       G(T1,N198,FULL)

C       G(T1,N199,FULL)
        CALL xC01234_(RMF2(2),RMF2(1),S12,NULL,CMF2(2),XMW2,C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,1)

        PRE = (QF(2)*ALPHA*PW12*PW34*(1D0-6D0*C2(0,0)-C1(1)*S12-
     &  C1(2)*S12-C2(1,2)*S12-C2(2,2)*S12-C0*S12)*SBA*XMW)/(4D0*PI*
     &  XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T1,N200,FULL)
        CALL xC01234_(RMF2(1),S12,RMF2(2),CMF2(2),XMW2,XMZ2,C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,1)

        PRE = -((ALPHA*PW12*PW34*(1D0-6D0*C2(0,0)+C1(1)*S12+C1(2)*
     &  S12+C2(1,2)*S12)*SBA*XMW*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2))/
     &  (8D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T1,N202,FULL)
        CALL xC01234_(RMF2(1),S12,RMF2(2),CMF2(1),NULL,XMW2,C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,1)

        PRE = -((QF(1)*ALPHA*PW12*PW34*(1D0-6D0*C2(0,0)+C1(1)*S12+
     &  C1(2)*S12+C2(1,2)*S12)*SBA*XMW)/(4D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T1,N204,FULL)
        CALL xC01234_(RMF2(1),S12,RMF2(2),CMF2(1),XMZ2,XMW2,C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,1)

        PRE = -((ALPHA*PW12*PW34*(1D0-6D0*C2(0,0)+C1(1)*S12+C1(2)*
     &  S12+C2(1,2)*S12)*SBA*XMW*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2))/
     &  (8D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T1,N253,FULL)

C       G(T1,N254,FULL)

C       G(T1,N255,FULL)

C       G(T1,N256,FULL)

C       G(T1,N257,FULL)
        CALL xC01234_(RMF2(2),S12,RMF2(1),NULL,CMF2(2),CMF2(1),C0,C1,C2,
     &  C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((QF(1)*QF(2)*ALPHA*PW12*PW34*(1D0-2D0*C2(0,0)+C1(1)*
     &  S12+C1(2)*S12+C2(1,2)*S12+C0*S12)*SBA*XMW)/(4D0*PI*XSW*
     &  XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T1,N258,FULL)
        CALL xC01234_(S12,RMF2(1),RMF2(2),CMF2(2),CMF2(1),XMZ2,C0,C1,C2,
     &  C3,C4,B0,B1,B2,B3,2,1)

        PRE = (ALPHA*PW12*PW34*(1D0-2D0*C2(0,0)-C1(1)*S12-C1(2)*S12-
     &  C2(1,1)*S12-C2(1,2)*S12)*SBA*XMW*XSW2**(-2)*(1D0-2D0*QF(1)*
     &  XSW2)*(1D0+2D0*QF(2)*XSW2))/(16D0*PI*XCW2*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T2,N313,FULL)

C       G(T2,N316,FULL)

C       G(T2,N319,FULL)

C       G(T2,N320,FULL)

C       G(T2,N321,FULL)

C       G(T2,N322,FULL)

C       G(T2,N324,FULL)

C       G(T2,N326,FULL)

C       G(T2,N339,FULL)

C       G(T2,N340,FULL)

C       G(T2,N341,FULL)

C       G(T2,N342,FULL)

C       G(T2,N343,FULL)

C       G(T2,N344,FULL)

C       G(T3,N399,FULL)

C       G(T3,N402,FULL)

C       G(T3,N405,FULL)

C       G(T3,N406,FULL)

C       G(T3,N407,FULL)

C       G(T3,N408,FULL)

C       G(T3,N410,FULL)

C       G(T3,N412,FULL)

C       G(T3,N425,FULL)

C       G(T3,N426,FULL)

C       G(T3,N427,FULL)

C       G(T3,N428,FULL)

C       G(T3,N429,FULL)

C       G(T3,N430,FULL)

C       G(T4,N475,FULL)

C       G(T4,N476,FULL)

C       G(T4,N477,FULL)

C       G(T4,N478,FULL)

C       G(T4,N479,FULL)

C       G(T4,N480,FULL)

C       G(T4,N481,FULL)

C       G(T4,N482,FULL)

C       G(T4,N483,FULL)

C       G(T4,N484,FULL)

C       G(T4,N491,FULL)

C       G(T4,N492,FULL)

C       G(T4,N493,FULL)
        CALL xC01234_(T12,MH02,RMF2(2),CMF2(2),XMZ2,XMZ2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(1)*ALPHA*PW34*SBA*XMZ*XSW2**(-2)*(1D0+2D0*QF(2)*
     &  XSW2)**2)/(16D0*PI*XCW*XCW2*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T4,N496,FULL)
        CALL xC01234_(RMF2(2),MH02,T12,CMF2(1),XMW2,XMW2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(2)*ALPHA*PW34*SBA*XMW*XSW2**(-2))/(8D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T4,N505,FULL)

C       G(T4,N518,FULL)

C       G(T4,N519,FULL)

C       G(T4,N520,FULL)

C       G(T4,N521,FULL)

C       G(T4,N522,FULL)

C       G(T4,N523,FULL)

C       G(T5,N574,FULL)

C       G(T5,N575,FULL)

C       G(T5,N576,FULL)

C       G(T5,N577,FULL)

C       G(T5,N578,FULL)

C       G(T5,N579,FULL)

C       G(T5,N580,FULL)

C       G(T5,N581,FULL)

C       G(T5,N582,FULL)

C       G(T5,N583,FULL)

C       G(T5,N586,FULL)
        CALL xC01234_(RMF2(1),MH02,T11,CMF2(2),XMW2,XMW2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(2)*ALPHA*PW34*SBA*XMW*XSW2**(-2))/(8D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T5,N587,FULL)

C       G(T5,N588,FULL)

C       G(T5,N589,FULL)
        CALL xC01234_(RMF2(1),MH02,T11,CMF2(1),XMZ2,XMZ2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(2)*ALPHA*PW34*SBA*XMZ*XSW2**(-2)*(1D0-2D0*QF(1)*
     &  XSW2)**2)/(16D0*PI*XCW*XCW2*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T5,N598,FULL)

C       G(T5,N611,FULL)

C       G(T5,N612,FULL)

C       G(T5,N613,FULL)

C       G(T5,N614,FULL)

C       G(T5,N615,FULL)

C       G(T5,N616,FULL)

C       G(T6,N633,FULL)

C       G(T6,N634,FULL)

C       G(T6,N635,FULL)

C       G(T6,N636,FULL)

C       G(T6,N637,FULL)

C       G(T6,N638,FULL)

C       G(T6,N648,FULL)

C       G(T6,N650,FULL)

C       G(T6,N677,FULL)

C       G(T6,N680,FULL)

C       G(T6,N689,FULL)

C       G(T6,N690,FULL)

C       G(T6,N691,FULL)

C       G(T6,N692,FULL)

C       G(T7,N753,FULL)

C       G(T7,N754,FULL)

C       G(T7,N755,FULL)

C       G(T7,N756,FULL)

C       G(T7,N757,FULL)

C       G(T7,N758,FULL)

C       G(T7,N759,FULL)

C       G(T7,N760,FULL)

C       G(T7,N761,FULL)

C       G(T7,N762,FULL)

C       G(T7,N765,FULL)
        CALL xC01234_(RMF2(3),MH02,T13,CMF2(4),XMW2,XMW2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(2)*ALPHA*PW12*SBA*XMW*XSW2**(-2))/(8D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T7,N766,FULL)

C       G(T7,N767,FULL)

C       G(T7,N768,FULL)
        CALL xC01234_(T13,MH02,RMF2(3),CMF2(3),XMZ2,XMZ2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(1)*ALPHA*PW12*SBA*XMZ*XSW2**(-2)*(1D0+2D0*QF(3)*
     &  XSW2)**2)/(16D0*PI*XCW*XCW2*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T7,N777,FULL)

C       G(T7,N790,FULL)

C       G(T7,N791,FULL)

C       G(T7,N792,FULL)

C       G(T7,N793,FULL)

C       G(T7,N794,FULL)

C       G(T7,N795,FULL)

C       G(T8,N814,FULL)

C       G(T8,N815,FULL)

C       G(T8,N816,FULL)

C       G(T8,N817,FULL)

C       G(T8,N818,FULL)

C       G(T8,N819,FULL)

C       G(T8,N827,FULL)

C       G(T8,N829,FULL)

C       G(T8,N856,FULL)

C       G(T8,N859,FULL)

C       G(T8,N868,FULL)

C       G(T8,N869,FULL)

C       G(T8,N870,FULL)

C       G(T8,N871,FULL)

C       G(T9,N974,FULL)
        CALL xC01234_(S12,MH02,S34,XMHP2,XMA02,XMA02,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)

        PRE = -((PI**(-2)*PW12*PW34*XSW2**(-2)*(4D0*ALPHA*C2B*CBA*
     &  MA02*PI-4D0*ALPHA*CA*CB**3*MH02*PI+4D0*ALPHA*MH02*PI*SA*SB**
     &  3+4D0*CAB*LAM5*XMW2*XSW2))/(64D0*CB*SB*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE

C       G(T9,N975,FULL)
        CALL xC01234_(S12,MH02,S34,XMW2,XMZ2,XMZ2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)

        PRE = (ALPHA*MH02*PW12*PW34*SBA*XSW2**(-2))/(16D0*PI*XMW*
     &  XSW)

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE

C       G(T9,N976,FULL)
        CALL xC01234_(S12,MH02,S34,XMW2,XMZ2,XMZ2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)

        PRE = (ALPHA*PW12*PW34*SBA*XMZ)/(16D0*PI*XCW*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(-(2D0*C1(2))-C2(1,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)+(-(2D0*C1(2))-C2(1,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)+(-(2D0*C1(2))-C2(1,2))*PRE
        F(8,-1,-1) = F(8,-1,-1)+(-(2D0*C1(2))-C2(1,2))*PRE

C       G(T9,N977,FULL)
        CALL xC01234_(S12,MH02,S34,XMW2,XMZ2,XMZ2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)

        PRE = -((ALPHA*PW12*PW34*SBA*XCW*XMZ*XSW2**(-2))/(16D0*PI*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE

C       G(T9,N978,FULL)
        CALL xC01234_(S12,MH02,S34,XMW2,XMZ2,XMZ2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)

        PRE = -((ALPHA*PW12*PW34*SBA*XCW*XMZ*XSW2**(-2))/(16D0*PI*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE

C       G(T9,N979,FULL)
        CALL xC01234_(S12,MH02,S34,XMW2,XMZ2,XMZ2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)

        PRE = (ALPHA*PW12*PW34*SBA*XMZ)/(16D0*PI*XCW*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(-(2D0*C1(1))-C2(1,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)+(-(2D0*C1(1))-C2(1,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)+(-(2D0*C1(1))-C2(1,2))*PRE
        F(8,-1,-1) = F(8,-1,-1)+(-(2D0*C1(1))-C2(1,2))*PRE

C       G(T9,N1072,FULL)
        CALL xC01234_(S12,MH02,S34,XMH02,XMW2,XMHP2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)

        PRE = (ALPHA*CBA**2*(MH02-MHP2)*PW12*PW34*SBA*XSW2**(-2))/
     &  (16D0*PI*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE

C       G(T9,N1073,FULL)
        CALL xC01234_(S12,MH02,S34,XMHH2,XMW2,XMHP2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)

        PRE = -((ALPHA*CBA**2*(MH02-MHP2)*PW12*PW34*SBA*XSW2**(-2))/
     &  (16D0*PI*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE

C       G(T9,N1074,FULL)
        CALL xC01234_(S12,MH02,S34,XMH02,XMHP2,XMW2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)

        PRE = (ALPHA*CBA**2*(MH02-MHP2)*PW12*PW34*SBA*XSW2**(-2))/
     &  (16D0*PI*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE

C       G(T9,N1075,FULL)
        CALL xC01234_(S12,MH02,S34,XMHH2,XMHP2,XMW2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)

        PRE = -((ALPHA*CBA**2*(MH02-MHP2)*PW12*PW34*SBA*XSW2**(-2))/
     &  (16D0*PI*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE

C       G(T9,N1076,FULL)
        CALL xC01234_(S12,MH02,S34,XMH02,XMHP2,XMW2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)

        PRE = (ALPHA*CBA**2*PW12*PW34*SBA*XMW*XSW2**(-2))/(16D0*PI*
     &  XSW)

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(-(2D0*C1(2))-C2(1,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)+(-(2D0*C1(2))-C2(1,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)+(-(2D0*C1(2))-C2(1,2))*PRE
        F(8,-1,-1) = F(8,-1,-1)+(-(2D0*C1(2))-C2(1,2))*PRE

C       G(T9,N1077,FULL)
        CALL xC01234_(S12,MH02,S34,XMHH2,XMHP2,XMW2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)

        PRE = -((ALPHA*CBA**2*PW12*PW34*SBA*XMW*XSW2**(-2))/(16D0*
     &  PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(-(2D0*C1(2))-C2(1,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)+(-(2D0*C1(2))-C2(1,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)+(-(2D0*C1(2))-C2(1,2))*PRE
        F(8,-1,-1) = F(8,-1,-1)+(-(2D0*C1(2))-C2(1,2))*PRE

C       G(T9,N1078,FULL)
        CALL xC01234_(S12,MH02,S34,XMZ2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)

        PRE = -((ALPHA*PW12*PW34*SBA*XCW2*XMW*XSW2**(-2))/(16D0*PI*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE

C       G(T9,N1079,FULL)
        CALL xC01234_(S12,MH02,S34,NULL,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)

        PRE = -((ALPHA*PW12*PW34*SBA*XMW)/(16D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE

C       G(T9,N1080,FULL)
        CALL xC01234_(S12,MH02,S34,NULL,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)

        PRE = -((ALPHA*PW12*PW34*SBA*XMW)/(16D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE

C       G(T9,N1081,FULL)
        CALL xC01234_(S12,MH02,S34,XMZ2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)

        PRE = -((ALPHA*PW12*PW34*SBA*XCW2*XMW*XSW2**(-2))/(16D0*PI*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE

C       G(T9,N1082,FULL)
        CALL xC01234_(S12,MH02,S34,XMH02,XMW2,XMHP2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)

        PRE = (ALPHA*CBA**2*PW12*PW34*SBA*XMW*XSW2**(-2))/(16D0*PI*
     &  XSW)

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(-(2D0*C1(1))-C2(1,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)+(-(2D0*C1(1))-C2(1,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)+(-(2D0*C1(1))-C2(1,2))*PRE
        F(8,-1,-1) = F(8,-1,-1)+(-(2D0*C1(1))-C2(1,2))*PRE

C       G(T9,N1083,FULL)
        CALL xC01234_(S12,MH02,S34,XMHH2,XMW2,XMHP2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)

        PRE = -((ALPHA*CBA**2*PW12*PW34*SBA*XMW*XSW2**(-2))/(16D0*
     &  PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(-(2D0*C1(1))-C2(1,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)+(-(2D0*C1(1))-C2(1,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)+(-(2D0*C1(1))-C2(1,2))*PRE
        F(8,-1,-1) = F(8,-1,-1)+(-(2D0*C1(1))-C2(1,2))*PRE

C       G(T9,N1084,FULL)
        CALL xC01234_(S12,MH02,S34,XMW2,XMZ2,XMZ2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,0,0)

        PRE = -((ALPHA*C0*PW12*PW34*SBA*XMZ*XMZ2)/(8D0*PI*XCW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T9,N1085,FULL)
        CALL xC01234_(S12,MH02,S34,XMW2,XMZ2,XMZ2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = -(C1(1))-C1(2)-10D0*C2(1,2)+4D0*C0

        PRE = -((ALPHA*PW12*PW34*SBA*XCW*XMZ*XSW2**(-2))/(16D0*PI*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(6D0-36D0*C2(0,0)-4D0*C2(1,1)*
     &  S12+4D0*C2(1,2)*(S13+S14+S23+S24)+5D0*C0*(S13+S14+S23+S24)-
     &  C1(1)*(2D0*S12-S13-S14-S23-S24)-4D0*C2(2,2)*S34+C1(2)*(S13+
     &  S14+S23+S24-2D0*S34))
        F(5,-1,-1) = F(5,-1,-1)-2D0*K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)-2D0*K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)-2D0*K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)-2D0*K(1)*PRE

C       G(T9,N1227,FULL)
        CALL xC01234_(S12,MH02,S34,XMH02,XMHP2,XMHP2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)

        PRE = -((CBA**2*PI**(-2)*PW12*PW34*XSW2**(-2)*(4D0*ALPHA*
     &  CAB*MA02*PI-4D0*ALPHA*CA*CB**3*MH02*PI+4D0*ALPHA*MH02*PI*SA*
     &  SB**3-8D0*ALPHA*CB*MHP2*PI*SB*SBA+4D0*CAB*LAM5*XMW2*XSW2))/
     &  (64D0*CB*SB*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE

C       G(T9,N1228,FULL)
        CALL xC01234_(S12,MH02,S34,XMHH2,XMHP2,XMHP2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)

        PRE = -((PI**(-2)*PW12*PW34*SBA**2*XSW2**(-2)*(4D0*ALPHA*
     &  CAB*MA02*PI-4D0*ALPHA*CA*CB**3*MH02*PI+4D0*ALPHA*MH02*PI*SA*
     &  SB**3-8D0*ALPHA*CB*MHP2*PI*SB*SBA+4D0*CAB*LAM5*XMW2*XSW2))/
     &  (64D0*CB*SB*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE

C       G(T9,N1229,FULL)
        CALL xC01234_(S12,MH02,S34,XMA02,XMHP2,XMHP2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)

        PRE = -((PI**(-2)*PW12*PW34*XSW2**(-2)*(4D0*ALPHA*CAB*MA02*
     &  PI-4D0*ALPHA*CA*CB**3*MH02*PI+4D0*ALPHA*MH02*PI*SA*SB**3-
     &  8D0*ALPHA*CB*MHP2*PI*SB*SBA+4D0*CAB*LAM5*XMW2*XSW2))/(64D0*
     &  CB*SB*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE

C       G(T9,N1230,FULL)
        CALL xC01234_(S12,MH02,S34,XMHP2,XMH02,XMH02,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)

        PRE = -((3D0*CBA**2*PI**(-2)*PW12*PW34*XSW2**(-2)*(16D0*
     &  ALPHA*CAB*CBA**2*MA02*PI-12D0*ALPHA*CAB*MH02*PI-4D0*ALPHA*
     &  C2A*CBA*MH02*PI-4D0*ALPHA*MH02*PI*S2A*SBA+16D0*CAB*CBA**2*
     &  LAM5*XMW2*XSW2))/(256D0*CB*SB*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE

C       G(T9,N1231,FULL)
        CALL xC01234_(S12,MH02,S34,XMW2,XMH02,XMH02,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)

        PRE = -((3D0*PI**(-2)*PW12*PW34*SBA**2*XSW2**(-2)*(16D0*
     &  ALPHA*CAB*CBA**2*MA02*PI-12D0*ALPHA*CAB*MH02*PI-4D0*ALPHA*
     &  C2A*CBA*MH02*PI-4D0*ALPHA*MH02*PI*S2A*SBA+16D0*CAB*CBA**2*
     &  LAM5*XMW2*XSW2))/(256D0*CB*SB*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE

C       G(T9,N1232,FULL)
        CALL xC01234_(S12,MH02,S34,XMW2,XMH02,XMH02,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,0,0)

        PRE = (3D0*C0*PI**(-2)*PW12*PW34*SBA**2*XMW*XSW2**(-2)*
     &  (16D0*ALPHA*CAB*CBA**2*MA02*PI-12D0*ALPHA*CAB*MH02*PI-4D0*
     &  ALPHA*C2A*CBA*MH02*PI-4D0*ALPHA*MH02*PI*S2A*SBA+16D0*CAB*
     &  CBA**2*LAM5*XMW2*XSW2))/(256D0*CB*SB*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T9,N1233,FULL)
        CALL xC01234_(S12,MH02,S34,XMHP2,XMH02,XMHH2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)

        PRE = (CBA*PI**(-2)*PW12*PW34*SBA*XSW2**(-2)*(12D0*ALPHA*
     &  CBA*MA02*PI*S2A-16D0*ALPHA*CBA*MH02*PI*S2A-8D0*ALPHA*CBA*
     &  MHH2*PI*S2A-4D0*ALPHA*CBA*MA02*PI*S2B+8D0*ALPHA*MA02*PI*SAB-
     &  12D0*ALPHA*C2A*MA02*PI*SBA-4D0*ALPHA*C2B*MA02*PI*SBA+12D0*
     &  CBA*LAM5*S2A*XMW2*XSW2-4D0*CBA*LAM5*S2B*XMW2*XSW2+8D0*LAM5*
     &  SAB*XMW2*XSW2-12D0*C2A*LAM5*SBA*XMW2*XSW2-4D0*C2B*LAM5*SBA*
     &  XMW2*XSW2))/(256D0*CB*SB*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE

C       G(T9,N1234,FULL)
        CALL xC01234_(S12,MH02,S34,XMW2,XMH02,XMHH2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)

        PRE = -((CBA*PI**(-2)*PW12*PW34*SBA*XSW2**(-2)*(12D0*ALPHA*
     &  CBA*MA02*PI*S2A-16D0*ALPHA*CBA*MH02*PI*S2A-8D0*ALPHA*CBA*
     &  MHH2*PI*S2A-4D0*ALPHA*CBA*MA02*PI*S2B+8D0*ALPHA*MA02*PI*SAB-
     &  12D0*ALPHA*C2A*MA02*PI*SBA-4D0*ALPHA*C2B*MA02*PI*SBA+12D0*
     &  CBA*LAM5*S2A*XMW2*XSW2-4D0*CBA*LAM5*S2B*XMW2*XSW2+8D0*LAM5*
     &  SAB*XMW2*XSW2-12D0*C2A*LAM5*SBA*XMW2*XSW2-4D0*C2B*LAM5*SBA*
     &  XMW2*XSW2))/(256D0*CB*SB*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE

C       G(T9,N1235,FULL)
        CALL xC01234_(S12,MH02,S34,XMW2,XMH02,XMHH2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,0,0)

        PRE = (C0*CBA*PI**(-2)*PW12*PW34*SBA*XMW*XSW2**(-2)*(12D0*
     &  ALPHA*CBA*MA02*PI*S2A-16D0*ALPHA*CBA*MH02*PI*S2A-8D0*ALPHA*
     &  CBA*MHH2*PI*S2A-4D0*ALPHA*CBA*MA02*PI*S2B+8D0*ALPHA*MA02*PI*
     &  SAB-12D0*ALPHA*C2A*MA02*PI*SBA-4D0*ALPHA*C2B*MA02*PI*SBA+
     &  12D0*CBA*LAM5*S2A*XMW2*XSW2-4D0*CBA*LAM5*S2B*XMW2*XSW2+8D0*
     &  LAM5*SAB*XMW2*XSW2-12D0*C2A*LAM5*SBA*XMW2*XSW2-4D0*C2B*LAM5*
     &  SBA*XMW2*XSW2))/(256D0*CB*SB*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T9,N1236,FULL)
        CALL xC01234_(S12,MH02,S34,XMHP2,XMHH2,XMH02,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)

        PRE = (CBA*PI**(-2)*PW12*PW34*SBA*XSW2**(-2)*(12D0*ALPHA*
     &  CBA*MA02*PI*S2A-16D0*ALPHA*CBA*MH02*PI*S2A-8D0*ALPHA*CBA*
     &  MHH2*PI*S2A-4D0*ALPHA*CBA*MA02*PI*S2B+8D0*ALPHA*MA02*PI*SAB-
     &  12D0*ALPHA*C2A*MA02*PI*SBA-4D0*ALPHA*C2B*MA02*PI*SBA+12D0*
     &  CBA*LAM5*S2A*XMW2*XSW2-4D0*CBA*LAM5*S2B*XMW2*XSW2+8D0*LAM5*
     &  SAB*XMW2*XSW2-12D0*C2A*LAM5*SBA*XMW2*XSW2-4D0*C2B*LAM5*SBA*
     &  XMW2*XSW2))/(256D0*CB*SB*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE

C       G(T9,N1237,FULL)
        CALL xC01234_(S12,MH02,S34,XMW2,XMHH2,XMH02,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)

        PRE = -((CBA*PI**(-2)*PW12*PW34*SBA*XSW2**(-2)*(12D0*ALPHA*
     &  CBA*MA02*PI*S2A-16D0*ALPHA*CBA*MH02*PI*S2A-8D0*ALPHA*CBA*
     &  MHH2*PI*S2A-4D0*ALPHA*CBA*MA02*PI*S2B+8D0*ALPHA*MA02*PI*SAB-
     &  12D0*ALPHA*C2A*MA02*PI*SBA-4D0*ALPHA*C2B*MA02*PI*SBA+12D0*
     &  CBA*LAM5*S2A*XMW2*XSW2-4D0*CBA*LAM5*S2B*XMW2*XSW2+8D0*LAM5*
     &  SAB*XMW2*XSW2-12D0*C2A*LAM5*SBA*XMW2*XSW2-4D0*C2B*LAM5*SBA*
     &  XMW2*XSW2))/(256D0*CB*SB*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE

C       G(T9,N1238,FULL)
        CALL xC01234_(S12,MH02,S34,XMW2,XMHH2,XMH02,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,0,0)

        PRE = (C0*CBA*PI**(-2)*PW12*PW34*SBA*XMW*XSW2**(-2)*(12D0*
     &  ALPHA*CBA*MA02*PI*S2A-16D0*ALPHA*CBA*MH02*PI*S2A-8D0*ALPHA*
     &  CBA*MHH2*PI*S2A-4D0*ALPHA*CBA*MA02*PI*S2B+8D0*ALPHA*MA02*PI*
     &  SAB-12D0*ALPHA*C2A*MA02*PI*SBA-4D0*ALPHA*C2B*MA02*PI*SBA+
     &  12D0*CBA*LAM5*S2A*XMW2*XSW2-4D0*CBA*LAM5*S2B*XMW2*XSW2+8D0*
     &  LAM5*SAB*XMW2*XSW2-12D0*C2A*LAM5*SBA*XMW2*XSW2-4D0*C2B*LAM5*
     &  SBA*XMW2*XSW2))/(256D0*CB*SB*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T9,N1239,FULL)
        CALL xC01234_(S12,MH02,S34,XMHP2,XMHH2,XMHH2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)

        PRE = -((PI**(-2)*PW12*PW34*SBA**2*XSW2**(-2)*(8D0*ALPHA*
     &  CAB*MA02*PI-12D0*ALPHA*C2A*CBA*MA02*PI+4D0*ALPHA*C2B*CBA*
     &  MA02*PI-12D0*ALPHA*MA02*PI*S2A*SBA+8D0*ALPHA*MH02*PI*S2A*
     &  SBA+16D0*ALPHA*MHH2*PI*S2A*SBA-4D0*ALPHA*MA02*PI*S2B*SBA+
     &  8D0*CAB*LAM5*XMW2*XSW2-12D0*C2A*CBA*LAM5*XMW2*XSW2+4D0*C2B*
     &  CBA*LAM5*XMW2*XSW2-12D0*LAM5*S2A*SBA*XMW2*XSW2-4D0*LAM5*S2B*
     &  SBA*XMW2*XSW2))/(256D0*CB*SB*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE

C       G(T9,N1240,FULL)
        CALL xC01234_(S12,MH02,S34,XMW2,XMHH2,XMHH2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)

        PRE = -((CBA**2*PI**(-2)*PW12*PW34*XSW2**(-2)*(8D0*ALPHA*
     &  CAB*MA02*PI-12D0*ALPHA*C2A*CBA*MA02*PI+4D0*ALPHA*C2B*CBA*
     &  MA02*PI-12D0*ALPHA*MA02*PI*S2A*SBA+8D0*ALPHA*MH02*PI*S2A*
     &  SBA+16D0*ALPHA*MHH2*PI*S2A*SBA-4D0*ALPHA*MA02*PI*S2B*SBA+
     &  8D0*CAB*LAM5*XMW2*XSW2-12D0*C2A*CBA*LAM5*XMW2*XSW2+4D0*C2B*
     &  CBA*LAM5*XMW2*XSW2-12D0*LAM5*S2A*SBA*XMW2*XSW2-4D0*LAM5*S2B*
     &  SBA*XMW2*XSW2))/(256D0*CB*SB*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE

C       G(T9,N1241,FULL)
        CALL xC01234_(S12,MH02,S34,XMW2,XMHH2,XMHH2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,0,0)

        PRE = (C0*CBA**2*PI**(-2)*PW12*PW34*XMW*XSW2**(-2)*(8D0*
     &  ALPHA*CAB*MA02*PI-12D0*ALPHA*C2A*CBA*MA02*PI+4D0*ALPHA*C2B*
     &  CBA*MA02*PI-12D0*ALPHA*MA02*PI*S2A*SBA+8D0*ALPHA*MH02*PI*
     &  S2A*SBA+16D0*ALPHA*MHH2*PI*S2A*SBA-4D0*ALPHA*MA02*PI*S2B*
     &  SBA+8D0*CAB*LAM5*XMW2*XSW2-12D0*C2A*CBA*LAM5*XMW2*XSW2+4D0*
     &  C2B*CBA*LAM5*XMW2*XSW2-12D0*LAM5*S2A*SBA*XMW2*XSW2-4D0*LAM5*
     &  S2B*SBA*XMW2*XSW2))/(256D0*CB*SB*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T9,N1314,FULL)
        CALL xC01234_(S12,MH02,S34,XMH02,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)

        PRE = (ALPHA*PW12*PW34*SBA**3*XMW*XSW2**(-2))/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(-(2D0*C1(2))-C2(1,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)+(-(2D0*C1(2))-C2(1,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)+(-(2D0*C1(2))-C2(1,2))*PRE
        F(8,-1,-1) = F(8,-1,-1)+(-(2D0*C1(2))-C2(1,2))*PRE

C       G(T9,N1315,FULL)
        CALL xC01234_(S12,MH02,S34,XMHH2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)

        PRE = (ALPHA*CBA**2*PW12*PW34*SBA*XMW*XSW2**(-2))/(16D0*PI*
     &  XSW)

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(-(2D0*C1(2))-C2(1,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)+(-(2D0*C1(2))-C2(1,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)+(-(2D0*C1(2))-C2(1,2))*PRE
        F(8,-1,-1) = F(8,-1,-1)+(-(2D0*C1(2))-C2(1,2))*PRE

C       G(T9,N1316,FULL)
        CALL xC01234_(S12,MH02,S34,NULL,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 4D0*C1(1)+2D0*C1(2)-C2(1,2)+4D0*C0

        PRE = -((ALPHA*PW12*PW34*SBA*XMW)/(32D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(1D0-6D0*C2(0,0)-2D0*C2(1,1)*
     &  S12+2D0*C2(1,2)*(S13+S14+S23+S24)-2D0*C1(1)*(2D0*S12+S13+
     &  S14+S23+S24)-2D0*C2(2,2)*S34+2D0*C1(2)*(S13+S14+S23+S24+2D0*
     &  S34)-2D0*C0*(S23+S24+T12))
        F(5,-1,-1) = F(5,-1,-1)+2D0*K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)+2D0*K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+2D0*K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+2D0*K(1)*PRE

C       G(T9,N1317,FULL)
        CALL xC01234_(S12,MH02,S34,XMZ2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 4D0*C1(1)+2D0*C1(2)-C2(1,2)+4D0*C0

        PRE = (ALPHA*PW12*PW34*SBA*XCW*XMZ)/(32D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE*(1D0-6D0*C2(0,0)-2D0*C2(1,1)*
     &  S12+2D0*C2(1,2)*(S13+S14+S23+S24)-2D0*C1(1)*(2D0*S12+S13+
     &  S14+S23+S24)-2D0*C2(2,2)*S34+2D0*C1(2)*(S13+S14+S23+S24+2D0*
     &  S34)-2D0*C0*(S23+S24+T12))
        F(5,-1,-1) = F(5,-1,-1)+2D0*K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)+2D0*K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+2D0*K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+2D0*K(1)*PRE

C       G(T9,N1318,FULL)
        CALL xC01234_(S12,MH02,S34,XMH02,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)

        PRE = (ALPHA*PW12*PW34*SBA**3*XMW*XSW2**(-2))/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(-(2D0*C1(1))-C2(1,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)+(-(2D0*C1(1))-C2(1,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)+(-(2D0*C1(1))-C2(1,2))*PRE
        F(8,-1,-1) = F(8,-1,-1)+(-(2D0*C1(1))-C2(1,2))*PRE

C       G(T9,N1319,FULL)
        CALL xC01234_(S12,MH02,S34,XMHH2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)

        PRE = (ALPHA*CBA**2*PW12*PW34*SBA*XMW*XSW2**(-2))/(16D0*PI*
     &  XSW)

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(-(2D0*C1(1))-C2(1,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)+(-(2D0*C1(1))-C2(1,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)+(-(2D0*C1(1))-C2(1,2))*PRE
        F(8,-1,-1) = F(8,-1,-1)+(-(2D0*C1(1))-C2(1,2))*PRE

C       G(T9,N1320,FULL)
        CALL xC01234_(S12,MH02,S34,NULL,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 2D0*C1(1)+4D0*C1(2)-C2(1,2)+4D0*C0

        PRE = -((ALPHA*PW12*PW34*SBA*XMW)/(32D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(1D0-6D0*C2(0,0)-2D0*C2(1,1)*
     &  S12+2D0*C2(1,2)*(S13+S14+S23+S24)+2D0*C1(1)*(2D0*S12+S13+
     &  S14+S23+S24)-2D0*C2(2,2)*S34-2D0*C1(2)*(S13+S14+S23+S24+2D0*
     &  S34)-2D0*C0*(S14+S24+T14))
        F(5,-1,-1) = F(5,-1,-1)+2D0*K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)+2D0*K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+2D0*K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+2D0*K(1)*PRE

C       G(T9,N1321,FULL)
        CALL xC01234_(S12,MH02,S34,XMZ2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 2D0*C1(1)+4D0*C1(2)-C2(1,2)+4D0*C0

        PRE = (ALPHA*PW12*PW34*SBA*XCW*XMZ)/(32D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE*(1D0-6D0*C2(0,0)-2D0*C2(1,1)*
     &  S12+2D0*C2(1,2)*(S13+S14+S23+S24)+2D0*C1(1)*(2D0*S12+S13+
     &  S14+S23+S24)-2D0*C2(2,2)*S34-2D0*C1(2)*(S13+S14+S23+S24+2D0*
     &  S34)-2D0*C0*(S14+S24+T14))
        F(5,-1,-1) = F(5,-1,-1)+2D0*K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)+2D0*K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+2D0*K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+2D0*K(1)*PRE

C       G(T9,N1322,FULL)
        CALL xC01234_(S12,MH02,S34,XMH02,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,0,0)

        PRE = -((ALPHA*C0*PW12*PW34*SBA**3*XMW*XMW2*XSW2**(-2))/
     &  (8D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T9,N1323,FULL)
        CALL xC01234_(S12,MH02,S34,XMHH2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,0,0)

        PRE = -((ALPHA*C0*CBA**2*PW12*PW34*SBA*XMW*XMW2*XSW2**(-2))/
     &  (8D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T9,N1324,FULL)
        CALL xC01234_(S12,MH02,S34,NULL,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = -(C1(1))-C1(2)-10D0*C2(1,2)+4D0*C0

        PRE = -((ALPHA*PW12*PW34*SBA*XMW)/(16D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(6D0-36D0*C2(0,0)-4D0*C2(1,1)*
     &  S12+4D0*C2(1,2)*(S13+S14+S23+S24)+5D0*C0*(S13+S14+S23+S24)-
     &  C1(1)*(2D0*S12-S13-S14-S23-S24)-4D0*C2(2,2)*S34+C1(2)*(S13+
     &  S14+S23+S24-2D0*S34))
        F(5,-1,-1) = F(5,-1,-1)-2D0*K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)-2D0*K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)-2D0*K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)-2D0*K(1)*PRE

C       G(T9,N1325,FULL)
        CALL xC01234_(S12,MH02,S34,XMZ2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = -(C1(1))-C1(2)-10D0*C2(1,2)+4D0*C0

        PRE = -((ALPHA*PW12*PW34*SBA*XCW2*XMW*XSW2**(-2))/(16D0*PI*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(6D0-36D0*C2(0,0)-4D0*C2(1,1)*
     &  S12+4D0*C2(1,2)*(S13+S14+S23+S24)+5D0*C0*(S13+S14+S23+S24)-
     &  C1(1)*(2D0*S12-S13-S14-S23-S24)-4D0*C2(2,2)*S34+C1(2)*(S13+
     &  S14+S23+S24-2D0*S34))
        F(5,-1,-1) = F(5,-1,-1)-2D0*K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)-2D0*K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)-2D0*K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)-2D0*K(1)*PRE

C       G(T9,N1341,FULL)
        CALL xC01234_(S12,MH02,S34,XMH02,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)

        PRE = (ALPHA*MH02*PW12*PW34*SBA**3*XSW2**(-2))/(16D0*PI*XMW*
     &  XSW)

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE

C       G(T9,N1342,FULL)
        CALL xC01234_(S12,MH02,S34,XMHH2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,
     &  B2,B3,2,0)

        PRE = (ALPHA*CBA**2*MH02*PW12*PW34*SBA*XSW2**(-2))/(16D0*PI*
     &  XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE

C       G(T9,N1343,FULL)
        CALL xC01234_(S12,MH02,S34,XMZ2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)

        PRE = (ALPHA*MH02*PW12*PW34*SBA*XSW2**(-2))/(16D0*PI*XMW*
     &  XSW)

        F(1,-1,-1) = F(1,-1,-1)+C2(0,0)*PRE
        F(5,-1,-1) = F(5,-1,-1)-C2(1,2)*PRE
        F(6,-1,-1) = F(6,-1,-1)-C2(1,2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-C2(1,2)*PRE
        F(8,-1,-1) = F(8,-1,-1)-C2(1,2)*PRE

C       G(T9,N1344,FULL)
        CALL xC01234_(S12,MH02,S34,NULL,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,0,0)

        PRE = -((ALPHA*C0*MH02*PW12*PW34*SBA*XMW)/(16D0*PI*XSW*
     &  XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T9,N1345,FULL)
        CALL xC01234_(S12,MH02,S34,XMZ2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,0,0)

        PRE = -((ALPHA*C0*MH02*PW12*PW34*SBA*XMZ2)/(16D0*PI*XMW*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T10,N1364,FULL)

C       G(T10,N1365,FULL)

C       G(T10,N1366,FULL)

C       G(T10,N1367,FULL)

C       G(T10,N1368,FULL)

C       G(T10,N1369,FULL)

C       G(T10,N1377,FULL)

C       G(T10,N1379,FULL)

C       G(T10,N1406,FULL)

C       G(T10,N1409,FULL)

C       G(T10,N1418,FULL)

C       G(T10,N1419,FULL)

C       G(T10,N1420,FULL)

C       G(T10,N1421,FULL)

C       G(T11,N1448,FULL)

C       G(T11,N1449,FULL)

C       G(T11,N1450,FULL)

C       G(T11,N1451,FULL)

C       G(T11,N1452,FULL)

C       G(T11,N1453,FULL)

C       G(T11,N1463,FULL)

C       G(T11,N1465,FULL)

C       G(T11,N1492,FULL)

C       G(T11,N1495,FULL)

C       G(T11,N1504,FULL)

C       G(T11,N1505,FULL)

C       G(T11,N1506,FULL)

C       G(T11,N1507,FULL)

C       G(T12,N1568,FULL)

C       G(T12,N1569,FULL)

C       G(T12,N1570,FULL)

C       G(T12,N1571,FULL)

C       G(T12,N1572,FULL)

C       G(T12,N1573,FULL)

C       G(T12,N1574,FULL)

C       G(T12,N1575,FULL)

C       G(T12,N1576,FULL)

C       G(T12,N1577,FULL)

C       G(T12,N1580,FULL)
        CALL xC01234_(T14,MH02,RMF2(4),CMF2(3),XMW2,XMW2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(1)*ALPHA*PW12*SBA*XMW*XSW2**(-2))/(8D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T12,N1581,FULL)

C       G(T12,N1582,FULL)

C       G(T12,N1583,FULL)
        CALL xC01234_(T14,MH02,RMF2(4),CMF2(4),XMZ2,XMZ2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(1)*ALPHA*PW12*SBA*XMZ*XSW2**(-2)*(1D0-2D0*QF(4)*
     &  XSW2)**2)/(16D0*PI*XCW*XCW2*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T12,N1592,FULL)

C       G(T12,N1605,FULL)

C       G(T12,N1606,FULL)

C       G(T12,N1607,FULL)

C       G(T12,N1608,FULL)

C       G(T12,N1609,FULL)

C       G(T12,N1610,FULL)

C       G(T13,N1661,FULL)

C       G(T13,N1664,FULL)

C       G(T13,N1666,FULL)

C       G(T13,N1675,FULL)

C       G(T13,N1677,FULL)

C       G(T13,N1678,FULL)

C       G(T13,N1679,FULL)

C       G(T13,N1680,FULL)

C       G(T13,N1681,FULL)

C       G(T13,N1682,FULL)

C       G(T13,N1725,FULL)

C       G(T13,N1728,FULL)

C       G(T13,N1730,FULL)

C       G(T13,N1740,FULL)

C       G(T13,N1741,FULL)

C       G(T13,N1742,FULL)

C       G(T13,N1793,FULL)

C       G(T13,N1796,FULL)

C       G(T13,N1808,FULL)
        CALL xC01234_(RMF2(3),S34,RMF2(4),CMF2(3),NULL,XMW2,C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,1)

        PRE = (QF(3)*ALPHA*PW12*PW34*(1D0-6D0*C2(0,0)+C1(1)*S34+
     &  C1(2)*S34+C2(1,2)*S34)*SBA*XMW)/(4D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T13,N1810,FULL)
        CALL xC01234_(RMF2(3),S34,RMF2(4),CMF2(3),XMZ2,XMW2,C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,1)

        PRE = -((ALPHA*PW12*PW34*(1D0-6D0*C2(0,0)+C1(1)*S34+C1(2)*
     &  S34+C2(1,2)*S34)*SBA*XMW*XSW2**(-2)*(1D0+2D0*QF(3)*XSW2))/
     &  (8D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T13,N1811,FULL)

C       G(T13,N1812,FULL)

C       G(T13,N1813,FULL)
        CALL xC01234_(RMF2(4),RMF2(3),S34,NULL,CMF2(4),XMW2,C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,1)

        PRE = -((QF(4)*ALPHA*PW12*PW34*(1D0-6D0*C2(0,0)-C1(1)*S34-
     &  C1(2)*S34-C2(1,2)*S34-C2(2,2)*S34-C0*S34)*SBA*XMW)/(4D0*PI*
     &  XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T13,N1814,FULL)
        CALL xC01234_(RMF2(3),S34,RMF2(4),CMF2(4),XMW2,XMZ2,C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,1)

        PRE = -((ALPHA*PW12*PW34*(1D0-6D0*C2(0,0)+C1(1)*S34+C1(2)*
     &  S34+C2(1,2)*S34)*SBA*XMW*XSW2**(-2)*(1D0-2D0*QF(4)*XSW2))/
     &  (8D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T13,N1863,FULL)

C       G(T13,N1864,FULL)

C       G(T13,N1865,FULL)

C       G(T13,N1866,FULL)

C       G(T13,N1867,FULL)
        CALL xC01234_(RMF2(3),S34,RMF2(4),NULL,CMF2(3),CMF2(4),C0,C1,C2,
     &  C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((QF(3)*QF(4)*ALPHA*PW12*PW34*(1D0-2D0*C2(0,0)+C1(1)*
     &  S34+C1(2)*S34+C2(1,2)*S34+C0*S34)*SBA*XMW)/(4D0*PI*XSW*
     &  XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T13,N1868,FULL)
        CALL xC01234_(S34,RMF2(4),RMF2(3),CMF2(3),CMF2(4),XMZ2,C0,C1,C2,
     &  C3,C4,B0,B1,B2,B3,2,1)

        PRE = (ALPHA*PW12*PW34*(1D0-2D0*C2(0,0)-C1(1)*S34-C1(2)*S34-
     &  C2(1,1)*S34-C2(1,2)*S34)*SBA*XMW*XSW2**(-2)*(1D0+2D0*QF(3)*
     &  XSW2)*(1D0-2D0*QF(4)*XSW2))/(16D0*PI*XCW2*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T14,N1915,FULL)

C       G(T14,N1918,FULL)

C       G(T14,N1930,FULL)

C       G(T14,N1932,FULL)

C       G(T14,N1933,FULL)

C       G(T14,N1934,FULL)

C       G(T14,N1935,FULL)

C       G(T14,N1936,FULL)

C       G(T14,N1949,FULL)

C       G(T14,N1950,FULL)

C       G(T14,N1951,FULL)

C       G(T14,N1952,FULL)

C       G(T14,N1953,FULL)

C       G(T14,N1954,FULL)

C       G(T15,N2001,FULL)

C       G(T15,N2004,FULL)

C       G(T15,N2016,FULL)

C       G(T15,N2018,FULL)

C       G(T15,N2019,FULL)

C       G(T15,N2020,FULL)

C       G(T15,N2021,FULL)

C       G(T15,N2022,FULL)

C       G(T15,N2035,FULL)

C       G(T15,N2036,FULL)

C       G(T15,N2037,FULL)

C       G(T15,N2038,FULL)

C       G(T15,N2039,FULL)

C       G(T15,N2040,FULL)

C       G(T16,N2093,FULL)
        CALL xB012345_(MH02,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*MH02*PW12*PW34*SBA*XSW2**(-2))/(32D0*PI*
     &  XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T16,N2094,FULL)
        CALL xB012345_(MH02,XMHP2,XMHP2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = (B0*PI**(-2)*PW12*PW34*XSW2**(-2)*(4D0*ALPHA*CAB*MA02*
     &  PI-4D0*ALPHA*CA*CB**3*MH02*PI+4D0*ALPHA*MH02*PI*SA*SB**3-
     &  8D0*ALPHA*CB*MHP2*PI*SB*SBA+4D0*CAB*LAM5*XMW2*XSW2))/(128D0*
     &  CB*SB*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T16,N2095,FULL)
        CALL xB012345_(MH02,XMH02,XMH02,B0,B1,B2,B3,B4,B5,0,0)

        PRE = (3D0*B0*PI**(-2)*PW12*PW34*XSW2**(-2)*(16D0*ALPHA*CAB*
     &  CBA**2*MA02*PI-12D0*ALPHA*CAB*MH02*PI-4D0*ALPHA*C2A*CBA*
     &  MH02*PI-4D0*ALPHA*MH02*PI*S2A*SBA+16D0*CAB*CBA**2*LAM5*XMW2*
     &  XSW2))/(1024D0*CB*SB*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T16,N2096,FULL)
        CALL xB012345_(MH02,XMHH2,XMHH2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = (B0*PI**(-2)*PW12*PW34*XSW2**(-2)*(8D0*ALPHA*CAB*MA02*
     &  PI-12D0*ALPHA*C2A*CBA*MA02*PI+4D0*ALPHA*C2B*CBA*MA02*PI-
     &  12D0*ALPHA*MA02*PI*S2A*SBA+8D0*ALPHA*MH02*PI*S2A*SBA+16D0*
     &  ALPHA*MHH2*PI*S2A*SBA-4D0*ALPHA*MA02*PI*S2B*SBA+8D0*CAB*
     &  LAM5*XMW2*XSW2-12D0*C2A*CBA*LAM5*XMW2*XSW2+4D0*C2B*CBA*LAM5*
     &  XMW2*XSW2-12D0*LAM5*S2A*SBA*XMW2*XSW2-4D0*LAM5*S2B*SBA*XMW2*
     &  XSW2))/(1024D0*CB*SB*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T16,N2097,FULL)
        CALL xB012345_(MH02,XMA02,XMA02,B0,B1,B2,B3,B4,B5,0,0)

        PRE = (B0*PI**(-2)*PW12*PW34*XSW2**(-2)*(4D0*ALPHA*C2B*CBA*
     &  MA02*PI-4D0*ALPHA*CA*CB**3*MH02*PI+4D0*ALPHA*MH02*PI*SA*SB**
     &  3+4D0*CAB*LAM5*XMW2*XSW2))/(256D0*CB*SB*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T16,N2098,FULL)
        CALL xB012345_(MH02,XMZ2,XMZ2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*MH02*PW12*PW34*SBA*XSW2**(-2))/(64D0*PI*
     &  XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T16,N2099,FULL)
        CALL xB012345_(MH02,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = (ALPHA*(2D0-3D0*B0)*PW12*PW34*SBA*XMW*XSW2**(-2))/
     &  (8D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T16,N2100,FULL)
        CALL xB012345_(MH02,XMZ2,XMZ2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = (ALPHA*(2D0-3D0*B0)*PW12*PW34*SBA*XCW*XMZ*XSW2**(-2))/
     &  (8D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T17,N2143,FULL)
        CALL xB012345_(S34,NULL,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12*PW34*SBA*XMW)/(16D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T17,N2144,FULL)
        CALL xB012345_(S34,XMW2,XMZ2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12*PW34*SBA*XMZ)/(16D0*PI*XCW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T17,N2145,FULL)
        CALL xB012345_(S34,XMW2,XMH02,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12*PW34*SBA*XMW*XSW2**(-2))/(16D0*PI*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T18,N2188,FULL)
        CALL xB012345_(S12,NULL,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12*PW34*SBA*XMW)/(16D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T18,N2189,FULL)
        CALL xB012345_(S12,XMW2,XMZ2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12*PW34*SBA*XMZ)/(16D0*PI*XCW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T18,N2190,FULL)
        CALL xB012345_(S12,XMW2,XMH02,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12*PW34*SBA*XMW*XSW2**(-2))/(16D0*PI*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

	end

**********************************************************************
        subroutine  h0toWW4f_box_thdm(F,pw12,pw34)
**********************************************************************
*       box corrections for h0 -> WW -> 4f in the THDM
*---------------------------------------------------------------------
*       24.4.16 Stefan Dittmaier
**********************************************************************
	implicit none
	complex*16 pre,F(13,-1:1,-1:1),pw12,pw34
	complex*16 A0,xA0_,B0_,xB0_,DB0_,xDB0_,B1_,xB1_,DB1_,xDB1_
        complex*16 B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 C0_,C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,2)
        complex*16 C4(0:2,0:2,0:2,0:2)
	complex*16 D0,D1(3),D2(0:3,0:3),D3(0:3,0:3,3)
        complex*16 D4(0:3,0:3,0:3,0:3),D5(0:3,0:3,0:3,0:3,3)
	complex*16 E0n,E1n(4),E2n(0:4,0:4),E3n(0:4,0:4,4)
	complex*16 E4n(0:4,0:4,0:4,0:4)
        COMPLEX*16 K(1)

c mandelstam variables
      	real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      	common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion charges of isospin duplets
	real*8 qf(4)
	common/fcharge/qf
c fermion masses as flag (i*1d-20)
      	complex*16 cme2,cmf2(5)
      	real*8 me2,rme2,mf2(5),rmf2(5)
      	common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
	include '../COMMON/param.inc'
	include '../COMMON/xparam.inc'
        include '../COMMON/param_thdm.inc'
        include '../COMMON/param_bsm.inc'

C       Process: S1F21aF22F23aF24,   Model: THDM

C       G(T3,N76,FULL)

C       G(T3,N77,FULL)
        CALL xD012345_(RMF2(1),RMF2(2),MH02,S34,T12,S12,NULL,CMF2(1),
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = D1(1)+D1(2)-D1(3)-2D0*D2(1,3)-2D0*D2(2,3)+D0

        PRE = -((QF(1)*ALPHA*PW34*SBA*XMW)/(8D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(12D0*D2(0,0))-2D0*D2(1,2)*
     &  S12-2D0*D2(2,2)*S12+2D0*D1(1)*(S13+S14)+2D0*D2(1,3)*(S13+
     &  S14)+2D0*D0*(S13+S14)+2D0*D2(2,3)*(S13+S14+S23+S24)-2D0*
     &  D2(3,3)*S34+D1(3)*(S13+S14-S34)-D1(2)*(MH02-2D0*S13-2D0*S14-
     &  T12))
        F(5,-1,-1) = F(5,-1,-1)-2D0*K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)+4D0*(D1(2)+D2(2,3))*PRE
        F(7,-1,-1) = F(7,-1,-1)-2D0*K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(D1(2)+D2(2,3))*PRE

C       G(T3,N78,FULL)
        CALL xD012345_(RMF2(2),MH02,S34,RMF2(1),S12,T12,CMF2(1),XMW2,
     &  XMW2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((ALPHA*PW34*SBA*XMW*XSW2**(-2)*(1D0-2D0*QF(1)*
     &  XSW2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(12D0*D2(0,0))+2D0*D2(1,3)*
     &  S12-2D0*D1(3)*(S13+S14)-2D0*D2(2,3)*(S13+S14)+D1(1)*(S12-
     &  S23-S24)-D1(2)*(3D0*S13+3D0*S14+S34)-2D0*D2(2,2)*T12+2D0*
     &  D2(1,2)*(MH02-T12))
        F(5,-1,-1) = F(5,-1,-1)+2D0*(D1(3)-2D0*D2(2,2)-2D0*D2(2,3))*
     &  PRE
        F(6,-1,-1) = F(6,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)+2D0*(D1(3)-2D0*D2(2,2)-2D0*D2(2,3))*
     &  PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE

C       G(T3,N80,FULL)
        CALL xD012345_(RMF2(2),MH02,S34,RMF2(1),S12,T12,CMF2(2),XMZ2,
     &  XMZ2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((ALPHA*PW34*SBA*XMZ*XSW2**(-2)*(1D0+2D0*QF(2)*
     &  XSW2))/(16D0*PI*XCW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(12D0*D2(0,0))+2D0*D2(1,3)*
     &  S12-2D0*D1(3)*(S13+S14)-2D0*D2(2,3)*(S13+S14)+D1(1)*(S12-
     &  S23-S24)-D1(2)*(3D0*S13+3D0*S14+S34)-2D0*D2(2,2)*T12+2D0*
     &  D2(1,2)*(MH02-T12))
        F(5,-1,-1) = F(5,-1,-1)+2D0*(D1(3)-2D0*D2(2,2)-2D0*D2(2,3))*
     &  PRE
        F(6,-1,-1) = F(6,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)+2D0*(D1(3)-2D0*D2(2,2)-2D0*D2(2,3))*
     &  PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE

C       G(T3,N96,FULL)

C       G(T3,N97,FULL)
        CALL xD012345_(RMF2(1),RMF2(2),MH02,S34,T12,S12,NULL,CMF2(1),
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((QF(1)*ALPHA*PW34*SBA*XMW)/(16D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(4D0*D2(0,0))-D2(1,2)*S12-
     &  D2(2,2)*S12+D2(1,3)*(S13+S14)+D2(2,3)*(S13+S14+S23+S24)+
     &  D1(2)*(S12+2D0*S23+2D0*S24)-D2(3,3)*S34-D1(3)*(S13+S14+2D0*
     &  S34))
        F(5,-1,-1) = F(5,-1,-1)+4D0*(D1(1)+D1(2)+D1(3)+D0)*PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*(D1(1)+D1(2)+D1(3)+D0)*PRE

C       G(T3,N98,FULL)
        CALL xD012345_(RMF2(2),MH02,S34,RMF2(1),S12,T12,CMF2(1),XMW2,
     &  XMW2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = (ALPHA*PW34*SBA*XMZ*(1D0-2D0*QF(1)*XSW2))/(32D0*PI*
     &  XCW*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(4D0*D2(0,0))+D2(1,3)*S12-
     &  D2(2,3)*(S13+S14)-2D0*D1(2)*T12-D2(2,2)*T12+2D0*D1(1)*(MH02-
     &  T12)+D2(1,2)*(MH02-T12))
        F(5,-1,-1) = F(5,-1,-1)-4D0*D1(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)-4D0*D1(3)*PRE

C       G(T6,N185,FULL)

C       G(T6,N186,FULL)

C       G(T6,N187,FULL)

C       G(T6,N188,FULL)
        CALL xD012345_(S34,RMF2(2),MH02,RMF2(1),T12,T11,CMF2(1),
     &  CMF2(2),XMZ2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((ALPHA*PW34*SBA*XMZ*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(2)*XSW2))/(16D0*PI*XCW*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(2D0*D2(0,0)-D1(3)*(S13+S14)-
     &  D2(1,3)*(S13+S14)+D1(1)*S34+D1(2)*S34+D2(1,1)*S34+D2(1,2)*
     &  (S23+S24+2D0*S34)+D2(2,2)*T11-D2(2,3)*(MH02-T11))
        F(5,-1,-1) = F(5,-1,-1)+2D0*(D1(3)+D2(1,3)+D2(2,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)-2D0*(D2(1,2)+D2(2,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)+2D0*(D1(3)+D2(1,3)+D2(2,3))*PRE
        F(8,-1,-1) = F(8,-1,-1)-2D0*(D2(1,2)+D2(2,2))*PRE

C       G(T7,N197,FULL)

C       G(T7,N198,FULL)

C       G(T7,N199,FULL)

C       G(T7,N200,FULL)
        CALL xD012345_(S12,RMF2(3),MH02,RMF2(4),T13,T14,CMF2(4),
     &  CMF2(3),XMZ2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((ALPHA*PW12*SBA*XMZ*XSW2**(-2)*(1D0+2D0*QF(3)*XSW2)*
     &  (1D0-2D0*QF(4)*XSW2))/(16D0*PI*XCW*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(2D0*D2(0,0)+D1(1)*S12+D1(2)*
     &  S12+D2(1,1)*S12+D2(1,2)*(2D0*S12+S13+S23)-D1(3)*(S14+S24)-
     &  D2(1,3)*(S14+S24)+D2(2,2)*T14-D2(2,3)*(MH02-T14))
        F(5,-1,-1) = F(5,-1,-1)-2D0*(D2(1,2)+D2(2,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)-2D0*(D2(1,2)+D2(2,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)+2D0*(D1(3)+D2(1,3)+D2(2,3))*PRE
        F(8,-1,-1) = F(8,-1,-1)+2D0*(D1(3)+D2(1,3)+D2(2,3))*PRE

C       G(T8,N236,FULL)

C       G(T8,N237,FULL)
        CALL xD012345_(RMF2(2),RMF2(1),MH02,S34,T11,S12,NULL,CMF2(2),
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = D1(1)+D1(2)-D1(3)-2D0*D2(1,3)-2D0*D2(2,3)+D0

        PRE = (QF(2)*ALPHA*PW34*SBA*XMW)/(8D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(12D0*D2(0,0))-2D0*D2(1,2)*
     &  S12-2D0*D2(2,2)*S12+2D0*D1(1)*(S23+S24)+2D0*D2(1,3)*(S23+
     &  S24)+2D0*D0*(S23+S24)+2D0*D2(2,3)*(S13+S14+S23+S24)-2D0*
     &  D2(3,3)*S34+D1(3)*(S23+S24-S34)-D1(2)*(MH02-2D0*S23-2D0*S24-
     &  T11))
        F(5,-1,-1) = F(5,-1,-1)+4D0*(D1(2)+D2(2,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)-2D0*K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*(D1(2)+D2(2,3))*PRE
        F(8,-1,-1) = F(8,-1,-1)-2D0*K(1)*PRE

C       G(T8,N238,FULL)
        CALL xD012345_(RMF2(1),MH02,S34,RMF2(2),S12,T11,CMF2(2),XMW2,
     &  XMW2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((ALPHA*PW34*SBA*XMW*XSW2**(-2)*(1D0+2D0*QF(2)*
     &  XSW2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(12D0*D2(0,0))+2D0*D2(1,3)*
     &  S12+D1(1)*(S12-S13-S14)-2D0*D1(3)*(S23+S24)-2D0*D2(2,3)*
     &  (S23+S24)-D1(2)*(3D0*S23+3D0*S24+S34)-2D0*D2(2,2)*T11+2D0*
     &  D2(1,2)*(MH02-T11))
        F(5,-1,-1) = F(5,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)+2D0*(D1(3)-2D0*D2(2,2)-2D0*D2(2,3))*
     &  PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE
        F(8,-1,-1) = F(8,-1,-1)+2D0*(D1(3)-2D0*D2(2,2)-2D0*D2(2,3))*
     &  PRE

C       G(T8,N240,FULL)
        CALL xD012345_(RMF2(1),MH02,S34,RMF2(2),S12,T11,CMF2(1),XMZ2,
     &  XMZ2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((ALPHA*PW34*SBA*XMZ*XSW2**(-2)*(1D0-2D0*QF(1)*
     &  XSW2))/(16D0*PI*XCW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(12D0*D2(0,0))+2D0*D2(1,3)*
     &  S12+D1(1)*(S12-S13-S14)-2D0*D1(3)*(S23+S24)-2D0*D2(2,3)*
     &  (S23+S24)-D1(2)*(3D0*S23+3D0*S24+S34)-2D0*D2(2,2)*T11+2D0*
     &  D2(1,2)*(MH02-T11))
        F(5,-1,-1) = F(5,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)+2D0*(D1(3)-2D0*D2(2,2)-2D0*D2(2,3))*
     &  PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE
        F(8,-1,-1) = F(8,-1,-1)+2D0*(D1(3)-2D0*D2(2,2)-2D0*D2(2,3))*
     &  PRE

C       G(T8,N256,FULL)

C       G(T8,N257,FULL)
        CALL xD012345_(RMF2(2),RMF2(1),MH02,S34,T11,S12,NULL,CMF2(2),
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = (QF(2)*ALPHA*PW34*SBA*XMW)/(16D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(4D0*D2(0,0))-D2(1,2)*S12-
     &  D2(2,2)*S12+D1(2)*(S12+2D0*S13+2D0*S14)+D2(1,3)*(S23+S24)+
     &  D2(2,3)*(S13+S14+S23+S24)-D2(3,3)*S34-D1(3)*(S23+S24+2D0*
     &  S34))
        F(6,-1,-1) = F(6,-1,-1)+4D0*(D1(1)+D1(2)+D1(3)+D0)*PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(D1(1)+D1(2)+D1(3)+D0)*PRE

C       G(T8,N258,FULL)
        CALL xD012345_(RMF2(1),MH02,S34,RMF2(2),S12,T11,CMF2(2),XMW2,
     &  XMW2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = (ALPHA*PW34*SBA*XMZ*(1D0+2D0*QF(2)*XSW2))/(32D0*PI*
     &  XCW*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(4D0*D2(0,0))+D2(1,3)*S12-
     &  D2(2,3)*(S23+S24)-2D0*D1(2)*T11-D2(2,2)*T11+2D0*D1(1)*(MH02-
     &  T11)+D2(1,2)*(MH02-T11))
        F(6,-1,-1) = F(6,-1,-1)-4D0*D1(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)-4D0*D1(3)*PRE

C       G(T9,N300,FULL)

C       G(T9,N301,FULL)
        CALL xD012345_(RMF2(4),RMF2(3),MH02,S12,T13,S34,NULL,CMF2(4),
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((QF(4)*ALPHA*PW12*SBA*XMW)/(16D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(4D0*D2(0,0))-D2(3,3)*S12+
     &  D2(1,3)*(S14+S24)-D1(3)*(2D0*S12+S14+S24)+D2(2,3)*(S13+S14+
     &  S23+S24)-D2(1,2)*S34-D2(2,2)*S34+D1(2)*(2D0*S13+2D0*S23+
     &  S34))
        F(7,-1,-1) = F(7,-1,-1)+4D0*(D1(1)+D1(2)+D1(3)+D0)*PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(D1(1)+D1(2)+D1(3)+D0)*PRE

C       G(T9,N302,FULL)
        CALL xD012345_(RMF2(3),MH02,S12,RMF2(4),S34,T13,CMF2(4),XMW2,
     &  XMW2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = (ALPHA*PW12*SBA*XMZ*(1D0-2D0*QF(4)*XSW2))/(32D0*PI*
     &  XCW*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(4D0*D2(0,0))-D2(2,3)*(S14+
     &  S24)+D2(1,3)*S34-2D0*D1(2)*T13-D2(2,2)*T13+2D0*D1(1)*(MH02-
     &  T13)+D2(1,2)*(MH02-T13))
        F(7,-1,-1) = F(7,-1,-1)-4D0*D1(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)-4D0*D1(3)*PRE

C       G(T9,N311,FULL)
        CALL xD012345_(RMF2(4),RMF2(3),MH02,S12,T13,S34,NULL,CMF2(4),
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = D1(1)+D1(2)-D1(3)-2D0*D2(1,3)-2D0*D2(2,3)+D0

        PRE = -((QF(4)*ALPHA*PW12*SBA*XMW)/(8D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(12D0*D2(0,0))-2D0*D2(3,3)*
     &  S12+2D0*D1(1)*(S14+S24)+2D0*D2(1,3)*(S14+S24)+2D0*D0*(S14+
     &  S24)+2D0*D2(2,3)*(S13+S14+S23+S24)-D1(3)*(S12-S14-S24)-2D0*
     &  D2(1,2)*S34-2D0*D2(2,2)*S34-D1(2)*(MH02-2D0*S14-2D0*S24-
     &  T13))
        F(5,-1,-1) = F(5,-1,-1)+4D0*(D1(2)+D2(2,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)+4D0*(D1(2)+D2(2,3))*PRE
        F(7,-1,-1) = F(7,-1,-1)-2D0*K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)-2D0*K(1)*PRE

C       G(T9,N312,FULL)
        CALL xD012345_(RMF2(3),MH02,S12,RMF2(4),S34,T13,CMF2(4),XMW2,
     &  XMW2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = (ALPHA*PW12*SBA*XMW*XSW2**(-2)*(1D0-2D0*QF(4)*XSW2))/
     &  (16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE*(12D0*D2(0,0)+2D0*D1(3)*(S14+
     &  S24)+2D0*D2(2,3)*(S14+S24)+D1(2)*(S12+3D0*S14+3D0*S24)-2D0*
     &  D2(1,3)*S34+D1(1)*(S13+S23-S34)+2D0*D2(2,2)*T13-2D0*D2(1,2)*
     &  (MH02-T13))
        F(5,-1,-1) = F(5,-1,-1)-4D0*(D1(1)+D2(1,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)-4D0*(D1(1)+D2(1,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)-2D0*(D1(3)-2D0*D2(2,2)-2D0*D2(2,3))*
     &  PRE
        F(8,-1,-1) = F(8,-1,-1)-2D0*(D1(3)-2D0*D2(2,2)-2D0*D2(2,3))*
     &  PRE

C       G(T9,N314,FULL)

C       G(T9,N316,FULL)
        CALL xD012345_(RMF2(3),MH02,S12,RMF2(4),S34,T13,CMF2(3),XMZ2,
     &  XMZ2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = (ALPHA*PW12*SBA*XMZ*XSW2**(-2)*(1D0+2D0*QF(3)*XSW2))/
     &  (16D0*PI*XCW*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE*(12D0*D2(0,0)+2D0*D1(3)*(S14+
     &  S24)+2D0*D2(2,3)*(S14+S24)+D1(2)*(S12+3D0*S14+3D0*S24)-2D0*
     &  D2(1,3)*S34+D1(1)*(S13+S23-S34)+2D0*D2(2,2)*T13-2D0*D2(1,2)*
     &  (MH02-T13))
        F(5,-1,-1) = F(5,-1,-1)-4D0*(D1(1)+D2(1,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)-4D0*(D1(1)+D2(1,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)-2D0*(D1(3)-2D0*D2(2,2)-2D0*D2(2,3))*
     &  PRE
        F(8,-1,-1) = F(8,-1,-1)-2D0*(D1(3)-2D0*D2(2,2)-2D0*D2(2,3))*
     &  PRE

C       G(T11,N397,FULL)

C       G(T11,N398,FULL)
        CALL xD012345_(RMF2(3),S12,MH02,RMF2(4),S34,T14,CMF2(3),NULL,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = (QF(3)*ALPHA*PW12*SBA*XMW)/(16D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(4D0*D2(0,0))-D2(1,2)*(S13+
     &  S23)+D2(1,3)*S34-2D0*D1(2)*T14-D2(2,2)*T14+2D0*D1(3)*(MH02-
     &  T14)+D2(2,3)*(MH02-T14))
        F(5,-1,-1) = F(5,-1,-1)-4D0*D1(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)-4D0*D1(1)*PRE

C       G(T11,N399,FULL)
        CALL xD012345_(RMF2(3),S12,MH02,RMF2(4),S34,T14,CMF2(3),XMZ2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = (ALPHA*PW12*SBA*XMZ*(1D0+2D0*QF(3)*XSW2))/(32D0*PI*
     &  XCW*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(4D0*D2(0,0))-D2(1,2)*(S13+
     &  S23)+D2(1,3)*S34-2D0*D1(2)*T14-D2(2,2)*T14+2D0*D1(3)*(MH02-
     &  T14)+D2(2,3)*(MH02-T14))
        F(5,-1,-1) = F(5,-1,-1)-4D0*D1(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)-4D0*D1(1)*PRE

C       G(T11,N408,FULL)
        CALL xD012345_(RMF2(3),S12,MH02,RMF2(4),S34,T14,CMF2(3),NULL,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = (QF(3)*ALPHA*PW12*SBA*XMW)/(8D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(12D0*D2(0,0))-2D0*D1(1)*(S13+
     &  S23)-2D0*D2(1,2)*(S13+S23)-D1(2)*(S12+3D0*S13+3D0*S23)+2D0*
     &  D2(1,3)*S34-D1(3)*(S14+S24-S34)-2D0*D2(2,2)*T14+2D0*D2(2,3)*
     &  (MH02-T14))
        F(5,-1,-1) = F(5,-1,-1)+2D0*(D1(1)-2D0*D2(1,2)-2D0*D2(2,2))*
     &  PRE
        F(6,-1,-1) = F(6,-1,-1)+2D0*(D1(1)-2D0*D2(1,2)-2D0*D2(2,2))*
     &  PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*(D1(3)+D2(2,3))*PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(D1(3)+D2(2,3))*PRE

C       G(T11,N409,FULL)
        CALL xD012345_(RMF2(3),S12,MH02,RMF2(4),S34,T14,CMF2(3),XMZ2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((ALPHA*PW12*SBA*XMW*XSW2**(-2)*(1D0+2D0*QF(3)*
     &  XSW2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(12D0*D2(0,0))-2D0*D1(1)*(S13+
     &  S23)-2D0*D2(1,2)*(S13+S23)-D1(2)*(S12+3D0*S13+3D0*S23)+2D0*
     &  D2(1,3)*S34-D1(3)*(S14+S24-S34)-2D0*D2(2,2)*T14+2D0*D2(2,3)*
     &  (MH02-T14))
        F(5,-1,-1) = F(5,-1,-1)+2D0*(D1(1)-2D0*D2(1,2)-2D0*D2(2,2))*
     &  PRE
        F(6,-1,-1) = F(6,-1,-1)+2D0*(D1(1)-2D0*D2(1,2)-2D0*D2(2,2))*
     &  PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*(D1(3)+D2(2,3))*PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(D1(3)+D2(2,3))*PRE

C       G(T11,N411,FULL)

C       G(T11,N413,FULL)
        CALL xD012345_(RMF2(3),S12,MH02,RMF2(4),S34,T14,CMF2(4),XMW2,
     &  XMZ2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((ALPHA*PW12*SBA*XMZ*XSW2**(-2)*(1D0-2D0*QF(4)*
     &  XSW2))/(16D0*PI*XCW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(12D0*D2(0,0))-2D0*D1(1)*(S13+
     &  S23)-2D0*D2(1,2)*(S13+S23)-D1(2)*(S12+3D0*S13+3D0*S23)+2D0*
     &  D2(1,3)*S34-D1(3)*(S14+S24-S34)-2D0*D2(2,2)*T14+2D0*D2(2,3)*
     &  (MH02-T14))
        F(5,-1,-1) = F(5,-1,-1)+2D0*(D1(1)-2D0*D2(1,2)-2D0*D2(2,2))*
     &  PRE
        F(6,-1,-1) = F(6,-1,-1)+2D0*(D1(1)-2D0*D2(1,2)-2D0*D2(2,2))*
     &  PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*(D1(3)+D2(2,3))*PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(D1(3)+D2(2,3))*PRE

	end

**********************************************************************
        subroutine  h0toWW4f_pent_thdm(F,pw12,pw34)
**********************************************************************
*       pentagon corrections for h0 -> WW -> 4f in the THDM
*---------------------------------------------------------------------
*       24.4.16 Stefan Dittmaier
**********************************************************************
	implicit none
	complex*16 pre,F(13,-1:1,-1:1),pw12,pw34
	complex*16 A0,xA0_,B0_,xB0_,DB0_,xDB0_,B1_,xB1_,DB1_,xDB1_
        complex*16 B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 C0_,C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,2)
        complex*16 C4(0:2,0:2,0:2,0:2)
	complex*16 D0,D1(3),D2(0:3,0:3),D3(0:3,0:3,3)
        complex*16 D4(0:3,0:3,0:3,0:3),D5(0:3,0:3,0:3,0:3,3)
	complex*16 E0n,E1n(4),E2n(0:4,0:4),E3n(0:4,0:4,4)
	complex*16 E4n(0:4,0:4,0:4,0:4)
        COMPLEX*16 K(1)

c mandelstam variables
      	real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      	common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion charges of isospin duplets
	real*8 qf(4)
	common/fcharge/qf
c fermion masses as flag (i*1d-20)
      	complex*16 cme2,cmf2(5)
      	real*8 me2,rme2,mf2(5),rmf2(5)
      	common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
	include '../COMMON/param.inc'
	include '../COMMON/xparam.inc'
        include '../COMMON/param_thdm.inc'
        include '../COMMON/param_bsm.inc'

C       Process: S1F21aF22F23aF24,   Model: THDM

C       G(T4,N119,FULL)

C       G(T4,N122,FULL)

C       G(T4,N129,FULL)

C       G(T4,N130,FULL)
        CALL xE01234_NEW(RMF2(3),RMF2(1),RMF2(2),MH02,RMF2(4),S13,
     &  S12,T12,T14,S34,CMF2(3),NULL,CMF2(1),XMW2,XMW2,E0N,E1N,E2N,
     &  E3N,E4N,D0,D1,D2,D3,2,1)
        K(1) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = -((QF(1)*QF(3)*ALPHA*SBA*XMW)/(8D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+2D0*(E1N(1)+2D0*E1N(2)+2D0*E1N(3)+
     &  2D0*E2N(1,2)+2D0*E2N(1,3)+2D0*E2N(2,2)+4D0*E2N(2,3)+2D0*
     &  E2N(3,3))*PRE*S13
        F(2,-1,-1) = F(2,-1,-1)+2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(3,-1,-1) = F(3,-1,-1)-2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(5,-1,-1) = F(5,-1,-1)-8D0*K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)-4D0*E1N(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)-4D0*E1N(4)*PRE
        F(9,-1,-1) = F(9,-1,-1)+K(1)*PRE
        F(10,-1,-1) = F(10,-1,-1)+(E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,
     &  3))*PRE
        F(11,-1,-1) = F(11,-1,-1)+(-(E2N(2,4))-E2N(3,4))*PRE
        F(12,-1,-1) = F(12,-1,-1)-E2N(3,4)*PRE
        F(13,-1,-1) = F(13,-1,-1)+E2N(0,0)*PRE

C       G(T4,N131,FULL)
        CALL xE01234_NEW(RMF2(3),RMF2(1),RMF2(2),MH02,RMF2(4),S13,
     &  S12,T12,T14,S34,CMF2(3),XMZ2,CMF2(1),XMW2,XMW2,E0N,E1N,E2N,
     &  E3N,E4N,D0,D1,D2,D3,2,1)
        K(1) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = (ALPHA*SBA*XMW*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*(1D0+
     &  2D0*QF(3)*XSW2))/(32D0*PI*XCW2*XSW)

        F(1,-1,-1) = F(1,-1,-1)+2D0*(E1N(1)+2D0*E1N(2)+2D0*E1N(3)+
     &  2D0*E2N(1,2)+2D0*E2N(1,3)+2D0*E2N(2,2)+4D0*E2N(2,3)+2D0*
     &  E2N(3,3))*PRE*S13
        F(2,-1,-1) = F(2,-1,-1)+2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(3,-1,-1) = F(3,-1,-1)-2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(5,-1,-1) = F(5,-1,-1)-8D0*K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)-4D0*E1N(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)-4D0*E1N(4)*PRE
        F(9,-1,-1) = F(9,-1,-1)+K(1)*PRE
        F(10,-1,-1) = F(10,-1,-1)+(E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,
     &  3))*PRE
        F(11,-1,-1) = F(11,-1,-1)+(-(E2N(2,4))-E2N(3,4))*PRE
        F(12,-1,-1) = F(12,-1,-1)-E2N(3,4)*PRE
        F(13,-1,-1) = F(13,-1,-1)+E2N(0,0)*PRE

C       G(T4,N134,FULL)

C       G(T4,N137,FULL)
        CALL xE01234_NEW(RMF2(3),RMF2(1),RMF2(2),MH02,RMF2(4),S13,
     &  S12,T12,T14,S34,CMF2(4),XMW2,CMF2(2),XMZ2,XMZ2,E0N,E1N,E2N,
     &  E3N,E4N,D0,D1,D2,D3,2,1)
        K(1) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = (ALPHA*SBA*XMZ*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2)*(1D0-
     &  2D0*QF(4)*XSW2))/(32D0*PI*XCW*XCW2*XSW)

        F(1,-1,-1) = F(1,-1,-1)+2D0*(E1N(1)+2D0*E1N(2)+2D0*E1N(3)+
     &  2D0*E2N(1,2)+2D0*E2N(1,3)+2D0*E2N(2,2)+4D0*E2N(2,3)+2D0*
     &  E2N(3,3))*PRE*S13
        F(2,-1,-1) = F(2,-1,-1)+2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(3,-1,-1) = F(3,-1,-1)-2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(5,-1,-1) = F(5,-1,-1)-8D0*K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)-4D0*E1N(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)-4D0*E1N(4)*PRE
        F(9,-1,-1) = F(9,-1,-1)+K(1)*PRE
        F(10,-1,-1) = F(10,-1,-1)+(E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,
     &  3))*PRE
        F(11,-1,-1) = F(11,-1,-1)+(-(E2N(2,4))-E2N(3,4))*PRE
        F(12,-1,-1) = F(12,-1,-1)-E2N(3,4)*PRE
        F(13,-1,-1) = F(13,-1,-1)+E2N(0,0)*PRE

C       G(T5,N158,FULL)

C       G(T5,N161,FULL)

C       G(T5,N168,FULL)

C       G(T5,N169,FULL)
        CALL xE01234_NEW(RMF2(1),RMF2(4),RMF2(3),MH02,RMF2(2),S14,
     &  S34,T13,T12,S12,CMF2(1),NULL,CMF2(4),XMW2,XMW2,E0N,E1N,E2N,
     &  E3N,E4N,D0,D1,D2,D3,2,1)
        K(1) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = -((QF(1)*QF(4)*ALPHA*SBA*XMW)/(8D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)-2D0*PRE*(10D0*E2N(0,0)-E1N(4)*S12-
     &  2D0*E2N(1,4)*S12+E1N(1)*S14+2D0*E1N(2)*S14+2D0*E2N(1,2)*S14+
     &  2D0*E2N(1,3)*S14+2D0*E2N(2,2)*S14-2D0*E2N(2,4)*(S12+S24)+
     &  2D0*E2N(3,3)*(S14+S34)+E1N(3)*(2D0*S14+S34)+2D0*E2N(2,3)*
     &  (2D0*S14+S34)-2D0*E2N(3,4)*(MH02-T12))
        F(2,-1,-1) = F(2,-1,-1)-2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(3,-1,-1) = F(3,-1,-1)+2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(5,-1,-1) = F(5,-1,-1)-4D0*(2D0*E1N(3)+3D0*E2N(1,3)+3D0*
     &  E2N(2,3)+3D0*E2N(3,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)+4D0*E2N(3,4)*PRE
        F(7,-1,-1) = F(7,-1,-1)-4D0*K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(E1N(4)+E2N(2,4)+E2N(3,4))*PRE
        F(9,-1,-1) = F(9,-1,-1)+(E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3))*
     &  PRE
        F(10,-1,-1) = F(10,-1,-1)-E2N(3,4)*PRE
        F(11,-1,-1) = F(11,-1,-1)+K(1)*PRE
        F(12,-1,-1) = F(12,-1,-1)+(-(E2N(2,4))-E2N(3,4))*PRE
        F(13,-1,-1) = F(13,-1,-1)+E2N(0,0)*PRE

C       G(T5,N170,FULL)
        CALL xE01234_NEW(RMF2(1),RMF2(4),RMF2(3),MH02,RMF2(2),S14,
     &  S34,T13,T12,S12,CMF2(1),XMZ2,CMF2(4),XMW2,XMW2,E0N,E1N,E2N,
     &  E3N,E4N,D0,D1,D2,D3,2,1)
        K(1) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = -((ALPHA*SBA*XMW*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*(1D0-
     &  2D0*QF(4)*XSW2))/(32D0*PI*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)-2D0*PRE*(10D0*E2N(0,0)-E1N(4)*S12-
     &  2D0*E2N(1,4)*S12+E1N(1)*S14+2D0*E1N(2)*S14+2D0*E2N(1,2)*S14+
     &  2D0*E2N(1,3)*S14+2D0*E2N(2,2)*S14-2D0*E2N(2,4)*(S12+S24)+
     &  2D0*E2N(3,3)*(S14+S34)+E1N(3)*(2D0*S14+S34)+2D0*E2N(2,3)*
     &  (2D0*S14+S34)-2D0*E2N(3,4)*(MH02-T12))
        F(2,-1,-1) = F(2,-1,-1)-2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(3,-1,-1) = F(3,-1,-1)+2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(5,-1,-1) = F(5,-1,-1)-4D0*(2D0*E1N(3)+3D0*E2N(1,3)+3D0*
     &  E2N(2,3)+3D0*E2N(3,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)+4D0*E2N(3,4)*PRE
        F(7,-1,-1) = F(7,-1,-1)-4D0*K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(E1N(4)+E2N(2,4)+E2N(3,4))*PRE
        F(9,-1,-1) = F(9,-1,-1)+(E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3))*
     &  PRE
        F(10,-1,-1) = F(10,-1,-1)-E2N(3,4)*PRE
        F(11,-1,-1) = F(11,-1,-1)+K(1)*PRE
        F(12,-1,-1) = F(12,-1,-1)+(-(E2N(2,4))-E2N(3,4))*PRE
        F(13,-1,-1) = F(13,-1,-1)+E2N(0,0)*PRE

C       G(T5,N173,FULL)

C       G(T5,N176,FULL)
        CALL xE01234_NEW(RMF2(1),RMF2(4),RMF2(3),MH02,RMF2(2),S14,
     &  S34,T13,T12,S12,CMF2(2),XMW2,CMF2(3),XMZ2,XMZ2,E0N,E1N,E2N,
     &  E3N,E4N,D0,D1,D2,D3,2,1)
        K(1) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = -((ALPHA*SBA*XMZ*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2)*(1D0+
     &  2D0*QF(3)*XSW2))/(32D0*PI*XCW*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)-2D0*PRE*(10D0*E2N(0,0)-E1N(4)*S12-
     &  2D0*E2N(1,4)*S12+E1N(1)*S14+2D0*E1N(2)*S14+2D0*E2N(1,2)*S14+
     &  2D0*E2N(1,3)*S14+2D0*E2N(2,2)*S14-2D0*E2N(2,4)*(S12+S24)+
     &  2D0*E2N(3,3)*(S14+S34)+E1N(3)*(2D0*S14+S34)+2D0*E2N(2,3)*
     &  (2D0*S14+S34)-2D0*E2N(3,4)*(MH02-T12))
        F(2,-1,-1) = F(2,-1,-1)-2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(3,-1,-1) = F(3,-1,-1)+2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(5,-1,-1) = F(5,-1,-1)-4D0*(2D0*E1N(3)+3D0*E2N(1,3)+3D0*
     &  E2N(2,3)+3D0*E2N(3,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)+4D0*E2N(3,4)*PRE
        F(7,-1,-1) = F(7,-1,-1)-4D0*K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(E1N(4)+E2N(2,4)+E2N(3,4))*PRE
        F(9,-1,-1) = F(9,-1,-1)+(E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3))*
     &  PRE
        F(10,-1,-1) = F(10,-1,-1)-E2N(3,4)*PRE
        F(11,-1,-1) = F(11,-1,-1)+K(1)*PRE
        F(12,-1,-1) = F(12,-1,-1)+(-(E2N(2,4))-E2N(3,4))*PRE
        F(13,-1,-1) = F(13,-1,-1)+E2N(0,0)*PRE

C       G(T10,N337,FULL)

C       G(T10,N340,FULL)

C       G(T10,N347,FULL)

C       G(T10,N348,FULL)
        CALL xE01234_NEW(RMF2(2),RMF2(4),RMF2(3),MH02,RMF2(1),S24,
     &  S34,T13,T11,S12,CMF2(2),NULL,CMF2(4),XMW2,XMW2,E0N,E1N,E2N,
     &  E3N,E4N,D0,D1,D2,D3,2,1)

        PRE = (QF(2)*QF(4)*ALPHA*SBA*XMW)/(8D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)-2D0*PRE*(-(2D0*E2N(3,4)*S13)+E1N(1)*
     &  S24)
        F(2,-1,-1) = F(2,-1,-1)+2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(3,-1,-1) = F(3,-1,-1)-2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(5,-1,-1) = F(5,-1,-1)-8D0*E2N(3,4)*PRE
        F(6,-1,-1) = F(6,-1,-1)+4D0*E1N(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*E1N(4)*PRE
        F(9,-1,-1) = F(9,-1,-1)+E2N(3,4)*PRE
        F(10,-1,-1) = F(10,-1,-1)+(-(E1N(3))-E2N(1,3)-E2N(2,3)-
     &  E2N(3,3))*PRE
        F(11,-1,-1) = F(11,-1,-1)+(E2N(2,4)+E2N(3,4))*PRE
        F(12,-1,-1) = F(12,-1,-1)+(-(E1N(2))-E1N(3)-E2N(1,2)-E2N(1,
     &  3)-E2N(2,2)-2D0*E2N(2,3)-E2N(3,3))*PRE
        F(13,-1,-1) = F(13,-1,-1)-E2N(0,0)*PRE

C       G(T10,N349,FULL)
        CALL xE01234_NEW(RMF2(2),RMF2(4),RMF2(3),MH02,RMF2(1),S24,
     &  S34,T13,T11,S12,CMF2(2),XMZ2,CMF2(4),XMW2,XMW2,E0N,E1N,E2N,
     &  E3N,E4N,D0,D1,D2,D3,2,1)

        PRE = -((ALPHA*SBA*XMW*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2)*(1D0-
     &  2D0*QF(4)*XSW2))/(32D0*PI*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)-2D0*PRE*(-(2D0*E2N(3,4)*S13)+E1N(1)*
     &  S24)
        F(2,-1,-1) = F(2,-1,-1)+2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(3,-1,-1) = F(3,-1,-1)-2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(5,-1,-1) = F(5,-1,-1)-8D0*E2N(3,4)*PRE
        F(6,-1,-1) = F(6,-1,-1)+4D0*E1N(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*E1N(4)*PRE
        F(9,-1,-1) = F(9,-1,-1)+E2N(3,4)*PRE
        F(10,-1,-1) = F(10,-1,-1)+(-(E1N(3))-E2N(1,3)-E2N(2,3)-
     &  E2N(3,3))*PRE
        F(11,-1,-1) = F(11,-1,-1)+(E2N(2,4)+E2N(3,4))*PRE
        F(12,-1,-1) = F(12,-1,-1)+(-(E1N(2))-E1N(3)-E2N(1,2)-E2N(1,
     &  3)-E2N(2,2)-2D0*E2N(2,3)-E2N(3,3))*PRE
        F(13,-1,-1) = F(13,-1,-1)-E2N(0,0)*PRE

C       G(T10,N352,FULL)

C       G(T10,N355,FULL)
        CALL xE01234_NEW(RMF2(2),RMF2(4),RMF2(3),MH02,RMF2(1),S24,
     &  S34,T13,T11,S12,CMF2(1),XMW2,CMF2(3),XMZ2,XMZ2,E0N,E1N,E2N,
     &  E3N,E4N,D0,D1,D2,D3,2,1)

        PRE = -((ALPHA*SBA*XMZ*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*(1D0+
     &  2D0*QF(3)*XSW2))/(32D0*PI*XCW*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)-2D0*PRE*(-(2D0*E2N(3,4)*S13)+E1N(1)*
     &  S24)
        F(2,-1,-1) = F(2,-1,-1)+2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(3,-1,-1) = F(3,-1,-1)-2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(5,-1,-1) = F(5,-1,-1)-8D0*E2N(3,4)*PRE
        F(6,-1,-1) = F(6,-1,-1)+4D0*E1N(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*E1N(4)*PRE
        F(9,-1,-1) = F(9,-1,-1)+E2N(3,4)*PRE
        F(10,-1,-1) = F(10,-1,-1)+(-(E1N(3))-E2N(1,3)-E2N(2,3)-
     &  E2N(3,3))*PRE
        F(11,-1,-1) = F(11,-1,-1)+(E2N(2,4)+E2N(3,4))*PRE
        F(12,-1,-1) = F(12,-1,-1)+(-(E1N(2))-E1N(3)-E2N(1,2)-E2N(1,
     &  3)-E2N(2,2)-2D0*E2N(2,3)-E2N(3,3))*PRE
        F(13,-1,-1) = F(13,-1,-1)-E2N(0,0)*PRE

C       G(T12,N434,FULL)

C       G(T12,N437,FULL)

C       G(T12,N444,FULL)

C       G(T12,N445,FULL)
        CALL xE01234_NEW(RMF2(3),RMF2(2),RMF2(1),MH02,RMF2(4),S23,
     &  S12,T11,T14,S34,CMF2(3),NULL,CMF2(2),XMW2,XMW2,E0N,E1N,E2N,
     &  E3N,E4N,D0,D1,D2,D3,2,1)
        K(1) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = -((QF(2)*QF(3)*ALPHA*SBA*XMW)/(8D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)-2D0*PRE*(10D0*E2N(0,0)+E1N(1)*S23+
     &  2D0*E1N(2)*S23+2D0*E2N(1,2)*S23+2D0*E2N(1,3)*S23+2D0*E2N(2,
     &  2)*S23+2D0*E2N(3,3)*(S12+S23)+E1N(3)*(S12+2D0*S23)+2D0*
     &  E2N(2,3)*(S12+2D0*S23)-E1N(4)*S34-2D0*E2N(1,4)*S34-2D0*
     &  E2N(2,4)*(S24+S34)-2D0*E2N(3,4)*(MH02-T14))
        F(2,-1,-1) = F(2,-1,-1)+2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(3,-1,-1) = F(3,-1,-1)-2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(5,-1,-1) = F(5,-1,-1)-4D0*(2D0*E1N(3)+3D0*E2N(1,3)+3D0*
     &  E2N(2,3)+3D0*E2N(3,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)-4D0*K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*E2N(3,4)*PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(E1N(4)+E2N(2,4)+E2N(3,4))*PRE
        F(9,-1,-1) = F(9,-1,-1)+(E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3))*
     &  PRE
        F(10,-1,-1) = F(10,-1,-1)+K(1)*PRE
        F(11,-1,-1) = F(11,-1,-1)-E2N(3,4)*PRE
        F(12,-1,-1) = F(12,-1,-1)+(-(E2N(2,4))-E2N(3,4))*PRE
        F(13,-1,-1) = F(13,-1,-1)+E2N(0,0)*PRE

C       G(T12,N446,FULL)
        CALL xE01234_NEW(RMF2(3),RMF2(2),RMF2(1),MH02,RMF2(4),S23,
     &  S12,T11,T14,S34,CMF2(3),XMZ2,CMF2(2),XMW2,XMW2,E0N,E1N,E2N,
     &  E3N,E4N,D0,D1,D2,D3,2,1)
        K(1) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = -((ALPHA*SBA*XMW*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2)*(1D0+
     &  2D0*QF(3)*XSW2))/(32D0*PI*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)-2D0*PRE*(10D0*E2N(0,0)+E1N(1)*S23+
     &  2D0*E1N(2)*S23+2D0*E2N(1,2)*S23+2D0*E2N(1,3)*S23+2D0*E2N(2,
     &  2)*S23+2D0*E2N(3,3)*(S12+S23)+E1N(3)*(S12+2D0*S23)+2D0*
     &  E2N(2,3)*(S12+2D0*S23)-E1N(4)*S34-2D0*E2N(1,4)*S34-2D0*
     &  E2N(2,4)*(S24+S34)-2D0*E2N(3,4)*(MH02-T14))
        F(2,-1,-1) = F(2,-1,-1)+2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(3,-1,-1) = F(3,-1,-1)-2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(5,-1,-1) = F(5,-1,-1)-4D0*(2D0*E1N(3)+3D0*E2N(1,3)+3D0*
     &  E2N(2,3)+3D0*E2N(3,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)-4D0*K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*E2N(3,4)*PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(E1N(4)+E2N(2,4)+E2N(3,4))*PRE
        F(9,-1,-1) = F(9,-1,-1)+(E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3))*
     &  PRE
        F(10,-1,-1) = F(10,-1,-1)+K(1)*PRE
        F(11,-1,-1) = F(11,-1,-1)-E2N(3,4)*PRE
        F(12,-1,-1) = F(12,-1,-1)+(-(E2N(2,4))-E2N(3,4))*PRE
        F(13,-1,-1) = F(13,-1,-1)+E2N(0,0)*PRE

C       G(T12,N449,FULL)

C       G(T12,N452,FULL)
        CALL xE01234_NEW(RMF2(3),RMF2(2),RMF2(1),MH02,RMF2(4),S23,
     &  S12,T11,T14,S34,CMF2(4),XMW2,CMF2(1),XMZ2,XMZ2,E0N,E1N,E2N,
     &  E3N,E4N,D0,D1,D2,D3,2,1)
        K(1) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = -((ALPHA*SBA*XMZ*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*(1D0-
     &  2D0*QF(4)*XSW2))/(32D0*PI*XCW*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)-2D0*PRE*(10D0*E2N(0,0)+E1N(1)*S23+
     &  2D0*E1N(2)*S23+2D0*E2N(1,2)*S23+2D0*E2N(1,3)*S23+2D0*E2N(2,
     &  2)*S23+2D0*E2N(3,3)*(S12+S23)+E1N(3)*(S12+2D0*S23)+2D0*
     &  E2N(2,3)*(S12+2D0*S23)-E1N(4)*S34-2D0*E2N(1,4)*S34-2D0*
     &  E2N(2,4)*(S24+S34)-2D0*E2N(3,4)*(MH02-T14))
        F(2,-1,-1) = F(2,-1,-1)+2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(3,-1,-1) = F(3,-1,-1)-2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(5,-1,-1) = F(5,-1,-1)-4D0*(2D0*E1N(3)+3D0*E2N(1,3)+3D0*
     &  E2N(2,3)+3D0*E2N(3,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)-4D0*K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*E2N(3,4)*PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(E1N(4)+E2N(2,4)+E2N(3,4))*PRE
        F(9,-1,-1) = F(9,-1,-1)+(E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3))*
     &  PRE
        F(10,-1,-1) = F(10,-1,-1)+K(1)*PRE
        F(11,-1,-1) = F(11,-1,-1)-E2N(3,4)*PRE
        F(12,-1,-1) = F(12,-1,-1)+(-(E2N(2,4))-E2N(3,4))*PRE
        F(13,-1,-1) = F(13,-1,-1)+E2N(0,0)*PRE

	end

**********************************************************************
        subroutine  h0toWW4f_self_ferm2_thdm(F,pw12,pw34)
**********************************************************************
*       self-energy contributions for h0 -> WW -> 4f in the THDM
*       closed fermion loops
*---------------------------------------------------------------------
*       24.4.16 Stefan Dittmaier
**********************************************************************
	implicit none
	complex*16 pre,F(13,-1:1,-1:1),pw12,pw34

c mandelstam variables
      	real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      	common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion charges of isospin duplets
	real*8 qf(4)
	common/fcharge/qf
c fermion masses as flag (i*1d-20)
      	complex*16 cme2,cmf2(5)
      	real*8 me2,rme2,mf2(5),rmf2(5)
      	common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
      	complex*16 fact,xseww_ferm
	include '../COMMON/param.inc'
	include '../COMMON/xparam.inc'
        include '../COMMON/param_thdm.inc'
        include '../COMMON/param_bsm.inc'

C       Process: S1F21aF22F23aF24,   Model: THDM

C       G(T1,N9,FULL)

        fact = - xseww_ferm(s12)*pw12 - xseww_ferm(s34)*pw34

        PRE = (PW12*PW34*SBA*XMW)/(2D0*XSW*XSW2) * fact

        F(1,-1,-1) = F(1,-1,-1)+PRE

	end

**********************************************************************
        subroutine  h0toWW4f_self_ferm_thdm(F,pw12,pw34)
**********************************************************************
*       self-energy contributions for h0 -> WW -> 4f in the THDM
*       closed fermion loops
*---------------------------------------------------------------------
*       24.4.16 Stefan Dittmaier
**********************************************************************
	implicit none
	complex*16 pre,F(13,-1:1,-1:1),pw12,pw34
	complex*16 A0,xA0_,B0_,xB0_,DB0_,xDB0_,B1_,xB1_,DB1_,xDB1_
        complex*16 B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 C0_,C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,2)
        complex*16 C4(0:2,0:2,0:2,0:2)
	complex*16 D0,D1(3),D2(0:3,0:3),D3(0:3,0:3,3)
        complex*16 D4(0:3,0:3,0:3,0:3),D5(0:3,0:3,0:3,0:3,3)
	complex*16 E0n,E1n(4),E2n(0:4,0:4),E3n(0:4,0:4,4)
	complex*16 E4n(0:4,0:4,0:4,0:4)
	integer i

c mandelstam variables
      	real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      	common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion charges of isospin duplets
	real*8 qf(4)
	common/fcharge/qf
c fermion masses as flag (i*1d-20)
      	complex*16 cme2,cmf2(5)
      	real*8 me2,rme2,mf2(5),rmf2(5)
      	common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
	include '../COMMON/param.inc'
	include '../COMMON/xparam.inc'
        include '../COMMON/param_thdm.inc'
        include '../COMMON/param_bsm.inc'

	do 100 i=1,3

C       Process: S1F21aF22F23aF24,   Model: THDM

C       G(T3,N357,FULL)

C       G(T3,N358,FULL)

C       G(T3,N467,FULL)

C       G(T3,N468,FULL)

C       G(T3,N601,FULL)
        CALL xB012345_(S12,XMQP2(I),XMQM2(I),B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*PW12**2*PW34*SBA*XMW*XSW2**(-2)*(12D0*B2(0,0)+
     &  S12+6D0*B1(1)*S12+6D0*B2(1,1)*S12-3D0*XMQM2(I)-3D0*
     &  XMQP2(I)))/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T3,N602,FULL)
        CALL xB012345_(S12,NULL,XML2(I),B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*PW12**2*PW34*SBA*XMW*XSW2**(-2)*(12D0*B2(0,0)+
     &  S12+6D0*B1(1)*S12+6D0*B2(1,1)*S12-3D0*XML2(I)))/(48D0*PI*
     &  XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T4,N741,FULL)

C       G(T4,N742,FULL)

C       G(T4,N851,FULL)

C       G(T4,N852,FULL)

C       G(T4,N985,FULL)
        CALL xB012345_(S34,XMQM2(I),XMQP2(I),B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*PW12*PW34**2*SBA*XMW*XSW2**(-2)*(12D0*B2(0,0)+
     &  S34+6D0*B1(1)*S34+6D0*B2(1,1)*S34-3D0*XMQM2(I)-3D0*
     &  XMQP2(I)))/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T4,N986,FULL)
        CALL xB012345_(S34,NULL,XML2(I),B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*PW12*PW34**2*SBA*XMW*XSW2**(-2)*(12D0*B2(0,0)+
     &  S34+6D0*B1(1)*S34+6D0*B2(1,1)*S34-3D0*XML2(I)))/(48D0*PI*
     &  XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

100	continue

	end

**********************************************************************
        subroutine  h0toWW4f_vert_ferm_thdm(F,pw12,pw34)
**********************************************************************
*       self-energy contributions for h0 -> WW -> 4f in the THDM
*       closed fermion loops
*---------------------------------------------------------------------
*       24.4.16 Stefan Dittmaier
**********************************************************************
	implicit none
	complex*16 pre,F(13,-1:1,-1:1),pw12,pw34
	complex*16 A0,xA0_,B0_,xB0_,DB0_,xDB0_,B1_,xB1_,DB1_,xDB1_
        complex*16 B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 C0_,C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,2)
        complex*16 C4(0:2,0:2,0:2,0:2)
	complex*16 D0,D1(3),D2(0:3,0:3),D3(0:3,0:3,3)
        complex*16 D4(0:3,0:3,0:3,0:3),D5(0:3,0:3,0:3,0:3,3)
	complex*16 E0n,E1n(4),E2n(0:4,0:4),E3n(0:4,0:4,4)
	complex*16 E4n(0:4,0:4,0:4,0:4)
	real *8 qeps
	integer i

c mandelstam variables
      	real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      	common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion charges of isospin duplets
	real*8 qf(4)
	common/fcharge/qf
c fermion masses as flag (i*1d-20)
      	complex*16 cme2,cmf2(5)
      	real*8 me2,rme2,mf2(5),rmf2(5)
      	common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
	include '../COMMON/param.inc'
	include '../COMMON/xparam.inc'
        include '../COMMON/param_thdm.inc'
        include '../COMMON/param_bsm.inc'

	qeps = 1d0

	do 100 i=1,3

C       Process: S1F21aF22F23aF24,   Model: THDM

C       G(T9,N967,FULL)

C       G(T9,N968,FULL)

C       G(T9,N969,FULL)
        CALL xC01234_(S12,MH02,S34,XMQP2(I),XMQM2(I),XMQM2(I),C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,0)

        PRE = -((3D0*ALPHA*CDOH*PW12*PW34*XSW2**(-2)*XMQM2(I))/
     &  (32D0*PI*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(2D0-8D0*C2(0,0)-4D0*C2(1,1)*
     &  S12+4D0*C2(1,2)*(S13+S14+S23+S24)-C1(1)*(2D0*S12-S13-QEPS*
     &  S13-S14-QEPS*S14-S23+QEPS*S23-S24+QEPS*S24)-4D0*C2(2,2)*S34+
     &  C1(2)*(S13-QEPS*S13+S14-QEPS*S14+S23+QEPS*S23+S24+QEPS*S24-
     &  2D0*S34))
        F(5,-1,-1) = F(5,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(1)*(1D0+
     &  QEPS)+C1(2)*(1D0-QEPS))
        F(6,-1,-1) = F(6,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(2)*(1D0+
     &  QEPS)+C1(1)*(1D0-QEPS))
        F(7,-1,-1) = F(7,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(1)*(1D0+
     &  QEPS)+C1(2)*(1D0-QEPS))
        F(8,-1,-1) = F(8,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(2)*(1D0+
     &  QEPS)+C1(1)*(1D0-QEPS))

C       G(T9,N970,FULL)
        CALL xC01234_(S12,MH02,S34,NULL,XML2(I),XML2(I),C0,C1,C2,C3,C4,B0,
     &  B1,B2,B3,2,0)

        PRE = -((ALPHA*CLEPH*PW12*PW34*XSW2**(-2)*XML2(I))/(32D0*PI*
     &  XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(2D0-8D0*C2(0,0)-4D0*C2(1,1)*
     &  S12+4D0*C2(1,2)*(S13+S14+S23+S24)-C1(1)*(2D0*S12-S13-QEPS*
     &  S13-S14-QEPS*S14-S23+QEPS*S23-S24+QEPS*S24)-4D0*C2(2,2)*S34+
     &  C1(2)*(S13-QEPS*S13+S14-QEPS*S14+S23+QEPS*S23+S24+QEPS*S24-
     &  2D0*S34))
        F(5,-1,-1) = F(5,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(1)*(1D0+
     &  QEPS)+C1(2)*(1D0-QEPS))
        F(6,-1,-1) = F(6,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(2)*(1D0+
     &  QEPS)+C1(1)*(1D0-QEPS))
        F(7,-1,-1) = F(7,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(1)*(1D0+
     &  QEPS)+C1(2)*(1D0-QEPS))
        F(8,-1,-1) = F(8,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(2)*(1D0+
     &  QEPS)+C1(1)*(1D0-QEPS))

C       G(T9,N971,FULL)
        CALL xC01234_(S12,MH02,S34,XMQM2(I),XMQP2(I),XMQP2(I),C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,0)

        PRE = -((3D0*ALPHA*CUPH*PW12*PW34*XSW2**(-2)*XMQP2(I))/
     &  (32D0*PI*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(2D0-8D0*C2(0,0)-4D0*C2(1,1)*
     &  S12+4D0*C2(1,2)*(S13+S14+S23+S24)-C1(1)*(2D0*S12-S13+QEPS*
     &  S13-S14+QEPS*S14-S23-QEPS*S23-S24-QEPS*S24)-4D0*C2(2,2)*S34+
     &  C1(2)*(S13+QEPS*S13+S14+QEPS*S14+S23-QEPS*S23+S24-QEPS*S24-
     &  2D0*S34))
        F(5,-1,-1) = F(5,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(2)*(1D0+
     &  QEPS)+C1(1)*(1D0-QEPS))
        F(6,-1,-1) = F(6,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(1)*(1D0+
     &  QEPS)+C1(2)*(1D0-QEPS))
        F(7,-1,-1) = F(7,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(2)*(1D0+
     &  QEPS)+C1(1)*(1D0-QEPS))
        F(8,-1,-1) = F(8,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(1)*(1D0+
     &  QEPS)+C1(2)*(1D0-QEPS))

C       G(T9,N972,FULL)

C       G(T9,N973,FULL)

100	continue

	end
