**********************************************************************
        function xsehp_ferm_thdm(s)
**********************************************************************
*       unrenormalized charged Higgs-boson self-energy
*       closed fermion loops only
*       THDM
*---------------------------------------------------------------------
*       30.5.16 Stefan Dittmaier
**********************************************************************
        implicit real*8 (a-z)
        complex*16 xsehp_ferm_thdm
        complex*16 B0_,xB0_
        complex*16 B00l,B00u,B00d,Bsln,Bsdu
	integer i

        include '../COMMON/param.inc'
        include '../COMMON/xparam.inc'
        include '../COMMON/param_thdm.inc'
        include '../COMMON/param_bsm.inc'

	xsehp_ferm_thdm = 0d0

	do 100 i=1,3

	B00l  =  xB0_(0D0,null, xML2(I),0)
	B00u  =  xB0_(0D0,null,xMQP2(I),0)
	B00d  =  xB0_(0D0,null,xMQM2(I),0)
	Bsln  =  xB0_(s, xML2(I),null,0)
	Bsdu  =  xB0_(s,xMQM2(I),xMQP2(I),0)

	xsehp_ferm_thdm = xsehp_ferm_thdm
     &  -3D0*ALPHA*B00D*XMQM2(I)*(CDOA**2*XMQM2(I)+CUPA**2*XMQP2(I))
     &  /(8D0*PI*XMW2*XSW2)
     &  -ALPHA*CLEPA**2*B00L*XML2(I)**2/(8D0*PI*XMW2*XSW2)
     &  -3D0*ALPHA*B00U*XMQP2(I)*(CDOA**2*XMQM2(I)+CUPA**2*XMQP2(I))
     &  /(8D0*PI*XMW2*XSW2)
     &  +3D0*ALPHA*BSDU*(CDOA**2*S*XMQM2(I)-CDOA**2*XMQM2(I)**2
     &  +CUPA**2*S*XMQP2(I)-CDOA**2*XMQM2(I)*XMQP2(I)
     &  +4D0*CDOA*CUPA*XMQM2(I)*XMQP2(I)-CUPA**2*XMQM2(I)*XMQP2(I)
     &  -CUPA**2*XMQP2(I)**2)/(8D0*PI*XMW2*XSW2)
     &  +ALPHA*CLEPA**2*BSLn*XML2(I)*(S-XML2(I))/(8D0*PI*XMW2*XSW2)

100	continue

	end

**********************************************************************
        function xsehp_thdm(s)
**********************************************************************
*       unrenormalized charged Higgs-boson self-energy
*       bosonic loops only
*       THDM
*---------------------------------------------------------------------
*       30.5.16 Stefan Dittmaier
**********************************************************************
        implicit real*8 (a-z)
        complex*16 xsehp_thdm
        complex*16 B0_,xB0_
        complex*16 B00H0,B00HH,B00A0,B00HP,B00W,B00Z 
	complex*16 BS0HP,BSA0W,BSH0HP,BSH0W,BSHHHP,BSHHW,BSHPZ  

        include '../COMMON/param.inc'
        include '../COMMON/xparam.inc'
        include '../COMMON/param_thdm.inc'
        include '../COMMON/param_bsm.inc'

        B00H0  = xB0_(0D0,null,xMH02,0)	
        B00HH  = xB0_(0D0,null,xMHH2,0)
        B00A0  = xB0_(0D0,null,xMA02,0)
        B00HP  = xB0_(0D0,null,xMHP2,0)	
        B00W   = xB0_(0D0,null,xMW2,0)	
        B00Z   = xB0_(0D0,null,xMZ2,0)

	BS0HP  = xB0_(S,0D0,XMHP2,0)
	BSA0W  = xB0_(S,XMA02,XMW2,0)
	BSH0HP = xB0_(S,XMH02,XMHP2,0)
	BSH0W  = xB0_(S,XMH02,XMW2,0)
	BSHHHP = xB0_(S,XMHH2,XMHP2,0)
	BSHHW  = xB0_(S,XMHH2,XMW2,0)
	BSHPZ  = xB0_(S,XMHP2,XMZ2,0)

	xsehp_thdm =
     &  -((ALPHA*(2D0*XCW2*XMW2+XCW2**2*XMZ2-2D0*XCW2*XMZ2*XSW2+
     &  XMZ2*XSW2**2))/(8D0*PI*XCW2*XSW2))
     &  +(CB**(-2)*PI**(-2)*S2B**(-2)*SB**(-2)*XMA02*(-(64D0*ALPHA*
     &  C2B**2*CB**2*PI*SB**2*XMA02)+9D0*ALPHA*CAB**2*PI*S2B**2*
     &  XMH02+6D0*ALPHA*C2B*CAB*CBA*PI*S2B**2*XMH02+ALPHA*C2B**2*
     &  CBA**2*PI*S2B**2*XMH02-6D0*ALPHA*CAB*PI*S2B**3*SBA*XMH02-
     &  2D0*ALPHA*C2B*CBA*PI*S2B**3*SBA*XMH02+ALPHA*PI*S2B**4*SBA**
     &  2*XMH02+16D0*ALPHA*CB**6*PI*S2B**2*SA**2*XMHH2+32D0*ALPHA*
     &  CA*CB**3*PI*S2B**2*SA*SB**3*XMHH2+16D0*ALPHA*CA**2*PI*S2B**
     &  2*SB**6*XMHH2+32D0*ALPHA*CB**2*PI*S2B**2*SB**2*XMW2-64D0*
     &  C2B**2*CB**2*LAM5*SB**2*XMW2*XSW2)*B00A0)/
     &  (512D0*XMW2*XSW2)
     &  +(CB**(-2)*PI**(-2)*SB**(-2)*XMH02*(-(12D0*ALPHA*PI*XMA02)-
     &  14D0*ALPHA*C2A*C2B*PI*XMA02-4D0*ALPHA*C2B**2*PI*XMA02-2D0*
     &  ALPHA*C2B**2*CA**2*CB**2*PI*XMA02+6D0*ALPHA*PI*S2A*S2B*
     &  XMA02+4D0*ALPHA*PI*S2B**2*XMA02+2D0*ALPHA*CA**2*CB**2*PI*
     &  S2B**2*XMA02-8D0*ALPHA*C2B*CA*CB**2*PI*S2B*SA*XMA02+2D0*
     &  ALPHA*C2B**2*CB**2*PI*SA**2*XMA02-2D0*ALPHA*CB**2*PI*S2B**2*
     &  SA**2*XMA02+8D0*ALPHA*C2B*CA**2*CB*PI*S2B*SB*XMA02-8D0*
     &  ALPHA*C2B**2*CA*CB*PI*SA*SB*XMA02+8D0*ALPHA*CA*CB*PI*S2B**2*
     &  SA*SB*XMA02-8D0*ALPHA*C2B*CB*PI*S2B*SA**2*SB*XMA02+2D0*
     &  ALPHA*C2B**2*CA**2*PI*SB**2*XMA02-2D0*ALPHA*CA**2*PI*S2B**2*
     &  SB**2*XMA02+8D0*ALPHA*C2B*CA*PI*S2B*SA*SB**2*XMA02-2D0*
     &  ALPHA*C2B**2*PI*SA**2*SB**2*XMA02+2D0*ALPHA*PI*S2B**2*SA**2*
     &  SB**2*XMA02+9D0*ALPHA*PI*XMH02+3D0*ALPHA*C2A**2*PI*XMH02+
     &  16D0*ALPHA*C2A*C2B*PI*XMH02+3D0*ALPHA*C2B**2*PI*XMH02+ALPHA*
     &  C2A**2*C2B**2*PI*XMH02-3D0*ALPHA*PI*S2A**2*XMH02-ALPHA*C2B**
     &  2*PI*S2A**2*XMH02-4D0*ALPHA*PI*S2A*S2B*XMH02+4D0*ALPHA*C2A*
     &  C2B*PI*S2A*S2B*XMH02-3D0*ALPHA*PI*S2B**2*XMH02-ALPHA*C2A**2*
     &  PI*S2B**2*XMH02+ALPHA*PI*S2A**2*S2B**2*XMH02+6D0*ALPHA*PI*
     &  S2A**2*XMHH2+2D0*ALPHA*C2B**2*PI*S2A**2*XMHH2+4D0*ALPHA*PI*
     &  S2A*S2B*XMHH2-4D0*ALPHA*C2A*C2B*PI*S2A*S2B*XMHH2-2D0*ALPHA*
     &  PI*S2A**2*S2B**2*XMHH2+64D0*ALPHA*CB**2*PI*SB**2*SBA**2*
     &  XMHP2+64D0*ALPHA*CB**2*CBA**2*PI*SB**2*XMW2-12D0*LAM5*XMW2*
     &  XSW2-14D0*C2A*C2B*LAM5*XMW2*XSW2-4D0*C2B**2*LAM5*XMW2*XSW2-
     &  2D0*C2B**2*CA**2*CB**2*LAM5*XMW2*XSW2+6D0*LAM5*S2A*S2B*XMW2*
     &  XSW2+4D0*LAM5*S2B**2*XMW2*XSW2+2D0*CA**2*CB**2*LAM5*S2B**2*
     &  XMW2*XSW2-8D0*C2B*CA*CB**2*LAM5*S2B*SA*XMW2*XSW2+2D0*C2B**2*
     &  CB**2*LAM5*SA**2*XMW2*XSW2-2D0*CB**2*LAM5*S2B**2*SA**2*XMW2*
     &  XSW2+8D0*C2B*CA**2*CB*LAM5*S2B*SB*XMW2*XSW2-8D0*C2B**2*CA*
     &  CB*LAM5*SA*SB*XMW2*XSW2+8D0*CA*CB*LAM5*S2B**2*SA*SB*XMW2*
     &  XSW2-8D0*C2B*CB*LAM5*S2B*SA**2*SB*XMW2*XSW2+2D0*C2B**2*CA**
     &  2*LAM5*SB**2*XMW2*XSW2-2D0*CA**2*LAM5*S2B**2*SB**2*XMW2*
     &  XSW2+8D0*C2B*CA*LAM5*S2B*SA*SB**2*XMW2*XSW2-2D0*C2B**2*LAM5*
     &  SA**2*SB**2*XMW2*XSW2+2D0*LAM5*S2B**2*SA**2*SB**2*XMW2*
     &  XSW2)*B00H0)/(1024D0*XMW2*XSW2)
     &  +(CB**(-2)*PI**(-2)*SB**(-2)*XMHH2*(-(12D0*ALPHA*PI*XMA02)+
     &  14D0*ALPHA*C2A*C2B*PI*XMA02-4D0*ALPHA*C2B**2*PI*XMA02+2D0*
     &  ALPHA*C2B**2*CA**2*CB**2*PI*XMA02-6D0*ALPHA*PI*S2A*S2B*
     &  XMA02+4D0*ALPHA*PI*S2B**2*XMA02-2D0*ALPHA*CA**2*CB**2*PI*
     &  S2B**2*XMA02+8D0*ALPHA*C2B*CA*CB**2*PI*S2B*SA*XMA02-2D0*
     &  ALPHA*C2B**2*CB**2*PI*SA**2*XMA02+2D0*ALPHA*CB**2*PI*S2B**2*
     &  SA**2*XMA02-8D0*ALPHA*C2B*CA**2*CB*PI*S2B*SB*XMA02+8D0*
     &  ALPHA*C2B**2*CA*CB*PI*SA*SB*XMA02-8D0*ALPHA*CA*CB*PI*S2B**2*
     &  SA*SB*XMA02+8D0*ALPHA*C2B*CB*PI*S2B*SA**2*SB*XMA02-2D0*
     &  ALPHA*C2B**2*CA**2*PI*SB**2*XMA02+2D0*ALPHA*CA**2*PI*S2B**2*
     &  SB**2*XMA02-8D0*ALPHA*C2B*CA*PI*S2B*SA*SB**2*XMA02+2D0*
     &  ALPHA*C2B**2*PI*SA**2*SB**2*XMA02-2D0*ALPHA*PI*S2B**2*SA**2*
     &  SB**2*XMA02+6D0*ALPHA*PI*S2A**2*XMH02+2D0*ALPHA*C2B**2*PI*
     &  S2A**2*XMH02-4D0*ALPHA*PI*S2A*S2B*XMH02-4D0*ALPHA*C2A*C2B*
     &  PI*S2A*S2B*XMH02-2D0*ALPHA*PI*S2A**2*S2B**2*XMH02+9D0*ALPHA*
     &  PI*XMHH2+3D0*ALPHA*C2A**2*PI*XMHH2-16D0*ALPHA*C2A*C2B*PI*
     &  XMHH2+3D0*ALPHA*C2B**2*PI*XMHH2+ALPHA*C2A**2*C2B**2*PI*
     &  XMHH2-3D0*ALPHA*PI*S2A**2*XMHH2-ALPHA*C2B**2*PI*S2A**2*
     &  XMHH2+4D0*ALPHA*PI*S2A*S2B*XMHH2+4D0*ALPHA*C2A*C2B*PI*S2A*
     &  S2B*XMHH2-3D0*ALPHA*PI*S2B**2*XMHH2-ALPHA*C2A**2*PI*S2B**2*
     &  XMHH2+ALPHA*PI*S2A**2*S2B**2*XMHH2+64D0*ALPHA*CB**2*CBA**2*
     &  PI*SB**2*XMHP2+64D0*ALPHA*CB**2*PI*SB**2*SBA**2*XMW2-12D0*
     &  LAM5*XMW2*XSW2+14D0*C2A*C2B*LAM5*XMW2*XSW2-4D0*C2B**2*LAM5*
     &  XMW2*XSW2+2D0*C2B**2*CA**2*CB**2*LAM5*XMW2*XSW2-6D0*LAM5*
     &  S2A*S2B*XMW2*XSW2+4D0*LAM5*S2B**2*XMW2*XSW2-2D0*CA**2*CB**2*
     &  LAM5*S2B**2*XMW2*XSW2+8D0*C2B*CA*CB**2*LAM5*S2B*SA*XMW2*
     &  XSW2-2D0*C2B**2*CB**2*LAM5*SA**2*XMW2*XSW2+2D0*CB**2*LAM5*
     &  S2B**2*SA**2*XMW2*XSW2-8D0*C2B*CA**2*CB*LAM5*S2B*SB*XMW2*
     &  XSW2+8D0*C2B**2*CA*CB*LAM5*SA*SB*XMW2*XSW2-8D0*CA*CB*LAM5*
     &  S2B**2*SA*SB*XMW2*XSW2+8D0*C2B*CB*LAM5*S2B*SA**2*SB*XMW2*
     &  XSW2-2D0*C2B**2*CA**2*LAM5*SB**2*XMW2*XSW2+2D0*CA**2*LAM5*
     &  S2B**2*SB**2*XMW2*XSW2-8D0*C2B*CA*LAM5*S2B*SA*SB**2*XMW2*
     &  XSW2+2D0*C2B**2*LAM5*SA**2*SB**2*XMW2*XSW2-2D0*LAM5*S2B**2*
     &  SA**2*SB**2*XMW2*XSW2)*B00HH)/(1024D0*XMW2*XSW2)
     &  +(CB**(-2)*PI**(-2)*S2B**(-2)*SB**(-2)*XMHP2*(-(64D0*ALPHA*
     &  C2B**2*CB**2*PI*SB**2*XCW2*XMA02)+9D0*ALPHA*CAB**2*PI*S2B**
     &  2*XCW2*XMH02+6D0*ALPHA*C2B*CAB*CBA*PI*S2B**2*XCW2*XMH02+
     &  ALPHA*C2B**2*CBA**2*PI*S2B**2*XCW2*XMH02-6D0*ALPHA*CAB*PI*
     &  S2B**3*SBA*XCW2*XMH02-2D0*ALPHA*C2B*CBA*PI*S2B**3*SBA*XCW2*
     &  XMH02+ALPHA*PI*S2B**4*SBA**2*XCW2*XMH02+16D0*ALPHA*CB**6*PI*
     &  S2B**2*SA**2*XCW2*XMHH2+32D0*ALPHA*CA*CB**3*PI*S2B**2*SA*
     &  SB**3*XCW2*XMHH2+16D0*ALPHA*CA**2*PI*S2B**2*SB**6*XCW2*
     &  XMHH2+8D0*ALPHA*CB**2*PI*S2B**2*SB**2*XCW2**2*XMW2-64D0*
     &  C2B**2*CB**2*LAM5*SB**2*XCW2*XMW2*XSW2+16D0*ALPHA*CB**2*PI*
     &  S2B**2*SB**2*XCW2*XMW2*XSW2+8D0*ALPHA*CB**2*PI*S2B**2*SB**2*
     &  XMW2*XSW2**2)*B00HP)/(128D0*XCW2*XMW2*XSW2)
     &  +(PI**(-2)*(-(4D0*ALPHA*CB*PI*S2B*SB*XMA02)-4D0*ALPHA*C2B**2*
     &  CB*PI*S2A*SB*XMH02+4D0*ALPHA*CB*PI*S2B*SB*XMH02+4D0*ALPHA*
     &  C2A*C2B*CB*PI*S2B*SB*XMH02+ALPHA*PI*S2A*S2B*XMHH2+ALPHA*
     &  C2B**2*PI*S2A*S2B*XMHH2+2D0*ALPHA*PI*S2B**2*XMHH2-2D0*ALPHA*
     &  C2A*C2B*PI*S2B**2*XMHH2-ALPHA*PI*S2A*S2B**3*XMHH2+24D0*
     &  ALPHA*CB*PI*S2B*SB*XMW2-8D0*ALPHA*CB*CBA**2*PI*S2B*SB*XMW2-
     &  8D0*ALPHA*CB*PI*S2B*SB*SBA**2*XMW2-8D0*CB*LAM5*S2B*SB*XMW2*
     &  XSW2)*B00W)/(64D0*CB*S2B*SB*XSW2)
     &  +(PI**(-2)*XMZ2*(-(16D0*ALPHA*CB*PI*SB*XCW2*XMA02)-3D0*ALPHA*
     &  PI*S2A*XCW2*XMH02-ALPHA*C2B**2*PI*S2A*XCW2*XMH02+2D0*ALPHA*
     &  PI*S2B*XCW2*XMH02+2D0*ALPHA*C2A*C2B*PI*S2B*XCW2*XMH02+ALPHA*
     &  PI*S2A*S2B**2*XCW2*XMH02+3D0*ALPHA*PI*S2A*XCW2*XMHH2+ALPHA*
     &  C2B**2*PI*S2A*XCW2*XMHH2+2D0*ALPHA*PI*S2B*XCW2*XMHH2-2D0*
     &  ALPHA*C2A*C2B*PI*S2B*XCW2*XMHH2-ALPHA*PI*S2A*S2B**2*XCW2*
     &  XMHH2+16D0*ALPHA*CB*PI*SB*XCW2*XMHP2+32D0*ALPHA*CB*PI*SB*
     &  XCW2**2*XMW2-16D0*CB*LAM5*SB*XCW2*XMW2*XSW2-64D0*ALPHA*CB*
     &  PI*SB*XCW2*XMW2*XSW2+32D0*ALPHA*CB*PI*SB*XMW2*XSW2**2)*
     &  B00Z)/(256D0*CB*SB*XCW2*XMW2*XSW2)
     &  -((ALPHA*(S+XMHP2)*BS0HP)/(2D0*PI))
     &  +(ALPHA*(XMA02**2-2D0*XMA02*XMHP2+XMHP2**2-2D0*S*XMW2-2D0*
     &  XMA02*XMW2+XMW2**2)*BSA0W)/(16D0*PI*XMW2*XSW2)
     &  +(CB**(-2)*PI**(-3)*SB**(-2)*(ALPHA*CAB*PI*XMA02-ALPHA*CA*
     &  CB**3*PI*XMH02+ALPHA*PI*SA*SB**3*XMH02-2D0*ALPHA*CB*PI*SB*
     &  SBA*XMHP2+CAB*LAM5*XMW2*XSW2)**2*BSH0HP)/(16D0*
     &  ALPHA*XMW2*XSW2)
     &  +(ALPHA*CBA**2*(XMH02**2-2D0*XMH02*XMHP2+XMHP2**2-2D0*S*XMW2-
     &  2D0*XMH02*XMW2+XMW2**2)*BSH0W)/(16D0*PI*XMW2*
     &  XSW2)
     &  +(CB**(-2)*PI**(-3)*SB**(-2)*(ALPHA*PI*SAB*XMA02-ALPHA*CB**3*
     &  PI*SA*XMHH2-ALPHA*CA*PI*SB**3*XMHH2-2D0*ALPHA*CB*CBA*PI*SB*
     &  XMHP2+LAM5*SAB*XMW2*XSW2)**2*BSHHHP)/(16D0*ALPHA*
     &  XMW2*XSW2)
     &  +(ALPHA*SBA**2*(XMHH2**2-2D0*XMHH2*XMHP2+XMHP2**2-2D0*S*XMW2-
     &  2D0*XMHH2*XMW2+XMW2**2)*BSHHW)/(16D0*PI*XMW2*
     &  XSW2)
     &  -((ALPHA*(2D0*S+2D0*XMHP2-XMZ2)*(XCW+XSW)**2*(XCW-XSW)**2*
     &  BSHPZ)/(16D0*PI*XCW2*XSW2))

	end

**********************************************************************
        function xseaa_ferm_thdm(s)
**********************************************************************
*       unrenormalized neutral CP-odd Higgs-boson self-energy
*       closed fermion loops only
*       THDM
*---------------------------------------------------------------------
*       30.5.16 Stefan Dittmaier
**********************************************************************
        implicit real*8 (a-z)
        complex*16 xseaa_ferm_thdm
        complex*16 B0_,xB0_
        complex*16 B00l,B00u,B00d,Bsll,Bsdd,Bsuu 
	integer i

        include '../COMMON/param.inc'
        include '../COMMON/xparam.inc'
        include '../COMMON/param_thdm.inc'
        include '../COMMON/param_bsm.inc'

	xseaa_ferm_thdm = 0d0

	do 100 i=1,3

	B00l  =  xB0_(0D0,null, xML2(I),0)
	B00u  =  xB0_(0D0,null,xMQP2(I),0)
	B00d  =  xB0_(0D0,null,xMQM2(I),0)
	Bsll  =  xB0_(s, xML2(I),xML2(I),0)
	Bsdd  =  xB0_(s,xMQM2(I),xMQM2(I),0)
	Bsuu  =  xB0_(s,xMQP2(I),xMQP2(I),0)

	xseaa_ferm_thdm = xseaa_ferm_thdm
     &  +ALPHA*CLEPA**2*(S*BSLL*XML2(I)-2D0*B00L*XML2(I)**2)
     &  /(8D0*PI*XMW2*XSW2)
     &  +ALPHA*CDOA**2*(3D0*S*BSDD*XMQM2(I)-6D0*B00D*XMQM2(I)**2)
     &  /(8D0*PI*XMW2*XSW2)
     &  +ALPHA*CUPA**2*(3D0*S*BSUU*XMQP2(I)-6D0*B00U*XMQP2(I)**2)
     &  /(8D0*PI*XMW2*XSW2)

100	continue

	end

**********************************************************************
        function xseaa_thdm(s)
**********************************************************************
*       unrenormalized neutral CP-odd Higgs-boson self-energy
*       bosonic loops only
*       THDM
*---------------------------------------------------------------------
*       30.5.16 Stefan Dittmaier
**********************************************************************
        implicit real*8 (a-z)
        complex*16 xseaa_thdm
        complex*16 B0_,xB0_
        complex*16 B00H0,B00HH,B00A0,B00HP,B00W,B00Z 
	complex*16 BSA0H0,BSA0HH,BSH0Z,BSHHZ,BSHPW  

        include '../COMMON/param.inc'
        include '../COMMON/xparam.inc'
        include '../COMMON/param_thdm.inc'
        include '../COMMON/param_bsm.inc'

        B00H0  = xB0_(0D0,null,xMH02,0)	
        B00HH  = xB0_(0D0,null,xMHH2,0)
        B00A0  = xB0_(0D0,null,xMA02,0)
        B00HP  = xB0_(0D0,null,xMHP2,0)	
        B00W   = xB0_(0D0,null,xMW2,0)	
        B00Z   = xB0_(0D0,null,xMZ2,0)

	BSA0H0 = xB0_(S,XMA02,XMH02,0)
	BSA0HH = xB0_(S,XMA02,XMHH2,0)
	BSH0Z  = xB0_(S,XMH02,XMZ2,0)
	BSHHZ  = xB0_(S,XMHH2,XMZ2,0)
	BSHPW  = xB0_(S,XMHP2,XMW2,0)

	xseaa_thdm =
     &  -((ALPHA*(2D0*XCW2*XMW2+XMZ2))/(8D0*PI*XCW2*XSW2))
     &	+(3D0*CB**
     &  (-2)*PI**(-2)*S2B**(-2)*SB**(-2)*XMA02*(-(64D0*ALPHA*C2B**2*
     &  CB**2*PI*SB**2*XMA02)+9D0*ALPHA*CAB**2*PI*S2B**2*XMH02+6D0*
     &  ALPHA*C2B*CAB*CBA*PI*S2B**2*XMH02+ALPHA*C2B**2*CBA**2*PI*
     &  S2B**2*XMH02-6D0*ALPHA*CAB*PI*S2B**3*SBA*XMH02-2D0*ALPHA*
     &  C2B*CBA*PI*S2B**3*SBA*XMH02+ALPHA*PI*S2B**4*SBA**2*XMH02+
     &  16D0*ALPHA*CB**6*PI*S2B**2*SA**2*XMHH2+32D0*ALPHA*CA*CB**3*
     &  PI*S2B**2*SA*SB**3*XMHH2+16D0*ALPHA*CA**2*PI*S2B**2*SB**6*
     &  XMHH2-64D0*C2B**2*CB**2*LAM5*SB**2*XMW2*XSW2)*B00A0
     &  )/(512D0*XMW2*XSW2)
     &	+(CB**(-2)*PI**(-2)*SB**(-2)*XMH02*
     &  (-(16D0*ALPHA*C2A*C2B*PI*XCW2*XMA02)-16D0*ALPHA*C2B**2*PI*
     &  XCW2*XMA02+9D0*ALPHA*PI*XCW2*XMH02+3D0*ALPHA*C2A**2*PI*XCW2*
     &  XMH02+16D0*ALPHA*C2A*C2B*PI*XCW2*XMH02+3D0*ALPHA*C2B**2*PI*
     &  XCW2*XMH02+ALPHA*C2A**2*C2B**2*PI*XCW2*XMH02-3D0*ALPHA*PI*
     &  S2A**2*XCW2*XMH02-ALPHA*C2B**2*PI*S2A**2*XCW2*XMH02-4D0*
     &  ALPHA*PI*S2A*S2B*XCW2*XMH02+4D0*ALPHA*C2A*C2B*PI*S2A*S2B*
     &  XCW2*XMH02-3D0*ALPHA*PI*S2B**2*XCW2*XMH02-ALPHA*C2A**2*PI*
     &  S2B**2*XCW2*XMH02+ALPHA*PI*S2A**2*S2B**2*XCW2*XMH02+8D0*
     &  ALPHA*CA*PI*S2B*SA*XCW2*XMHH2-4D0*ALPHA*C2B*CA*PI*S2B*SA*
     &  XCW2*XMHH2-4D0*ALPHA*C2A*C2B*CA*PI*S2B*SA*XCW2*XMHH2+24D0*
     &  ALPHA*CA**2*PI*SA**2*XCW2*XMHH2+8D0*ALPHA*C2B**2*CA**2*PI*
     &  SA**2*XCW2*XMHH2+4D0*ALPHA*C2B*PI*S2A*S2B*SA**2*XCW2*XMHH2-
     &  8D0*ALPHA*CA**2*PI*S2B**2*SA**2*XCW2*XMHH2+64D0*ALPHA*CB**2*
     &  CBA**2*PI*SB**2*XMW2-12D0*LAM5*XCW2*XMW2*XSW2-14D0*C2A*C2B*
     &  LAM5*XCW2*XMW2*XSW2-4D0*C2B**2*LAM5*XCW2*XMW2*XSW2-2D0*C2B**
     &  2*CA**2*CB**2*LAM5*XCW2*XMW2*XSW2+6D0*LAM5*S2A*S2B*XCW2*
     &  XMW2*XSW2+4D0*LAM5*S2B**2*XCW2*XMW2*XSW2+2D0*CA**2*CB**2*
     &  LAM5*S2B**2*XCW2*XMW2*XSW2-8D0*C2B*CA*CB**2*LAM5*S2B*SA*
     &  XCW2*XMW2*XSW2+2D0*C2B**2*CB**2*LAM5*SA**2*XCW2*XMW2*XSW2-
     &  2D0*CB**2*LAM5*S2B**2*SA**2*XCW2*XMW2*XSW2+8D0*C2B*CA**2*CB*
     &  LAM5*S2B*SB*XCW2*XMW2*XSW2-8D0*C2B**2*CA*CB*LAM5*SA*SB*XCW2*
     &  XMW2*XSW2+8D0*CA*CB*LAM5*S2B**2*SA*SB*XCW2*XMW2*XSW2-8D0*
     &  C2B*CB*LAM5*S2B*SA**2*SB*XCW2*XMW2*XSW2+2D0*C2B**2*CA**2*
     &  LAM5*SB**2*XCW2*XMW2*XSW2-2D0*CA**2*LAM5*S2B**2*SB**2*XCW2*
     &  XMW2*XSW2+8D0*C2B*CA*LAM5*S2B*SA*SB**2*XCW2*XMW2*XSW2-2D0*
     &  C2B**2*LAM5*SA**2*SB**2*XCW2*XMW2*XSW2+2D0*LAM5*S2B**2*SA**
     &  2*SB**2*XCW2*XMW2*XSW2)*B00H0)/(1024D0*XCW2*
     &  XMW2*XSW2)
     &	+(CB**(-2)*PI**(-2)*SB**(-2)*XMHH2*(16D0*ALPHA*
     &  C2A*C2B*PI*XCW2*XMA02-16D0*ALPHA*C2B**2*PI*XCW2*XMA02+6D0*
     &  ALPHA*PI*S2A**2*XCW2*XMH02+2D0*ALPHA*C2B**2*PI*S2A**2*XCW2*
     &  XMH02-4D0*ALPHA*PI*S2A*S2B*XCW2*XMH02-4D0*ALPHA*C2A*C2B*PI*
     &  S2A*S2B*XCW2*XMH02-2D0*ALPHA*PI*S2A**2*S2B**2*XCW2*XMH02+
     &  9D0*ALPHA*PI*XCW2*XMHH2+3D0*ALPHA*C2A**2*PI*XCW2*XMHH2-16D0*
     &  ALPHA*C2A*C2B*PI*XCW2*XMHH2+3D0*ALPHA*C2B**2*PI*XCW2*XMHH2+
     &  ALPHA*C2A**2*C2B**2*PI*XCW2*XMHH2-3D0*ALPHA*PI*S2A**2*XCW2*
     &  XMHH2-ALPHA*C2B**2*PI*S2A**2*XCW2*XMHH2+4D0*ALPHA*PI*S2A*
     &  S2B*XCW2*XMHH2+4D0*ALPHA*C2A*C2B*PI*S2A*S2B*XCW2*XMHH2-3D0*
     &  ALPHA*PI*S2B**2*XCW2*XMHH2-ALPHA*C2A**2*PI*S2B**2*XCW2*
     &  XMHH2+ALPHA*PI*S2A**2*S2B**2*XCW2*XMHH2+64D0*ALPHA*CB**2*PI*
     &  SB**2*SBA**2*XMW2-12D0*LAM5*XCW2*XMW2*XSW2+14D0*C2A*C2B*
     &  LAM5*XCW2*XMW2*XSW2-4D0*C2B**2*LAM5*XCW2*XMW2*XSW2+2D0*C2B**
     &  2*CA**2*CB**2*LAM5*XCW2*XMW2*XSW2-6D0*LAM5*S2A*S2B*XCW2*
     &  XMW2*XSW2+4D0*LAM5*S2B**2*XCW2*XMW2*XSW2-2D0*CA**2*CB**2*
     &  LAM5*S2B**2*XCW2*XMW2*XSW2+8D0*C2B*CA*CB**2*LAM5*S2B*SA*
     &  XCW2*XMW2*XSW2-2D0*C2B**2*CB**2*LAM5*SA**2*XCW2*XMW2*XSW2+
     &  2D0*CB**2*LAM5*S2B**2*SA**2*XCW2*XMW2*XSW2-8D0*C2B*CA**2*CB*
     &  LAM5*S2B*SB*XCW2*XMW2*XSW2+8D0*C2B**2*CA*CB*LAM5*SA*SB*XCW2*
     &  XMW2*XSW2-8D0*CA*CB*LAM5*S2B**2*SA*SB*XCW2*XMW2*XSW2+8D0*
     &  C2B*CB*LAM5*S2B*SA**2*SB*XCW2*XMW2*XSW2-2D0*C2B**2*CA**2*
     &  LAM5*SB**2*XCW2*XMW2*XSW2+2D0*CA**2*LAM5*S2B**2*SB**2*XCW2*
     &  XMW2*XSW2-8D0*C2B*CA*LAM5*S2B*SA*SB**2*XCW2*XMW2*XSW2+2D0*
     &  C2B**2*LAM5*SA**2*SB**2*XCW2*XMW2*XSW2-2D0*LAM5*S2B**2*SA**
     &  2*SB**2*XCW2*XMW2*XSW2)*B00HH)/(1024D0*XCW2*
     &  XMW2*XSW2)
     &	+(CB**(-2)*PI**(-2)*S2B**(-2)*SB**(-2)*XMHP2*(-
     &  (64D0*ALPHA*C2B**2*CB**2*PI*SB**2*XMA02)+9D0*ALPHA*CAB**2*
     &  PI*S2B**2*XMH02+6D0*ALPHA*C2B*CAB*CBA*PI*S2B**2*XMH02+ALPHA*
     &  C2B**2*CBA**2*PI*S2B**2*XMH02-6D0*ALPHA*CAB*PI*S2B**3*SBA*
     &  XMH02-2D0*ALPHA*C2B*CBA*PI*S2B**3*SBA*XMH02+ALPHA*PI*S2B**4*
     &  SBA**2*XMH02+16D0*ALPHA*CB**6*PI*S2B**2*SA**2*XMHH2+32D0*
     &  ALPHA*CA*CB**3*PI*S2B**2*SA*SB**3*XMHH2+16D0*ALPHA*CA**2*PI*
     &  S2B**2*SB**6*XMHH2+32D0*ALPHA*CB**2*PI*S2B**2*SB**2*XMW2-
     &  64D0*C2B**2*CB**2*LAM5*SB**2*XMW2*XSW2)*B00HP)/
     &  (256D0*XMW2*XSW2)
     &	+(PI**(-2)*(-(16D0*ALPHA*CB*PI*SB*XMA02)-
     &  3D0*ALPHA*PI*S2A*XMH02-ALPHA*C2B**2*PI*S2A*XMH02+2D0*ALPHA*
     &  PI*S2B*XMH02+2D0*ALPHA*C2A*C2B*PI*S2B*XMH02+ALPHA*PI*S2A*
     &  S2B**2*XMH02+3D0*ALPHA*PI*S2A*XMHH2+ALPHA*C2B**2*PI*S2A*
     &  XMHH2+2D0*ALPHA*PI*S2B*XMHH2-2D0*ALPHA*C2A*C2B*PI*S2B*XMHH2-
     &  ALPHA*PI*S2A*S2B**2*XMHH2+16D0*ALPHA*CB*PI*SB*XMHP2+32D0*
     &  ALPHA*CB*PI*SB*XMW2-16D0*CB*LAM5*SB*XMW2*XSW2)*B00W
     &  )/(128D0*CB*SB*XSW2)
     &	-(PI**(-2)*XMZ2*(16D0*ALPHA*CB*PI*
     &  SB*XCW2*XMA02+ALPHA*PI*S2A*XCW2*XMH02+3D0*ALPHA*C2B**2*PI*
     &  S2A*XCW2*XMH02-6D0*ALPHA*C2A*C2B*PI*S2B*XCW2*XMH02-3D0*
     &  ALPHA*PI*S2A*S2B**2*XCW2*XMH02-12D0*ALPHA*CB*PI*SB*XCW2*
     &  XMH02-ALPHA*PI*S2A*XCW2*XMHH2-3D0*ALPHA*C2B**2*PI*S2A*XCW2*
     &  XMHH2-6D0*ALPHA*PI*S2B*XCW2*XMHH2+6D0*ALPHA*C2A*C2B*PI*S2B*
     &  XCW2*XMHH2+3D0*ALPHA*PI*S2A*S2B**2*XCW2*XMHH2-64D0*ALPHA*CB*
     &  PI*SB*XMW2+32D0*ALPHA*CB*CBA**2*PI*SB*XMW2+32D0*ALPHA*CB*PI*
     &  SB*SBA**2*XMW2+16D0*CB*LAM5*SB*XCW2*XMW2*XSW2)*B00Z
     &  )/(256D0*CB*SB*XCW2*XMW2*XSW2)
     &	+(CB**(-2)*PI**(-3)*SB**
     &  (-2)*(ALPHA*C2B*CBA*PI*XMA02-ALPHA*CA*CB**3*PI*XMH02+ALPHA*
     &  PI*SA*SB**3*XMH02+CAB*LAM5*XMW2*XSW2)**2*BSA0H0)/
     &  (16D0*ALPHA*XMW2*XSW2)
     &	+(CB**(-2)*PI**(-3)*SB**(-2)*(ALPHA*
     &  C2B*PI*SBA*XMA02+ALPHA*CB**3*PI*SA*XMHH2+ALPHA*CA*PI*SB**3*
     &  XMHH2-LAM5*SAB*XMW2*XSW2)**2*BSA0HH)/(16D0*ALPHA*
     &  XMW2*XSW2)
     &	+(ALPHA*CBA**2*(XCW2*XMA02**2-2D0*XCW2*XMA02*
     &  XMH02+XCW2*XMH02**2-2D0*S*XMW2-2D0*XMH02*XMW2+XMW2*XMZ2)*
     &  BSH0Z)/(16D0*PI*XCW2*XMW2*XSW2)
     &	+(ALPHA*SBA**2*
     &  (XCW2*XMA02**2-2D0*XCW2*XMA02*XMHH2+XCW2*XMHH2**2-2D0*S*
     &  XMW2-2D0*XMHH2*XMW2+XMW2*XMZ2)*BSHHZ)/(16D0*PI*
     &  XCW2*XMW2*XSW2)
     &	+(ALPHA*(XMA02**2-2D0*XMA02*XMHP2+XMHP2**2-
     &  2D0*S*XMW2-2D0*XMHP2*XMW2+XMW2**2)*BSHPW)/(8D0*
     &  PI*XMW2*XSW2)

	end

**********************************************************************
        subroutine xsehh_thdm(s,seh0h0,seh0HH,seHHHH)
**********************************************************************
*       unrenormalized neutral CP-even Higgs-boson self-energies
*       bosonic loops only
*       THDM
*---------------------------------------------------------------------
*       10.5.16 Stefan Dittmaier
**********************************************************************
        implicit real*8 (a-z)
        complex*16 seh0h0,seh0HH,seHHHH
        complex*16 B0_,xB0_
        complex*16 B00H0,B00HH,B00A0,B00HP,B00W,B00Z 
        complex*16 BSA0A0,BSA0Z,BSH0H0,BSH0HH,BSHHHH,BSHPHP,BSHPW
	complex*16 BSWW,BSZZ   

        include '../COMMON/param.inc'
        include '../COMMON/xparam.inc'
        include '../COMMON/param_thdm.inc'
        include '../COMMON/param_bsm.inc'

        B00H0  = xB0_(0D0,null,xMH02,0)	
        B00HH  = xB0_(0D0,null,xMHH2,0)
        B00A0  = xB0_(0D0,null,xMA02,0)
        B00HP  = xB0_(0D0,null,xMHP2,0)	
        B00W   = xB0_(0D0,null,xMW2,0)	
        B00Z   = xB0_(0D0,null,xMZ2,0)

        BSA0A0 = xB0_(S,xMA02,xMA02,0)	
        BSA0Z  = xB0_(S,xMA02,xMZ2,0)	
        BSH0H0 = xB0_(S,xMH02,xMH02,0)	
        BSH0HH = xB0_(S,xMH02,xMHH2,0)	
        BSHHHH = xB0_(S,xMHH2,xMHH2,0)	
        BSHPHP = xB0_(S,xMHP2,xMHP2,0)	
        BSHPW  = xB0_(S,xMHP2,xMW2,0)	
        BSWW   = xB0_(S,xMW2,xMW2,0)	
        BSZZ   = xB0_(S,xMZ2,xMZ2,0)	

	seh0h0 = 
     &  (CB**(-2)*LAM5**2*PI**(-3)*SB**(-2)*XMW2*XSW2*(16D0*CAB**2*
     &  BSA0A0+144D0*CAB**2*CBA**4*BSH0H0+2D0*
     &  (CBA*(3D0*S2A-S2B)+2D0*SAB-(3D0*C2A+C2B)*SBA)**2*BSH0HH
     &  +(-(2D0*CAB)+3D0*C2A*CBA-C2B*CBA+3D0*S2A*SBA+S2B*
     &  SBA)**2*BSHHHH+32D0*CAB**2*BSHPHP))/
     &  (512D0*ALPHA)
     &
     &	-(LAM5/PI**2*(CB**(-2)*SB**(-2)*(6D0+7D0*
     &  C2A*C2B-3D0*S2A*S2B-2D0*S2B**2-CA2*CB2*S2B**2+CB2*S2B**2*
     &  SA2-4D0*CA*CB*S2B**2*SA*SB+CA2*S2B**2*SB2-S2B**2*SA2*SB2+
     &  C2B**2*(2D0-CB2*SA2+4D0*CA*CB*SA*SB+SA2*SB2+CA2*(CB2-SB2))+
     &  4D0*C2B*S2B*(-(CB*(CA2-SA2)*SB)+CA*SA*(CB2-SB2)))*XMA02*
     &  B00A0+12D0*(C2A+C2B)**2*CB**(-2)*SB**(-2)*XMH02*
     &  B00H0+2D0*CB**(-2)*(2D0-3D0*C2A**2+C2B**2+3D0*
     &  S2A**2-S2B**2)*SB**(-2)*XMHH2*B00HH+2D0*CB**(-
     &  2)*SB**(-2)*(6D0+7D0*C2A*C2B-3D0*S2A*S2B-2D0*S2B**2-CA2*CB2*
     &  S2B**2+CB2*S2B**2*SA2-4D0*CA*CB*S2B**2*SA*SB+CA2*S2B**2*SB2-
     &  S2B**2*SA2*SB2+C2B**2*(2D0-CB2*SA2+4D0*CA*CB*SA*SB+SA2*SB2+
     &  CA2*(CB2-SB2))+4D0*C2B*S2B*(-(CB*(CA2-SA2)*SB)+CA*SA*(CB2-
     &  SB2)))*XMHP2*B00HP+64D0*CBA**2*XMW2*B00W
     &  +32D0*CBA**2*XMZ2*B00Z-32D0*CAB*CB**(-2)*
     &  SB**(-2)*(C2B*CBA*XMA02-(CA*CB**3-SA*SB**3)*XMH02)*BSA0A0
     &  +72D0*CAB*CB**(-2)*CBA**2*SB**(-2)*((C2A*CBA+
     &  S2A*SBA)*XMH02-CAB*(4D0*CBA**2*XMA02-3D0*XMH02))*BSH0H0
     &  -4D0*CB**(-2)*SB**(-2)*((-(2D0*SAB)+(3D0*C2A+C2B)*
     &  SBA)**2*XMA02-2D0*CBA*(2D0*SAB-(3D0*C2A+C2B)*SBA)*(S2B*
     &  XMA02+S2A*(-(3D0*XMA02)+2D0*XMH02+XMHH2))+CBA**2*(S2B**2*
     &  XMA02+2D0*S2A*S2B*(-(3D0*XMA02)+2D0*XMH02+XMHH2)+3D0*S2A**2*
     &  (3D0*XMA02-2D0*(2D0*XMH02+XMHH2))))*BSH0HH-2D0*
     &  CB**(-2)*SB**(-2)*(4D0*CAB**2*XMA02+9D0*C2A**2*CBA**2*XMA02+
     &  C2B**2*CBA**2*XMA02-6D0*C2B*CBA*S2A*SBA*XMA02-2D0*C2B*CBA*
     &  S2B*SBA*XMA02+9D0*S2A**2*SBA**2*XMA02+6D0*S2A*S2B*SBA**2*
     &  XMA02+S2B**2*SBA**2*XMA02+2D0*C2B*CBA*S2A*SBA*XMH02-6D0*
     &  S2A**2*SBA**2*XMH02-2D0*S2A*S2B*SBA**2*XMH02+4D0*C2B*CBA*
     &  S2A*SBA*XMHH2-12D0*S2A**2*SBA**2*XMHH2-4D0*S2A*S2B*SBA**2*
     &  XMHH2-4D0*CAB*(3D0*C2A*CBA*XMA02-C2B*CBA*XMA02+SBA*(3D0*S2A*
     &  XMA02+S2B*XMA02-S2A*XMH02-2D0*S2A*XMHH2))-6D0*C2A*CBA*(C2B*
     &  CBA*XMA02-SBA*(S2B*XMA02-S2A*(-(3D0*XMA02)+XMH02+2D0*
     &  XMHH2))))*BSHHHH-64D0*CAB*CB**(-2)*SB**(-2)*(CAB*
     &  XMA02-CA*CB**3*XMH02+SA*SB**3*XMH02-2D0*CB*SB*SBA*XMHP2)*
     &  BSHPHP))/512D0
     &
     &	+(ALPHA*(-((128D0*(1D0+2D0*SBA**2)*
     &  (2D0*XCW2*XMW2+XMZ2))/XCW2)-(CB**(-2)*SB**(-2)*XMA02*(16D0*
     &  C2A*C2B*XCW2*XMA02+16D0*C2B**2*XCW2*XMA02-9D0*XCW2*XMH02-
     &  3D0*C2A**2*XCW2*XMH02-16D0*C2A*C2B*XCW2*XMH02-3D0*C2B**2*
     &  XCW2*XMH02-C2A**2*C2B**2*XCW2*XMH02+3D0*S2A**2*XCW2*XMH02+
     &  C2B**2*S2A**2*XCW2*XMH02+4D0*S2A*S2B*XCW2*XMH02-4D0*C2A*C2B*
     &  S2A*S2B*XCW2*XMH02+3D0*S2B**2*XCW2*XMH02+C2A**2*S2B**2*XCW2*
     &  XMH02-S2A**2*S2B**2*XCW2*XMH02-8D0*CA*S2B*SA*XCW2*XMHH2+4D0*
     &  C2B*CA*S2B*SA*XCW2*XMHH2+4D0*C2A*C2B*CA*S2B*SA*XCW2*XMHH2-
     &  4D0*C2B*S2A*S2B*SA**2*XCW2*XMHH2-24D0*CA2*SA2*XCW2*XMHH2-
     &  8D0*C2B**2*CA2*SA2*XCW2*XMHH2+8D0*CA2*S2B**2*SA2*XCW2*XMHH2-
     &  64D0*CB2*CBA**2*SB2*XMW2)*B00A0)/(XCW2*XMW2)+
     &  (6D0*CB**(-2)*SB**(-2)*XMH02*(-(4D0*C2A**2*XMA02)-8D0*C2A*
     &  C2B*XMA02-4D0*C2B**2*XMA02+9D0*CAB**2*XMH02+6D0*C2A*CAB*CBA*
     &  XMH02+C2A**2*CBA**2*XMH02+6D0*CAB*S2A*SBA*XMH02+2D0*C2A*CBA*
     &  S2A*SBA*XMH02+S2A**2*SBA**2*XMH02+16D0*CA2*CBA**2*SA2*
     &  XMHH2)*B00H0)/XMW2+(2D0*CB**(-2)*SB**(-2)*XMHH2*
     &  (-(4D0*XMA02)+6D0*C2A**2*XMA02-2D0*C2B**2*XMA02-6D0*S2A**2*
     &  XMA02+2D0*S2B**2*XMA02+6D0*S2A**2*XMH02+6D0*C2A*C2B*S2A**2*
     &  XMH02-S2A*S2B*XMH02-3D0*C2A**2*S2A*S2B*XMH02+3D0*S2A**3*S2B*
     &  XMH02+6D0*S2A**2*XMHH2-6D0*C2A*C2B*S2A**2*XMHH2+S2A*S2B*
     &  XMHH2+3D0*C2A**2*S2A*S2B*XMHH2-3D0*S2A**3*S2B*XMHH2)*B00HH 
     &  )/XMW2-(2D0*CB**(-2)*SB**(-2)*XMHP2*(12D0*XMA02+
     &  14D0*C2A*C2B*XMA02+4D0*C2B**2*XMA02+2D0*C2B**2*CA2*CB2*
     &  XMA02-6D0*S2A*S2B*XMA02-4D0*S2B**2*XMA02-2D0*CA2*CB2*S2B**2*
     &  XMA02+8D0*C2B*CA*CB2*S2B*SA*XMA02-2D0*C2B**2*CB2*SA2*XMA02+
     &  2D0*CB2*S2B**2*SA2*XMA02-8D0*C2B*CA2*CB*S2B*SB*XMA02+8D0*
     &  C2B**2*CA*CB*SA*SB*XMA02-8D0*CA*CB*S2B**2*SA*SB*XMA02+8D0*
     &  C2B*CB*S2B*SA2*SB*XMA02-2D0*C2B**2*CA2*SB2*XMA02+2D0*CA2*
     &  S2B**2*SB2*XMA02-8D0*C2B*CA*S2B*SA*SB2*XMA02+2D0*C2B**2*SA2*
     &  SB2*XMA02-2D0*S2B**2*SA2*SB2*XMA02-9D0*XMH02-3D0*C2A**2*
     &  XMH02-16D0*C2A*C2B*XMH02-3D0*C2B**2*XMH02-C2A**2*C2B**2*
     &  XMH02+3D0*S2A**2*XMH02+C2B**2*S2A**2*XMH02+4D0*S2A*S2B*
     &  XMH02-4D0*C2A*C2B*S2A*S2B*XMH02+3D0*S2B**2*XMH02+C2A**2*
     &  S2B**2*XMH02-S2A**2*S2B**2*XMH02-6D0*S2A**2*XMHH2-2D0*C2B**
     &  2*S2A**2*XMHH2-4D0*S2A*S2B*XMHH2+4D0*C2A*C2B*S2A*S2B*XMHH2+
     &  2D0*S2A**2*S2B**2*XMHH2-64D0*CB2*SB2*SBA**2*XMHP2-64D0*CB2*
     &  CBA**2*SB2*XMW2)*B00HP)/XMW2-(8D0*(16D0*CB*CBA**
     &  2*SB*XMA02+2D0*S2A*XMH02+2D0*C2A*C2B*S2A*XMH02-3D0*S2B*
     &  XMH02-C2A**2*S2B*XMH02+S2A**2*S2B*XMH02-8D0*CA*CBA**2*SA*
     &  XMHH2-16D0*CB*CBA**2*SB*XMHP2-64D0*CB*SB*XMW2+32D0*CB*CBA**
     &  2*SB*XMW2+16D0*CB*SB*SBA**2*XMW2)*B00W)/(CB*SB)+
     &  (4D0*(-(2D0*S2A*XCW2*XMH02)-2D0*C2A*C2B*S2A*XCW2*XMH02+C2A**
     &  2*S2B*XCW2*XMH02-S2A**2*S2B*XCW2*XMH02+6D0*CB*SB*XCW2*XMH02+
     &  4D0*CBA**2*S2A*XCW2*XMHH2+64D0*CB*SB*XMW2-32D0*CB*CBA**2*SB*
     &  XMW2-16D0*CB*SB*SBA**2*XMW2)*XMZ2*B00Z)/(CB*SB*
     &  XCW2*XMW2)+(32D0*CB**(-2)*SB**(-2)*(C2B*CBA*XMA02-CA*CB**3*
     &  XMH02+SA*SB**3*XMH02)**2*BSA0A0)/XMW2+(64D0*CBA**
     &  2*(XCW2*XMA02**2-2D0*XCW2*XMA02*XMH02+XCW2*XMH02**2-2D0*S*
     &  XMW2-2D0*XMA02*XMW2+XMW2*XMZ2)*BSA0Z)/(XCW2*
     &  XMW2)+(18D0*CB**(-2)*SB**(-2)*(-(4D0*CAB*CBA**2*XMA02)+3D0*
     &  CAB*XMH02+C2A*CBA*XMH02+S2A*SBA*XMH02)**2*BSH0H0
     &  )/XMW2+(4D0*CB**(-2)*SB**(-2)*(3D0*CBA*S2A*XMA02-CBA*
     &  S2B*XMA02+2D0*SAB*XMA02-3D0*C2A*SBA*XMA02-C2B*SBA*XMA02-4D0*
     &  CBA*S2A*XMH02-2D0*CBA*S2A*XMHH2)**2*BSH0HH)/XMW2+
     &  (2D0*CB**(-2)*SB**(-2)*(2D0*CAB*XMA02-3D0*C2A*CBA*XMA02+C2B*
     &  CBA*XMA02-3D0*S2A*SBA*XMA02-S2B*SBA*XMA02+2D0*S2A*SBA*XMH02+
     &  4D0*S2A*SBA*XMHH2)**2*BSHHHH)/XMW2+(64D0*CB**(-
     &  2)*SB**(-2)*(CAB*XMA02-CA*CB**3*XMH02+SA*SB**3*XMH02-2D0*CB*
     &  SB*SBA*XMHP2)**2*BSHPHP)/XMW2+(128D0*CBA**2*
     &  (XMH02**2-2D0*XMH02*XMHP2+XMHP2**2-2D0*S*XMW2-2D0*XMHP2*
     &  XMW2+XMW2**2)*BSHPW)/XMW2+(64D0*SBA**2*(XMH02**2-
     &  4D0*S*XMW2+12D0*XMW2**2)*BSWW)/XMW2+(32D0*SBA**2*
     &  (XCW2*XMH02**2-4D0*S*XMW2+12D0*XMW2*XMZ2)*BSZZ)/
     &  (XCW2*XMW2)))/(1024D0*PI*XSW2)

	seh0HH = 
     &  (CB**(-2)*LAM5**2*PI**(-3)*SB**(-2)*XMW2*XSW2*(8D0*CAB*SAB*
     &  BSA0A0+6D0*CAB*CBA**2*(CBA*(3D0*S2A-S2B)+2D0*SAB-
     &  (3D0*C2A+C2B)*SBA)*BSH0H0-(CBA*(3D0*S2A-S2B)+2D0*
     &  SAB-(3D0*C2A+C2B)*SBA)*(-(2D0*CAB)+3D0*C2A*CBA-C2B*CBA+3D0*
     &  S2A*SBA+S2B*SBA)*BSH0HH-6D0*SAB*SBA**2*(-(2D0*
     &  CAB)+3D0*C2A*CBA-C2B*CBA+3D0*S2A*SBA+S2B*SBA)*BSHHHH
     &  +16D0*CAB*SAB*BSHPHP))/(256D0*ALPHA)
     &
     &	-(LAM5*
     &  PI**(-2)*(-(CB**(-2)*SB**(-2)*(-(2D0*C2B**2*(-(CB*(CA2-SA2)*
     &  SB)+CA*SA*(CB2-SB2)))+C2B*(-(7D0*S2A)+2D0*S2B*(CA2*CB2-CB2*
     &  SA2+4D0*CA*CB*SA*SB-CA2*SB2+SA2*SB2))+S2B*(-(3D0*C2A)+2D0*
     &  S2B*(-(CB*(CA2-SA2)*SB)+CA*SA*(CB2-SB2))))*XMA02*B00A0
     &  )+12D0*(C2A+C2B)*CB**(-2)*S2A*SB**(-2)*XMH02*B00H0
     &  -12D0*(C2A-C2B)*CB**(-2)*S2A*SB**(-2)*XMHH2*
     &  B00HH-2D0*CB**(-2)*SB**(-2)*(-(C2B*S2A*(7D0-4D0*
     &  CB*S2B*SB))-C2B**2*S2A*(CB2-SB2)+S2B*(CB2*S2A*S2B-16D0*C2A*
     &  CB2*SB2-S2A*S2B*SB2))*XMHP2*B00HP+32D0*(C2B*S2A-
     &  C2A*S2B)*XMW2*B00W+16D0*(C2B*S2A-C2A*S2B)*XMZ2*
     &  B00Z-16D0*CB**(-2)*SB**(-2)*(SAB*(C2B*CBA*MA02-
     &  MH02*(CA*CB**3-SA*SB**3))-CAB*(CB**3*MHH2*SA+CA*MHH2*SB**3+
     &  C2B*MA02*SBA))*BSA0A0-3D0*CB**(-2)*SB**(-2)*
     &  (MH02*(CBA*(-(3D0*S2A)+S2B)-2D0*SAB+3D0*C2A*SBA+C2B*SBA)*
     &  (C2A*CBA+S2A*SBA)+CAB*(3D0*CBA*MH02*(-(3D0*S2A)+S2B)-8D0*
     &  CBA**3*((2D0*MH02+MHH2)*S2A+MA02*(-(3D0*S2A)+S2B))+3D0*MH02*
     &  (-(2D0*SAB)+(3D0*C2A+C2B)*SBA)+8D0*CBA**2*MA02*(2D0*SAB-
     &  (3D0*C2A+C2B)*SBA)))*BSH0H0-4D0*CB**(-2)*SB**(-
     &  2)*(3D0*C2B*CBA**2*MA02*S2A-2D0*C2B*CBA**2*MH02*S2A-C2B*
     &  CBA**2*MHH2*S2A-C2B*CBA**2*MA02*S2B+2D0*C2B*CBA*MA02*SAB+
     &  9D0*C2A**2*CBA*MA02*SBA-C2B**2*CBA*MA02*SBA-9D0*CBA*MA02*
     &  S2A**2*SBA+9D0*CBA*MH02*S2A**2*SBA+9D0*CBA*MHH2*S2A**2*SBA+
     &  CBA*MH02*S2A*S2B*SBA-CBA*MHH2*S2A*S2B*SBA+CBA*MA02*S2B**2*
     &  SBA-6D0*MA02*S2A*SAB*SBA+2D0*MH02*S2A*SAB*SBA+4D0*MHH2*S2A*
     &  SAB*SBA-2D0*MA02*S2B*SAB*SBA+3D0*C2B*MA02*S2A*SBA**2-C2B*
     &  MH02*S2A*SBA**2-2D0*C2B*MHH2*S2A*SBA**2+C2B*MA02*S2B*SBA**2+
     &  3D0*C2A*(CBA**2*((2D0*MH02+MHH2)*S2A+MA02*(-(3D0*S2A)+S2B))-
     &  2D0*CBA*MA02*SAB-((MH02+2D0*MHH2)*S2A-MA02*(3D0*S2A+S2B))*
     &  SBA**2)-2D0*CAB*(CBA*((2D0*MH02+MHH2)*S2A+MA02*(-(3D0*S2A)+
     &  S2B))+MA02*(-(2D0*SAB)+(3D0*C2A+C2B)*SBA)))*BSH0HH
     &  +12D0*CB**(-2)*SB**(-2)*(C2B*CB*CBA*MHH2*SA**3+C2B*
     &  CA**3*CBA*MHH2*SB-3D0*CB*MHH2*S2A*SA**3*SBA-CB*MHH2*S2B*SA**
     &  3*SBA-3D0*CA**3*MHH2*S2A*SB*SBA-CA**3*MHH2*S2B*SB*SBA-2D0*
     &  C2B*CBA*MA02*SAB*SBA**2+6D0*MA02*S2A*SAB*SBA**3-2D0*MH02*
     &  S2A*SAB*SBA**3-4D0*MHH2*S2A*SAB*SBA**3+2D0*MA02*S2B*SAB*
     &  SBA**3+2D0*CAB*(CB*MHH2*SA**3+CA**3*MHH2*SB-2D0*MA02*SAB*
     &  SBA**2)-3D0*C2A*CBA*(CB*MHH2*SA**3+CA**3*MHH2*SB-2D0*MA02*
     &  SAB*SBA**2))*BSHHHH+32D0*CB**(-2)*SB**(-2)*(CAB*
     &  (CB**3*MHH2*SA-2D0*MA02*SAB+2D0*CB*CBA*MHP2*SB+CA*MHH2*SB**
     &  3)+SAB*(CA*CB**3*MH02-MH02*SA*SB**3+2D0*CB*MHP2*SB*SBA))*
     &  BSHPHP))/512D0
     &	
     &	-(ALPHA*((128D0*CBA*SBA*(2D0*XCW2*
     &  XMW2+XMZ2))/XCW2-(CB**(-2)*SB**(-2)*XMA02*(C2A*(MH02-MHH2)*
     &  S2A*(3D0+C2B**2-S2B**2)*XCW2+2D0*(C2B*S2A*(MH02*(2D0+S2A*
     &  S2B)+MHH2*(2D0-S2A*S2B))*XCW2-8D0*(CA*MA02*SA*(CB2-SB2)*
     &  XCW2+2D0*CB2*CBA*SB2*SBA*XMW2)))*B00A0)/(XCW2*
     &  XMW2)-(3D0*CB**(-2)*S2A*(C2A**2*C2B*MH02-C2B*(4D0*MA02-2D0*
     &  MHH2*S2A**2-MH02*(3D0-S2A**2))-2D0*C2A*(2D0*MA02+MHH2*S2A*
     &  S2B-MH02*(2D0+S2A*S2B)))*SB**(-2)*XMH02*B00H0)/
     &  XMW2-(3D0*CB**(-2)*S2A*(C2A**2*C2B*MHH2-C2B*(4D0*MA02-2D0*
     &  MH02*S2A**2-MHH2*(3D0-S2A**2))-C2A*(-(4D0*MA02)+2D0*MH02*
     &  S2A*S2B+MHH2*(4D0-2D0*S2A*S2B)))*SB**(-2)*XMHH2*B00HH
     &  )/XMW2-(2D0*CB**(-2)*SB**(-2)*XMHP2*(C2A*(-(3D0*MA02*
     &  S2B)+MH02*S2A*(3D0-S2B**2)-MHH2*S2A*(3D0-S2B**2)+16D0*CB2*
     &  MHP2*S2B*SB2)+C2B**2*(C2A*(MH02-MHH2)*S2A+2D0*MA02*(CB*(CA2-
     &  SA2)*SB-CA*SA*(CB2-SB2)))+C2B*(2D0*S2A*(MH02*(2D0+S2A*S2B)+
     &  MHH2*(2D0-S2A*S2B)-8D0*CB2*MHP2*SB2)+MA02*(-(7D0*S2A)-2D0*
     &  S2B*(CB2*SA2-4D0*CA*CB*SA*SB-SA2*SB2-CA2*(CB2-SB2))))-2D0*
     &  (CA2*CB*MA02*S2B**2*SB-CB*MA02*S2B**2*SA2*SB-CA*MA02*S2B**2*
     &  SA*(CB2-SB2)+16D0*CB2*CBA*SB2*SBA*XMW2))*B00HP)/
     &  XMW2+(8D0*(C2B*S2A*(MH02*S2A-MHH2*S2A+4D0*CB*(MA02-MHP2)*
     &  SB)-C2A*S2B*(MH02*S2A-MHH2*S2A+4D0*CB*(MA02-MHP2)*SB)-8D0*
     &  CB*CBA*SB*SBA*XMW2)*B00W)/(CB*SB)-(4D0*(-(C2B*
     &  (MH02-MHH2)*S2A**2*XCW2)+C2A*(MH02-MHH2)*S2A*S2B*XCW2+8D0*
     &  CB*CBA*SB*SBA*XMW2)*XMZ2*B00Z)/(CB*SB*XCW2*
     &  XMW2)+(16D0*CB**(-2)*SB**(-2)*(C2B*CBA*MA02-MH02*(CA*CB**3-
     &  SA*SB**3))*(CB**3*MHH2*SA+CA*MHH2*SB**3+C2B*MA02*SBA)*BSA0A0
     &  )/XMW2+(32D0*CBA*SBA*(MA02**2*XCW2+MH02*MHH2*
     &  XCW2-MA02*(MH02+MHH2)*XCW2+XMW2*(-(2D0*S)-2D0*XMA02+XMZ2))*
     &  BSA0Z)/(XCW2*XMW2)+(3D0*CB**(-2)*SB**(-2)*(CBA*
     &  (2D0*(2D0*MH02+MHH2)*S2A+MA02*(-(3D0*S2A)+S2B))+MA02*(-(2D0*
     &  SAB)+(3D0*C2A+C2B)*SBA))*(CAB*(4D0*CBA**2*MA02-3D0*MH02)-
     &  MH02*(C2A*CBA+S2A*SBA))*BSH0H0)/XMW2+(2D0*CB**(-
     &  2)*SB**(-2)*(2D0*CAB*MA02-3D0*C2A*CBA*MA02+C2B*CBA*MA02-3D0*
     &  MA02*S2A*SBA+2D0*MH02*S2A*SBA+4D0*MHH2*S2A*SBA-MA02*S2B*
     &  SBA)*(CBA*(2D0*(2D0*MH02+MHH2)*S2A+MA02*(-(3D0*S2A)+S2B))+
     &  MA02*(-(2D0*SAB)+(3D0*C2A+C2B)*SBA))*BSH0HH)/
     &  XMW2+(12D0*CB**(-2)*SB**(-2)*(2D0*CAB*MA02-3D0*C2A*CBA*MA02+
     &  C2B*CBA*MA02-3D0*MA02*S2A*SBA+2D0*MH02*S2A*SBA+4D0*MHH2*S2A*
     &  SBA-MA02*S2B*SBA)*(CB*MHH2*SA**3+CA**3*MHH2*SB-MA02*SAB*
     &  SBA**2)*BSHHHH)/XMW2+(32D0*CB**(-2)*SB**(-2)*
     &  (CB**3*MHH2*SA-MA02*SAB+2D0*CB*CBA*MHP2*SB+CA*MHH2*SB**3)*
     &  (CAB*MA02-CA*CB**3*MH02+MH02*SA*SB**3-2D0*CB*MHP2*SB*SBA)*
     &  BSHPHP)/XMW2-(64D0*CBA*SBA*(MHH2*MHP2-MHP2**2-
     &  MH02*(MHH2-MHP2)+2D0*S*XMW2+2D0*XMHP2*XMW2-XMW2**2)*BSHPW
     &  )/XMW2-(32D0*CBA*SBA*(MH02*MHH2-4D0*S*XMW2+12D0*
     &  XMW2**2)*BSWW)/XMW2-(16D0*CBA*SBA*(MH02*MHH2*
     &  XCW2-4D0*XMW2*(S-3D0*XMZ2))*BSZZ)/(XCW2*XMW2)))/
     &  (512D0*PI*XSW2)

	seHHHH = 
     &  (CB**(-2)*LAM5**2*PI**(-3)*SB**(-2)*XMW2*XSW2*(16D0*SAB**2*
     &  BSA0A0+(CBA*(3D0*S2A-S2B)+2D0*SAB-(3D0*C2A+C2B)*
     &  SBA)**2*BSH0H0+2D0*(-(2D0*CAB)+3D0*C2A*CBA-C2B*
     &  CBA+3D0*S2A*SBA+S2B*SBA)**2*BSH0HH+144D0*SAB**2*
     &  SBA**4*BSHHHH+32D0*SAB**2*BSHPHP))/
     &  (512D0*ALPHA)
     &
     &	+(LAM5/PI**2*(-(CB**(-2)*SB**(-2)*(6D0-7D0*
     &  C2A*C2B+3D0*S2A*S2B-2D0*S2B**2+CA2*CB2*S2B**2-CB2*S2B**2*
     &  SA2+4D0*CA*CB*S2B**2*SA*SB-CA2*S2B**2*SB2+S2B**2*SA2*SB2+
     &  C2B**2*(2D0+CB2*SA2-4D0*CA*CB*SA*SB-SA2*SB2-CA2*(CB2-SB2))-
     &  4D0*C2B*S2B*(-(CB*(CA2-SA2)*SB)+CA*SA*(CB2-SB2)))*XMA02*
     &  B00A0)-2D0*CB**(-2)*(2D0-3D0*C2A**2+C2B**2+3D0*
     &  S2A**2-S2B**2)*SB**(-2)*XMH02*B00H0-12D0*(C2A-
     &  C2B)**2*CB**(-2)*SB**(-2)*XMHH2*B00HH-2D0*CB**(-
     &  2)*SB**(-2)*(6D0-7D0*C2A*C2B+3D0*S2A*S2B-2D0*S2B**2+CA2*CB2*
     &  S2B**2-CB2*S2B**2*SA2+4D0*CA*CB*S2B**2*SA*SB-CA2*S2B**2*SB2+
     &  S2B**2*SA2*SB2+C2B**2*(2D0+CB2*SA2-4D0*CA*CB*SA*SB-SA2*SB2-
     &  CA2*(CB2-SB2))-4D0*C2B*S2B*(-(CB*(CA2-SA2)*SB)+CA*SA*(CB2-
     &  SB2)))*XMHP2*B00HP-64D0*SBA**2*XMW2*B00W
     &  -32D0*SBA**2*XMZ2*B00Z-32D0*CB**(-2)*SAB*
     &  SB**(-2)*(C2B*SBA*XMA02+(CB**3*SA+CA*SB**3)*XMHH2)*BSA0A0
     &  +2D0*CB**(-2)*SB**(-2)*((-(2D0*SAB)+(3D0*C2A+
     &  C2B)*SBA)**2*XMA02-2D0*CBA*(2D0*SAB-(3D0*C2A+C2B)*SBA)*(S2B*
     &  XMA02+S2A*(-(3D0*XMA02)+2D0*XMH02+XMHH2))+CBA**2*(S2B**2*
     &  XMA02+2D0*S2A*S2B*(-(3D0*XMA02)+2D0*XMH02+XMHH2)+3D0*S2A**2*
     &  (3D0*XMA02-2D0*(2D0*XMH02+XMHH2))))*BSH0H0+4D0*
     &  CB**(-2)*SB**(-2)*(4D0*CAB**2*XMA02+9D0*C2A**2*CBA**2*XMA02+
     &  C2B**2*CBA**2*XMA02-6D0*C2B*CBA*S2A*SBA*XMA02-2D0*C2B*CBA*
     &  S2B*SBA*XMA02+9D0*S2A**2*SBA**2*XMA02+6D0*S2A*S2B*SBA**2*
     &  XMA02+S2B**2*SBA**2*XMA02+2D0*C2B*CBA*S2A*SBA*XMH02-6D0*
     &  S2A**2*SBA**2*XMH02-2D0*S2A*S2B*SBA**2*XMH02+4D0*C2B*CBA*
     &  S2A*SBA*XMHH2-12D0*S2A**2*SBA**2*XMHH2-4D0*S2A*S2B*SBA**2*
     &  XMHH2-4D0*CAB*(3D0*C2A*CBA*XMA02-C2B*CBA*XMA02+SBA*(3D0*S2A*
     &  XMA02+S2B*XMA02-S2A*XMH02-2D0*S2A*XMHH2))-6D0*C2A*CBA*(C2B*
     &  CBA*XMA02-SBA*(S2B*XMA02-S2A*(-(3D0*XMA02)+XMH02+2D0*
     &  XMHH2))))*BSH0HH+288D0*CB**(-2)*SAB*SB**(-2)*
     &  SBA**2*(SAB*SBA**2*XMA02-(CB*SA**3+CA**3*SB)*XMHH2)*BSHHHH
     &  +64D0*CB**(-2)*SAB*SB**(-2)*(SAB*XMA02-CB**3*SA*
     &  XMHH2-CA*SB**3*XMHH2-2D0*CB*CBA*SB*XMHP2)*BSHPHP
     &  ))/512D0
     &
     &	+(ALPHA*(-((128D0*(1D0+2D0*CBA**2)*(2D0*XCW2*
     &  XMW2+XMZ2))/XCW2)+(CB**(-2)*SB**(-2)*XMA02*(6D0*S2A**2*XCW2*
     &  XMH02-4D0*S2A*S2B*XCW2*XMH02-2D0*S2A**2*S2B**2*XCW2*XMH02+
     &  9D0*XCW2*XMHH2-3D0*S2A**2*XCW2*XMHH2+4D0*S2A*S2B*XCW2*XMHH2-
     &  3D0*S2B**2*XCW2*XMHH2+S2A**2*S2B**2*XCW2*XMHH2+C2A**2*(3D0+
     &  C2B**2-S2B**2)*XCW2*XMHH2+4D0*C2A*C2B*XCW2*(4D0*XMA02-4D0*
     &  XMHH2-S2A*S2B*(XMH02-XMHH2))+C2B**2*XCW2*(-(16D0*XMA02)+3D0*
     &  XMHH2+S2A**2*(2D0*XMH02-XMHH2))+64D0*CB2*SB2*SBA**2*XMW2)*
     &  B00A0)/(XCW2*XMW2)-(2D0*CB**(-2)*SB**(-2)*XMH02*
     &  ((4D0-6D0*C2A**2+2D0*C2B**2+6D0*S2A**2-2D0*S2B**2)*XMA02+
     &  S2A*((1D0+3D0*C2A**2)*S2B*(XMH02-XMHH2)-3D0*S2A**2*S2B*
     &  (XMH02-XMHH2)-6D0*S2A*(XMH02+C2A*C2B*XMH02+XMHH2-C2A*C2B*
     &  XMHH2)))*B00H0)/XMW2+(6D0*CB**(-2)*SB**(-2)*
     &  XMHH2*(-(4D0*C2B**2*XMA02)+4D0*S2A**2*SBA**2*XMH02+CBA**2*
     &  S2A**2*XMHH2-6D0*CBA*S2A*SAB*XMHH2+9D0*SAB**2*XMHH2+C2A*
     &  (8D0*C2B*XMA02-2D0*(CBA*S2A-3D0*SAB)*SBA*XMHH2)+C2A**2*(-
     &  (4D0*XMA02)+SBA**2*XMHH2))*B00HH)/XMW2+(2D0*CB**
     &  (-2)*SB**(-2)*XMHP2*(-(2D0*(6D0-7D0*C2A*C2B+3D0*S2A*S2B-2D0*
     &  S2B**2+CA2*CB2*S2B**2-CB2*S2B**2*SA2+4D0*CA*CB*S2B**2*SA*SB-
     &  CA2*S2B**2*SB2+S2B**2*SA2*SB2+C2B**2*(2D0+CB2*SA2-4D0*CA*CB*
     &  SA*SB-SA2*SB2-CA2*(CB2-SB2))-4D0*C2B*S2B*(-(CB*(CA2-SA2)*
     &  SB)+CA*SA*(CB2-SB2)))*XMA02)+9D0*XMHH2+3D0*C2A**2*XMHH2-
     &  16D0*C2A*C2B*XMHH2+3D0*C2B**2*XMHH2+C2A**2*C2B**2*XMHH2-3D0*
     &  S2B**2*XMHH2-C2A**2*S2B**2*XMHH2-4D0*(1D0+C2A*C2B)*S2A*S2B*
     &  (XMH02-XMHH2)+S2A**2*(3D0+C2B**2-S2B**2)*(2D0*XMH02-XMHH2)+
     &  64D0*CB2*CBA**2*SB2*XMHP2+64D0*CB2*SB2*SBA**2*XMW2)*B00HP 
     &  )/XMW2-(16D0*(S2B*(4D0*CA*SA*SBA**2*XMH02-S2A*
     &  XMHH2)+CB*SB*(2D0*C2A*C2B*S2A*XMHH2+S2B*(-((3D0+C2A**2-S2A**
     &  2)*XMHH2)-8D0*(4D0-CBA**2)*XMW2+8D0*SBA**2*(XMA02-XMHP2+2D0*
     &  XMW2))))*B00W)/(CB*S2B*SB)-(8D0*(CB*S2A**2*S2B*
     &  SB*XCW2*XMHH2+S2A*XCW2*(2D0*S2B*SBA**2*XMH02-S2B*XMHH2+2D0*
     &  C2A*C2B*CB*SB*XMHH2)-CB*S2B*SB*((3D0+C2A**2)*XCW2*XMHH2+8D0*
     &  (4D0-CBA**2-2D0*SBA**2)*XMW2))*XMZ2*B00Z)/(CB*
     &  S2B*SB*XCW2*XMW2)+(32D0*CB**(-2)*SB**(-2)*(C2B*SBA*XMA02+
     &  (CB**3*SA+CA*SB**3)*XMHH2)**2*BSA0A0)/XMW2+(64D0*
     &  SBA**2*(XCW2*(XMA02-XMHH2)**2+XMW2*(-(2D0*S)-2D0*XMA02+
     &  XMZ2))*BSA0Z)/(XCW2*XMW2)+(2D0*CB**(-2)*SB**(-2)*
     &  ((2D0*SAB-(3D0*C2A+C2B)*SBA)*XMA02-CBA*(S2B*XMA02+S2A*(-
     &  (3D0*XMA02)+4D0*XMH02+2D0*XMHH2)))**2*BSH0H0)/
     &  XMW2+(4D0*CB**(-2)*SB**(-2)*(2D0*CAB*XMA02-3D0*C2A*CBA*
     &  XMA02+C2B*CBA*XMA02-3D0*S2A*SBA*XMA02-S2B*SBA*XMA02+2D0*S2A*
     &  SBA*XMH02+4D0*S2A*SBA*XMHH2)**2*BSH0HH)/XMW2+
     &  (288D0*CB**(-2)*SB**(-2)*(SAB*SBA**2*XMA02-(CB*SA**3+CA**3*
     &  SB)*XMHH2)**2*BSHHHH)/XMW2+(64D0*CB**(-2)*SB**(-
     &  2)*(SAB*XMA02-CB**3*SA*XMHH2-CA*SB**3*XMHH2-2D0*CB*CBA*SB*
     &  XMHP2)**2*BSHPHP)/XMW2+(128D0*SBA**2*(XMHH2**2-
     &  2D0*XMHH2*XMHP2+XMHP2**2-2D0*S*XMW2-2D0*XMHP2*XMW2+XMW2**2)*
     &  BSHPW)/XMW2+(64D0*CBA**2*(XMHH2**2-4D0*S*XMW2+
     &  12D0*XMW2**2)*BSWW)/XMW2+(32D0*CBA**2*(XCW2*
     &  XMHH2**2-4D0*XMW2*(S-3D0*XMZ2))*BSZZ)/(XCW2*
     &  XMW2)))/(1024D0*PI*XSW2)
	
	end

**********************************************************************
        subroutine xsehh_ferm_thdm(s,seh0h0,seh0HH,seHHHH)
**********************************************************************
*       unrenormalized neutral CP-even Higgs-boson self-energies
*       closed fermion loops only
*       THDM
*---------------------------------------------------------------------
*       24.5.16 Stefan Dittmaier
**********************************************************************
        implicit real*8 (a-z)
        complex*16 seh0h0,seh0HH,seHHHH
        complex*16 B0_,xB0_
        complex*16 B00l,B00u,B00d,Bsll,Bsdd,Bsuu 
	integer i

        include '../COMMON/param.inc'
        include '../COMMON/xparam.inc'
        include '../COMMON/param_thdm.inc'
        include '../COMMON/param_bsm.inc'

	seh0h0 = 0d0
	seh0HH = 0d0
	seHHHH = 0d0

	do 100 i=1,3

	B00l  =  xB0_(0D0,null, xML2(I),0)
	B00u  =  xB0_(0D0,null,xMQP2(I),0)
	B00d  =  xB0_(0D0,null,xMQM2(I),0)
	Bsll  =  xB0_(s, xML2(I),xML2(I),0)
	Bsdd  =  xB0_(s,xMQM2(I),xMQM2(I),0)
	Bsuu  =  xB0_(s,xMQP2(I),xMQP2(I),0)

	seh0h0 = seh0h0 
     &  -ALPHA*CLEPh0**2/(8D0*PI*XMW2*XSW2)
     &	*(2D0*B00L*XML2(I)**2+BSLL*XML2(I)*(-S+4D0*XML2(I)))
     &	-ALPHA*CDOh0**2/(8D0*PI*XMW2*XSW2)
     &	*(6D0*B00D*XMQM2(I)**2+3D0*BSDD*XMQM2(I)*(-S+4D0*XMQM2(I)))
     &	-ALPHA*CUPh0**2/(8D0*PI*XMW2*XSW2)
     &	*(6D0*B00U*XMQP2(I)**2+3D0*BSUU*XMQP2(I)*(-S+4D0*XMQP2(I)))

	seh0HH = seh0HH 
     &  -ALPHA*CLEPh0*CLEPHH/(8D0*PI*XMW2*XSW2)
     &	*(2D0*B00L*XML2(I)**2+BSLL*XML2(I)*(-S+4D0*XML2(I)))
     &	-ALPHA*CDOh0*CDOHH/(8D0*PI*XMW2*XSW2)
     &	*(6D0*B00D*XMQM2(I)**2+3D0*BSDD*XMQM2(I)*(-S+4D0*XMQM2(I)))
     &	-ALPHA*CUPh0*CUPHH/(8D0*PI*XMW2*XSW2)
     &	*(6D0*B00U*XMQP2(I)**2+3D0*BSUU*XMQP2(I)*(-S+4D0*XMQP2(I)))

	seHHHH = seHHHH 
     &  -ALPHA*CLEPHH**2/(8D0*PI*XMW2*XSW2)
     &	*(2D0*B00L*XML2(I)**2+BSLL*XML2(I)*(-S+4D0*XML2(I)))
     &	-ALPHA*CDOHH**2/(8D0*PI*XMW2*XSW2)
     &	*(6D0*B00D*XMQM2(I)**2+3D0*BSDD*XMQM2(I)*(-S+4D0*XMQM2(I)))
     &	-ALPHA*CUPHH**2/(8D0*PI*XMW2*XSW2)
     &	*(6D0*B00U*XMQP2(I)**2+3D0*BSUU*XMQP2(I)*(-S+4D0*XMQP2(I)))

100	continue
	
	end

**********************************************************************
        function xseww_thdm(s)
**********************************************************************
*       unrenormalized W self-energy
*       bosonic loops only
*       THDM
*---------------------------------------------------------------------
*       4.5.16 Stefan Dittmaier
**********************************************************************
        implicit real*8 (a-z)
        complex*16 B00A0,B00h0,B00HH,B00HP,B00W,B00Z 
        complex*16 BsA0HP,Bs0W,Bsh0W,BsHHW,BsWZ,Bsh0HP,BsHHHP 
        complex*16 B0A0HP,B0H0HP,B0H0W,B0HHHP,B0HHW,B0WZ   
        complex*16 DB0A0HP,DB00W,DB0h0W,DB0HHW,DB0WZ,DB0h0HP,DB0HHHP 
        complex*16 xseww_thdm,B0_,xB0_,xDB0_
        complex*16 B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)

        include '../COMMON/param.inc'
        include '../COMMON/xparam.inc'
        include '../COMMON/param_thdm.inc'
        include '../COMMON/param_bsm.inc'

        B00A0  = xB0_(0D0,null,xMA02,0)
        B00h0  = xB0_(0D0,null,xMh02,0)
        B00HH  = xB0_(0D0,null,xMHH2,0)
        B00HP  = xB0_(0D0,null,xMHP2,0)
        B00W   = xB0_(0D0,null,xMW2,0)
        B00Z   = xB0_(0D0,null,xMZ2,0)
        BsA0HP = xB0_(S,xMA02,xMHP2,0)
        Bs0W   = xB0_(S,null,xMW2,0)
        Bsh0W  = xB0_(S,xMh02,xMW2,0)
        BsHHW  = xB0_(S,xMHH2,xMW2,0)
        BsWZ   = xB0_(S,xMW2,xMZ2,0)
        Bsh0HP = xB0_(S,xMh02,xMHP2,0)
        BsHHHP = xB0_(S,xMHH2,xMHP2,0)

	B0A0HP = xB0_(0d0,xMA02,xMHP2,0)
	B0H0HP = xB0_(0d0,xMh02,xMHP2,0)
	B0H0W  = xB0_(0d0,xMh02,xMW2,0)
	B0HHHP = xB0_(0d0,xMHH2,xMHP2,0)
	B0HHW  = xB0_(0d0,xMHH2,xMW2,0)
	B0WZ   = xB0_(0d0,xMW2,xMZ2,0)

        DB0A0HP = xDB0_(0d0,xMA02,xMHP2,0)
        DB00W   = xDB0_(0d0,null,xMW2,0)
        DB0h0W  = xDB0_(0d0,xMh02,xMW2,0)
        DB0HHW  = xDB0_(0d0,xMHH2,xMW2,0)
        DB0WZ   = xDB0_(0d0,xMW2,xMZ2,0)
        DB0h0HP = xDB0_(0d0,xMh02,xMHP2,0)
        DB0HHHP = xDB0_(0d0,xMHH2,xMHP2,0)

        if (s.ne.0d0) then
        xseww_thdm = 
     &  (ALPHA*(-((2D0*(-(2D0*S)-2D0*CBA**2*S-2D0*S*SBA**2+4D0*S*
     &  XCW2+3D0*XMA02+3D0*CBA**2*XMH02+3D0*SBA**2*XMH02+3D0*CBA**2*
     &  XMHH2+3D0*SBA**2*XMHH2+3D0*XMHP2+3D0*CBA**2*XMHP2+3D0*SBA**
     &  2*XMHP2+39D0*XMW2+3D0*CBA**2*XMW2+3D0*SBA**2*XMW2-12D0*XCW2*
     &  XMW2+3D0*XMZ2+24D0*XCW2*XMZ2+4D0*S*XSW2-12D0*XMW2*XSW2))/
     &  XSW2)-(3D0*XMA02*(-(2D0*S)+XMA02-XMHP2)*B00A0)/
     &  (S*XSW2)-(3D0*XMH02*(-(3D0*S)+CBA**2*S+S*SBA**2+CBA**2*
     &  XMH02+SBA**2*XMH02-CBA**2*XMHP2-SBA**2*XMW2)*B00h0
     &  )/(S*XSW2)-(3D0*XMHH2*(-(3D0*S)+CBA**2*S+S*SBA**2+
     &  CBA**2*XMHH2+SBA**2*XMHH2-SBA**2*XMHP2-CBA**2*XMW2)*B00HH 
     &  )/(S*XSW2)+(3D0*XMHP2*(5D0*S-CBA**2*S-S*SBA**2+
     &  XMA02+CBA**2*XMH02+SBA**2*XMHH2-XMHP2-CBA**2*XMHP2-SBA**2*
     &  XMHP2)*B00HP)/(S*XSW2)+(3D0*XMW2*(41D0*S-CBA**2*
     &  S-S*SBA**2-20D0*S*XCW2+SBA**2*XMH02+CBA**2*XMHH2-XMW2-CBA**
     &  2*XMW2-SBA**2*XMW2-8D0*XCW2*XMW2+XMZ2+8D0*XCW2*XMZ2-20D0*S*
     &  XSW2-8D0*XMW2*XSW2)*B00W)/(S*XSW2)+(3D0*(1D0+
     &  8D0*XCW2)*XMZ2*(2D0*S+XMW2-XMZ2)*B00Z)/(S*XSW2)+
     &  (24D0*(-(5D0*S**2)-2D0*S*XMW2+XMW2**2)*BS0W)/S+
     &  (3D0*(-(S)+XMA02-2D0*XMA0*XMHP+XMHP2)*(-(S)+XMA02+2D0*XMA0*
     &  XMHP+XMHP2)*BSA0HP)/(S*XSW2)+(3D0*CBA**2*(-(S)+
     &  XMH02-2D0*XMH0*XMHP+XMHP2)*(-(S)+XMH02+2D0*XMH0*XMHP+XMHP2)*
     &  BSH0HP)/(S*XSW2)+(3D0*SBA**2*(S**2-2D0*S*XMH02+
     &  XMH02**2+10D0*S*XMW2-2D0*XMH02*XMW2+XMW2**2)*BSH0W
     &  )/(S*XSW2)+(3D0*SBA**2*(-(S)+XMHH2-2D0*XMHH*XMHP+
     &  XMHP2)*(-(S)+XMHH2+2D0*XMHH*XMHP+XMHP2)*BSHHHP)/
     &  (S*XSW2)+(3D0*CBA**2*(S**2-2D0*S*XMHH2+XMHH2**2+10D0*S*XMW2-
     &  2D0*XMHH2*XMW2+XMW2**2)*BSHHW)/(S*XSW2)+(3D0*(S**
     &  2-40D0*S**2*XCW2-2D0*S*XMW2-28D0*S*XCW2*XMW2+XMW2**2+8D0*
     &  XCW2*XMW2**2-2D0*S*XMZ2-28D0*S*XCW2*XMZ2-2D0*XMW2*XMZ2-16D0*
     &  XCW2*XMW2*XMZ2+XMZ2**2+8D0*XCW2*XMZ2**2+12D0*S*XMZ2*XSW2**
     &  2)*BSWZ)/(S*XSW2)))/(144D0*PI)
	else
        xseww_thdm = 
     &  -((ALPHA*((2D0*(XMA02+SBA**2*XMH02+SBA**2*XMHH2+XMHP2+SBA**
     &  2*XMHP2+17D0*XMW2+SBA**2*XMW2+CBA**2*(XMH02+XMHH2+XMHP2+
     &  XMW2)+XMZ2))/XSW2-(2D0*XMA02*B00A0)/XSW2-(2D0*
     &  XMH02*B00H0)/XSW2-(2D0*XMHH2*B00HH)/
     &  XSW2-(4D0*XMHP2*B00HP)/XSW2-(4D0*XMW2*(5D0-4D0*
     &  XSW2)*B00W)/XSW2-(2D0*XMW2*(9D0-8D0*XSW2)*
     &  B00Z)/(XCW2*XSW2)+(2D0*(XMA02+XMHP2)*B0A0HP
     &  )/XSW2+(2D0*CBA**2*(XMH02+XMHP2)*B0H0HP
     &  )/XSW2+(2D0*SBA**2*(XMH02-5D0*XMW2)*B0H0W
     &  )/XSW2+(2D0*SBA**2*(XMHH2+XMHP2)*B0HHHP)/
     &  XSW2+(2D0*CBA**2*(XMHH2-5D0*XMW2)*B0HHW)/XSW2+
     &  (2D0*XMW2*(30D0-43D0*XSW2+8D0*XSW2**2)*B0WZ)/
     &  (XCW2*XSW2)-8D0*XMW2**2*DB00W-((XMA02-XMHP2)**2*
     &  DB0A0HP)/XSW2-(CBA**2*(XMH02-XMHP2)**2*DB0H0HP
     &  )/XSW2-(SBA**2*(XMH02-XMW2)**2*DB0H0W
     &  )/XSW2-(SBA**2*(XMHH2-XMHP2)**2*DB0HHHP)/
     &  XSW2-(CBA**2*(XMHH2-XMW2)**2*DB0HHW)/XSW2-
     &  XCW2**(-2)*XMW2**2*XSW2*(9D0-8D0*XSW2)*DB0WZ))/
     &  (48D0*PI))
	endif

        end

**********************************************************************
        subroutine xsevv_thdm(s,seaa,seaz,sezz)
**********************************************************************
*       unrenormalized neutral boson self-energies
*       bosonic loops only
*       THDM
*---------------------------------------------------------------------
*       4.5.16 Stefan Dittmaier
**********************************************************************
        implicit real*8 (a-z)
        complex*16 seaa,seaz,sezz
        complex*16 B0_,xB0_,xDB0_
        complex*16 B00H0,B00HH,B00A0,B00HP,B00W,B00Z 
        complex*16 BSHPHP,BSWW,BSH0Z,BSHHZ,BSA0H0,BSA0HH
        complex*16 B0A0H0,B0A0HH,B0H0Z,B0HHZ,B0HPHP,B0WW   
        complex*16 DB0H0Z,DB0HHZ,DB0A0H0,DB0A0HH
        include '../COMMON/param.inc'
        include '../COMMON/xparam.inc'
        include '../COMMON/param_thdm.inc'
        include '../COMMON/param_bsm.inc'

        B00H0  = xB0_(0D0,null,xMH02,0)	
        B00HH  = xB0_(0D0,null,xMHH2,0)
        B00A0  = xB0_(0D0,null,xMA02,0)
        B00HP  = xB0_(0D0,null,xMHP2,0)	
        B00W   = xB0_(0D0,null,xMW2,0)	
        B00Z   = xB0_(0D0,null,xMZ2,0)
        BSHPHP = xB0_(S,xMHP2,xMHP2,0)	
        BSWW   = xB0_(S,xMW2,xMW2,0)	
        BSH0Z  = xB0_(S,xMH02,xMZ2,0)	
        BSHHZ  = xB0_(S,xMHH2,xMZ2,0)
        BSA0H0 = xB0_(S,xMA02,xMH02,0)	
        BSA0HH = xB0_(S,xMA02,xMHH2,0)	

	B0A0H0 = xB0_(0d0,xMA02,xMH02,0)	
	B0A0HH = xB0_(0d0,xMA02,xMHH2,0)	
	B0H0Z  = xB0_(0d0,xMH02,xMZ2,0)	
	B0HHZ  = xB0_(0d0,xMHH2,xMZ2,0)
	B0HPHP = xB0_(0d0,xMHP2,xMHP2,0)	
	B0WW   = xB0_(0d0,xMW2,xMW2,0)	

        DB0H0Z  = xDB0_(0D0,XMH02,XMZ2,0)	
        DB0HHZ  = xDB0_(0D0,XMHH2,XMZ2,0)	
        DB0A0H0 = xDB0_(0D0,XMA02,XMH02,0)	
        DB0A0HH = xDB0_(0D0,XMA02,XMHH2,0)	

	seaa = 
     &  (ALPHA*(-(2D0*(-(S)+6D0*XMHP2+18D0*XMW2))+12D0*XMHP2*B00HP 
     &  +36D0*XMW2*B00W-3D0*(-(S)+4D0*XMHP2)*
     &  BSHPHP-9D0*(3D0*S+4D0*XMW2)*BSWW))/
     &  (36D0*PI)

	seaz = 
     &  -((ALPHA*(-(4D0*(3D0*XCW2*XMHP2+15D0*XCW2*XMW2+S*XSW2-3D0*
     &  XMHP2*XSW2-3D0*XMW2*XSW2))+12D0*XMHP2*(XCW+XSW)*(XCW-XSW)*
     &  B00HP+12D0*XMW2*(5D0*XCW2-XSW2)*B00W
     &  -3D0*(-(S)+4D0*XMHP2)*(XCW+XSW)*(XCW-XSW)*BSHPHP
     &  -3D0*(19D0*S*XCW2+32D0*XCW2*XMW2+S*XSW2-4D0*XMW2*XSW2+
     &  12D0*XCW*XMW*XMZ*XSW2)*BSWW))/(72D0*PI*XCW*XSW))

        if (s.ne.0d0) then
          sezz = 
     &  (ALPHA*(-(2D0*(-(2D0*CBA**2*S)-2D0*S*SBA**2+2D0*S*XCW2**2+
     &  3D0*CBA**2*XMA02+3D0*SBA**2*XMA02+3D0*CBA**2*XMH02+3D0*SBA**
     &  2*XMH02+3D0*CBA**2*XMHH2+3D0*SBA**2*XMHH2+6D0*XCW2**2*XMHP2+
     &  54D0*XCW2**2*XMW2+3D0*CBA**2*XMZ2+3D0*SBA**2*XMZ2+4D0*S*
     &  XCW2*XSW2-12D0*XCW2*XMHP2*XSW2-12D0*XCW2*XMW2*XSW2-2D0*S*
     &  XSW2**2+6D0*XMHP2*XSW2**2+6D0*XMW2*XSW2**2))-(3D0*XMA02*(-
     &  (3D0*S)+CBA**2*S+S*SBA**2+CBA**2*XMA02+SBA**2*XMA02-CBA**2*
     &  XMH02-SBA**2*XMHH2)*B00A0)/S+(3D0*XMH02*(3D0*S-
     &  CBA**2*S-S*SBA**2+CBA**2*XMA02-CBA**2*XMH02-SBA**2*XMH02+
     &  SBA**2*XMZ2)*B00H0)/S-(3D0*XMHH2*(-(3D0*S)+CBA**
     &  2*S+S*SBA**2-SBA**2*XMA02+CBA**2*XMHH2+SBA**2*XMHH2-CBA**2*
     &  XMZ2)*B00HH)/S+12D0*XMHP2*(XCW+XSW)**2*(XCW-
     &  XSW)**2*B00HP+12D0*XMW2*(9D0*XCW2**2-2D0*XCW2*
     &  XSW2+XSW2**2)*B00W+(3D0*XMZ2*(3D0*S-CBA**2*S-S*
     &  SBA**2+SBA**2*XMH02+CBA**2*XMHH2-CBA**2*XMZ2-SBA**2*XMZ2)*
     &  B00Z)/S+(3D0*CBA**2*(-(S)+XMA02-2D0*XMA0*XMH0+
     &  XMH02)*(-(S)+XMA02+2D0*XMA0*XMH0+XMH02)*BSA0H0)/
     &  S+(3D0*SBA**2*(-(S)+XMA02-2D0*XMA0*XMHH+XMHH2)*(-(S)+XMA02+
     &  2D0*XMA0*XMHH+XMHH2)*BSA0HH)/S+(3D0*SBA**2*(S**2-
     &  2D0*S*XMH02+XMH02**2+10D0*S*XMZ2-2D0*XMH02*XMZ2+XMZ2**2)*
     &  BSH0Z)/S+(3D0*CBA**2*(S**2-2D0*S*XMHH2+XMHH2**2+
     &  10D0*S*XMZ2-2D0*XMHH2*XMZ2+XMZ2**2)*BSHHZ)/S+3D0*
     &  (S-4D0*XMHP2)*(XCW+XSW)**2*(XCW-XSW)**2*BSHPHP-
     &  3D0*(39D0*S*XCW2**2+60D0*XCW2**2*XMW2+2D0*S*XCW2*XSW2-8D0*
     &  XCW2*XMW2*XSW2-S*XSW2**2+4D0*XMW2*XSW2**2-24D0*XCW2*XMZ2*
     &  XSW2**2)*BSWW))/(144D0*PI*XCW2*XSW2)
        else
          sezz = 
     &  -((ALPHA*((2D0*(SBA**2*XMA02+SBA**2*XMH02+SBA**2*XMHH2+2D0*
     &  (1D0-2D0*XCW2)**2*XMHP2+2D0*XMW2+SBA**2*XMZ2-8D0*XCW2**2*
     &  XMZ2+24D0*XCW2**3*XMZ2+CBA**2*(XMA02+XMH02+XMHH2+XMZ2)))/
     &  XCW2-(2D0*XMA02*B00A0)/XCW2-(2D0*XMH02*B00H0
     &  )/XCW2-(2D0*XMHH2*B00HH)/XCW2-(4D0*
     &  (1D0-2D0*XCW2)**2*XMHP2*B00HP)/XCW2-4D0*(1D0-
     &  4D0*XCW2+12D0*XCW2**2)*XMZ2*B00W-(2D0*XMZ2*
     &  B00Z)/XCW2+(2D0*CBA**2*(XMA02+XMH02)*B0A0H0
     &  )/XCW2+(2D0*SBA**2*(XMA02+XMHH2)*B0A0HH
     &  )/XCW2+(2D0*SBA**2*(XMH02-5D0*XMZ2)*B0H0Z
     &  )/XCW2+(2D0*CBA**2*(XMHH2-5D0*XMZ2)*B0HHZ
     &  )/XCW2+(4D0*(1D0-2D0*XCW2)**2*XMHP2*B0HPHP
     &  )/XCW2-4D0*(5D0-8D0*XCW2-12D0*XCW2**2)*XMZ2*B0WW
     &  -(CBA**2*(XMA02-XMH02)**2*DB0A0H0)/
     &  XCW2-(SBA**2*(XMA02-XMHH2)**2*DB0A0HH)/XCW2-
     &  (SBA**2*(XMH02-XMZ2)**2*DB0H0Z)/XCW2-(CBA**2*
     &  (XMHH2-XMZ2)**2*DB0HHZ)/XCW2))/(48D0*PI*XSW2))
        endif

        end

************************************************************************
        subroutine xcalcrenc_thdm
************************************************************************
*	calculate renormalization constants
*	bosonic loops only
*	THDM
*-----------------------------------------------------------------------
*       9.5.16 Stefan Dittmaier
************************************************************************

        use COLLIER
        use collier_init

        implicit real*8 (a-z)
	complex*16 xseww_thdm,seaa,seaz,sezz,dZff_a
	complex*16 xseaa_thdm,xsehp_thdm,seh0HH_mh02,seh0HH_mHH2
        complex*16 seh0h0,seh0HH,seHHHH,seh0HHdiv
	complex*16 xA0_,xB0_,xDB0_,xB1_,B1Z,B1W,xC0_
	complex*16 B00A0,B00H0,B00HH,B00HP,B00W,B00Z   
	complex*16 BW0W,BWWZ,BWH0W,BWHHW,BWA0HP,BWH0HP,BWHHHP
	complex*16 BZWW,BZA0H0,BZA0HH,BZH0Z,BZHHZ,BZHPHP 
	complex*16 BAH0Z,BAHHZ,BAHpW,BAAh0,BAAHH 
	complex*16 BH0AZ,BH0HpW,BH0WW,BH0ZZ
	complex*16 BHHAZ,BHHHpW,BHHWW,BHHZZ   
	complex*16 DBAAh0,DBAAHH,DBAh0Z,DBAHHZ,DBAHpW
	complex*16 DBW0W,DBWH0W,DBWHHW,DBWA0HP,DBWH0HP,DBWHHHP,DBWWZ  
	complex*16 DBZA0H0,DBZA0HH,DBZH0Z,DBZHHZ,DBZHPHP,DBZWW  
	complex*16 DB0WW,DB0HPHP
	complex*16 BSA0Z,BSHPW,BSWW,BSZZ    
	complex*16 DBSA0A0,DBSA0Z,DBSH0H0,DBSH0HH,DBSHHHH,DBSHPHP,DBSHPW
	complex*16 DBSWW,DBSZZ   
	complex*16 CAH0Z,CAHHZ,CAHpW 
	complex*16 CH0AZ,CH0HpW,CH0WW,CH0ZZ  
	complex*16 CHHAZ,CHHHpW,CHHWW,CHHZZ  
	complex*16 seww0
        complex*16 gnnl,geer,geel,gffr(4),gffl(4)
	complex*16 th0,tHH,th0div,tHHdiv
        complex*16 dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw
        complex*16 dmh02,dmHH2,dma02,dmhp2,dZh0,dZHH,dZh0HH,dZHHh0
	complex*16 dtb,dsa,dmh0HH2,dlam3,dlam5,dlam35
        complex*16 dZeer,dZeel,dZnnl,dZffr(4),dZffl(4)
        complex*16 ct_aww,ct_zww,ct_wen,ct_wf1f2,ct_wf3f4
        complex*16 ct_annl,ct_aeer,ct_aeel,ct_affr(4),ct_affl(4)
        complex*16 ct_znnl,ct_zeer,ct_zeel,ct_zffr(4),ct_zffl(4)
        complex*16 ct_h0ww,ct_HHww,ct_h0zz,ct_HHzz,ct_h0za,ct_HHza
        complex*16 dmw2tad,dmz2tad,dtbtad
        complex*16 dZh0div,dZHHdiv,dZh0HHdiv,dZHHh0div
        complex*16 DSAvert1,DSAvert2,DTBvert1,DTBvert2,DTBvert12
        complex*16 DTBvert1full,DTBvert2full
	complex*16 dZA0,dZG0A0
	complex*16 ddZh0bfm,ddZHHbfm,ddZHHh0bfm,ddZh0HHbfm
        real*8 iw3f(4)
	integer i,dir(7)

        include '../COMMON/param.inc'
        include '../COMMON/options.inc'
        include '../COMMON/xparam.inc'
        include '../COMMON/processpar.inc'
        include '../COMMON/param_thdm.inc'
        include '../COMMON/param_bsm.inc'
        include '../COMMON/model.inc'
        COMMON/UV/MUDIM2
        COMMON/IR/LAMBDA,LAMBDA2
        common/xrenc_thdm/
     &	       dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,
     &	       dmh02,dmHH2,dma02,dmhp2,dZh0,dZHH,dZh0HH,dZHHh0,
     &	       dtb,dsa,dmh0HH2,dlam3,dlam5,
     &         dZeer,dZeel,dZnnl,dZffr,dZffl,
     &         ct_aww,ct_zww,ct_wen,ct_wf1f2,ct_wf3f4,
     &         ct_annl,ct_aeer,ct_aeel,ct_affr,ct_affl,
     &         ct_znnl,ct_zeer,ct_zeel,ct_zffr,ct_zffl,
     &         ct_h0ww,ct_HHww,ct_h0zz,ct_HHzz,ct_h0za,ct_HHza

c collier parameters
	real*8 deltaUV,muv2,delta1ir,delta2ir,mir2

	call GetMuUV2_cll(muv2)
	call GetDeltaUV_cll(deltaUV)
	mudim2 = exp(deltauv + log(muv2))
        call GetDeltaIR_cll(delta1ir,delta2ir)
        call GetMuIR2_cll(mir2)
	lambda2 = exp(delta1ir + log(mir2))
	lambda  = sqrt(lambda2)

	B00A0   = xB0_(0d0,null,xmA02,0)
	B00H0   = xB0_(0d0,null,xmh02,0)
	B00HH   = xB0_(0d0,null,xmHH2,0)
	B00HP   = xB0_(0d0,null,xmHP2,0)
	B00W    = xB0_(0d0,null,xmw2,0)
	B00Z    = xB0_(0d0,null,xmz2,0)
	BW0W    = xB0_(mw2,null,xmw2,0)
	BWWZ    = xB0_(mw2,xmw2,xmz2,0)
	BWH0W   = xB0_(mw2,xmh02,xmw2,0)
	BWHHW   = xB0_(mw2,xmHH2,xmw2,0)
	BWA0HP  = xB0_(mw2,xmA02,xmHP2,0)
	BWH0HP  = xB0_(mw2,xmh02,xmHP2,0)
	BWHHHP  = xB0_(mw2,xmHH2,xmHP2,0)
	BZWW    = xB0_(mz2,xmw2,xmw2,0)
	BZA0H0  = xB0_(mz2,xmA02,xmh02,0)
	BZA0HH  = xB0_(mz2,xmA02,xmHH2,0)
	BZH0Z   = xB0_(mz2,xmh02,xmz2,0)
	BZHHZ   = xB0_(mz2,xmHH2,xmz2,0)
	BZHPHP  = xB0_(mz2,xmHP2,xmHP2,0)
	BAH0Z   = xB0_(MA02,xMh02,xMZ2,0) 
	BAHHZ   = xB0_(MA02,xMHH2,xMZ2,0) 
	BAHpW   = xB0_(MA02,xMHp2,xMW2,0) 
	BAAh0   = xB0_(MA02,xMA02,xMh02,0)
	BAAHH   = xB0_(MA02,xMA02,xMHH2,0)
	BH0AZ   = xB0_(Mh02,xMA02,xMZ2,0) 
	BH0HpW  = xB0_(Mh02,xMHp2,xMW2,0) 
	BH0WW   = xB0_(Mh02,xMW2,xMW2,0)  
	BH0ZZ   = xB0_(Mh02,xMZ2,xMZ2,0)  
	BHHAZ   = xB0_(MHH2,xMA02,xMZ2,0) 
	BHHHpW  = xB0_(MHH2,xMHp2,xMW2,0) 
	BHHWW   = xB0_(MHH2,xMW2,xMW2,0)  
	BHHZZ   = xB0_(MHH2,xMZ2,xMZ2,0)  

	DB0WW   = xDB0_(0d0,xmw2,xmw2,0)
	DB0HPHP = xDB0_(0d0,xmHP2,xmHP2,0)
	DBW0W   = xDB0_(mw2,null,xmw2,0)
	DBWH0W  = xDB0_(mw2,xmh02,xmw2,0)
	DBWHHW  = xDB0_(mw2,xmHH2,xmw2,0)
	DBWA0HP = xDB0_(mw2,xmA02,xmHP2,0)
	DBWH0HP = xDB0_(mw2,xmh02,xmHP2,0)
	DBWHHHP = xDB0_(mw2,xmHH2,xmHP2,0)
	DBWWZ   = xDB0_(mw2,xmw2,xmz2,0)
	DBZA0H0 = xDB0_(mz2,xmA02,xmH02,0)
	DBZA0HH = xDB0_(mz2,xmA02,xmHH2,0)
	DBZH0Z  = xDB0_(mz2,xmh02,xmz2,0)
	DBZHHZ  = xDB0_(mz2,xmHH2,xmz2,0)
	DBZHPHP = xDB0_(mz2,xmHP2,xmHP2,0)
	DBZWW   = xDB0_(mz2,xmw2,xmw2,0)
	DBAAh0  = xDB0_(MA02,xMA02,xMh02,0) 
	DBAAHH  = xDB0_(MA02,xMA02,xMHH2,0) 
	DBAh0Z  = xDB0_(MA02,xMh02,xMZ2,0)  
	DBAHHZ  = xDB0_(MA02,xMHH2,xMZ2,0)  
	DBAHpW  = xDB0_(MA02,xMHp2,xMW2,0)  

        B1W   = xB1_(0D0,null,xMW2,0)
        B1Z   = xB1_(0D0,null,xMZ2,0)

	CAH0Z  = xC0_(0d0,0d0,MA02,xMh02,null,xMZ2,0) 
	CAHHZ  = xC0_(0d0,0d0,MA02,xMHH2,null,xMZ2,0) 
	CAHpW  = xC0_(0d0,0d0,MA02,xMHp2,null,xMW2,0) 
	CH0AZ  = xC0_(0d0,0d0,Mh02,xMA02,null,xMZ2,0) 
	CH0HpW = xC0_(0d0,0d0,Mh02,xMHp2,null,xMW2,0) 
	CH0WW  = xC0_(0d0,0d0,Mh02,xMW2,null,xMW2,0)  
	CH0ZZ  = xC0_(0d0,0d0,Mh02,xMZ2,null,xMZ2,0)  
	CHHAZ  = xC0_(0d0,0d0,MHH2,xMA02,null,xMZ2,0) 
	CHHHpW = xC0_(0d0,0d0,MHH2,xMHp2,null,xMW2,0) 
	CHHWW  = xC0_(0d0,0d0,MHH2,xMW2,null,xMW2,0)  
	CHHZZ  = xC0_(0d0,0d0,MHH2,xMZ2,null,xMZ2,0)  

	dmw2 = xseww_thdm(mw2)

	call xsevv_thdm(mz2,seaa,seaz,sezz)
	dmz2 = sezz
	dZaz = -2d0*seaz/mz2

	call xsevv_thdm(0d0,seaa,seaz,sezz)

	dZza = 2d0*seaz/xmz2

	dZaz = dZaz + (xmz2-mz2)/mz2*dZza

	dZaa = 
     &  -((ALPHA*(2D0+3D0*(-1D0+B00HP)-27D0*(-1D0+B00W)
     &  -12D0*XMHP2*DB0HPHP-36D0*XMW2*DB0WW))/(36D0*PI))

	x = mw2
	dZw = 
     &  (ALPHA*(-((XMA02*(XMA02-XMHP2)*B00A0)/(x*XSW2))-
     &  (XMH02*(CBA**2*(XMH02-XMHP2)+SBA**2*(XMH02-XMW2))*B00H0
     &  )/(x*XSW2)-(XMHH2*(SBA**2*(XMHH2-XMHP2)+CBA**2*
     &  (XMHH2-XMW2))*B00HH)/(x*XSW2)+(XMHP2*(XMA02+
     &  SBA**2*XMHH2-XMHP2-SBA**2*XMHP2+CBA**2*(XMH02-XMHP2))*
     &  B00HP)/(x*XSW2)-(XMW2*(-(SBA**2*XMH02)-CBA**2*
     &  (XMHH2-XMW2)-XMZ2-8D0*XCW2*XMZ2+XMW2*(1D0+SBA**2+8D0*XCW2+
     &  8D0*XSW2))*B00W)/(x*XSW2)+((1D0+8D0*XCW2)*XMZ2*
     &  (XMW2-XMZ2)*B00Z)/(x*XSW2)+(8D0*(5D0*x**2+XMW2**
     &  2)*BW0W)/x+((-(x**2)+XMA02**2-2D0*XMA02*XMHP2+
     &  XMHP2**2)*BWA0HP)/(x*XSW2)+(CBA**2*(-(x**2)+
     &  XMH02**2-2D0*XMH02*XMHP2+XMHP2**2)*BWH0HP)/(x*
     &  XSW2)+(SBA**2*(-(x**2)+XMH02**2-2D0*XMH02*XMW2+XMW2**2)*
     &  BWH0W)/(x*XSW2)+(SBA**2*(-(x**2)+XMHH2**2-2D0*
     &  XMHH2*XMHP2+XMHP2**2)*BWHHHP)/(x*XSW2)+(CBA**2*(-
     &  (x**2)+XMHH2**2-2D0*XMHH2*XMW2+XMW2**2)*BWHHW)/
     &  (x*XSW2)+((-(x**2*(1D0-40D0*XCW2))+(1D0+8D0*XCW2)*XMW2**2-
     &  2D0*(1D0+8D0*XCW2)*XMW2*XMZ2+(1D0+8D0*XCW2)*XMZ2**2)*BWWZ
     &  )/(x*XSW2)-8D0*(-(5D0*x**2)-2D0*x*XMW2+XMW2**2)*
     &  DBW0W-((-(x)+XMA02-2D0*XMA0*XMHP+XMHP2)*(-(x)+
     &  XMA02+2D0*XMA0*XMHP+XMHP2)*DBWA0HP)/XSW2-(CBA**2*
     &  (-(x)+XMH02-2D0*XMH0*XMHP+XMHP2)*(-(x)+XMH02+2D0*XMH0*XMHP+
     &  XMHP2)*DBWH0HP)/XSW2-(SBA**2*(x**2+XMH02**2+10D0*
     &  x*XMW2+XMW2**2-2D0*XMH02*(x+XMW2))*DBWH0W)/XSW2-
     &  (SBA**2*(-(x)+XMHH2-2D0*XMHH*XMHP+XMHP2)*(-(x)+XMHH2+2D0*
     &  XMHH*XMHP+XMHP2)*DBWHHHP)/XSW2-(CBA**2*(x**2+
     &  XMHH2**2+10D0*x*XMW2+XMW2**2-2D0*XMHH2*(x+XMW2))*DBWHHW
     &  )/XSW2-((x**2*(1D0-40D0*XCW2)+(1D0+8D0*XCW2)*
     &  XMW2**2+(1D0+8D0*XCW2)*XMZ2**2-2D0*XMW2*(x+14D0*x*XCW2+(1D0+
     &  8D0*XCW2)*XMZ2)-2D0*x*XMZ2*(1D0+14D0*XCW2-6D0*XSW2**2))*
     &  DBWWZ)/XSW2))/(48D0*PI*x)

	x = mz2
	dZzz = 
     &  (ALPHA*(-(8D0*XSW2**2)-3D0*X**(-2)*XMA02*(CBA**2*(XMA02-
     &  XMH02)+SBA**2*(XMA02-XMHH2))*B00A0-3D0*X**(-2)*
     &  XMH02*(-(CBA**2*(XMA02-XMH02))+SBA**2*(XMH02-XMZ2))*B00H0
     &  -3D0*X**(-2)*XMHH2*(-(SBA**2*(XMA02-XMHH2))+CBA**
     &  2*(XMHH2-XMZ2))*B00HH-3D0*X**(-2)*XMZ2*(-(SBA**
     &  2*(XMH02-XMZ2))-CBA**2*(XMHH2-XMZ2))*B00Z+3D0*
     &  CBA**2*X**(-2)*(-(X**2)+XMA02**2-2D0*XMA02*XMH02+XMH02**2)*
     &  BZA0H0+3D0*SBA**2*X**(-2)*(-(X**2)+XMA02**2-2D0*
     &  XMA02*XMHH2+XMHH2**2)*BZA0HH+3D0*SBA**2*X**(-2)*
     &  (-(X**2)+XMH02**2-2D0*XMH02*XMZ2+XMZ2**2)*BZH0Z+
     &  3D0*CBA**2*X**(-2)*(-(X**2)+XMHH2**2-2D0*XMHH2*XMZ2+XMZ2**
     &  2)*BZHHZ-3D0*(XCW+XSW)**2*(XCW-XSW)**2*BZHPHP
     &  -3D0*(1D0-38D0*XCW2**2-2D0*XCW2*(1D0+XSW2))*
     &  BZWW-(3D0*CBA**2*(-(X)+XMA02-2D0*XMA0*XMH0+
     &  XMH02)*(-(X)+XMA02+2D0*XMA0*XMH0+XMH02)*DBZA0H0)/
     &  X-(3D0*SBA**2*(-(X)+XMA02-2D0*XMA0*XMHH+XMHH2)*(-(X)+XMA02+
     &  2D0*XMA0*XMHH+XMHH2)*DBZA0HH)/X-(3D0*SBA**2*(X**
     &  2+XMH02**2+10D0*X*XMZ2+XMZ2**2-2D0*XMH02*(X+XMZ2))*DBZH0Z
     &  )/X-(3D0*CBA**2*(X**2+XMHH2**2+10D0*X*XMZ2+XMZ2**
     &  2-2D0*XMHH2*(X+XMZ2))*DBZHHZ)/X-3D0*(X-4D0*
     &  XMHP2)*(XCW+XSW)**2*(XCW-XSW)**2*DBZHPHP+3D0*(-
     &  (24D0*XCW2*XMZ2*XSW2**2)-X*(1D0-38D0*XCW2**2-2D0*XCW2*(1D0+
     &  XSW2))+XMW2*(4D0+64D0*XCW2**2-8D0*XCW2*(1D0+XSW2)))*DBZWW
     &  ))/(144D0*PI*XCW2*XSW2)

        call xsehh_thdm(mh02,seh0h0,seh0HH,seHHHH)
	dmh02  = seh0h0
	seh0HH_mh02 = seh0HH

        call xsehh_thdm(mHH2,seh0h0,seh0HH,seHHHH)
	dmHH2  = seHHHH
	seh0HH_mHH2 = seh0HH

	dZh0HH  = -2d0*seh0HH_mHH2/(mHH2-mh02)
	dZHHh0  = -2d0*seh0HH_mh02/(mh02-mHH2)

        dma02 = xseaa_thdm(ma02)

        dmhp2 = xsehp_thdm(mhp2)

	s = mh02
        BSA0Z   = xB0_(S,xMA02,xMZ2,0)	
        BSHPW   = xB0_(S,xMHP2,xMW2,0)	
        BSWW    = xB0_(S,xMW2,xMW2,0)	
        BSZZ    = xB0_(S,xMZ2,xMZ2,0)	
        DBSA0A0 = xDB0_(S,xMA02,xMA02,0)	
        DBSA0Z  = xDB0_(S,xMA02,xMZ2,0)	
        DBSH0H0 = xDB0_(S,xMH02,xMH02,0)	
        DBSH0HH = xDB0_(S,xMH02,xMHH2,0)	
        DBSHHHH = xDB0_(S,xMHH2,xMHH2,0)	
        DBSHPHP = xDB0_(S,xMHP2,xMHP2,0)	
        DBSHPW  = xDB0_(S,xMHP2,xMW2,0)	
        DBSWW   = xDB0_(S,xMW2,xMW2,0)	
        DBSZZ   = xDB0_(S,xMZ2,xMZ2,0)	

	dZh0  = 
     &  -((CB**(-2)*LAM5**2*PI**(-3)*SB**(-2)*XMW2*XSW2*(16D0*CAB**
     &  2*DBSA0A0+144D0*CAB**2*CBA**4*DBSH0H0+
     &  2D0*(CBA*(3D0*S2A-S2B)+2D0*SAB-(3D0*C2A+C2B)*SBA)**2*DBSH0HH
     &  +(-(2D0*CAB)+3D0*C2A*CBA-C2B*CBA+3D0*S2A*SBA+
     &  S2B*SBA)**2*DBSHHHH+32D0*CAB**2*DBSHPHP
     &  ))/(512D0*ALPHA))
     &
     &	+(CB**(-2)*LAM5/PI**2*SB**(-2)*(-
     &  (16D0*CAB*(C2B*CBA*XMA02-(CA*CB**3-SA*SB**3)*XMH02)*DBSA0A0
     &  )+36D0*CAB*CBA**2*((C2A*CBA+S2A*SBA)*XMH02-CAB*
     &  (4D0*CBA**2*XMA02-3D0*XMH02))*DBSH0H0-2D0*((-
     &  (2D0*SAB)+(3D0*C2A+C2B)*SBA)**2*XMA02-2D0*CBA*(2D0*SAB-(3D0*
     &  C2A+C2B)*SBA)*(S2B*XMA02+S2A*(-(3D0*XMA02)+2D0*XMH02+
     &  XMHH2))+CBA**2*(S2B**2*XMA02+2D0*S2A*S2B*(-(3D0*XMA02)+2D0*
     &  XMH02+XMHH2)+3D0*S2A**2*(3D0*XMA02-2D0*(2D0*XMH02+XMHH2))))*
     &  DBSH0HH-(4D0*CAB**2*XMA02+9D0*C2A**2*CBA**2*
     &  XMA02+C2B**2*CBA**2*XMA02-6D0*C2B*CBA*S2A*SBA*XMA02-2D0*C2B*
     &  CBA*S2B*SBA*XMA02+9D0*S2A**2*SBA**2*XMA02+6D0*S2A*S2B*SBA**
     &  2*XMA02+S2B**2*SBA**2*XMA02+2D0*C2B*CBA*S2A*SBA*XMH02-6D0*
     &  S2A**2*SBA**2*XMH02-2D0*S2A*S2B*SBA**2*XMH02+4D0*C2B*CBA*
     &  S2A*SBA*XMHH2-12D0*S2A**2*SBA**2*XMHH2-4D0*S2A*S2B*SBA**2*
     &  XMHH2-4D0*CAB*(3D0*C2A*CBA*XMA02-C2B*CBA*XMA02+SBA*(3D0*S2A*
     &  XMA02+S2B*XMA02-S2A*XMH02-2D0*S2A*XMHH2))-6D0*C2A*CBA*(C2B*
     &  CBA*XMA02-SBA*(S2B*XMA02-S2A*(-(3D0*XMA02)+XMH02+2D0*
     &  XMHH2))))*DBSHHHH-32D0*CAB*(CAB*XMA02-CA*CB**3*
     &  XMH02+SA*SB**3*XMH02-2D0*CB*SB*SBA*XMHP2)*DBSHPHP
     &  ))/256D0
     &
     &	+(ALPHA*((64D0*CBA**2*BSA0Z)/XCW2+
     &  128D0*CBA**2*BSHPW+128D0*SBA**2*BSWW+
     &  (64D0*SBA**2*BSZZ)/XCW2-(16D0*CB**(-2)*SB**(-2)*
     &  (C2B*CBA*XMA02-(CA*CB**3-SA*SB**3)*XMH02)**2*DBSA0A0
     &  )/XMW2-(32D0*CBA**2*(XCW2*(XMA02-XMH02)**2+XMW2*(-
     &  (2D0*S)-2D0*XMA02+XMZ2))*DBSA0Z)/(XCW2*XMW2)-
     &  (9D0*CB**(-2)*SB**(-2)*((C2A*CBA+S2A*SBA)*XMH02+CAB*(-(4D0*
     &  CBA**2*XMA02)+3D0*XMH02))**2*DBSH0H0)/XMW2-(2D0*
     &  CB**(-2)*SB**(-2)*((2D0*SAB-(3D0*C2A+C2B)*SBA)*XMA02-CBA*
     &  (S2B*XMA02+S2A*(-(3D0*XMA02)+4D0*XMH02+2D0*XMHH2)))**2*
     &  DBSH0HH)/XMW2-(CB**(-2)*SB**(-2)*(2D0*CAB*XMA02-
     &  3D0*C2A*CBA*XMA02+C2B*CBA*XMA02-3D0*S2A*SBA*XMA02-S2B*SBA*
     &  XMA02+2D0*S2A*SBA*XMH02+4D0*S2A*SBA*XMHH2)**2*DBSHHHH
     &  )/XMW2-(32D0*CB**(-2)*SB**(-2)*(CAB*XMA02-CA*CB**3*
     &  XMH02+SA*SB**3*XMH02-2D0*CB*SB*SBA*XMHP2)**2*DBSHPHP
     &  )/XMW2-(64D0*CBA**2*(XMH02**2-2D0*XMH02*XMHP2+XMHP2**
     &  2-2D0*S*XMW2-2D0*XMHP2*XMW2+XMW2**2)*DBSHPW)/
     &  XMW2-(32D0*SBA**2*(XMH02**2-4D0*S*XMW2+12D0*XMW2**2)*DBSWW
     &  )/XMW2-(16D0*SBA**2*(XCW2*XMH02**2-4D0*XMW2*(S-
     &  3D0*XMZ2))*DBSZZ)/(XCW2*XMW2)))/(512D0*PI*XSW2)

	dZh0div = ( deltauv + log(muv2/mren2bsm) ) 
     &	          * ALPHA*(1d0+2d0*xCW2)/(8d0*xCW2*PI*xSW2)

	s = mHH2
        BSA0Z   = xB0_(S,xMA02,xMZ2,0)	
        BSHPW   = xB0_(S,xMHP2,xMW2,0)	
        BSWW    = xB0_(S,xMW2,xMW2,0)	
        BSZZ    = xB0_(S,xMZ2,xMZ2,0)	
        DBSA0A0 = xDB0_(S,xMA02,xMA02,0)	
        DBSA0Z  = xDB0_(S,xMA02,xMZ2,0)	
        DBSH0H0 = xDB0_(S,xMH02,xMH02,0)	
        DBSH0HH = xDB0_(S,xMH02,xMHH2,0)	
        DBSHHHH = xDB0_(S,xMHH2,xMHH2,0)	
        DBSHPHP = xDB0_(S,xMHP2,xMHP2,0)	
        DBSHPW  = xDB0_(S,xMHP2,xMW2,0)	
        DBSWW   = xDB0_(S,xMW2,xMW2,0)	
        DBSZZ   = xDB0_(S,xMZ2,xMZ2,0)	

	dZHH  = 
     &  -((CB**(-2)*LAM5**2*PI**(-3)*SB**(-2)*XMW2*XSW2*(16D0*SAB**
     &  2*DBSA0A0+(CBA*(3D0*S2A-S2B)+2D0*SAB-(3D0*C2A+
     &  C2B)*SBA)**2*DBSH0H0+2D0*(-(2D0*CAB)+3D0*C2A*CBA-
     &  C2B*CBA+3D0*S2A*SBA+S2B*SBA)**2*DBSH0HH+144D0*
     &  SAB**2*SBA**4*DBSHHHH+32D0*SAB**2*DBSHPHP
     &  ))/(512D0*ALPHA))
     &
     &	-(CB**(-2)*LAM5/PI**2*SB**(-2)*(-
     &  (16D0*SAB*(C2B*SBA*XMA02+(CB**3*SA+CA*SB**3)*XMHH2)*DBSA0A0
     &  )+((-(2D0*SAB)+(3D0*C2A+C2B)*SBA)**2*XMA02-2D0*
     &  CBA*(2D0*SAB-(3D0*C2A+C2B)*SBA)*(S2B*XMA02+S2A*(-(3D0*
     &  XMA02)+2D0*XMH02+XMHH2))+CBA**2*(S2B**2*XMA02+2D0*S2A*S2B*(-
     &  (3D0*XMA02)+2D0*XMH02+XMHH2)+3D0*S2A**2*(3D0*XMA02-2D0*(2D0*
     &  XMH02+XMHH2))))*DBSH0H0+2D0*(4D0*CAB**2*XMA02+
     &  9D0*C2A**2*CBA**2*XMA02+C2B**2*CBA**2*XMA02-6D0*C2B*CBA*S2A*
     &  SBA*XMA02-2D0*C2B*CBA*S2B*SBA*XMA02+9D0*S2A**2*SBA**2*XMA02+
     &  6D0*S2A*S2B*SBA**2*XMA02+S2B**2*SBA**2*XMA02+2D0*C2B*CBA*
     &  S2A*SBA*XMH02-6D0*S2A**2*SBA**2*XMH02-2D0*S2A*S2B*SBA**2*
     &  XMH02+4D0*C2B*CBA*S2A*SBA*XMHH2-12D0*S2A**2*SBA**2*XMHH2-
     &  4D0*S2A*S2B*SBA**2*XMHH2-4D0*CAB*(3D0*C2A*CBA*XMA02-C2B*CBA*
     &  XMA02+SBA*(3D0*S2A*XMA02+S2B*XMA02-S2A*XMH02-2D0*S2A*
     &  XMHH2))-6D0*C2A*CBA*(C2B*CBA*XMA02-SBA*(S2B*XMA02-S2A*(-
     &  (3D0*XMA02)+XMH02+2D0*XMHH2))))*DBSH0HH+144D0*
     &  SAB*SBA**2*(SAB*SBA**2*XMA02-(CB*SA**3+CA**3*SB)*XMHH2)*
     &  DBSHHHH+32D0*SAB*(SAB*XMA02-CB**3*SA*XMHH2-CA*
     &  SB**3*XMHH2-2D0*CB*CBA*SB*XMHP2)*DBSHPHP))/256D0
     &
     &  +(ALPHA*((64D0*SBA**2*BSA0Z)/XCW2+128D0*SBA**2*
     &  BSHPW+128D0*CBA**2*BSWW+(64D0*CBA**2*
     &  BSZZ)/XCW2-(16D0*CB**(-2)*SB**(-2)*(C2B*SBA*
     &  XMA02+(CB**3*SA+CA*SB**3)*XMHH2)**2*DBSA0A0)/
     &  XMW2-(32D0*SBA**2*(XCW2*(XMA02-XMHH2)**2+XMW2*(-(2D0*S)-2D0*
     &  XMA02+XMZ2))*DBSA0Z)/(XCW2*XMW2)-(CB**(-2)*SB**(-
     &  2)*((2D0*SAB-(3D0*C2A+C2B)*SBA)*XMA02-CBA*(S2B*XMA02+S2A*(-
     &  (3D0*XMA02)+4D0*XMH02+2D0*XMHH2)))**2*DBSH0H0)/
     &  XMW2-(2D0*CB**(-2)*SB**(-2)*(2D0*CAB*XMA02-3D0*C2A*CBA*
     &  XMA02+C2B*CBA*XMA02-3D0*S2A*SBA*XMA02-S2B*SBA*XMA02+2D0*S2A*
     &  SBA*XMH02+4D0*S2A*SBA*XMHH2)**2*DBSH0HH)/XMW2-
     &  (144D0*CB**(-2)*SB**(-2)*(SAB*SBA**2*XMA02-(CB*SA**3+CA**3*
     &  SB)*XMHH2)**2*DBSHHHH)/XMW2-(32D0*CB**(-2)*SB**(-
     &  2)*(SAB*XMA02-CB**3*SA*XMHH2-CA*SB**3*XMHH2-2D0*CB*CBA*SB*
     &  XMHP2)**2*DBSHPHP)/XMW2-(64D0*SBA**2*(XMHH2**2-
     &  2D0*XMHH2*XMHP2+XMHP2**2-2D0*S*XMW2-2D0*XMHP2*XMW2+XMW2**2)*
     &  DBSHPW)/XMW2-(32D0*CBA**2*(XMHH2**2-4D0*S*XMW2+
     &  12D0*XMW2**2)*DBSWW)/XMW2-(16D0*CBA**2*(XCW2*
     &  XMHH2**2-4D0*XMW2*(S-3D0*XMZ2))*DBSZZ)/(XCW2*
     &  XMW2)))/(512D0*PI*XSW2)

	dZHHdiv = ( deltauv + log(muv2/mren2bsm) ) 
     &	          * ALPHA*(1d0+2d0*xCW2)/(8d0*xCW2*PI*xSW2)

	seh0HHdiv = ( deltauv + log(muv2/mren2bsm) ) * (
     &  -((CB**(-2)*EL**(-2)*LAM5**2*PI**(-2)*SB**(-2)*(-(2D0*CB**3*
     &  SB**3)+4D0*CB**3*SA**2*SB**3+CA*SA*(-3D0+8D0*SB**2-6D0*SB**
     &  4+4D0*SB**6))*XMW2*XSW2)/2D0)
     & 
     &  -((CB**(-2)*EL**2*PI**(-2)*SB**(-2)*XCW2**(-2)*((2D0*CB*SB*
     &  (1D0-5D0*SB**2+5D0*SB**4)-4D0*CB*SA**2*SB*(1D0-5D0*SB**2+
     &  5D0*SB**4)+CA*SA*(-11D0+32D0*SB**2-30D0*SB**4+20D0*SB**6))*
     &  XCW2**2*XMA02**2+SA*(-(9D0*CA*CB**2)-5D0*CB*SA*SB+15D0*CB*
     &  SA**3*SB-10D0*CB*SA**5*SB+5D0*CA*SA**4*(-1D0+2D0*SB**2)-2D0*
     &  CA*SA**2*(-7D0+5D0*SB**2))*XCW2**2*XMH02**2-4D0*CA*SA**3*
     &  XMHH2**2-5D0*CA*SA**5*XMHH2**2-5D0*CB*SA**2*SB*XMHH2**2+
     &  15D0*CB*SA**4*SB*XMHH2**2-10D0*CB*SA**6*SB*XMHH2**2+9D0*CA*
     &  SA*SB**2*XMHH2**2-10D0*CA*SA**3*SB**2*XMHH2**2+10D0*CA*SA**
     &  5*SB**2*XMHH2**2-2D0*CA*SA**3*XMHH2*XMHP2+6D0*CB*SA**2*SB*
     &  XMHH2*XMHP2-2D0*CB*SA**4*SB*XMHH2*XMHP2+4D0*CA*SA**3*SB**2*
     &  XMHH2*XMHP2-4D0*CB*SB**3*XMHH2*XMHP2-4D0*CB*SA**2*SB**3*
     &  XMHH2*XMHP2+4D0*CB*SA**4*SB**3*XMHH2*XMHP2+2D0*CA*SA*SB**4*
     &  XMHH2*XMHP2-4D0*CA*SA**3*SB**4*XMHH2*XMHP2+8D0*CA*SA*SB**2*
     &  XMHP2**2-8D0*CB*SB**3*XMHP2**2+16D0*CB*SA**2*SB**3*XMHP2**2-
     &  24D0*CA*SA*SB**4*XMHP2**2+8D0*CB*SB**5*XMHP2**2-16D0*CB*SA**
     &  2*SB**5*XMHP2**2+16D0*CA*SA*SB**6*XMHP2**2-3D0*CB*SA**2*SB*
     &  XMHH2*XMW2+3D0*CB*SA**4*SB*XMHH2*XMW2+3D0*CA*SA*SB**2*XMHH2*
     &  XMW2-6D0*CA*SA**3*SB**2*XMHH2*XMW2+6D0*CB*SA**2*SB**3*XMHH2*
     &  XMW2-6D0*CB*SA**4*SB**3*XMHH2*XMW2-3D0*CA*SA*SB**4*XMHH2*
     &  XMW2+6D0*CA*SA**3*SB**4*XMHH2*XMW2+36D0*CA*SA*SB**2*XMW2**2-
     &  36D0*CB*SB**3*XMW2**2+72D0*CB*SA**2*SB**3*XMW2**2-108D0*CA*
     &  SA*SB**4*XMW2**2+36D0*CB*SB**5*XMW2**2-72D0*CB*SA**2*SB**5*
     &  XMW2**2+72D0*CA*SA*SB**6*XMW2**2+8D0*CA*SA**3*XMHH2**2*XSW2+
     &  10D0*CA*SA**5*XMHH2**2*XSW2+10D0*CB*SA**2*SB*XMHH2**2*XSW2-
     &  30D0*CB*SA**4*SB*XMHH2**2*XSW2+20D0*CB*SA**6*SB*XMHH2**2*
     &  XSW2-18D0*CA*SA*SB**2*XMHH2**2*XSW2+20D0*CA*SA**3*SB**2*
     &  XMHH2**2*XSW2-20D0*CA*SA**5*SB**2*XMHH2**2*XSW2+4D0*CA*SA**
     &  3*XMHH2*XMHP2*XSW2-12D0*CB*SA**2*SB*XMHH2*XMHP2*XSW2+4D0*CB*
     &  SA**4*SB*XMHH2*XMHP2*XSW2-8D0*CA*SA**3*SB**2*XMHH2*XMHP2*
     &  XSW2+8D0*CB*SB**3*XMHH2*XMHP2*XSW2+8D0*CB*SA**2*SB**3*XMHH2*
     &  XMHP2*XSW2-8D0*CB*SA**4*SB**3*XMHH2*XMHP2*XSW2-4D0*CA*SA*
     &  SB**4*XMHH2*XMHP2*XSW2+8D0*CA*SA**3*SB**4*XMHH2*XMHP2*XSW2-
     &  16D0*CA*SA*SB**2*XMHP2**2*XSW2+16D0*CB*SB**3*XMHP2**2*XSW2-
     &  32D0*CB*SA**2*SB**3*XMHP2**2*XSW2+48D0*CA*SA*SB**4*XMHP2**2*
     &  XSW2-16D0*CB*SB**5*XMHP2**2*XSW2+32D0*CB*SA**2*SB**5*XMHP2**
     &  2*XSW2-32D0*CA*SA*SB**6*XMHP2**2*XSW2+5D0*CB*SA**2*SB*XMHH2*
     &  XMW2*XSW2-5D0*CB*SA**4*SB*XMHH2*XMW2*XSW2-5D0*CA*SA*SB**2*
     &  XMHH2*XMW2*XSW2+10D0*CA*SA**3*SB**2*XMHH2*XMW2*XSW2-10D0*CB*
     &  SA**2*SB**3*XMHH2*XMW2*XSW2+10D0*CB*SA**4*SB**3*XMHH2*XMW2*
     &  XSW2+5D0*CA*SA*SB**4*XMHH2*XMW2*XSW2-10D0*CA*SA**3*SB**4*
     &  XMHH2*XMW2*XSW2-48D0*CA*SA*SB**2*XMW2**2*XSW2+48D0*CB*SB**3*
     &  XMW2**2*XSW2-96D0*CB*SA**2*SB**3*XMW2**2*XSW2+144D0*CA*SA*
     &  SB**4*XMW2**2*XSW2-48D0*CB*SB**5*XMW2**2*XSW2+96D0*CB*SA**2*
     &  SB**5*XMW2**2*XSW2-96D0*CA*SA*SB**6*XMW2**2*XSW2-4D0*CA*SA**
     &  3*XMHH2**2*XSW2**2-5D0*CA*SA**5*XMHH2**2*XSW2**2-5D0*CB*SA**
     &  2*SB*XMHH2**2*XSW2**2+15D0*CB*SA**4*SB*XMHH2**2*XSW2**2-
     &  10D0*CB*SA**6*SB*XMHH2**2*XSW2**2+9D0*CA*SA*SB**2*XMHH2**2*
     &  XSW2**2-10D0*CA*SA**3*SB**2*XMHH2**2*XSW2**2+10D0*CA*SA**5*
     &  SB**2*XMHH2**2*XSW2**2-2D0*CA*SA**3*XMHH2*XMHP2*XSW2**2+6D0*
     &  CB*SA**2*SB*XMHH2*XMHP2*XSW2**2-2D0*CB*SA**4*SB*XMHH2*XMHP2*
     &  XSW2**2+4D0*CA*SA**3*SB**2*XMHH2*XMHP2*XSW2**2-4D0*CB*SB**3*
     &  XMHH2*XMHP2*XSW2**2-4D0*CB*SA**2*SB**3*XMHH2*XMHP2*XSW2**2+
     &  4D0*CB*SA**4*SB**3*XMHH2*XMHP2*XSW2**2+2D0*CA*SA*SB**4*
     &  XMHH2*XMHP2*XSW2**2-4D0*CA*SA**3*SB**4*XMHH2*XMHP2*XSW2**2+
     &  8D0*CA*SA*SB**2*XMHP2**2*XSW2**2-8D0*CB*SB**3*XMHP2**2*
     &  XSW2**2+16D0*CB*SA**2*SB**3*XMHP2**2*XSW2**2-24D0*CA*SA*SB**
     &  4*XMHP2**2*XSW2**2+8D0*CB*SB**5*XMHP2**2*XSW2**2-16D0*CB*
     &  SA**2*SB**5*XMHP2**2*XSW2**2+16D0*CA*SA*SB**6*XMHP2**2*
     &  XSW2**2-2D0*CB*SA**2*SB*XMHH2*XMW2*XSW2**2+2D0*CB*SA**4*SB*
     &  XMHH2*XMW2*XSW2**2+2D0*CA*SA*SB**2*XMHH2*XMW2*XSW2**2-4D0*
     &  CA*SA**3*SB**2*XMHH2*XMW2*XSW2**2+4D0*CB*SA**2*SB**3*XMHH2*
     &  XMW2*XSW2**2-4D0*CB*SA**4*SB**3*XMHH2*XMW2*XSW2**2-2D0*CA*
     &  SA*SB**4*XMHH2*XMW2*XSW2**2+4D0*CA*SA**3*SB**4*XMHH2*XMW2*
     &  XSW2**2+24D0*CA*SA*SB**2*XMW2**2*XSW2**2-24D0*CB*SB**3*
     &  XMW2**2*XSW2**2+48D0*CB*SA**2*SB**3*XMW2**2*XSW2**2-72D0*CA*
     &  SA*SB**4*XMW2**2*XSW2**2+24D0*CB*SB**5*XMW2**2*XSW2**2-48D0*
     &  CB*SA**2*SB**5*XMW2**2*XSW2**2+48D0*CA*SA*SB**6*XMW2**2*
     &  XSW2**2+XCW2*XMH02*(-(2D0*SA*(-(5D0*CB*SA*SB)+15D0*CB*SA**3*
     &  SB-10D0*CB*SA**5*SB+3D0*CA*(1D0-2D0*SB**2)+5D0*CA*SA**2*
     &  (1D0-2D0*SB**2)+5D0*CA*SA**4*(-1D0+2D0*SB**2))*XCW2*XMHH2)+
     &  2D0*(-(CA*CB**4*SA)-2D0*CB**3*SB+CB*SA**4*SB*(1D0-2D0*SB**
     &  2)+CB*SA**2*SB*(1D0+2D0*SB**2)+CA*SA**3*(1D0-2D0*SB**2+2D0*
     &  SB**4))*XCW2*XMHP2-SA*SB*(CA**2*CB*SA+CA*(-1D0+2D0*SA**2)*
     &  SB-2D0*CA**2*CB*SA*SB**2+CA*(1D0-2D0*SA**2)*SB**3)*XMW2*(-
     &  3D0+2D0*XSW2))+XCW2*XMA02*(-((2D0*CB**3*SB+CB*SA**2*SB*(-
     &  9D0+14D0*SB**2)+7D0*CB*SA**4*SB*(1D0-2D0*SB**2)+14D0*CA*SA**
     &  3*(CB**2+SB**4)+CA*SA*(-20D0+33D0*SB**2-7D0*SB**4))*XCW2*
     &  XMH02)+(-(2D0*CB*SB**3)+CB*SA**2*SB*(-5D0+14D0*SB**2)+7D0*
     &  CB*SA**4*SB*(1D0-2D0*SB**2)+14D0*CA*SA**3*(CB**2+SB**4)+CA*
     &  SA*(6D0-19D0*SB**2-7D0*SB**4))*XCW2*XMHH2+2D0*(-((2D0*CB*SB*
     &  (-1D0-SB**2+SB**4)+4D0*CB*SA**2*SB*(1D0+SB**2-SB**4)+CA*SA*
     &  (-1D0+4D0*SB**2-6D0*SB**4+4D0*SB**6))*XCW2*XMHP2)+CB**2*SB**
     &  2*(CB*SB-2D0*CB*SA**2*SB+CA*SA*(-1D0+2D0*SB**2))*XMW2*(-3D0+
     &  2D0*XSW2)))))/(128D0*XMW2*XSW2))
     & 
     &  +(CB**(-2)*LAM5*PI**(-2)*SB**(-2)*(-((2D0*CB*SB*(1D0-7D0*SB**
     &  2+7D0*SB**4)-4D0*CB*SA**2*SB*(1D0-7D0*SB**2+7D0*SB**4)+CA*
     &  SA*(-23D0+60D0*SB**2-42D0*SB**4+28D0*SB**6))*XCW2*XMA02)-SA*
     &  (8D0*CB*SA*SB*(1D0-2D0*SB**2)+8D0*CB*SA**3*SB*(-1D0+2D0*SB**
     &  2)+CA*SA**2*(-15D0+16D0*SB**2-16D0*SB**4)+CA*(21D0-35D0*SB**
     &  2+8D0*SB**4))*XCW2*XMH02-6D0*CA*SA*XMHH2-15D0*CA*SA**3*
     &  XMHH2+8D0*CB*SA**2*SB*XMHH2-8D0*CB*SA**4*SB*XMHH2+19D0*CA*
     &  SA*SB**2*XMHH2+16D0*CA*SA**3*SB**2*XMHH2-16D0*CB*SA**2*SB**
     &  3*XMHH2+16D0*CB*SA**4*SB**3*XMHH2+8D0*CA*SA*SB**4*XMHH2-
     &  16D0*CA*SA**3*SB**4*XMHH2-2D0*CA*SA*XMHP2-4D0*CB*SB*XMHP2+
     &  8D0*CB*SA**2*SB*XMHP2+8D0*CA*SA*SB**2*XMHP2-4D0*CB*SB**3*
     &  XMHP2+8D0*CB*SA**2*SB**3*XMHP2-12D0*CA*SA*SB**4*XMHP2+4D0*
     &  CB*SB**5*XMHP2-8D0*CB*SA**2*SB**5*XMHP2+8D0*CA*SA*SB**6*
     &  XMHP2-6D0*CA*SA*SB**2*XMW2+6D0*CB*SB**3*XMW2-12D0*CB*SA**2*
     &  SB**3*XMW2+18D0*CA*SA*SB**4*XMW2-6D0*CB*SB**5*XMW2+12D0*CB*
     &  SA**2*SB**5*XMW2-12D0*CA*SA*SB**6*XMW2+6D0*CA*SA*XMHH2*XSW2+
     &  15D0*CA*SA**3*XMHH2*XSW2-8D0*CB*SA**2*SB*XMHH2*XSW2+8D0*CB*
     &  SA**4*SB*XMHH2*XSW2-19D0*CA*SA*SB**2*XMHH2*XSW2-16D0*CA*SA**
     &  3*SB**2*XMHH2*XSW2+16D0*CB*SA**2*SB**3*XMHH2*XSW2-16D0*CB*
     &  SA**4*SB**3*XMHH2*XSW2-8D0*CA*SA*SB**4*XMHH2*XSW2+16D0*CA*
     &  SA**3*SB**4*XMHH2*XSW2+2D0*CA*SA*XMHP2*XSW2+4D0*CB*SB*XMHP2*
     &  XSW2-8D0*CB*SA**2*SB*XMHP2*XSW2-8D0*CA*SA*SB**2*XMHP2*XSW2+
     &  4D0*CB*SB**3*XMHP2*XSW2-8D0*CB*SA**2*SB**3*XMHP2*XSW2+12D0*
     &  CA*SA*SB**4*XMHP2*XSW2-4D0*CB*SB**5*XMHP2*XSW2+8D0*CB*SA**2*
     &  SB**5*XMHP2*XSW2-8D0*CA*SA*SB**6*XMHP2*XSW2+4D0*CA*SA*SB**2*
     &  XMW2*XSW2-4D0*CB*SB**3*XMW2*XSW2+8D0*CB*SA**2*SB**3*XMW2*
     &  XSW2-12D0*CA*SA*SB**4*XMW2*XSW2+4D0*CB*SB**5*XMW2*XSW2-8D0*
     &  CB*SA**2*SB**5*XMW2*XSW2+8D0*CA*SA*SB**6*XMW2*XSW2))/(32D0*
     &  XCW2) )

	th0 = 
     &  -((EL/PI**2*SBA*XMW*XMW2)/(8D0*XSW))
     &	-(EL/PI**2*SBA*XMZ*XMZ2)/(16D0*XCW*XSW)
     &  -(PI**(-2)*(C2B*CBA*EL**2*XMA02-CA*CB**3*EL**2*XMH02
     &  +EL**2*SA*SB**3*XMH02+4D0*CAB*LAM5*XMW2*XSW2)*xA0_(XMA02))
     &	/(64D0*CB*EL*SB*XMW*XSW)
     &  +(3D0/PI**2*(EL**2*(C2A*CBA+S2A*SBA)*XMH02+CAB*(3D0*EL**2*XMH02
     &  -4D0*CBA**2*(EL**2*XMA02+4D0*LAM5*XMW2*XSW2)))*xA0_(XMH02))
     &  /(256D0*CB*EL*SB*XMW*XSW)
     &  -(PI**(-2)*(C2B*CBA*EL**2*XMA02-3D0*EL**2*S2A*SBA*XMA02
     &  -EL**2*S2B*SBA*XMA02+2D0*EL**2*S2A*SBA*XMH02
     &  +4D0*EL**2*S2A*SBA*XMHH2+4D0*C2B*CBA*LAM5*XMW2*XSW2
     &  -12D0*LAM5*S2A*SBA*XMW2*XSW2-4D0*LAM5*S2B*SBA*XMW2*XSW2
     &  +2D0*CAB*(EL**2*XMA02+4D0*LAM5*XMW2*XSW2)
     &  -3D0*C2A*CBA*(EL**2*XMA02+4D0*LAM5*XMW2*XSW2))*xA0_(XMHH2))
     &	/(256D0*CB*EL*SB*XMW*XSW)
     &  -(PI**(-2)*(EL**2*(-(CA*CB**3*XMH02)+SA*SB**3*XMH02
     &  -2D0*CB*SB*SBA*XMHP2)+CAB*(EL**2*XMA02+4D0*LAM5*XMW2*XSW2))
     &  *xA0_(XMHP2))/(32D0*CB*EL*SB*XMW*XSW)
     &	+(EL/PI**2*SBA*(XMH02+6D0*XMW2)*xA0_(XMW2))/(32D0*XMW*XSW)
     &  +(EL/PI**2*SBA*(XCW*XMH02+6D0*XMW*XMZ)*xA0_(XMZ2))
     &  /(64D0*XCW*XMW*XSW)
 
	tHH = 
     &  -((CBA*EL/PI**2*XMW*XMW2)/(8D0*XSW))
     &	-(CBA*EL/PI**2*XMZ*XMZ2)/(16D0*XCW*XSW)
     &  +(PI**(-2)*(C2B*EL**2*SBA*XMA02+CB**3*EL**2*SA*XMHH2
     &  +CA*EL**2*SB**3*XMHH2-4D0*LAM5*SAB*XMW2*XSW2)*xA0_(XMA02))
     &	/(64D0*CB*EL*SB*XMW*XSW)
     &  -(PI**(-2)*((2D0*SAB-(3D0*C2A+C2B)*SBA)*(EL**2*XMA02
     &  +4D0*LAM5*XMW2*XSW2)+CBA*(-(EL**2*(S2B*XMA02+S2A*(-(3D0*XMA02)
     &  +4D0*XMH02+2D0*XMHH2)))+4D0*LAM5*(3D0*S2A-S2B)*XMW2*XSW2))
     &  *xA0_(XMH02))/(256D0*CB*EL*SB*XMW*XSW)
     &  +(3D0/PI**2*(EL**2*(-(SAB*SBA**2*XMA02)
     &  +(CB*SA**3+CA**3*SB)*XMHH2)-4D0*LAM5*SAB*SBA**2*XMW2*XSW2)
     &  *xA0_(XMHH2))/(64D0*CB*EL*SB*XMW*XSW)
     &	+(PI**(-2)*(EL**2*(-(SAB*XMA02)+CB**3*SA*XMHH2+CA*SB**3*XMHH2
     &  +2D0*CB*CBA*SB*XMHP2)-4D0*LAM5*SAB*XMW2*XSW2)*xA0_(XMHP2))
     &  /(32D0*CB*EL*SB*XMW*XSW)
     &  +(CBA*EL/PI**2*(XMHH2+6D0*XMW2)*xA0_(XMW2))/(32D0*XMW*XSW)
     &  +(CBA*EL/PI**2*(XCW*XMHH2+6D0*XMW*XMZ)*xA0_(XMZ2))
     &  /(64D0*XCW*XMW*XSW)

	th0div = ( deltauv + log(muv2/mren2bsm) ) * (
     &  -(PI**(-2)*(C2B*CBA*EL**2*XMA02-CA*CB**3*EL**2*XMH02
     &  +EL**2*SA*SB**3*XMH02+4D0*CAB*LAM5*XMW2*XSW2)*(XMA02))
     &	/(64D0*CB*EL*SB*XMW*XSW)
     &  +(3D0/PI**2*(EL**2*(C2A*CBA+S2A*SBA)*XMH02+CAB*(3D0*EL**2*XMH02
     &  -4D0*CBA**2*(EL**2*XMA02+4D0*LAM5*XMW2*XSW2)))*(XMH02))
     &  /(256D0*CB*EL*SB*XMW*XSW)
     &  -(PI**(-2)*(C2B*CBA*EL**2*XMA02-3D0*EL**2*S2A*SBA*XMA02
     &  -EL**2*S2B*SBA*XMA02+2D0*EL**2*S2A*SBA*XMH02
     &  +4D0*EL**2*S2A*SBA*XMHH2+4D0*C2B*CBA*LAM5*XMW2*XSW2
     &  -12D0*LAM5*S2A*SBA*XMW2*XSW2-4D0*LAM5*S2B*SBA*XMW2*XSW2
     &  +2D0*CAB*(EL**2*XMA02+4D0*LAM5*XMW2*XSW2)
     &  -3D0*C2A*CBA*(EL**2*XMA02+4D0*LAM5*XMW2*XSW2))*(XMHH2))
     &	/(256D0*CB*EL*SB*XMW*XSW)
     &  -(PI**(-2)*(EL**2*(-(CA*CB**3*XMH02)+SA*SB**3*XMH02
     &  -2D0*CB*SB*SBA*XMHP2)+CAB*(EL**2*XMA02+4D0*LAM5*XMW2*XSW2))
     &  *(XMHP2))/(32D0*CB*EL*SB*XMW*XSW)
     &	+(EL/PI**2*SBA*(XMH02+6D0*XMW2)*(XMW2))/(32D0*XMW*XSW)
     &  +(EL/PI**2*SBA*(XCW*XMH02+6D0*XMW*XMZ)*(XMZ2))
     &  /(64D0*XCW*XMW*XSW) )
 
	tHHdiv = ( deltauv + log(muv2/mren2bsm) ) * (
     &  +(PI**(-2)*(C2B*EL**2*SBA*XMA02+CB**3*EL**2*SA*XMHH2
     &  +CA*EL**2*SB**3*XMHH2-4D0*LAM5*SAB*XMW2*XSW2)*(XMA02))
     &	/(64D0*CB*EL*SB*XMW*XSW)
     &  -(PI**(-2)*((2D0*SAB-(3D0*C2A+C2B)*SBA)*(EL**2*XMA02
     &  +4D0*LAM5*XMW2*XSW2)+CBA*(-(EL**2*(S2B*XMA02+S2A*(-(3D0*XMA02)
     &  +4D0*XMH02+2D0*XMHH2)))+4D0*LAM5*(3D0*S2A-S2B)*XMW2*XSW2))
     &  *(XMH02))/(256D0*CB*EL*SB*XMW*XSW)
     &  +(3D0/PI**2*(EL**2*(-(SAB*SBA**2*XMA02)
     &  +(CB*SA**3+CA**3*SB)*XMHH2)-4D0*LAM5*SAB*SBA**2*XMW2*XSW2)
     &  *(XMHH2))/(64D0*CB*EL*SB*XMW*XSW)
     &	+(PI**(-2)*(EL**2*(-(SAB*XMA02)+CB**3*SA*XMHH2+CA*SB**3*XMHH2
     &  +2D0*CB*CBA*SB*XMHP2)-4D0*LAM5*SAB*XMW2*XSW2)*(XMHP2))
     &  /(32D0*CB*EL*SB*XMW*XSW)
     &  +(CBA*EL/PI**2*(XMHH2+6D0*XMW2)*(XMW2))/(32D0*XMW*XSW)
     &  +(CBA*EL/PI**2*(XCW*XMHH2+6D0*XMW*XMZ)*(XMZ2))
     &  /(64D0*XCW*XMW*XSW) )

	seww0 =  xseww_thdm(0d0)

c modifications for complex renormalization
        dmw2 = dmw2 + dcmplx(0d0,mw*gw*alpha/pi)
        dmw2 = dmw2 - (xmw2-mw2)*dZw
        dmz2 = dmz2 - (xmz2-mz2)*dZzz

c dependent parameters
        dsw  = xcw2/2d0/xsw*( dmz2/xmz2 - dmw2/xmw2 )

	drbos = -dZaa-2d0*dsw/xsw+(seww0-dmw2)/xmw2+xcw/xsw*dZza
     &		+alpha/4d0/pi/xsw2*(6d0+(7d0-4d0*xsw2)
     &			/2d0/xsw2*log(xcw2))

	if ((qalp.eq.0).or.(qalp.eq.2)) then
	  dZe = -dZaa/2d0-dZza*xsw/2d0/xcw
	elseif (qalp.eq.1) then
	  dZe = -dZaa/2d0-dZza*xsw/2d0/xcw - drbos/2d0
	endif

cxxx Test!!!!!!!
c	th0div = th0
c	tHHdiv = tHH

c THDM Higgs sector renormalization
	dtb = 0d0

	dlam5 = - ( deltauv + log(muv2/mren2bsm) ) 
     &  	*ALPHA*LAM5/xMW2/xSW2/(16D0*PI)
     &		*( 4D0*MHP2+6D0*(2D0*xMW2+xMZ2)
     &  	  +(1D0-10D0*CB2+10D0*CB**4)*MA02/SB2/CB2
     &		  -(1D0-CA2-CB2+6D0*CA2*CB2)*MH02/SB2/CB2
     &		  -(CA2+CB2-6D0*CA2*CB2)*MHH2/SB2/CB2
     &		  +4D0*CA*MH02/SB2*(CA*CB+SA*SB)/CB
     &  	  -4D0*CA*MHH2/SB2*(CA*CB+SA*SB)/CB )

	do i=0,8
	  dlam5_bos_RSthdm(i) = dlam5
	enddo

c scheme 0: alpha/beta MSbar
	dtb_bos_RSthdm(0) = 0d0
	dZh0HHdiv = -2d0*seh0HHdiv/(mHH2-mh02)
	dZHHh0div = -2d0*seh0HHdiv/(mh02-mHH2)
	dsa_bos_RSthdm(0)   = ca*( dZHHh0div/2d0
     &	                      +s2a/4d0/c2a*(dZHHdiv-dZh0div) )
c	dsa_bos_RSthdm(0)   = ca*seh0HHdiv/(xMHH2-xMh02)
	dlam35 = -1d0/( 4d0*xmw2*sb*cb*xsw2/(4d0*pi*alpha)/c2a )
     &	         *( s2a/c2a/2d0*(dmh02-dmHH2) 
     &	            + s2b/c2a/2d0*(dma02-2d0*dmhp2)
     &		    + dtb*c2b*cb*s2a/2d0/c2a/sb*(mHH2-mh02)
     &		    - (s2b*(ma02-2d0*mhp2)+(mh02-mHH2)*s2a)/2d0/xmw2/c2a
     &		      *(dmw2+2d0*xmw2*(dsw/xsw-dZe))
     &		    + sqrt(4d0*pi*alpha)/8d0/xmw/c2a/xsw
     &		      *( th0*(cba*c2b-sba*s2b+3d0*cab)
     &	                +tHH*(-c2b*sba-cba*s2b+3d0*sab))            )
	dlam3_bos_RSthdm(0) = dlam35 - dlam5

c scheme 1: alpha/beta MSbar a la FJ
	dtbtad    = - el/2d0/xsw/xMW/cb2
     &	                  *(th0div/xMh02*cba-tHHdiv/xMHH2*sba)
	dtb_bos_RSthdm(1) = dtbtad
        seh0HHdiv   = seh0HHdiv   
     &                  + el*(th0div*Ch0h0HH/xMh02+tHHdiv*Ch0HHHH/xMHH2)
	dZh0HHdiv = -2d0*seh0HHdiv/(mHH2-mh02)
	dZHHh0div = -2d0*seh0HHdiv/(mh02-mHH2)
	dsa_bos_RSthdm(1) = ca*( dZHHh0div/2d0
     &	                    +s2a/4d0/c2a*(dZHHdiv-dZh0div) )
	dlam3_bos_RSthdm(1) = dlam3_bos_RSthdm(0)

c scheme 2: lambda3/beta MSbar
	dtb_bos_RSthdm(2) = 0d0
	dlam35 = ( deltauv + log(muv2/mren2bsm) ) * (
     &      (CB**(-2)*LAM5**2*PI**(-2)*(1D0+S2B**2)*SB**(-2))/16D0
     &      +(ALPHA**2*CB**(-2)*SB**(-2)*(4D0*(MA02-2D0*MHP2)**2*
     &      (1D0+S2B**2)+((MH02-MHH2)**2*S2A*(-(6D0*C2B*CA**2)+S2A*S2B-
     &      6D0*SB**2))/(CB*SB)-((MH02-MHH2)*(MA02-2D0*MHP2)*(-(6D0*
     &      S2A)+2D0*C2B*CA**2*S2B+S2A*S2B**2+4D0*CB*SB**3))/(CB*SB)+
     &      2D0*(8D0*MHH2*MHP2-2D0*MHP2**2*(4D0+S2B**2)-2D0*MA02*(MHH2-
     &      2D0*MHP2*S2B**2)-(3D0*MHH2*(MH02-MHH2)*S2A)/(CB*SB)+((MH02-
     &      MHH2)*MHP2*(3D0*S2A*(2D0-S2B**2)+4D0*CB*SB**3-2D0*CA**2*
     &      (S2B-4D0*CB**3*SB)))/(CB*SB)))*XMW2**(-2)*XSW2**(-2))/64D0
     &      +(3D0*ALPHA**2*(MA02-2D0*MHP2+(CA*(MH02-MHH2)*SA)/(CB*
     &      SB))*XSW2**(-2)*(3D0-2D0*XSW2))/(8D0*XCW2*XMW2)
     &      +(ALPHA*CB**(-2)*LAM5*SB**(-2)*(-(8D0*MHP2*(2D0+S2B**2))+
     &      4D0*MA02*(2D0+3D0*S2B**2)+(MHH2*(2D0*C2B*CA**2*S2B-2D0*CB**
     &      2*S2B-3D0*S2A*(2D0-S2B**2)))/(CB*SB)-(MH02*(-(3D0*S2A*(2D0-
     &      S2B**2))+2D0*S2B*(C2B*CA**2+SB**2)))/(CB*SB)))/(64D0*PI*
     &      XMW2*XSW2)
     &      +(3D0*ALPHA**2*XCW2**(-2)*XSW2**(-2)*(3D0-8D0*XSW2+6D0*
     &      XSW2**2))/8D0	)
	dmh0HH2 =   s2a/c2a/2d0*(dmh02-dmHH2) 
     &	          + s2b/c2a/2d0*(dma02-2d0*dmhp2)
     &		  + dtb*c2b*cb*s2a/2d0/c2a/sb*(mHH2-mh02)
     &		  + 4d0*xmw2*sb*cb*xsw2/(4d0*pi*alpha)/c2a*dlam35
     &		  - (s2b*(ma02-2d0*mhp2)+(mh02-mHH2)*s2a)/2d0/xmw2/c2a
     &		    *(dmw2+2d0*xmw2*(dsw/xsw-dZe))
     &		  + sqrt(4d0*pi*alpha)/8d0/xmw/c2a/xsw
     &		    *( th0*(cba*c2b-sba*s2b+3d0*cab)
     &	              +tHH*(-c2b*sba-cba*s2b+3d0*sab))
	dsa_bos_RSthdm(2) = -dmh0HH2/(mh02-mHH2)*ca
	dlam3_bos_RSthdm(2) = dlam35 - dlam5

c scheme 3: lambda3/beta MSbar a la FJ
	dtb_bos_RSthdm(3)   = dtbtad
	dsa_bos_RSthdm(3)   = -dmh0HH2/(mh02-mHH2)*ca
	dlam3_bos_RSthdm(3) = dlam3_bos_RSthdm(2) 

c scheme 4: OS scheme 2 -- based on formfactors for Neutrino nu2
	DSAvert2 =
     &  (ALPHA*CA*(-(2D0*BH0HPW*CB*CBA*SA)+4D0*CB*CBA*CH0HPW*MHP2*
     &  SA-2D0*BHHHPW*CA*CB*SBA+4D0*CA*CB*CHHHPW*MHP2*SBA-(BH0AZ*CB*
     &  CBA*SA)/XCW2+(2D0*CB*CBA*CH0AZ*MA02*SA)/XCW2-(BHHAZ*CA*CB*
     &  SBA)/XCW2+(2D0*CA*CB*CHHAZ*MA02*SBA)/XCW2+(8D0*B00W*SB*(CA2*
     &  CB*MH02+CB*MHH2*SA2+CA*(MH02-MHH2)*SA*SB)*XMW2)/(MH02*MHH2)+
     &  (4D0*CH0WW*SA*SB*SBA*XMW2*(MH02-2D0*XMW2))/MH02-(4D0*CA*CBA*
     &  CHHWW*SB*XMW2*(MHH2-2D0*XMW2))/MHH2-(2D0*BH0WW*SA*SB*SBA*
     &  (MH02-4D0*XMW2))/MH02+(2D0*BHHWW*CA*CBA*SB*(MHH2-4D0*XMW2))/
     &  MHH2+(4D0*B00Z*SB*(CA2*CB*MH02+CB*MHH2*SA2+CA*(MH02-MHH2)*
     &  SA*SB)*XMZ2)/(MH02*MHH2*XCW2)+(2D0*CH0ZZ*SA*SB*SBA*XMZ2*
     &  (MH02-2D0*XMZ2))/(MH02*XCW2)-(2D0*CA*CBA*CHHZZ*SB*XMZ2*
     &  (MHH2-2D0*XMZ2))/(MHH2*XCW2)-(BH0ZZ*SA*SB*SBA*(MH02-4D0*
     &  XMZ2))/(MH02*XCW2)+(BHHZZ*CA*CBA*SB*(MHH2-4D0*XMZ2))/(MHH2*
     &  XCW2)))/(16D0*PI*XSW2)
	DTBvert2 =
     &  (ALPHA*(-((2D0*BAHPW)/(CB*SB))+(2D0*BH0HPW*CBA)/(CA*SB)+
     &  (4D0*CAHPW*MHP2)/(CB*SB)-(4D0*CBA*CH0HPW*MHP2)/(CA*SB)+
     &  (BH0AZ*CBA)/(CA*SB*XCW2)-(BAH0Z*CA*CBA)/(CB2*SB*XCW2)-(2D0*
     &  CBA*CH0AZ*MA02)/(CA*SB*XCW2)+(2D0*CA*CAH0Z*CBA*MH02)/(CB2*
     &  SB*XCW2)+(BAHHZ*SA*SBA)/(CB2*SB*XCW2)-(2D0*CAHHZ*MHH2*SA*
     &  SBA)/(CB2*SB*XCW2)+(8D0*B00W*SBA*XMW2)/(CA*CB*MH02)-(4D0*
     &  CH0WW*SBA*XMW2*(MH02-2D0*XMW2))/(CA*CB*MH02)+(2D0*BH0WW*SBA*
     &  (MH02-4D0*XMW2))/(CA*CB*MH02)-(2D0*CH0ZZ*SBA*XMZ2*(MH02-2D0*
     &  XMZ2))/(CA*CB*MH02*XCW2)+(BH0ZZ*SBA*(MH02-4D0*XMZ2))/(CA*CB*
     &  MH02*XCW2)+(2D0*B00Z*(CA*CA2*MH02-2D0*CB*SA*SB*XMZ2-CA*(CB2*
     &  MH02-MH02*(SA2-SB2)-2D0*SB2*XMZ2)))/(CA*CB*MH02*SB*XCW2)))/
     &  (16D0*PI*XSW2)
	dZA0 =
     &  ((64D0*ALPHA*BAHPW+(32D0*ALPHA*BAH0Z*CBA**2)/XCW2+(32D0*
     &  ALPHA*BAHHZ*SBA**2)/XCW2-(32D0*ALPHA*DBAHPW*(MA02**2-2D0*
     &  MA02*(MHP2+XMW2)+(MHP2-XMW2)**2))/XMW2-(16D0*ALPHA*CBA**2*
     &  DBAH0Z*((MA02-MH02)**2*XCW2+XMW2*(-(2D0*MA02)-2D0*MH02+
     &  XMZ2)))/(XCW2*XMW2)-(16D0*ALPHA*DBAHHZ*SBA**2*((MA02-MHH2)**
     &  2*XCW2+XMW2*(-(2D0*MA02)-2D0*MHH2+XMZ2)))/(XCW2*XMW2)-
     &  (DBAAH0*PI**(-2)*(-(4D0*ALPHA*CA*CB*CB2*MH02*PI)+4D0*ALPHA*
     &  MH02*PI*SA*SB*SB2+4D0*ALPHA*CBA*MA02*PI*(CB2-SB2)+4D0*CAB*
     &  LAM5*XMW2*XSW2)**2)/(ALPHA*CB2*SB2*XMW2)-(DBAAHH*PI**(-2)*
     &  (4D0*ALPHA*CB*CB2*MHH2*PI*SA+4D0*ALPHA*CA*MHH2*PI*SB*SB2+
     &  4D0*ALPHA*MA02*PI*(CB2-SB2)*SBA-4D0*LAM5*SAB*XMW2*XSW2)**2)/
     &  (ALPHA*CB2*SB2*XMW2)))/(256D0*PI*XSW2)
	dZG0A0 =
     &  -((PI**(-2)*(64D0*ALPHA*B00W*(MH02-MHH2)*PI*(CA2*CB*SB-CB*
     &  SA2*SB-CA*SA*(CB2-SB2))+(96D0*ALPHA*B00Z*(MH02-MHH2)*PI*
     &  (CA2*CB*SB-CB*SA2*SB-CA*SA*(CB2-SB2))*XMZ2)/XMW2-(64D0*
     &  ALPHA*BAHHZ*CBA*PI*SBA*(-((MA02*MHH2-MHH2**2)*XCW2)+XMW2*(-
     &  (2D0*MA02)-2D0*MHH2+XMZ2)))/(XCW2*XMW2)-(64D0*ALPHA*BAH0Z*
     &  CBA*PI*SBA*(MH02*(MA02-MH02)*XCW2+XMW2*(2D0*MA02+2D0*MH02-
     &  XMZ2)))/(XCW2*XMW2)+(16D0*BAAH0*CBA*(MA02-MH02)*(-(4D0*
     &  ALPHA*CA*CB*CB2*MH02*PI)+4D0*ALPHA*MH02*PI*SA*SB*SB2+4D0*
     &  ALPHA*CBA*MA02*PI*(CB2-SB2)+4D0*CAB*LAM5*XMW2*XSW2))/(CB*SB*
     &  XMW2)+(16D0*BAAHH*(MA02-MHH2)*SBA*(4D0*ALPHA*CB*CB2*MHH2*PI*
     &  SA+4D0*ALPHA*CA*MHH2*PI*SB*SB2+4D0*ALPHA*MA02*PI*(CB2-SB2)*
     &  SBA-4D0*LAM5*SAB*XMW2*XSW2))/(CB*SB*XMW2)+(3D0*B00A0*MA02*
     &  (4D0*ALPHA*PI*(4D0*CB2*MH02+4D0*CB2*MHH2-3D0*MH02*SA2-CB2**
     &  2*MH02*SA2+3D0*MHH2*SA2+CB2**2*MHH2*SA2-4D0*MH02*SB2-4D0*
     &  MHH2*SB2+6D0*CB2*MH02*SA2*SB2-6D0*CB2*MHH2*SA2*SB2-MH02*SA2*
     &  SB2**2+MHH2*SA2*SB2**2+8D0*CA*CB*(MH02-MHH2)*SA*SB*(CB2-
     &  SB2)-8D0*MA02*(1D0-2D0*SB2)+CA2*(MH02-MHH2)*(3D0+CB2**2-6D0*
     &  CB2*SB2+SB2**2))-32D0*LAM5*(1D0-2D0*SB2)*XMW2*XSW2))/(CB*SB*
     &  XMW2)+(2D0*B00HP*MHP2*(4D0*ALPHA*PI*(4D0*CB2*MH02+4D0*CB2*
     &  MHH2-3D0*MH02*SA2-CB2**2*MH02*SA2+3D0*MHH2*SA2+CB2**2*MHH2*
     &  SA2-4D0*MH02*SB2-4D0*MHH2*SB2+6D0*CB2*MH02*SA2*SB2-6D0*CB2*
     &  MHH2*SA2*SB2-MH02*SA2*SB2**2+MHH2*SA2*SB2**2+8D0*CA*CB*
     &  (MH02-MHH2)*SA*SB*(CB2-SB2)-8D0*MA02*(1D0-2D0*SB2)+CA2*
     &  (MH02-MHH2)*(3D0+CB2**2-6D0*CB2*SB2+SB2**2))-32D0*LAM5*(1D0-
     &  2D0*SB2)*XMW2*XSW2))/(CB*SB*XMW2)+(4D0*B00H0*MH02*(-(4D0*
     &  ALPHA*MA02*PI*(CA2-SA2)*XCW2)+4D0*ALPHA*MH02*PI*(CA2-SA2)*
     &  XCW2+8D0*ALPHA*CA*CB*MH02*PI*SA*(CA2-SA2)*SB*XCW2-8D0*ALPHA*
     &  CA*CB*MHH2*PI*SA*(CA2-SA2)*SB*XCW2-4D0*ALPHA*MA02*PI*(CB2-
     &  SB2)*XCW2+3D0*ALPHA*MH02*PI*(CB2-SB2)*XCW2-4D0*ALPHA*CA2*
     &  MH02*PI*SA2*(CB2-SB2)*XCW2+8D0*ALPHA*CA2*MHH2*PI*SA2*(CB2-
     &  SB2)*XCW2+ALPHA*MH02*PI*(CA2-SA2)**2*(CB2-SB2)*XCW2+16D0*
     &  ALPHA*CB*CBA*PI*SB*SBA*XMW2-8D0*CBA**2*LAM5*(CB2-SB2)*XCW2*
     &  XMW2*XSW2))/(CB*SB*XCW2*XMW2)-(4D0*B00HH*MHH2*(-(4D0*ALPHA*
     &  MA02*PI*(CA2-SA2)*XCW2)+4D0*ALPHA*MHH2*PI*(CA2-SA2)*XCW2+
     &  8D0*ALPHA*CA*CB*MH02*PI*SA*(CA2-SA2)*SB*XCW2-8D0*ALPHA*CA*
     &  CB*MHH2*PI*SA*(CA2-SA2)*SB*XCW2+4D0*ALPHA*MA02*PI*(CB2-SB2)*
     &  XCW2-3D0*ALPHA*MHH2*PI*(CB2-SB2)*XCW2-8D0*ALPHA*CA2*MH02*PI*
     &  SA2*(CB2-SB2)*XCW2+4D0*ALPHA*CA2*MHH2*PI*SA2*(CB2-SB2)*XCW2-
     &  ALPHA*MHH2*PI*(CA2-SA2)**2*(CB2-SB2)*XCW2+16D0*ALPHA*CB*CBA*
     &  PI*SB*SBA*XMW2+8D0*LAM5*(CB2-SB2)*SBA**2*XCW2*XMW2*XSW2))/
     &  (CB*SB*XCW2*XMW2)))/(512D0*MA02*XSW2))
	dZG0A0 = dZG0A0 + EL/xMW/xSW/MA02*(th0*cba-tHH*sba)

	DTBvert2full =
     &  -((ALPHA*((2D0*BAHPW)/(CB*SB)-(2D0*BH0HPW*CA*CBA)/SB-(4D0*
     &  CAHPW*MHP2)/(CB*SB)+(4D0*CA*CBA*CH0HPW*MHP2)/SB+(2D0*BHHHPW*
     &  SA*SBA)/SB-(4D0*CHHHPW*MHP2*SA*SBA)/SB-(BH0AZ*CA*CBA)/(SB*
     &  XCW2)+(BAH0Z*CA*CBA)/(CB2*SB*XCW2)+(2D0*CA*CBA*CH0AZ*MA02)/
     &  (SB*XCW2)-(2D0*CA*CAH0Z*CBA*MH02)/(CB2*SB*XCW2)+(BHHAZ*SA*
     &  SBA)/(SB*XCW2)-(BAHHZ*SA*SBA)/(CB2*SB*XCW2)-(2D0*CHHAZ*MA02*
     &  SA*SBA)/(SB*XCW2)+(2D0*CAHHZ*MHH2*SA*SBA)/(CB2*SB*XCW2)-
     &  (8D0*B00W*(CA*CB*(MH02-MHH2)*SA+CA2*MHH2*SB+MH02*SA2*SB)*
     &  XMW2)/(CB*MH02*MHH2)+(4D0*CA*CH0WW*SBA*XMW2*(MH02-2D0*
     &  XMW2))/(CB*MH02)+(4D0*CBA*CHHWW*SA*XMW2*(MHH2-2D0*XMW2))/
     &  (CB*MHH2)-(2D0*BH0WW*CA*SBA*(MH02-4D0*XMW2))/(CB*MH02)-(2D0*
     &  BHHWW*CBA*SA*(MHH2-4D0*XMW2))/(CB*MHH2)+(2D0*CA*CH0ZZ*SBA*
     &  XMZ2*(MH02-2D0*XMZ2))/(CB*MH02*XCW2)+(2D0*CBA*CHHZZ*SA*XMZ2*
     &  (MHH2-2D0*XMZ2))/(CB*MHH2*XCW2)-(BH0ZZ*CA*SBA*(MH02-4D0*
     &  XMZ2))/(CB*MH02*XCW2)-(BHHZZ*CBA*SA*(MHH2-4D0*XMZ2))/(CB*
     &  MHH2*XCW2)-(2D0*B00Z*(2D0*CA*CB*(MH02-MHH2)*SA*SB*XMZ2+CA2*
     &  MHH2*(MH02+2D0*SB2*XMZ2)-MH02*(CB2*MHH2-MHH2*(SA2-SB2)-2D0*
     &  SA2*SB2*XMZ2)))/(CB*MH02*MHH2*SB*XCW2)))/(16D0*PI*XSW2))

	dsa_bos_RSthdm(4)   = DSAvert2
     &		- CA/2d0*(CA2*dZh0HH-CA*SA*dZh0+CA*SA*dZHH-dZHHh0*SA2) 
c	dtb_bos_RSthdm(4)   = DTBvert2 
c     &		+ dsa_bos_RSthdm(4)*SA/(CA2*CB*SB)
c     &		+ (CA*CB*dZA0-CA*CB*dZh0-CB*dZHHh0*SA+CA*dZG0A0*SB)
c     &		  /(2d0*CA*CB2*SB)
	dtb_bos_RSthdm(4)   = DTBvert2full 
     &	+ ( -CA*dZh0HH*SA-CA2*dZh0-SA2*dZHH-dZHHh0*CA*SA
     &	    +dZA0+dZG0A0*TB )/(2d0*CB*SB)
	dlam3_bos_RSthdm(4) = dlam3_bos_RSthdm(0)

c scheme 5: OS scheme 12 -- based on formfactors for Neutrinos nu1,nu2
	DTBvert12 =
     &  -((ALPHA*(-(2D0*BH0HPW*CAB*CBA*SB)+4D0*CAB*CBA*CH0HPW*MHP2*
     &  SB+2D0*BHHHPW*SAB*SB*SBA-4D0*CHHHPW*MHP2*SAB*SB*SBA-(BH0AZ*
     &  CAB*CBA*SB)/XCW2+(2D0*CAB*CBA*CH0AZ*MA02*SB)/XCW2+(BAH0Z*
     &  CBA*SBA)/(CB*XCW2)-(BAHHZ*CBA*SBA)/(CB*XCW2)-(2D0*CAH0Z*CBA*
     &  MH02*SBA)/(CB*XCW2)+(2D0*CAHHZ*CBA*MHH2*SBA)/(CB*XCW2)+
     &  (BHHAZ*SAB*SB*SBA)/XCW2-(2D0*CHHAZ*MA02*SAB*SB*SBA)/XCW2+
     &  (8D0*B00W*SB*(CA2*CB2*MH02+CB2*MHH2*SA2-CA2*MHH2*SB2-MH02*
     &  SA2*SB2)*XMW2)/(MH02*MHH2)+(4D0*CH0WW*SAB*SB*SBA*XMW2*(MH02-
     &  2D0*XMW2))/MH02-(4D0*CAB*CBA*CHHWW*SB*XMW2*(MHH2-2D0*XMW2))/
     &  MHH2-(2D0*BH0WW*SAB*SB*SBA*(MH02-4D0*XMW2))/MH02+(2D0*BHHWW*
     &  CAB*CBA*SB*(MHH2-4D0*XMW2))/MHH2+(4D0*B00Z*SB*(CA2*CB2*MH02+
     &  CB2*MHH2*SA2-CA2*MHH2*SB2-MH02*SA2*SB2)*XMZ2)/(MH02*MHH2*
     &  XCW2)+(2D0*CH0ZZ*SAB*SB*SBA*XMZ2*(MH02-2D0*XMZ2))/(MH02*
     &  XCW2)-(2D0*CAB*CBA*CHHZZ*SB*XMZ2*(MHH2-2D0*XMZ2))/(MHH2*
     &  XCW2)-(BH0ZZ*SAB*SB*SBA*(MH02-4D0*XMZ2))/(MH02*XCW2)+(BHHZZ*
     &  CAB*CBA*SB*(MHH2-4D0*XMZ2))/(MHH2*XCW2)))/(16D0*CB*PI*XSW2))

	dsa_bos_RSthdm(5)   = dsa_bos_RSthdm(4)
	dtb_bos_RSthdm(5)   = DTBvert12 + dZG0A0/2d0/CB2
     &	   -CA*(dZh0HH+dZHHh0)*SA*SB/CB-(dZh0-dZHH)*(CA2-SA2)*SB/2d0/CB
	dlam3_bos_RSthdm(5) = dlam3_bos_RSthdm(0) 

c scheme 6: OS scheme 1 -- based on formfactors for Neutrino nu1
	DSAvert1 =
     &  (ALPHA*CA*(2D0*BH0HPW*CA*CBA*SB-4D0*CA*CBA*CH0HPW*MHP2*SB-
     &  2D0*BHHHPW*SA*SB*SBA+4D0*CHHHPW*MHP2*SA*SB*SBA+(BH0AZ*CA*
     &  CBA*SB)/XCW2-(2D0*CA*CBA*CH0AZ*MA02*SB)/XCW2-(BHHAZ*SA*SB*
     &  SBA)/XCW2+(2D0*CHHAZ*MA02*SA*SB*SBA)/XCW2-(8D0*B00W*CB*(CA*
     &  CB*(MH02-MHH2)*SA+CA2*MHH2*SB+MH02*SA2*SB)*XMW2)/(MH02*
     &  MHH2)+(4D0*CA*CB*CH0WW*SBA*XMW2*(MH02-2D0*XMW2))/MH02+(4D0*
     &  CB*CBA*CHHWW*SA*XMW2*(MHH2-2D0*XMW2))/MHH2-(2D0*BH0WW*CA*CB*
     &  SBA*(MH02-4D0*XMW2))/MH02-(2D0*BHHWW*CB*CBA*SA*(MHH2-4D0*
     &  XMW2))/MHH2-(4D0*B00Z*CB*(CA*CB*(MH02-MHH2)*SA+CA2*MHH2*SB+
     &  MH02*SA2*SB)*XMZ2)/(MH02*MHH2*XCW2)+(2D0*CA*CB*CH0ZZ*SBA*
     &  XMZ2*(MH02-2D0*XMZ2))/(MH02*XCW2)+(2D0*CB*CBA*CHHZZ*SA*XMZ2*
     &  (MHH2-2D0*XMZ2))/(MHH2*XCW2)-(BH0ZZ*CA*CB*SBA*(MH02-4D0*
     &  XMZ2))/(MH02*XCW2)-(BHHZZ*CB*CBA*SA*(MHH2-4D0*XMZ2))/(MHH2*
     &  XCW2)))/(16D0*PI*XSW2)
	DTBvert1 =
     &  (ALPHA*((2D0*BAHPW*SB)/CB-(4D0*CAHPW*MHP2*SB)/CB-(2D0*
     &  BH0HPW*CBA*SB2)/(CB*SA)+(4D0*CBA*CH0HPW*MHP2*SB2)/(CB*SA)+
     &  (BAH0Z*CBA*SA)/(CB*XCW2)-(2D0*CAH0Z*CBA*MH02*SA)/(CB*XCW2)-
     &  (BH0AZ*CBA*SB2)/(CB*SA*XCW2)+(2D0*CBA*CH0AZ*MA02*SB2)/(CB*
     &  SA*XCW2)+(BAHHZ*CA*SBA)/(CB*XCW2)-(2D0*CA*CAHHZ*MHH2*SBA)/
     &  (CB*XCW2)+(8D0*B00W*SB*SBA*XMW2)/(MH02*SA)-(4D0*CH0WW*SB*
     &  SBA*XMW2*(MH02-2D0*XMW2))/(MH02*SA)+(2D0*BH0WW*SB*SBA*(MH02-
     &  4D0*XMW2))/(MH02*SA)-(2D0*CH0ZZ*SB*SBA*XMZ2*(MH02-2D0*
     &  XMZ2))/(MH02*SA*XCW2)+(BH0ZZ*SB*SBA*(MH02-4D0*XMZ2))/(MH02*
     &  SA*XCW2)-(2D0*B00Z*SB*(CA2*MH02*SA-2D0*CA*CB*SB*XMZ2+SA*
     &  (MH02*(SA2-SB2)-CB2*(MH02-2D0*XMZ2))))/(CB*MH02*SA*XCW2)))/
     &  (16D0*CB2*PI*XSW2)

	DTBvert1full =
     &  -((ALPHA*(-((2D0*BAHPW*SB)/CB)+(4D0*CAHPW*MHP2*SB)/CB+(2D0*
     &  BH0HPW*CBA*SA*SB2)/CB-(4D0*CBA*CH0HPW*MHP2*SA*SB2)/CB+(2D0*
     &  BHHHPW*CA*SB2*SBA)/CB-(4D0*CA*CHHHPW*MHP2*SB2*SBA)/CB-
     &  (BAH0Z*CBA*SA)/(CB*XCW2)+(2D0*CAH0Z*CBA*MH02*SA)/(CB*XCW2)+
     &  (BH0AZ*CBA*SA*SB2)/(CB*XCW2)-(2D0*CBA*CH0AZ*MA02*SA*SB2)/
     &  (CB*XCW2)-(BAHHZ*CA*SBA)/(CB*XCW2)+(2D0*CA*CAHHZ*MHH2*SBA)/
     &  (CB*XCW2)+(BHHAZ*CA*SB2*SBA)/(CB*XCW2)-(2D0*CA*CHHAZ*MA02*
     &  SB2*SBA)/(CB*XCW2)+(8D0*B00W*SB*(CA2*CB*MH02+CB*MHH2*SA2+CA*
     &  (MH02-MHH2)*SA*SB)*XMW2)/(MH02*MHH2)+(4D0*CH0WW*SA*SB*SBA*
     &  XMW2*(MH02-2D0*XMW2))/MH02-(4D0*CA*CBA*CHHWW*SB*XMW2*(MHH2-
     &  2D0*XMW2))/MHH2-(2D0*BH0WW*SA*SB*SBA*(MH02-4D0*XMW2))/MH02+
     &  (2D0*BHHWW*CA*CBA*SB*(MHH2-4D0*XMW2))/MHH2+(4D0*B00Z*SB*
     &  (CA2*CB*MH02+CB*MHH2*SA2+CA*(MH02-MHH2)*SA*SB)*XMZ2)/(MH02*
     &  MHH2*XCW2)+(2D0*CH0ZZ*SA*SB*SBA*XMZ2*(MH02-2D0*XMZ2))/(MH02*
     &  XCW2)-(2D0*CA*CBA*CHHZZ*SB*XMZ2*(MHH2-2D0*XMZ2))/(MHH2*
     &  XCW2)-(BH0ZZ*SA*SB*SBA*(MH02-4D0*XMZ2))/(MH02*XCW2)+(BHHZZ*
     &  CA*CBA*SB*(MHH2-4D0*XMZ2))/(MHH2*XCW2)))/(16D0*CB2*PI*XSW2))

	dsa_bos_RSthdm(6)   = DSAvert1
     &	   + CA*(-s2a/4d0*(dZh0-dZHH)+ca2/2d0*dZHHh0-sa2/2d0*dZh0HH)
c	dtb_bos_RSthdm(6)   = DTBvert1 
c     &	   + ( dsa_bos_RSthdm(6)*TB/SA
c     &	         + (dZG0A0-dZA0*TB+dZh0*TB-dZHHh0*TB/TA)/2d0 )/CB2 
	dtb_bos_RSthdm(6)   = DTBvert1full 
     &	  + (  TB*(sa2*dZh0+ca2*dZHH-sa*ca*dZh0HH-sa*ca*dZHHh0)
     &	      +dZG0A0-dZA0*TB )/2d0/CB2 
	dlam3_bos_RSthdm(6) = dlam3_bos_RSthdm(0) 

c scheme 7: BFM-inspired scheme 1
        ddZHHh0bfm = sba*cba*alpha/8d0/pi/xsw2/xcw2
     &	              *(2d0*xcw2*BH0WW+BH0ZZ-2d0*xcw2*BH0HpW-BH0AZ)
        ddZh0HHbfm = sba*cba*alpha/8d0/pi/xsw2/xcw2
     &	              *(2d0*xcw2*BHHWW+BHHZZ-2d0*xcw2*BHHHpW-BHHAZ)
	dsa_bos_RSthdm(7) = CA*(dZHHh0-dZh0HH+ddZHHh0bfm-ddZh0HHbfm)/4d0
     &		+ ca*el*(th0*Ch0h0HH/xMh02+tHH*Ch0HHHH/xMHH2)
     &	               /(xMHH2-xMh02)
	dtb_bos_RSthdm(7) = 
     &	  s2b/s2a*(dZHHh0+dZh0HH+ddZHHh0bfm+ddZh0HHbfm)/4d0/cb2
     &	  - el/2d0/xsw/xMW/cb2*(th0/xMh02*cba-tHH/xMHH2*sba)

c scheme 8: BFM-inspired scheme 2
        ddZh0bfm = alpha/8d0/pi/xsw2/xcw2
     &	              *(2d0*xcw2*(sba**2*BH0WW+cba**2*BH0HpW)
     &	                +sba**2*BH0ZZ+cba**2*BH0AZ)
        ddZHHbfm = alpha/8d0/pi/xsw2/xcw2
     &	              *(2d0*xcw2*(cba**2*BHHWW+sba**2*BHHHpW)
     &	                +cba**2*BHHZZ+sba**2*BHHAZ)
	dsa_bos_RSthdm(8) = dsa_bos_RSthdm(7)
	dtb_bos_RSthdm(8) = 
     &	  s2b*( c2a*(dZh0-dZHH+ddZh0bfm-ddZHHbfm)
     &	       +s2a*(dZHHh0+dZh0HH+ddZHHh0bfm+ddZh0HHbfm))/4d0/cb2
     &	  - el/2d0/xsw/xMW/cb2*(th0/xMh02*cba-tHH/xMHH2*sba)

c general settings
	dtb    = dtb_bos_RSthdm(renscheme)
	dsa    = dsa_bos_RSthdm(renscheme)
	dlam35 = dlam3_bos_RSthdm(3) + dlam5

	if ((renscheme.eq.1).or.(renscheme.eq.7)
     &	                    .or.(renscheme.eq.8)) then
          seh0HH_mh02 = seh0HH_mh02 
     &                + el*(th0*Ch0h0HH/xMh02+tHH*Ch0HHHH/xMHH2)
          seh0HH_mHH2 = seh0HH_mHH2 
     &                + el*(th0*Ch0h0HH/xMh02+tHH*Ch0HHHH/xMHH2)
	  dZh0HH  = -2d0*seh0HH_mHH2/(mHH2-mh02)
	  dZHHh0  = -2d0*seh0HH_mh02/(mh02-mHH2)
	endif

c redistribute tadpoles in schemes 1, 3, 7, and 8
c before calculating RS shift ("t-variant")
	do i=0,8
	  if ((i.eq.1).or.(i.eq.3).or.(i.eq.7).or.(i.eq.8)) 
     &	    dtb_bos_RSthdm(i) = dtb_bos_RSthdm(i)
     &	      + el/2d0/xsw/xMW/cb2*(th0/xMh02*cba-tHH/xMHH2*sba)
	  if ((i.eq.1).or.(i.eq.7).or.(i.eq.8)) 
     &	    dsa_bos_RSthdm(i) = dsa_bos_RSthdm(i)
     &	      + ca/(mh02-mHH2)* el*(th0*Ch0h0HH/xMh02+tHH*Ch0HHHH/xMHH2)
	enddo

        iw3f(1) = iso(1)/2d0
        iw3f(2) = iso(2)/2d0
        iw3f(3) = iso(3)/2d0
        iw3f(4) = iso(4)/2d0
        do i=1,4
          gffr(i) = -q(i)*xsw/xcw
          gffl(i) = -q(i)*xsw/xcw+iw3f(i)/xsw/xcw
	  if (q(i).eq.0d0) then
	    dZff_a = 0d0
	  else
	    dZff_a  = -ALPHA/4D0/PI*q(i)**2*( log(mudim2/mf(i)**2)+4d0
     &		  	                      +4d0*log(lambda/mf(i)) )
	  endif
          dZffl(i) = dZff_a + ALPHA/4D0/PI*(
     &              + gffl(i)**2*(2D0*B1Z+1D0)
     &              + (2D0*B1W+1D0)/2D0/xSW2               )
          dZffr(i) = dZff_a + ALPHA/4D0/PI*(
     &              + gffr(i)**2*(2D0*B1Z+1D0) )
	enddo

c*** vertex counterterms
	ct_wf1f2 = dZe-dsw/xsw+(dZw+dZffl(1)+dZffl(2))/2d0
	ct_wf3f4 = dZe-dsw/xsw+(dZw+dZffl(3)+dZffl(4))/2d0

	do i=1,4
	  ct_zffr(i) = dZe+dsw/xsw/xcw2+dZzz/2d0+dZffr(i)
     &			+dZaz/2d0/xsw*xcw
	  ct_zffl(i) = dZe+dsw/xsw/xcw2-2d0*iw3f(i)/xsw2/xcw*dsw/gffl(i)
     &			+dZzz/2d0+dZffl(i)
     &			-q(i)*dZaz/2d0/gffl(i)
	enddo

c HVV counterterms
        ct_h0ww = dZe - dsw/xsw + dmw2/xmw2/2d0 + dZw  
     &	    + dZh0/2d0 + dZHHh0/2d0*cba/sba + cba/sba*(dtb*cb2-dsa/ca)
        ct_HHww = dZe - dsw/xsw + dmw2/xmw2/2d0 + dZw 
     &	    + dZHH/2d0 + dZh0HH/2d0*sba/cba - sba/cba*(dtb*cb2-dsa/ca)
        ct_h0zz = dZe - dsw/xsw + dsw*xsw/xcw2 + dmz2/xmz2/2d0 + dZzz   
     &	    + dZh0/2d0 + dZHHh0/2d0*cba/sba + cba/sba*(dtb*cb2-dsa/ca)
        ct_h0za = dZza/2d0
        ct_HHzz = dZe - dsw/xsw + dsw*xsw/xcw2 + dmz2/xmz2/2d0 + dZzz  
     &	    + dZHH/2d0 + dZh0HH/2d0*sba/cba - sba/cba*(dtb*cb2-dsa/ca)
        ct_HHza = dZza/2d0
	if ((renscheme.eq.1).or.(renscheme.eq.3).or.
     &	    (renscheme.eq.7).or.(renscheme.eq.8)) then
	  dmw2tad = - el*xMW/xsw*(sba*th0/xMh02+cba*tHH/xMHH2)
 	  dmz2tad = - el*xMW/xsw*(sba*th0/xMh02+cba*tHH/xMHH2)/xcw2
	  ct_h0ww = ct_h0ww + dmw2tad/xmw2/2d0 
     &	                    + EL/(2d0*xMW*SBA*xSW)*th0/xMh02
	  ct_h0zz = ct_h0zz + dmw2tad/xmw2/2d0 
     &	                    + EL/(2d0*xMW*SBA*xSW)*th0/xMh02
	  ct_HHww = ct_HHww + dmz2tad/xmz2/2d0 
     &	                    + EL/(2d0*xMW*CBA*xSW)*tHH/xMHH2
	  ct_HHzz = ct_HHzz + dmz2tad/xmz2/2d0 
     &	                    + EL/(2d0*xMW*CBA*xSW)*tHH/xMHH2
	endif

c      print*,'CT bosonic:'
c      write(*,'((a),2g26.18)')'dmw2    =',dmw2
c      write(*,'((a),2g26.18)')'dmz2    =',dmz2
c      write(*,'((a),2g26.18)')'dmh02   =',dmh02
c      write(*,'((a),2g26.18)')'dmHH2   =',dmHH2
c      write(*,'((a),2g26.18)')'dmA02   =',dmA02
c      write(*,'((a),2g26.18)')'dmHP2   =',dmHP2
c      write(*,'((a),2g26.18)')'dsw     =',dsw
c      write(*,'((a),2g26.18)')'dZe     =',dZe
c      write(*,'((a),2g26.18)')'dZaa    =',dZaa
c      write(*,'((a),2g26.18)')'dZaz    =',dZaz
c      write(*,'((a),2g26.18)')'dZza    =',dZza
c      write(*,'((a),2g26.18)')'dZzz    =',dZzz
c      write(*,'((a),2g26.18)')'dZw     =',dZw
c      write(*,'((a),2g26.18)')'dZh0    =',dZh0
c      write(*,'((a),2g26.18)')'dZHH    =',dZHH
c      write(*,'((a),2g26.18)')'dZh0HH  =',dZh0HH
c      write(*,'((a),2g26.18)')'dZHHh0  =',dZHHh0
c      write(*,'((a),2g26.18)')'dtb     =',dtb 
c      write(*,'((a),2g26.18)')'dsa     =',dsa 
c      write(*,'((a),2g26.18)')'th0     =',th0
c      write(*,'((a),2g26.18)')'tHH     =',tHH
c      write(*,'((a),2g26.18)')'dZffr(1)=',dZffr(1)
c      write(*,'((a),2g26.18)')'dZffr(2)=',dZffr(2)
c      write(*,'((a),2g26.18)')'dZffr(3)=',dZffr(3)
c      write(*,'((a),2g26.18)')'dZffr(4)=',dZffr(4)
c      write(*,'((a),2g26.18)')'dZffl(1)=',dZffl(1)
c      write(*,'((a),2g26.18)')'dZffl(2)=',dZffl(2)
c      write(*,'((a),2g26.18)')'dZffl(3)=',dZffl(3)
c      write(*,'((a),2g26.18)')'dZffl(4)=',dZffl(4)

	end

************************************************************************
        subroutine xcalcrenc_ferm_thdm
************************************************************************
*	calculate renormalization constants
*	fermion-loop contributions only
*	THDM
*-----------------------------------------------------------------------
*       28.5.04 Stefan Dittmaier
************************************************************************

        use COLLIER
        use collier_init

        implicit real*8 (a-z)
	complex*16 xseww_ferm,xseaa,xseaz,xsezz
	complex*16 xseaa_ferm_thdm,xsehp_ferm_thdm
	complex*16 seh0HH_mh02,seh0HH_mHH2
	complex*16 seh0HH_mh02_div,seh0HH_mHH2_div
	complex*16 seh0h0,seh0HH,seHHHH
	complex*16 xA0_,xB0_
	complex*16 B00l,B00u,B00d,B0du,BWnl,BWud,BZnn,BZll,BZdd,BZuu
	complex*16 xDB0_,DBWnl,DBWud,DBZnn,DBZll,DBZdd,DBZuu
	complex*16 DB0ll,DB0dd,DB0uu,DB0nl,DB0du,seww0
	complex*16 B00n,B0nl
	complex*16 BAll,BAdd,BAuu,DBAll,DBAdd,DBAuu 
	complex*16 gnnl,geer,geel,gffr(4),gffl(4)
	complex*16 th0,tHH,th0div,tHHdiv
        complex*16 dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw
        complex*16 dmh02,dmHH2,dma02,dmhp2,dZh0,dZHH,dZh0HH,dZHHh0
	complex*16 dtb,dsa,dmh0HH2,dlam3,dlam5,dlam35
        complex*16 dZeer,dZeel,dZnnl,dZffr(4),dZffl(4)
        complex*16 ct_aww,ct_zww,ct_wen,ct_wf1f2,ct_wf3f4
        complex*16 ct_annl,ct_aeer,ct_aeel,ct_affr(4),ct_affl(4)
        complex*16 ct_znnl,ct_zeer,ct_zeel,ct_zffr(4),ct_zffl(4)
        complex*16 ct_h0ww,ct_HHww,ct_h0zz,ct_HHzz,ct_h0za,ct_HHza
        complex*16 ymn2(4),yml2(4),ymqm2(4),ymqp2(4)
        complex*16 dmw2tad,dmz2tad,dtbtad
        complex*16 dZh0div,dZHHdiv,dZh0HHdiv,dZHHh0div
        complex*16 seZA0div
        complex*16 dZA0,dZG0A0
	real*8 iw3f(4)
	integer i,dir(7)
        include '../COMMON/param.inc'
        include '../COMMON/options.inc'
        include '../COMMON/xparam.inc'
        include '../COMMON/processpar.inc'
        include '../COMMON/param_thdm.inc'
        include '../COMMON/param_bsm.inc'
        include '../COMMON/model.inc'
        common/xrenc_ferm_thdm/
     &	       dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,
     &	       dmh02,dmHH2,dma02,dmhp2,dZh0,dZHH,dZh0HH,dZHHh0,
     &	       dtb,dsa,dmh0HH2,dlam3,dlam5,
     &         dZeer,dZeel,dZnnl,dZffr,dZffl,
     &         ct_aww,ct_zww,ct_wen,ct_wf1f2,ct_wf3f4,
     &         ct_annl,ct_aeer,ct_aeel,ct_affr,ct_affl,
     &         ct_znnl,ct_zeer,ct_zeel,ct_zffr,ct_zffl,
     &         ct_h0ww,ct_HHww,ct_h0zz,ct_HHzz,ct_h0za,ct_HHza

c collier parameters
	real*8 deltaUV,muv2,delta1ir,delta2ir,mir2

	call GetMuUV2_cll(muv2)
	call GetDeltaUV_cll(deltaUV)
	mudim2 = exp(deltauv + log(muv2))
        call GetDeltaIR_cll(delta1ir,delta2ir)
        call GetMuIR2_cll(mir2)
	lambda2 = exp(delta1ir + log(mir2))
	lambda  = sqrt(lambda2)

	dmw2   = 0d0
	dmz2   = 0d0
	dZw    = 0d0
	dZzz   = 0d0
	dZaa   = 0d0
	dZza   = 0d0
	dZaz   = 0d0
	dZh0   = 0d0
	dZHH   = 0d0
        dZh0div= 0d0
	dZHHdiv= 0d0
	dalpz  = 0d0
	seww0  = 0d0
	seh0HH_mh02_div = 0d0
	seh0HH_mHH2_div = 0d0
        seZA0div        = 0d0
	th0    = 0d0
	tHH    = 0d0
	th0div = 0d0
	tHHdiv = 0d0
	dtb    = 0d0
	dlam35 = 0d0
	dlam5  = 0d0
        dZA0   = 0d0
	dZG0A0 = 0d0

	do 10 i=1,3

	  ymn2(i)  = null
	  yml2(i)  = xml2(i)
	  ymqm2(i) = xmqm2(i)
	  ymqp2(i) = xmqp2(i)
	  B00n     = null

	B00l  =  xB0_(0D0,   null, yML2(I),0)
	B00u  =  xB0_(0D0,   null,yMQP2(I),0)
	B00d  =  xB0_(0D0,   null,yMQM2(I),0)
	B0nl  =  xB0_(0D0,yMN2(I), yML2(I),0)
	B0du  =  xB0_(0D0,yMQM2(I),yMQP2(I),0)
	BWnl  =  xB0_(MW2,yMN2(I), yML2(I),0)
	BWud  =  xB0_(MW2,yMQP2(I),yMQM2(I),0)
	DBWnl = xDB0_(MW2,yMN2(I), yML2(I),0)
	DBWud = xDB0_(MW2,yMQP2(I),yMQM2(I),0)
	BZnn  =  xB0_(MZ2,yMN2(I),yMN2(I),0)
	BZll  =  xB0_(MZ2,yML2(I),yML2(I),0)
	BZdd  =  xB0_(MZ2,yMQM2(I),yMQM2(I),0)
	BZuu  =  xB0_(MZ2,yMQP2(I),yMQP2(I),0)
	DBZnn = xDB0_(MZ2,yMN2(I),yMN2(I),0)
	DBZll = xDB0_(MZ2,yML2(I),yML2(I),0)
	DBZdd = xDB0_(MZ2,yMQM2(I),yMQM2(I),0)
	DBZuu = xDB0_(MZ2,yMQP2(I),yMQP2(I),0)
	DB0ll = xDB0_(0d0,yML2(I),yML2(I),0)
	DB0dd = xDB0_(0d0,yMQM2(I),yMQM2(I),0)
	DB0uu = xDB0_(0d0,yMQP2(I),yMQP2(I),0)
	DB0nl = xDB0_(0d0,yMN2(I),yML2(I),0)
	DB0du = xDB0_(0d0,yMQM2(I),yMQP2(I),0)

	BAll  =  xB0_(MA02,yML2(I),yML2(I),0)
	BAdd  =  xB0_(MA02,yMQM2(I),yMQM2(I),0)
	BAuu  =  xB0_(MA02,yMQP2(I),yMQP2(I),0)
	DBAll = xDB0_(MA02,yML2(I),yML2(I),0)
	DBAdd = xDB0_(MA02,yMQM2(I),yMQM2(I),0)
	DBAuu = xDB0_(MA02,yMQP2(I),yMQP2(I),0)

        dZA0 = dZA0 - ALPHA/(8D0*PI*XMW2*XSW2)*(
     &	 CLEPA**2*BAll*XML2(I)
     &	+CLEPA**2*MA02*DBAll*XML2(I)
     &	+3D0*CDOA**2*BAdd*XMQM2(I)
     &	+3D0*CDOA**2*MA02*DBAdd*XMQM2(I)
     &	+3D0*CUPA**2*BAuu*XMQP2(I)
     &	+3D0*CUPA**2*MA02*DBAuu*XMQP2(I) )

	dZG0A0 = dZG0A0 - ALPHA/(4D0*MA02*PI*XMW2*XSW2)*(
     &	     CLEPA*CLEPG*MA02*BAll*XML2(I)
     &	-2D0*CLEPA*CLEPG*B00l*XML2(I)**2
     &	+3D0*CDOA*CDOG*MA02*BAdd*XMQM2(I)
     &	-6D0*CDOA*CDOG*B00d*XMQM2(I)**2
     &	+3D0*CUPA*CUPG*MA02*BAuu*XMQP2(I)
     &	-6D0*CUPA*CUPG*B00u*XMQP2(I)**2 )

	dZw   = dZw  + ALPHA/(72D0*PI*xSW2)*(
     &	8D0
     &	+3D0*MW2**(-2)*B00l*yML2(I) *(yML2(I) -yMN2(I))
     &	-3D0*MW2**(-2)*B00n*yMN2(I) *(yML2(I) -yMN2(I))
     & 	+9D0*MW2**(-2)*B00d*yMQM2(I)*(yMQM2(I)-yMQP2(I))
     & 	-9D0*MW2**(-2)*B00u*yMQP2(I)*(yMQM2(I)-yMQP2(I))
     &	-3D0*MW2**(-2)*BWnl*(2D0*MW2**2+yML2(I)**2-2D0*yML2(I)*yMN2(I)
     &			     +yMN2(I)**2)
     &	-9D0*MW2**(-2)*BWud*(2D0*MW2**2+yMQM2(I)**2-2D0*yMQM2(I)*yMQP2(I)
     &			     +yMQP2(I)**2)
     &	+3D0*DBWnl*(-2D0*MW2**2+MW2*yML2(I)+yML2(I)**2+MW2*yMN2(I)
     &  	    -2D0*yML2(I)*yMN2(I)+yMN2(I)**2)/MW2
     &	+9D0*DBWud*(-2D0*MW2**2+MW2*yMQM2(I)+yMQM2(I)**2+MW2*yMQP2(I)
     &  	    -2D0*yMQM2(I)*yMQP2(I)+yMQP2(I)**2)/MW2	    )

	dZzz  = dZzz - ALPHA/(216D0*xCW2*PI)*(
     &	48D0-64D0*xSW2-24D0/xSW2
     &	+9D0*BZnn/xSW2
     &  +9D0*(1D0-4D0*xSW2+8D0*xSW2**2)*BZll/xSW2
     &  +3D0*(9D0-12D0*xSW2+8D0*xSW2**2)*BZdd/xSW2
     &  +3D0*(9D0-24D0*xSW2+32D0*xSW2**2)*BZuu/xSW2
     &	+9D0*(MZ2-yMN2(I))*DBZnn/xSW2
     &	-9D0*DBZll*(-MZ2+4D0*MZ2*xSW2-8D0*MZ2*xSW2**2+yML2(I)
     &  	    +8D0*xSW2*yML2(I)-16D0*xSW2**2*yML2(I))/xSW2
     &	+3D0*DBZdd*(9D0*MZ2-12D0*MZ2*xSW2+8D0*MZ2*xSW2**2-9D0*yMQM2(I)
     &  	    -24D0*xSW2*yMQM2(I)+16D0*xSW2**2*yMQM2(I))/xSW2
     &	+3D0*DBZuu*(9D0*MZ2-24D0*MZ2*xSW2+32D0*MZ2*xSW2**2-9D0*yMQP2(I)
     &		    -48D0*xSW2*yMQP2(I)+64D0*xSW2**2*yMQP2(I))/xSW2     )

	dZaa  = dZaa - ALPHA/(27D0*PI)*(
     &	-32D0+9D0*B00l+3D0*B00d+12D0*B00u
     &	+18D0*DB0ll*yML2(I)+6D0*DB0dd*yMQM2(I)+24D0*DB0uu*yMQP2(I)	)

	s = mh02
	dZh0 = dZh0
     &  +ALPHA*CLEPh0**2*yML2(I)/(8D0*PI*XMW2*XSW2)
     &	*(-xB0_(S,yML2(I),yML2(I),0)
     &    +xDB0_(S,yML2(I),yML2(I),0)*(-S+4D0*yML2(I)))
     &	+3D0*ALPHA*CDOh0**2*yMQM2(I)/(8D0*PI*XMW2*XSW2)
     &	*(-xB0_(S,yMQM2(I),yMQM2(I),0)
     &    +xDB0_(S,yMQM2(I),yMQM2(I),0)*(-S+4D0*yMQM2(I)))
     &	+3D0*ALPHA*CUPh0**2*yMQP2(I)/(8D0*PI*XMW2*XSW2)
     &	*(-xB0_(S,yMQP2(I),yMQP2(I),0)
     &    +xDB0_(S,yMQP2(I),yMQP2(I),0)*(-S+4D0*yMQP2(I)))

	s = mHH2
	dZHH = dZHH
     &  +ALPHA*CLEPHH**2*yML2(I)/(8D0*PI*XMW2*XSW2)
     &	*(-xB0_(S,yML2(I),yML2(I),0)
     &    +xDB0_(S,yML2(I),yML2(I),0)*(-S+4D0*yML2(I)))
     &	+3D0*ALPHA*CDOHH**2*yMQM2(I)/(8D0*PI*XMW2*XSW2)
     &	*(-xB0_(S,yMQM2(I),yMQM2(I),0)
     &    +xDB0_(S,yMQM2(I),yMQM2(I),0)*(-S+4D0*yMQM2(I)))
     &	+3D0*ALPHA*CUPHH**2*yMQP2(I)/(8D0*PI*XMW2*XSW2)
     &	*(-xB0_(S,yMQP2(I),yMQP2(I),0)
     &    +xDB0_(S,yMQP2(I),yMQP2(I),0)*(-S+4D0*yMQP2(I)))

	dZh0div = dZh0div
     &	+ ( deltauv + log(muv2/mren2bsm) ) * (
     &    -ALPHA*CLEPh0**2*yML2(I)/(8D0*PI*XMW2*XSW2)
     &	  -3D0*ALPHA*CDOh0**2*yMQM2(I)/(8D0*PI*XMW2*XSW2)
     &	  -3D0*ALPHA*CUPh0**2*yMQP2(I)/(8D0*PI*XMW2*XSW2) )

	dZHHdiv = dZHHdiv
     &	+ ( deltauv + log(muv2/mren2bsm) ) * (
     &    -ALPHA*CLEPHH**2*yML2(I)/(8D0*PI*XMW2*XSW2)
     &	  -3D0*ALPHA*CDOHH**2*yMQM2(I)/(8D0*PI*XMW2*XSW2)
     &	  -3D0*ALPHA*CUPHH**2*yMQP2(I)/(8D0*PI*XMW2*XSW2) )

	s = mh02
	seh0HH_mh02_div = seh0HH_mh02_div
     &	+ ( deltauv + log(muv2/mren2bsm) ) * (
     &      -3D0*ALPHA*CDOh0*CDOHH*yMQM2(I)*(-S+6D0*yMQM2(I))
     &        /(8D0*PI*XMW2*XSW2)
     &      -3D0*ALPHA*CUPh0*CUPHH*yMQP2(I)*(-S+6D0*yMQP2(I))
     &        /(8D0*PI*XMW2*XSW2)
     &      -ALPHA*CLEPh0*CLEPHH*yML2(I)*(-S+6D0*yML2(I))
     &        /(8D0*PI*XMW2*XSW2) )

	s = mHH2
	seh0HH_mHH2_div = seh0HH_mHH2_div
     &	+ ( deltauv + log(muv2/mren2bsm) ) * (
     &      -3D0*ALPHA*CDOh0*CDOHH*yMQM2(I)*(-S+6D0*yMQM2(I))
     &        /(8D0*PI*XMW2*XSW2)
     &      -3D0*ALPHA*CUPh0*CUPHH*yMQP2(I)*(-S+6D0*yMQP2(I))
     &        /(8D0*PI*XMW2*XSW2)
     &      -ALPHA*CLEPh0*CLEPHH*yML2(I)*(-S+6D0*yML2(I))
     &        /(8D0*PI*XMW2*XSW2) )

	th0 = th0 
     &  -(CLEPh0*EL/PI**2*xA0_(XML2(I))*XML2(I))/(8D0*XMW*XSW)
     &  -(3D0*CDOh0*EL/PI**2*xA0_(XMQM2(I))*XMQM2(I))/(8D0*XMW*XSW)
     &  -(3D0*CUPh0*EL/PI**2*xA0_(XMQP2(I))*XMQP2(I))/(8D0*XMW*XSW)
 
	tHH = tHH 
     &	-(CLEPHH*EL/PI**2*xA0_(XML2(I))*XML2(I))/(8D0*XMW*XSW)
     &  -(3D0*CDOHH*EL/PI**2*xA0_(XMQM2(I))*XMQM2(I))/(8D0*XMW*XSW)
     &  -(3D0*CUPHH*EL/PI**2*xA0_(XMQP2(I))*XMQP2(I))/(8D0*XMW*XSW)

	th0div = th0div + (deltauv+log(muv2/mren2bsm))*(
     &  -(CLEPh0*EL/PI**2*(XML2(I))*XML2(I))/(8D0*XMW*XSW)
     &  -(3D0*CDOh0*EL/PI**2*(XMQM2(I))*XMQM2(I))/(8D0*XMW*XSW)
     &  -(3D0*CUPh0*EL/PI**2*(XMQP2(I))*XMQP2(I))/(8D0*XMW*XSW) )
 
	tHHdiv = tHHdiv + (deltauv+log(muv2/mren2bsm))*(
     &	-(CLEPHH*EL/PI**2*(XML2(I))*XML2(I))/(8D0*XMW*XSW)
     &  -(3D0*CDOHH*EL/PI**2*(XMQM2(I))*XMQM2(I))/(8D0*XMW*XSW)
     &  -(3D0*CUPHH*EL/PI**2*(XMQP2(I))*XMQP2(I))/(8D0*XMW*XSW) )

c	dtb = dtb 
c     &  -ALPHA/(8D0*PI*XMW2*XSW2)*(
c     &	       (CLEPh0**2-CLEPHH**2)*XML2(I)
c     &	  +3D0*(CDOh0**2 -CDOHH**2 )*XMQM2(I)
c     &    +3D0*(CUPh0**2 -CUPHH**2 )*XMQP2(I) )
c     &	*( deltauv + log(muv2/mren2bsm) )
c     &	*tb/2d0/c2a

	dalpz = dalpz + alpha/3d0/pi*dreal(
     & 	     ( 1d0/3d0+(1d0+2d0* yml2(i)/mz2)*(B00l-1d0-BZll) )
     & 	    +( 1d0/3d0+(1d0+2d0*ymqm2(i)/mz2)*(B00d-1d0-BZdd) )/3d0 )
	if (i.ne.3)
     &  dalpz = dalpz + alpha/3d0/pi*dreal(
     &    ( 1d0/3d0+(1d0+2d0*ymqp2(i)/mz2)*(B00u-1d0-BZuu) )*4d0/3d0 )

	seww0 = seww0 - ALPHA/(24D0*PI*xSW2)*(
     & 	-6D0*ymqm2(i)-6D0*ymqp2(i)-2D0*yml2(i)-2D0*ymn2(i)
     &	+6D0*ymqm2(i)*B00d+6D0*ymqp2(i)*B00u
     &	+3D0*(ymqm2(i)+ymqp2(i))*B0du
     &	+2D0*yml2(i)*B00l+2D0*ymn2(i)*B00n
     &	+(yml2(i)+ymn2(i))*B0nl
     &	+(yml2(i)-ymn2(i))**2*DB0nl
     &	+3D0*(ymqm2(i)-ymqp2(i))**2*DB0du	)

	dlam35 = dlam35 - (deltauv+log(muv2/mren2bsm))
     &		  *( ALPHA**2/(4d0*xMW**4*xSW**4)
     &	              *(     xml2(i) *(1d0+C2B*CLEPA/S2B)
     &		        +3d0*xmqp2(i)*(1d0+C2B*CUPA /S2B)
     &		        +3d0*xmqm2(i)*(1d0+C2B*CDOA /S2B) )
     &		      *(MA02-2d0*MHp2+((Mh02-MHH2)*S2A)/S2B)
     &		    +(3d0*ALPHA**2*xmqp2(i)*xmqm2(i)/(xMW**4*xSW**4)
     &	              *(1d0-CdoA*CupA+(C2B*(CdoA+CupA))/S2B)) )

	dlam5 = dlam5 + (deltauv+log(muv2/mren2bsm))
     &  	*ALPHA*LAM5/xMW2/xSW2/(4D0*PI*S2B)*(
     &	  	        xml2(i)*(C2B*CLEPA+S2B)
     &		  +3D0*xmqm2(i)*(C2B*CDOA +S2B)
     &  	  +3D0*xmqp2(i)*(C2B*CUPA +S2B) )

	seZA0div = seZA0div - (deltauv+log(muv2/mren2bsm))
     &  *(ALPHA*(CLEPA*yML2(I)+3D0*CDOA*yMQM2(I)+3D0*CUPA*yMQP2(I)))
     &  /(8D0*PI*XCW*XMW*XSW2)

10	continue

	dlam3 = dlam35 - dlam5

        call xsehh_ferm_thdm(mh02,seh0h0,seh0HH,seHHHH)
	dmh02  = seh0h0
	seh0HH_mh02 = seh0HH

        call xsehh_ferm_thdm(mHH2,seh0h0,seh0HH,seHHHH)
	dmHH2  = seHHHH
	seh0HH_mHH2 = seh0HH

	dZh0HH = -2d0*seh0HH_mHH2/(mHH2-mh02)
	dZHHh0 = -2d0*seh0HH_mh02/(mh02-mHH2)

        dma02 = xseaa_ferm_thdm(ma02)

        dmhp2 = xsehp_ferm_thdm(mhp2)

	dmw2 = xseww_ferm(mw2)
        call xsevv_ferm(mz2,xseaa,xseaz,xsezz)
	dmz2 = xsezz
	dZaz = -2d0*xseaz/mz2
        call xsevv_ferm(0d0,xseaa,xseaz,xsezz)
c	dZza = 2d0*xseaz/xmz2
	dZza = 0d0

c modifications for complex renormalization
	dmw2 = dmw2 - (xmw2-mw2)*dZw
	dmz2 = dmz2 - (xmz2-mz2)*dZzz
	dZaz = dZaz + (xmz2-mz2)/mz2*dZza

c dependent parameters
	dsw  = xcw2/2d0/xsw*( dmz2/xmz2 - dmw2/xmw2 )

	drferm = -dZaa-2d0*dsw/xsw+(seww0-dmw2)/xmw2

	if (qalp.eq.0) then
	  dZe = -dZaa/2d0 - dZza/2d0*xsw/xcw
	elseif (qalp.eq.2) then
	  dZe = -dZaa/2d0 - dZza/2d0*xsw/xcw - dalpz/2d0
	elseif (qalp.eq.1) then
	  dZe = -dZaa/2d0 - dZza/2d0*xsw/xcw - drferm/2d0
	endif

cxxx Test!!!!!!!
c	th0div = th0
c	tHHdiv = tHH

	dtb = tb*( (dZHHdiv-dZh0div)/2d0/c2a+seZA0div/xMZ/cb/sb )

	do i=0,8
	  dlam5_ferm_RSthdm(i) = dlam5
	enddo

c scheme 0: alpha/beta MSbar
	dtb_ferm_RSthdm(0)   = tb*( (dZHHdiv-dZh0div)/2d0/c2a
     &	                        +seZA0div/xMZ/cb/sb )
	dsa_ferm_RSthdm(0)   = ca*(seh0HH_mh02_div+seh0HH_mHH2_div)
     &	                   /2d0/(xMHH2-xMh02)
	dlam3_ferm_RSthdm(0) = 
     &	      -1d0/( 4d0*xmw2*sb*cb*xsw2/(4d0*pi*alpha)/c2a )
     &	         *( s2a/c2a/2d0*(dmh02-dmHH2) 
     &	            + s2b/c2a/2d0*(dma02-2d0*dmhp2)
     &		    + dtb*c2b*cb*s2a/2d0/c2a/sb*(mHH2-mh02)
     &		    - (s2b*(ma02-2d0*mhp2)+(mh02-mHH2)*s2a)/2d0/xmw2/c2a
     &		      *(dmw2+2d0*xmw2*(dsw/xsw-dZe))
     &		    + sqrt(4d0*pi*alpha)/8d0/xmw/c2a/xsw
     &		      *( th0*(cba*c2b-sba*s2b+3d0*cab)
     &	                +tHH*(-c2b*sba-cba*s2b+3d0*sab))            )
     &		- dlam5

c scheme 1: alpha/beta MSbar a la FJ
	seh0HH_mh02_div = seh0HH_mh02_div
     &                   +el*(th0div*Ch0h0HH/xMh02+tHHdiv*Ch0HHHH/xMHH2)
	seh0HH_mHH2_div = seh0HH_mHH2_div
     &                   +el*(th0div*Ch0h0HH/xMh02+tHHdiv*Ch0HHHH/xMHH2)
	dsa_ferm_RSthdm(1)  = ca*(seh0HH_mh02_div+seh0HH_mHH2_div)
     &	                  /2d0/(xMHH2-xMh02)
	dtbtad  = - el/2d0/xsw/xMW/cb2
     &	                *(th0div/xMh02*cba-tHHdiv/xMHH2*sba)
	dtb_ferm_RSthdm(1)   = dtb_ferm_RSthdm(0) + dtbtad
	dlam3_ferm_RSthdm(1) = dlam3_ferm_RSthdm(0) 

c scheme 2: lambda3/beta MSbar
	dmh0HH2 = s2a/c2a/2d0*(dmh02-dmHH2) 
     &	          + s2b/c2a/2d0*(dma02-2d0*dmhp2)
     &		  + dtb*c2b*cb*s2a/2d0/c2a/sb*(mHH2-mh02)
     &		  + 4d0*xmw2*sb*cb*xsw2/(4d0*pi*alpha)/c2a*(dlam3+dlam5) 
     &		  - (s2b*(ma02-2d0*mhp2)+(mh02-mHH2)*s2a)/2d0/xmw2/c2a
     &		    *(dmw2+2d0*xmw2*(dsw/xsw-dZe))
     &		  + sqrt(4d0*pi*alpha)/8d0/xmw/c2a/xsw
     &		    *( th0*(cba*c2b-sba*s2b+3d0*cab)
     &	              +tHH*(-c2b*sba-cba*s2b+3d0*sab))
	dtb_ferm_RSthdm(2)   = dtb_ferm_RSthdm(0) 
	dsa_ferm_RSthdm(2)   = -dmh0HH2/(mh02-mHH2)*ca
	dlam3_ferm_RSthdm(2) = dlam35 - dlam5

c scheme 3: lambda3/beta MSbar a la FJ
	dtb_ferm_RSthdm(3)   = dtb_ferm_RSthdm(0) + dtbtad
	dsa_ferm_RSthdm(3)   = -dmh0HH2/(mh02-mHH2)*ca
	dlam3_ferm_RSthdm(3) = dlam3_ferm_RSthdm(2) 

c scheme 4: OS scheme 2 -- based on formfactors for Neutrino nu2
	dZG0A0 = dZG0A0 + EL/xMW/xSW/MA02*(th0*cba-tHH*sba)
c	dsa_ferm_RSthdm(4)   = 
c     &		- CA/2d0*(CA2*dZh0HH-CA*SA*dZh0+CA*SA*dZHH-dZHHh0*SA2) 
c	dtb_ferm_RSthdm(4)   = 
c     &		+ dsa_ferm_RSthdm(4)*SA/(CA2*CB*SB)
c     &		+ (CA*CB*dZA0-CA*CB*dZh0-CB*dZHHh0*SA+CA*dZG0A0*SB)
c     &		  /(2d0*CA*CB2*SB)
	dsa_ferm_RSthdm(4)   = 
     &		CA*(s2a/4d0*(dZh0-dZHH)+sa2/2d0*dZHHh0-ca2/2d0*dZh0HH)
c	dtb_ferm_RSthdm(4)   = (
c     &		- dsa_ferm_RSthdm(4)/ca/ta/tb
c     &		+ 1d0/2d0/tb*(dZA0-dZHH)+dZG0A0/2d0-dZh0HH/ta/tb/2d0
c     &	                       )/cb2
	dtb_ferm_RSthdm(4)   = 
     &	+ ( -CA*dZh0HH*SA-CA2*dZh0-SA2*dZHH-dZHHh0*CA*SA
     &	    +dZA0+dZG0A0*TB )/(2d0*CB*SB)
	dlam3_ferm_RSthdm(4) = dlam3_ferm_RSthdm(0) 

c scheme 5: OS scheme 12 -- based on formfactors for Neutrinos nu1,nu2
	dsa_ferm_RSthdm(5)   = dsa_ferm_RSthdm(4)
	dtb_ferm_RSthdm(5)   = dZG0A0/2d0/CB2
     &	  -CA*(dZh0HH+dZHHh0)*SA*SB/CB-(dZh0-dZHH)*(CA2-SA2)*SB/2d0/CB
	dlam3_ferm_RSthdm(5) = dlam3_ferm_RSthdm(0) 

c scheme 6: OS scheme 1 -- based on formfactors for Neutrino nu1
	dsa_ferm_RSthdm(6)   = 
     &		CA*(-s2a/4d0*(dZh0-dZHH)+ca2/2d0*dZHHh0-sa2/2d0*dZh0HH)
c	dtb_ferm_RSthdm(6)   = 
c     &	   + ( dsa_ferm_RSthdm(6)*TB/SA
c     &	         + (dZG0A0-dZA0*TB+dZh0*TB-dZHHh0*TB/TA)/2d0 )/CB2 
	dtb_ferm_RSthdm(6)   = 
     &	  + (  TB*(sa2*dZh0+ca2*dZHH-sa*ca*dZh0HH-sa*ca*dZHHh0)
     &	      +dZG0A0-dZA0*TB )/2d0/CB2 
	dlam3_ferm_RSthdm(6) = dlam3_ferm_RSthdm(0) 

c scheme 7: BFM-inspired scheme 1
	dsa_ferm_RSthdm(7)   = CA*(dZHHh0-dZh0HH)/4d0
     &	  + ca*el*(th0*Ch0h0HH/xMh02+tHH*Ch0HHHH/xMHH2)/(xMHH2-xMh02)
	dtb_ferm_RSthdm(7)   = s2b/s2a*(dZHHh0+dZh0HH)/4d0/cb2
     &	  - el/2d0/xsw/xMW/cb2*(th0/xMh02*cba-tHH/xMHH2*sba)

c scheme 8: BFM-inspired scheme 2
	dsa_ferm_RSthdm(8)   = dsa_ferm_RSthdm(7)
	dtb_ferm_RSthdm(8)   = 
     &	  s2b*(c2a*(dZh0-dZHH)+s2a*(dZHHh0+dZh0HH))/4d0/cb2
     &	  - el/2d0/xsw/xMW/cb2*(th0/xMh02*cba-tHH/xMHH2*sba)

c general settings
	dtb    = dtb_ferm_RSthdm(renscheme)
	dsa    = dsa_ferm_RSthdm(renscheme)
	dlam35 = dlam3 + dlam5

	if ((renscheme.eq.1).or.(renscheme.eq.7)
     &	                    .or.(renscheme.eq.8)) then
          seh0HH_mh02 = seh0HH_mh02 
     &                 +el*(th0*Ch0h0HH/xMh02+tHH*Ch0HHHH/xMHH2)
          seh0HH_mHH2 = seh0HH_mHH2 
     &                 +el*(th0*Ch0h0HH/xMh02+tHH*Ch0HHHH/xMHH2)
	  dZh0HH = -2d0*seh0HH_mHH2/(mHH2-mh02)
	  dZHHh0 = -2d0*seh0HH_mh02/(mh02-mHH2)
	endif

c redistribute tadpoles in schemes 1, 3, 7 and 8
c before calculating RS shift ("t-variant")
	do i=0,8
	  if ((i.eq.1).or.(i.eq.3).or.(i.eq.7).or.(i.eq.8)) 
     &	    dtb_ferm_RSthdm(i) = dtb_ferm_RSthdm(i)
     &	      + el/2d0/xsw/xMW/cb2*(th0/xMh02*cba-tHH/xMHH2*sba)
	  if ((i.eq.1).or.(i.eq.7).or.(i.eq.8))
     &	    dsa_ferm_RSthdm(i) = dsa_ferm_RSthdm(i)
     &	      + ca/(mh02-mHH2)* el*(th0*Ch0h0HH/xMh02+tHH*Ch0HHHH/xMHH2)
	enddo

	do i=1,4
	  dZffr(i) = 0d0
	  dZffl(i) = 0d0
	enddo

c*** vertex counterterms
	ct_aww = dZe+dZw+dZaa/2d0-xcw/xsw*dZza/2d0
	ct_zww = dZe-dsw/xsw/xcw2+dZw+dZzz/2d0+dZaz/2d0/(-xcw/xsw)

	ct_wf1f2 = dZe-dsw/xsw+(dZw+dZffl(1)+dZffl(2))/2d0
	ct_wf3f4 = dZe-dsw/xsw+(dZw+dZffl(3)+dZffl(4))/2d0

        iw3f(1) = iso(1)/2d0
        iw3f(2) = iso(2)/2d0
        iw3f(3) = iso(3)/2d0
        iw3f(4) = iso(4)/2d0
	do i=1,4
	  gffr(i) = -q(i)*xsw/xcw
	  gffl(i) = -q(i)*xsw/xcw+iw3f(i)/xsw/xcw
	enddo

	do i=1,4
	  ct_zffr(i) = dZe+dsw/xsw/xcw2+dZzz/2d0+dZffr(i)
     &                  +dZaz/2d0/xsw*xcw
	  ct_zffl(i) = dZe+dsw/xsw/xcw2-2d0*iw3f(i)/xsw2/xcw*dsw/gffl(i)
     &			+dZzz/2d0+dZffl(i)
     &			-q(i)*dZaz/2d0/gffl(i)
	enddo

c HVV counterterms
        ct_h0ww = dZe - dsw/xsw + dmw2/xmw2/2d0 + dZw       ! 1st line is UV finite
     &	    + dZh0/2d0 + dZHHh0/2d0*cba/sba + cba/sba*(dtb*cb2-dsa/ca)
        ct_HHww = dZe - dsw/xsw + dmw2/xmw2/2d0 + dZw 
     &	    + dZHH/2d0 + dZh0HH/2d0*sba/cba - sba/cba*(dtb*cb2-dsa/ca)

        ct_h0zz = dZe - dsw/xsw + dsw*xsw/xcw2 + dmz2/xmz2/2d0 + dZzz   
     &	    + dZh0/2d0 + dZHHh0/2d0*cba/sba + cba/sba*(dtb*cb2-dsa/ca)
        ct_h0za = dZza/2d0
        ct_HHzz = dZe - dsw/xsw + dsw*xsw/xcw2 + dmz2/xmz2/2d0 + dZzz  
     &	    + dZHH/2d0 + dZh0HH/2d0*sba/cba - sba/cba*(dtb*cb2-dsa/ca)
        ct_HHza = dZza/2d0
	if ((renscheme.eq.1).or.(renscheme.eq.3).or.
     &	    (renscheme.eq.7).or.(renscheme.eq.8)) then
	  dmw2tad = - el*xMW/xsw*(sba*th0/xMh02+cba*tHH/xMHH2)
 	  dmz2tad = - el*xMW/xsw*(sba*th0/xMh02+cba*tHH/xMHH2)/xcw2
	  ct_h0ww = ct_h0ww + dmw2tad/xmw2/2d0 
     &	                    + EL/(2d0*xMW*SBA*xSW)*th0/xMh02
	  ct_h0zz = ct_h0zz + dmw2tad/xmw2/2d0 
     &	                    + EL/(2d0*xMW*SBA*xSW)*th0/xMh02
	  ct_HHww = ct_HHww + dmz2tad/xmz2/2d0 
     &	                    + EL/(2d0*xMW*CBA*xSW)*tHH/xMHH2
	  ct_HHzz = ct_HHzz + dmz2tad/xmz2/2d0 
     &	                    + EL/(2d0*xMW*CBA*xSW)*tHH/xMHH2
	endif

c      print*
c      print*,'CT fermionic:'
c      write(*,'((a),2g26.18)')'dmw2    =',dmw2
c      write(*,'((a),2g26.18)')'dmz2    =',dmz2
c      write(*,'((a),2g26.18)')'dmh02   =',dmh02
c      write(*,'((a),2g26.18)')'dmHH2   =',dmHH2
c      write(*,'((a),2g26.18)')'dmA02   =',dmA02
c      write(*,'((a),2g26.18)')'dmHP2   =',dmHP2
c      write(*,'((a),2g26.18)')'dsw     =',dsw
c      write(*,'((a),2g26.18)')'dZe     =',dZe
c      write(*,'((a),2g26.18)')'dZaa    =',dZaa
c      write(*,'((a),2g26.18)')'dZaz    =',dZaz
c      write(*,'((a),2g26.18)')'dZza    =',dZza
c      write(*,'((a),2g26.18)')'dZzz    =',dZzz
c      write(*,'((a),2g26.18)')'dZw     =',dZw
c      write(*,'((a),2g26.18)')'dZh0    =',dZh0
c      write(*,'((a),2g26.18)')'dZHH    =',dZHH
c      write(*,'((a),2g26.18)')'dZh0HH  =',dZh0HH
c      write(*,'((a),2g26.18)')'dZHHh0  =',dZHHh0
c      write(*,'((a),2g26.18)')'dtb     =',dtb 
c      write(*,'((a),2g26.18)')'dsa     =',dsa 
c      write(*,'((a),2g26.18)')'th0     =',th0
c      write(*,'((a),2g26.18)')'tHH     =',tHH
c      write(*,'((a),2g26.18)')'dZffr(1)=',dZffr(1)
c      write(*,'((a),2g26.18)')'dZffr(2)=',dZffr(2)
c      write(*,'((a),2g26.18)')'dZffr(3)=',dZffr(3)
c      write(*,'((a),2g26.18)')'dZffr(4)=',dZffr(4)
c      write(*,'((a),2g26.18)')'dZffl(1)=',dZffl(1)
c      write(*,'((a),2g26.18)')'dZffl(2)=',dZffl(2)
c      write(*,'((a),2g26.18)')'dZffl(3)=',dZffl(3)
c      write(*,'((a),2g26.18)')'dZffl(4)=',dZffl(4)
c      write(*,'((a),2g26.18)')'ct_h0ww =',ct_h0ww

	end

**********************************************************************
        subroutine transinput_thdm(qmethod)
**********************************************************************
*	translate THDM input parameters beta and alpha 
*	between renormalization schemes
*	qmethod = 0: linearized approach
*	qmethod = 1: matching the bare parameters
*---------------------------------------------------------------------
*       23.9.16 Stefan Dittmaier
**********************************************************************
        use COLLIER
        use collier_init

        implicit real*8 (a-z)
	real*8 x(10)
	integer i,qmethod,conv
        logical misnan

        include '../COMMON/model.inc'
        include '../COMMON/param.inc'
        include '../COMMON/xparam.inc'
        include '../COMMON/param_thdm.inc'
        include '../COMMON/param_bsm.inc'

	external chi2bare_thdm

c store parameters
	tb_store      = tb
	ta_store      = ta
	lam3_store    = lam3 
	lam5_store    = lam5 
        call GetDeltaUV_cll(deltaUV)
        call GetMuUV2_cll(muv2)
	muv2_store    = muv2
	deltaUV_store = deltaUV

c bare parameters
        deltauv  = 0d0
        muv2     = mren2bsm
        call SetDeltaUV_cll(deltaUV)
        call SetMuUV2_cll(muv2)
	call bsm_setparams()
        call thdm_setcoupl(modeltype,hboson)
	call xcalcrenc_thdm
	call xcalcrenc_ferm_thdm
	tb_bare = tb + dtb_bos_RSthdm(renscheme) 
     &	             + dtb_ferm_RSthdm(renscheme)
	ta_bare = ta + dsa_bos_RSthdm(renscheme)/ca**3
     &	             + dsa_ferm_RSthdm(renscheme)/ca**3
	lam3_bare = lam3 + dlam3_bos_RSthdm(renscheme)
     &	                 + dlam3_ferm_RSthdm(renscheme)
	lam5_bare = lam5 + dlam5_bos_RSthdm(renscheme)
     &	                 + dlam5_ferm_RSthdm(renscheme)

	do i=0,8

	if (i.eq.renscheme) then
          if (ta_store.ne.1d30) then
	    sa_RSthdm_lin(i) = ta_store/sqrt(1d0+ta_store**2)
	    sa_RSthdm(i)     = ta_store/sqrt(1d0+ta_store**2)
	  else
	    sa_RSthdm_lin(i) = 1d0
	    sa_RSthdm(i)     = 1d0
	  endif
	  tb_RSthdm_lin(i)   = tb_store
	  lam3_RSthdm_lin(i) = lam3_store
	  lam5_RSthdm_lin(i) = lam5_store
	  tb_RSthdm(i)       = tb_store
	  lam3_RSthdm(i)     = lam3_store
	  lam5_RSthdm(i)     = lam5_store
	else  

c linearized approach
	if (qmethod.eq.0) then
	  tb   = tb_store  
	  ta   = ta_store  
	  lam5 = lam5_store
	  call bsm_setparams()
          call thdm_setcoupl(modeltype,hboson)
	  call xcalcrenc_thdm
	  call xcalcrenc_ferm_thdm
	  tb_RSthdm_lin(i)= tb_bare-dtb_bos_RSthdm(i)-dtb_ferm_RSthdm(i)
	  ta_RSthdm       = ta_bare 
     &			   -(dsa_bos_RSthdm(i)+dsa_ferm_RSthdm(i))/ca**3
	  sa_RSthdm_lin(i)   = ta_RSthdm/sqrt(1d0+ta_RSthdm**2)
	  lam3_RSthdm_lin(i) = lam3_bare
     &	                   -dlam3_bos_RSthdm(i)-dlam3_ferm_RSthdm(i)
	  lam5_RSthdm_lin(i) = lam5_bare
     &	                   -dlam5_bos_RSthdm(i)-dlam5_ferm_RSthdm(i)

c matching the bare parameters
	elseif (qmethod.eq.1) then
	  x(1) = tb_store
	  x(2) = ta_store
	  x(3) = lam5_store
	  x(4) = tb_bare
	  x(5) = ta_bare
	  x(6) = lam5_bare
	  x(7) = i
	  call mini(chi2bare_thdm,x,y,0,1,3,conv)
	  conv_thdm(i) = conv
c	  tb   = x(1)
c	  ta   = x(2)
c	  lam5 = x(3)
	  tb_RSthdm(i)   = x(1)
	  ta_RSthdm      = x(2)
	  sa_RSthdm(i)   = ta_RSthdm/sqrt(1d0+ta_RSthdm**2)
	  lam3_RSthdm(i) = lam3
	  lam5_RSthdm(i) = x(3)
          if (misnan(x(1)*x(2)*x(3))) conv_thdm(i) = 1

	endif
	endif

	enddo

c restore parameters
	tb      = tb_store  
	ta      = ta_store  
	lam5    = lam5_store
	muv2    = muv2_store
	deltaUV = deltaUV_store
        call SetDeltaUV_cll(deltaUV)
        call SetMuUV2_cll(muv2)
	call bsm_setparams()
        call thdm_setcoupl(modeltype,hboson)
	call xcalcrenc_thdm
	call xcalcrenc_ferm_thdm

	end

**********************************************************************
        function chi2bare_thdm(x)
**********************************************************************
*	chi2 for matching of bare parameters 
*---------------------------------------------------------------------
*       20.3.17 Stefan Dittmaier
**********************************************************************
        use COLLIER
        use collier_init

        implicit real*8 (a-z)
	real*8 x(10)
	integer i,qren

	include '../COMMON/model.inc'
        include '../COMMON/param.inc'
        include '../COMMON/xparam.inc'
        include '../COMMON/param_thdm.inc'
        include '../COMMON/param_bsm.inc'

	tb   = x(1)
        ta   = x(2) 
        lam5 = x(3)
	qren = nint(x(7))
        deltauv  = 0d0
        muv2     = mren2bsm
        call SetDeltaUV_cll(deltaUV)
        call SetMuUV2_cll(muv2)
 
	call bsm_setparams()
        call thdm_setcoupl(modeltype,hboson)
	call xcalcrenc_thdm
	call xcalcrenc_ferm_thdm
	
	tb_bare = tb + dtb_bos_RSthdm(qren) 
     &	             + dtb_ferm_RSthdm(qren)
	ta_bare = ta + dsa_bos_RSthdm(qren)/ca**3
     &	             + dsa_ferm_RSthdm(qren)/ca**3
	lam3_bare = lam3 + dlam3_bos_RSthdm(qren)
     &	                 + dlam3_ferm_RSthdm(qren)
	lam5_bare = lam5 + dlam5_bos_RSthdm(qren)
     &	                 + dlam5_ferm_RSthdm(qren)
	
	chi2bare_thdm = (tb_bare-x(4))**2 + (ta_bare-x(5))**2
     &	                + (lam5_bare-x(6))**2 

	end

**********************************************************************
        subroutine beta_thdm(Btb,Bta,Blam5,Blam3,
     &                       Mh0,MHH,MA0,MHp,tb,ta,lam5)
**********************************************************************
*	beta functions of MSbar renormalized THDM input parameters 
*	Note: All input masses taken real !
*---------------------------------------------------------------------
*       27.9.16 Stefan Dittmaier
**********************************************************************
        implicit real*8 (a-z)
	complex*16 Ch0h0HH,Ch0HHHH
	complex*16 seh0HH_mh02_div,seh0HH_mHH2_div
	complex*16 th0div,tHHdiv
	integer i

        include '../COMMON/model.inc'
        include '../COMMON/param.inc'
        include '../COMMON/xparam.inc'

c*** dependent variables
        Mh02 = Mh0**2
        MHH2 = MHH**2
        MA02 = MA0**2
        MHp2 = MHp**2

c angle beta
        TB2 = TB**2
        SB  = TB/sqrt(1d0+TB2)
        CB  = SB/TB
        CB2 = CB**2
        SB2 = SB**2
        S2B = 2d0*CB*SB
        C2B = CB**2 - SB**2
c angle alpha
c	TA  = sa/sqrt(1d0-sa**2)
        TA2 = TA**2
        if (ta.ne.0d0) then
          SA = TA/sqrt(1d0+TA2)
          CA = SA/TA
        else
          SA = 0d0
          CA = 1d0
	endif
        CA2 = CA**2
        SA2 = SA**2
        S2A = 2d0*CA*SA
        C2A = CA**2 - SA**2
c angles alpha and beta
        CBA = CB*CA + SB*SA
        CAB = CB*CA - SB*SA
        SBA = SB*CA - CB*SA
        SAB = SB*CA + CB*SA

c*** some 3-Higgs couplings
        Ch0h0HH = -(-(2d0*SAB-(3d0*C2A+C2B)*SBA)
     &               *(MA02+4d0*lam5/el**2*MW2*SW2)
     &      +CBA*(-3d0*MA02*S2A+4d0*Mh02*S2A+2d0*MHH2*S2A
     &      +MA02*S2B+4d0*lam5/el**2*MW2*(-3d0*S2A+S2B)*SW2))
     &    /(8d0*CB*MW*SB*SW)
        Ch0HHHH = (2d0*Mh02*S2A*SBA+4*MHH2*S2A*SBA
     &      +MA02*(2d0*CAB-3d0*C2A*CBA+C2B*CBA-3d0*S2A*SBA-S2B*SBA)
     &      +4d0*lam5/el**2*MW2
     &          *(2*CAB-3d0*C2A*CBA+C2B*CBA-3d0*S2A*SBA-S2B*SBA)*SW2)
     &    /(8d0*CB*MW*SB*SW)

c*** fermion couplings
c THDM type 1
        if (modeltype.eq.1) then
          Cleph0 = CA/SB
          ClepHH = SA/SB
          ClepA = 1d0/TB
          ClepG = 1d0
          Cuph0 = CA/SB
          CupHH = SA/SB
          CupA = 1d0/TB
          CupG = 1d0
          Cdoh0 = CA/SB
          CdoHH = SA/SB
          CdoA = 1d0/TB
          CdoG = 1d0
c THDM type 2
        elseif (modeltype.eq.2) then
          Cleph0 = -SA/CB
          ClepHH = CA/CB
          ClepA = -TB
          ClepG = 1d0
          Cuph0 = CA/SB
          CupHH = SA/SB
          CupA = 1d0/TB
          CupG = 1d0
          Cdoh0 = -SA/CB
          CdoHH = CA/CB
          CdoA = -TB
          CdoG = 1d0
c THDM type 3 (lepton specific)
        elseif (modeltype.eq.3) then
          Cleph0 = -SA/CB
          ClepHH = CA/CB
          ClepA = -TB
          ClepG = 1d0
          Cuph0 = CA/SB
          CupHH = SA/SB
          CupA = 1d0/TB
          CupG = 1d0
          Cdoh0 = CA/SB
          CdoHH = SA/SB
          CdoA = 1d0/TB
          CdoG = 1d0
c THDM type 4 (flipped)
        elseif (modeltype.eq.4) then
          Cleph0 = CA/SB
          ClepHH = SA/SB
          ClepA = 1d0/TB
          ClepG = 1d0
          Cuph0 = CA/SB
          CupHH = SA/SB
          CupA = 1d0/TB
          CupG = 1d0
          Cdoh0 = -SA/CB
          CdoHH = CA/CB
          CdoA = -TB
          CdoG = 1d0
        endif

c beta functions derived from UV-divergent parts of counterterms
c	div = deltauv + log(muv2/mren2bsm)
	div = 1d0

	seh0HH_mHH2_div = div * (
     &  -((CB**(-2)*EL**(-2)*LAM5**2*PI**(-2)*SB**(-2)*(-(2D0*CB**3*
     &  SB**3)+4D0*CB**3*SA**2*SB**3+CA*SA*(-3D0+8D0*SB**2-6D0*SB**
     &  4+4D0*SB**6))*MW2*SW2)/2D0)
     & 
     &  -((CB**(-2)*EL**2*PI**(-2)*SB**(-2)*CW2**(-2)*((2D0*CB*SB*
     &  (1D0-5D0*SB**2+5D0*SB**4)-4D0*CB*SA**2*SB*(1D0-5D0*SB**2+
     &  5D0*SB**4)+CA*SA*(-11D0+32D0*SB**2-30D0*SB**4+20D0*SB**6))*
     &  CW2**2*ma02**2+SA*(-(9D0*CA*CB**2)-5D0*CB*SA*SB+15D0*CB*
     &  SA**3*SB-10D0*CB*SA**5*SB+5D0*CA*SA**4*(-1D0+2D0*SB**2)-2D0*
     &  CA*SA**2*(-7D0+5D0*SB**2))*CW2**2*mh02**2-4D0*CA*SA**3*
     &  mhh2**2-5D0*CA*SA**5*mhh2**2-5D0*CB*SA**2*SB*mhh2**2+
     &  15D0*CB*SA**4*SB*mhh2**2-10D0*CB*SA**6*SB*mhh2**2+9D0*CA*
     &  SA*SB**2*mhh2**2-10D0*CA*SA**3*SB**2*mhh2**2+10D0*CA*SA**
     &  5*SB**2*mhh2**2-2D0*CA*SA**3*mhh2*mhp2+6D0*CB*SA**2*SB*
     &  mhh2*mhp2-2D0*CB*SA**4*SB*mhh2*mhp2+4D0*CA*SA**3*SB**2*
     &  mhh2*mhp2-4D0*CB*SB**3*mhh2*mhp2-4D0*CB*SA**2*SB**3*
     &  mhh2*mhp2+4D0*CB*SA**4*SB**3*mhh2*mhp2+2D0*CA*SA*SB**4*
     &  mhh2*mhp2-4D0*CA*SA**3*SB**4*mhh2*mhp2+8D0*CA*SA*SB**2*
     &  mhp2**2-8D0*CB*SB**3*mhp2**2+16D0*CB*SA**2*SB**3*mhp2**2-
     &  24D0*CA*SA*SB**4*mhp2**2+8D0*CB*SB**5*mhp2**2-16D0*CB*SA**
     &  2*SB**5*mhp2**2+16D0*CA*SA*SB**6*mhp2**2-3D0*CB*SA**2*SB*
     &  mhh2*MW2+3D0*CB*SA**4*SB*mhh2*MW2+3D0*CA*SA*SB**2*mhh2*
     &  MW2-6D0*CA*SA**3*SB**2*mhh2*MW2+6D0*CB*SA**2*SB**3*mhh2*
     &  MW2-6D0*CB*SA**4*SB**3*mhh2*MW2-3D0*CA*SA*SB**4*mhh2*
     &  MW2+6D0*CA*SA**3*SB**4*mhh2*MW2+36D0*CA*SA*SB**2*MW2**2-
     &  36D0*CB*SB**3*MW2**2+72D0*CB*SA**2*SB**3*MW2**2-108D0*CA*
     &  SA*SB**4*MW2**2+36D0*CB*SB**5*MW2**2-72D0*CB*SA**2*SB**5*
     &  MW2**2+72D0*CA*SA*SB**6*MW2**2+8D0*CA*SA**3*mhh2**2*SW2+
     &  10D0*CA*SA**5*mhh2**2*SW2+10D0*CB*SA**2*SB*mhh2**2*SW2-
     &  30D0*CB*SA**4*SB*mhh2**2*SW2+20D0*CB*SA**6*SB*mhh2**2*
     &  SW2-18D0*CA*SA*SB**2*mhh2**2*SW2+20D0*CA*SA**3*SB**2*
     &  mhh2**2*SW2-20D0*CA*SA**5*SB**2*mhh2**2*SW2+4D0*CA*SA**
     &  3*mhh2*mhp2*SW2-12D0*CB*SA**2*SB*mhh2*mhp2*SW2+4D0*CB*
     &  SA**4*SB*mhh2*mhp2*SW2-8D0*CA*SA**3*SB**2*mhh2*mhp2*
     &  SW2+8D0*CB*SB**3*mhh2*mhp2*SW2+8D0*CB*SA**2*SB**3*mhh2*
     &  mhp2*SW2-8D0*CB*SA**4*SB**3*mhh2*mhp2*SW2-4D0*CA*SA*
     &  SB**4*mhh2*mhp2*SW2+8D0*CA*SA**3*SB**4*mhh2*mhp2*SW2-
     &  16D0*CA*SA*SB**2*mhp2**2*SW2+16D0*CB*SB**3*mhp2**2*SW2-
     &  32D0*CB*SA**2*SB**3*mhp2**2*SW2+48D0*CA*SA*SB**4*mhp2**2*
     &  SW2-16D0*CB*SB**5*mhp2**2*SW2+32D0*CB*SA**2*SB**5*mhp2**
     &  2*SW2-32D0*CA*SA*SB**6*mhp2**2*SW2+5D0*CB*SA**2*SB*mhh2*
     &  MW2*SW2-5D0*CB*SA**4*SB*mhh2*MW2*SW2-5D0*CA*SA*SB**2*
     &  mhh2*MW2*SW2+10D0*CA*SA**3*SB**2*mhh2*MW2*SW2-10D0*CB*
     &  SA**2*SB**3*mhh2*MW2*SW2+10D0*CB*SA**4*SB**3*mhh2*MW2*
     &  SW2+5D0*CA*SA*SB**4*mhh2*MW2*SW2-10D0*CA*SA**3*SB**4*
     &  mhh2*MW2*SW2-48D0*CA*SA*SB**2*MW2**2*SW2+48D0*CB*SB**3*
     &  MW2**2*SW2-96D0*CB*SA**2*SB**3*MW2**2*SW2+144D0*CA*SA*
     &  SB**4*MW2**2*SW2-48D0*CB*SB**5*MW2**2*SW2+96D0*CB*SA**2*
     &  SB**5*MW2**2*SW2-96D0*CA*SA*SB**6*MW2**2*SW2-4D0*CA*SA**
     &  3*mhh2**2*SW2**2-5D0*CA*SA**5*mhh2**2*SW2**2-5D0*CB*SA**
     &  2*SB*mhh2**2*SW2**2+15D0*CB*SA**4*SB*mhh2**2*SW2**2-
     &  10D0*CB*SA**6*SB*mhh2**2*SW2**2+9D0*CA*SA*SB**2*mhh2**2*
     &  SW2**2-10D0*CA*SA**3*SB**2*mhh2**2*SW2**2+10D0*CA*SA**5*
     &  SB**2*mhh2**2*SW2**2-2D0*CA*SA**3*mhh2*mhp2*SW2**2+6D0*
     &  CB*SA**2*SB*mhh2*mhp2*SW2**2-2D0*CB*SA**4*SB*mhh2*mhp2*
     &  SW2**2+4D0*CA*SA**3*SB**2*mhh2*mhp2*SW2**2-4D0*CB*SB**3*
     &  mhh2*mhp2*SW2**2-4D0*CB*SA**2*SB**3*mhh2*mhp2*SW2**2+
     &  4D0*CB*SA**4*SB**3*mhh2*mhp2*SW2**2+2D0*CA*SA*SB**4*
     &  mhh2*mhp2*SW2**2-4D0*CA*SA**3*SB**4*mhh2*mhp2*SW2**2+
     &  8D0*CA*SA*SB**2*mhp2**2*SW2**2-8D0*CB*SB**3*mhp2**2*
     &  SW2**2+16D0*CB*SA**2*SB**3*mhp2**2*SW2**2-24D0*CA*SA*SB**
     &  4*mhp2**2*SW2**2+8D0*CB*SB**5*mhp2**2*SW2**2-16D0*CB*
     &  SA**2*SB**5*mhp2**2*SW2**2+16D0*CA*SA*SB**6*mhp2**2*
     &  SW2**2-2D0*CB*SA**2*SB*mhh2*MW2*SW2**2+2D0*CB*SA**4*SB*
     &  mhh2*MW2*SW2**2+2D0*CA*SA*SB**2*mhh2*MW2*SW2**2-4D0*
     &  CA*SA**3*SB**2*mhh2*MW2*SW2**2+4D0*CB*SA**2*SB**3*mhh2*
     &  MW2*SW2**2-4D0*CB*SA**4*SB**3*mhh2*MW2*SW2**2-2D0*CA*
     &  SA*SB**4*mhh2*MW2*SW2**2+4D0*CA*SA**3*SB**4*mhh2*MW2*
     &  SW2**2+24D0*CA*SA*SB**2*MW2**2*SW2**2-24D0*CB*SB**3*
     &  MW2**2*SW2**2+48D0*CB*SA**2*SB**3*MW2**2*SW2**2-72D0*CA*
     &  SA*SB**4*MW2**2*SW2**2+24D0*CB*SB**5*MW2**2*SW2**2-48D0*
     &  CB*SA**2*SB**5*MW2**2*SW2**2+48D0*CA*SA*SB**6*MW2**2*
     &  SW2**2+CW2*mh02*(-(2D0*SA*(-(5D0*CB*SA*SB)+15D0*CB*SA**3*
     &  SB-10D0*CB*SA**5*SB+3D0*CA*(1D0-2D0*SB**2)+5D0*CA*SA**2*
     &  (1D0-2D0*SB**2)+5D0*CA*SA**4*(-1D0+2D0*SB**2))*CW2*mhh2)+
     &  2D0*(-(CA*CB**4*SA)-2D0*CB**3*SB+CB*SA**4*SB*(1D0-2D0*SB**
     &  2)+CB*SA**2*SB*(1D0+2D0*SB**2)+CA*SA**3*(1D0-2D0*SB**2+2D0*
     &  SB**4))*CW2*mhp2-SA*SB*(CA**2*CB*SA+CA*(-1D0+2D0*SA**2)*
     &  SB-2D0*CA**2*CB*SA*SB**2+CA*(1D0-2D0*SA**2)*SB**3)*MW2*(-
     &  3D0+2D0*SW2))+CW2*ma02*(-((2D0*CB**3*SB+CB*SA**2*SB*(-
     &  9D0+14D0*SB**2)+7D0*CB*SA**4*SB*(1D0-2D0*SB**2)+14D0*CA*SA**
     &  3*(CB**2+SB**4)+CA*SA*(-20D0+33D0*SB**2-7D0*SB**4))*CW2*
     &  mh02)+(-(2D0*CB*SB**3)+CB*SA**2*SB*(-5D0+14D0*SB**2)+7D0*
     &  CB*SA**4*SB*(1D0-2D0*SB**2)+14D0*CA*SA**3*(CB**2+SB**4)+CA*
     &  SA*(6D0-19D0*SB**2-7D0*SB**4))*CW2*mhh2+2D0*(-((2D0*CB*SB*
     &  (-1D0-SB**2+SB**4)+4D0*CB*SA**2*SB*(1D0+SB**2-SB**4)+CA*SA*
     &  (-1D0+4D0*SB**2-6D0*SB**4+4D0*SB**6))*CW2*mhp2)+CB**2*SB**
     &  2*(CB*SB-2D0*CB*SA**2*SB+CA*SA*(-1D0+2D0*SB**2))*MW2*(-3D0+
     &  2D0*SW2)))))/(128D0*MW2*SW2))
     & 
     &  +(CB**(-2)*LAM5*PI**(-2)*SB**(-2)*(-((2D0*CB*SB*(1D0-7D0*SB**
     &  2+7D0*SB**4)-4D0*CB*SA**2*SB*(1D0-7D0*SB**2+7D0*SB**4)+CA*
     &  SA*(-23D0+60D0*SB**2-42D0*SB**4+28D0*SB**6))*CW2*ma02)-SA*
     &  (8D0*CB*SA*SB*(1D0-2D0*SB**2)+8D0*CB*SA**3*SB*(-1D0+2D0*SB**
     &  2)+CA*SA**2*(-15D0+16D0*SB**2-16D0*SB**4)+CA*(21D0-35D0*SB**
     &  2+8D0*SB**4))*CW2*mh02-6D0*CA*SA*mhh2-15D0*CA*SA**3*
     &  mhh2+8D0*CB*SA**2*SB*mhh2-8D0*CB*SA**4*SB*mhh2+19D0*CA*
     &  SA*SB**2*mhh2+16D0*CA*SA**3*SB**2*mhh2-16D0*CB*SA**2*SB**
     &  3*mhh2+16D0*CB*SA**4*SB**3*mhh2+8D0*CA*SA*SB**4*mhh2-
     &  16D0*CA*SA**3*SB**4*mhh2-2D0*CA*SA*mhp2-4D0*CB*SB*mhp2+
     &  8D0*CB*SA**2*SB*mhp2+8D0*CA*SA*SB**2*mhp2-4D0*CB*SB**3*
     &  mhp2+8D0*CB*SA**2*SB**3*mhp2-12D0*CA*SA*SB**4*mhp2+4D0*
     &  CB*SB**5*mhp2-8D0*CB*SA**2*SB**5*mhp2+8D0*CA*SA*SB**6*
     &  mhp2-6D0*CA*SA*SB**2*MW2+6D0*CB*SB**3*MW2-12D0*CB*SA**2*
     &  SB**3*MW2+18D0*CA*SA*SB**4*MW2-6D0*CB*SB**5*MW2+12D0*CB*
     &  SA**2*SB**5*MW2-12D0*CA*SA*SB**6*MW2+6D0*CA*SA*mhh2*SW2+
     &  15D0*CA*SA**3*mhh2*SW2-8D0*CB*SA**2*SB*mhh2*SW2+8D0*CB*
     &  SA**4*SB*mhh2*SW2-19D0*CA*SA*SB**2*mhh2*SW2-16D0*CA*SA**
     &  3*SB**2*mhh2*SW2+16D0*CB*SA**2*SB**3*mhh2*SW2-16D0*CB*
     &  SA**4*SB**3*mhh2*SW2-8D0*CA*SA*SB**4*mhh2*SW2+16D0*CA*
     &  SA**3*SB**4*mhh2*SW2+2D0*CA*SA*mhp2*SW2+4D0*CB*SB*mhp2*
     &  SW2-8D0*CB*SA**2*SB*mhp2*SW2-8D0*CA*SA*SB**2*mhp2*SW2+
     &  4D0*CB*SB**3*mhp2*SW2-8D0*CB*SA**2*SB**3*mhp2*SW2+12D0*
     &  CA*SA*SB**4*mhp2*SW2-4D0*CB*SB**5*mhp2*SW2+8D0*CB*SA**2*
     &  SB**5*mhp2*SW2-8D0*CA*SA*SB**6*mhp2*SW2+4D0*CA*SA*SB**2*
     &  MW2*SW2-4D0*CB*SB**3*MW2*SW2+8D0*CB*SA**2*SB**3*MW2*
     &  SW2-12D0*CA*SA*SB**4*MW2*SW2+4D0*CB*SB**5*MW2*SW2-8D0*
     &  CB*SA**2*SB**5*MW2*SW2+8D0*CA*SA*SB**6*MW2*SW2))/(32D0*
     &  CW2) )

	seh0HH_mh02_div = seh0HH_mHH2_div 

	th0div = div * (
     &  -(PI**(-2)*(C2B*CBA*EL**2*ma02-CA*CB**3*EL**2*mh02
     &  +EL**2*SA*SB**3*mh02+4D0*CAB*LAM5*MW2*SW2)*(ma02))
     &	/(64D0*CB*EL*SB*MW*SW)
     &  +(3D0/PI**2*(EL**2*(C2A*CBA+S2A*SBA)*mh02+CAB*(3D0*EL**2*mh02
     &  -4D0*CBA**2*(EL**2*ma02+4D0*LAM5*MW2*SW2)))*(mh02))
     &  /(256D0*CB*EL*SB*MW*SW)
     &  -(PI**(-2)*(C2B*CBA*EL**2*ma02-3D0*EL**2*S2A*SBA*ma02
     &  -EL**2*S2B*SBA*ma02+2D0*EL**2*S2A*SBA*mh02
     &  +4D0*EL**2*S2A*SBA*mhh2+4D0*C2B*CBA*LAM5*MW2*SW2
     &  -12D0*LAM5*S2A*SBA*MW2*SW2-4D0*LAM5*S2B*SBA*MW2*SW2
     &  +2D0*CAB*(EL**2*ma02+4D0*LAM5*MW2*SW2)
     &  -3D0*C2A*CBA*(EL**2*ma02+4D0*LAM5*MW2*SW2))*(mhh2))
     &	/(256D0*CB*EL*SB*MW*SW)
     &  -(PI**(-2)*(EL**2*(-(CA*CB**3*mh02)+SA*SB**3*mh02
     &  -2D0*CB*SB*SBA*mhp2)+CAB*(EL**2*ma02+4D0*LAM5*MW2*SW2))
     &  *(mhp2))/(32D0*CB*EL*SB*MW*SW)
     &	+(EL/PI**2*SBA*(mh02+6D0*MW2)*(MW2))/(32D0*MW*SW)
     &  +(EL/PI**2*SBA*(CW*mh02+6D0*MW*MZ)*(MZ2))
     &  /(64D0*CW*MW*SW) )
 
	tHHdiv = div * (
     &  +(PI**(-2)*(C2B*EL**2*SBA*ma02+CB**3*EL**2*SA*mhh2
     &  +CA*EL**2*SB**3*mhh2-4D0*LAM5*SAB*MW2*SW2)*(ma02))
     &	/(64D0*CB*EL*SB*MW*SW)
     &  -(PI**(-2)*((2D0*SAB-(3D0*C2A+C2B)*SBA)*(EL**2*ma02
     &  +4D0*LAM5*MW2*SW2)+CBA*(-(EL**2*(S2B*ma02+S2A*(-(3D0*ma02)
     &  +4D0*mh02+2D0*mhh2)))+4D0*LAM5*(3D0*S2A-S2B)*MW2*SW2))
     &  *(mh02))/(256D0*CB*EL*SB*MW*SW)
     &  +(3D0/PI**2*(EL**2*(-(SAB*SBA**2*ma02)
     &  +(CB*SA**3+CA**3*SB)*mhh2)-4D0*LAM5*SAB*SBA**2*MW2*SW2)
     &  *(mhh2))/(64D0*CB*EL*SB*MW*SW)
     &	+(PI**(-2)*(EL**2*(-(SAB*ma02)+CB**3*SA*mhh2+CA*SB**3*mhh2
     &  +2D0*CB*CBA*SB*mhp2)-4D0*LAM5*SAB*MW2*SW2)*(mhp2))
     &  /(32D0*CB*EL*SB*MW*SW)
     &  +(CBA*EL/PI**2*(mhh2+6D0*MW2)*(MW2))/(32D0*MW*SW)
     &  +(CBA*EL/PI**2*(CW*mhh2+6D0*MW*MZ)*(MZ2))
     &  /(64D0*CW*MW*SW) )

	dtb = 0d0

	dlam35 = div * (
     &      (CB**(-2)*LAM5**2*PI**(-2)*(1D0+S2B**2)*SB**(-2))/16D0
     &      +(ALPHA**2*CB**(-2)*SB**(-2)*(4D0*(MA02-2D0*MHP2)**2*
     &      (1D0+S2B**2)+((MH02-MHH2)**2*S2A*(-(6D0*C2B*CA**2)+S2A*S2B-
     &      6D0*SB**2))/(CB*SB)-((MH02-MHH2)*(MA02-2D0*MHP2)*(-(6D0*
     &      S2A)+2D0*C2B*CA**2*S2B+S2A*S2B**2+4D0*CB*SB**3))/(CB*SB)+
     &      2D0*(8D0*MHH2*MHP2-2D0*MHP2**2*(4D0+S2B**2)-2D0*MA02*(MHH2-
     &      2D0*MHP2*S2B**2)-(3D0*MHH2*(MH02-MHH2)*S2A)/(CB*SB)+((MH02-
     &      MHH2)*MHP2*(3D0*S2A*(2D0-S2B**2)+4D0*CB*SB**3-2D0*CA**2*
     &      (S2B-4D0*CB**3*SB)))/(CB*SB)))*MW2**(-2)*SW2**(-2))/64D0
     &      +(3D0*ALPHA**2*(MA02-2D0*MHP2+(CA*(MH02-MHH2)*SA)/(CB*
     &      SB))*SW2**(-2)*(3D0-2D0*SW2))/(8D0*CW2*MW2)
     &      +(ALPHA*CB**(-2)*LAM5*SB**(-2)*(-(8D0*MHP2*(2D0+S2B**2))+
     &      4D0*MA02*(2D0+3D0*S2B**2)+(MHH2*(2D0*C2B*CA**2*S2B-2D0*CB**
     &      2*S2B-3D0*S2A*(2D0-S2B**2)))/(CB*SB)-(MH02*(-(3D0*S2A*(2D0-
     &      S2B**2))+2D0*S2B*(C2B*CA**2+SB**2)))/(CB*SB)))/(64D0*PI*
     &      MW2*SW2)
     &      +(3D0*ALPHA**2*CW2**(-2)*SW2**(-2)*(3D0-8D0*SW2+6D0*
     &      SW2**2))/8D0	)

	dlam5 = - div 
     &  	*ALPHA*LAM5/MW2/SW2/(16D0*PI)
     &		*( 4D0*MHP2+6D0*(2D0*MW2+MZ2)
     &  	  +(1D0-10D0*CB2+10D0*CB**4)*MA02/SB2/CB2
     &		  -(1D0-CA2-CB2+6D0*CA2*CB2)*MH02/SB2/CB2
     &		  -(CA2+CB2-6D0*CA2*CB2)*MHH2/SB2/CB2
     &		  +4D0*CA*MH02/SB2*(CA*CB+SA*SB)/CB
     &  	  -4D0*CA*MHH2/SB2*(CA*CB+SA*SB)/CB )
     &	        -(-1d0+2d0*CB2)**2*div*lam5**2/(16d0*CB2*Pi**2*SB2)

c	C4B  = (C2B-S2B)*(C2B+S2B)
c	C2BA =  (CA*CB + CB*SA - CA*SB + SA*SB) 
c     &	       *(CA*CB - CB*SA + CA*SB + SA*SB)
c	C2AB =  (CA*CB + CB*SA + CA*SB - SA*SB) 
c     &	       *(CA*CB - CB*SA - CA*SB - SA*SB)
c
c	dlam5 = + div 
c     &  	*ALPHA*LAM5/MW2/SW2/(64D0*PI)
c     &		*( 8d0*MA02-16d0*MHP2-24d0*(2d0*MW2+MZ2)
c     &	           +( 2d0*(MH02+MHH2)
c     &  	     -4d0*MA02*C4B-(MH02-MHH2)*(C2BA-3d0*C2AB) 
c     &	            )/SB2/CB2 )
c     &	        -C2B**2*div*lam5**2/(4d0*Pi**2*S2B**2)

	do 100 i=1,3

	s = mh02
	seh0HH_mh02_div = seh0HH_mh02_div
     &	+ div * (
     &      -3D0*ALPHA*CDOh0*CDOHH*MQM2(I)*(-S+6D0*MQM2(I))
     &        /(8D0*PI*MW2*SW2)
     &      -3D0*ALPHA*CUPh0*CUPHH*MQP2(I)*(-S+6D0*MQP2(I))
     &        /(8D0*PI*MW2*SW2)
     &      -ALPHA*CLEPh0*CLEPHH*ML2(I)*(-S+6D0*ML2(I))
     &        /(8D0*PI*MW2*SW2) )

	s = mHH2
	seh0HH_mHH2_div = seh0HH_mHH2_div
     &	+ div * (
     &      -3D0*ALPHA*CDOh0*CDOHH*MQM2(I)*(-S+6D0*MQM2(I))
     &        /(8D0*PI*MW2*SW2)
     &      -3D0*ALPHA*CUPh0*CUPHH*MQP2(I)*(-S+6D0*MQP2(I))
     &        /(8D0*PI*MW2*SW2)
     &      -ALPHA*CLEPh0*CLEPHH*ML2(I)*(-S+6D0*ML2(I))
     &        /(8D0*PI*MW2*SW2) )

	th0div = th0div + div*(
     &  -(CLEPh0*EL/PI**2*(ML2(I))*ML2(I))/(8D0*MW*SW)
     &  -(3D0*CDOh0*EL/PI**2*(MQM2(I))*MQM2(I))/(8D0*MW*SW)
     &  -(3D0*CUPh0*EL/PI**2*(MQP2(I))*MQP2(I))/(8D0*MW*SW) )
 
	tHHdiv = tHHdiv + div*(
     &	-(CLEPHH*EL/PI**2*(ML2(I))*ML2(I))/(8D0*MW*SW)
     &  -(3D0*CDOHH*EL/PI**2*(MQM2(I))*MQM2(I))/(8D0*MW*SW)
     &  -(3D0*CUPHH*EL/PI**2*(MQP2(I))*MQP2(I))/(8D0*MW*SW) )

	dtb = dtb 
     &  -ALPHA/(8D0*PI*MW2*SW2)*(
     &	       (CLEPh0**2-CLEPHH**2)*ML2(I)
     &	  +3D0*(CDOh0**2 -CDOHH**2 )*MQM2(I)
     &    +3D0*(CUPh0**2 -CUPHH**2 )*MQP2(I) )
     &	*div
     &	*tb/2d0/c2a

	dlam35 = dlam35 - div 
     &		  *( ALPHA**2/(4d0*MW**4*SW**4)
     &	              *(     ml2(i) *(1d0+C2B*CLEPA/S2B)
     &		        +3d0*mqp2(i)*(1d0+C2B*CUPA /S2B)
     &		        +3d0*mqm2(i)*(1d0+C2B*CDOA /S2B) )
     &		      *(MA02-2d0*MHp2+((Mh02-MHH2)*S2A)/S2B)
     &		    +(3d0*ALPHA**2*mqp2(i)*mqm2(i)/(MW**4*SW**4)
     &	              *(1d0-CdoA*CupA+(C2B*(CdoA+CupA))/S2B)) )

	dlam5 = dlam5 + div
     &  	*ALPHA*LAM5/MW2/SW2/(4D0*PI*S2B)*(
     &	  	        ml2(i)*(C2B*CLEPA+S2B)
     &		  +3D0*mqm2(i)*(C2B*CDOA +S2B)
     &  	  +3D0*mqp2(i)*(C2B*CUPA +S2B) )

c	dlam5 = dlam5 + div
c     &  	*ALPHA*LAM5/MW2/SW2/(8D0*PI)*(
c     &	  	        ml2(i)*(CLEPA**2+1d0)
c     &		  +3D0*mqm2(i)*(CDOA**2 +1d0)
c     &  	  +3D0*mqp2(i)*(CUPA**2 +1d0) )

100	continue

	dlam3  = dlam35 - dlam5

c scheme 0: alpha/beta MSbar
c scheme 1: alpha/beta MSbar a la FJ
c scheme 2: lambda3/beta MSbar
c scheme 3: lambda3/beta MSbar a la FJ
c scheme 4: alpha/beta OS scheme 2  -- based on formfactors for Neutrino nu2
c scheme 5: alpha/beta OS scheme 12 -- based on formfactors for Neutrinos nu1,nu2

	if ((renscheme.eq.1).or.(renscheme.eq.3)) then
	  dtbtad = - el/2d0/sw/MW/cb2
     &	                  *(th0div/Mh02*cba-tHHdiv/MHH2*sba)
	  dtb = dtb + dtbtad
	  seh0HH_mh02_div = seh0HH_mh02_div
     &                   +el*(th0div*Ch0h0HH/Mh02+tHHdiv*Ch0HHHH/MHH2)
	  seh0HH_mHH2_div = seh0HH_mHH2_div
     &                   +el*(th0div*Ch0h0HH/Mh02+tHHdiv*Ch0HHHH/MHH2)
	endif

	if ((renscheme.eq.4).or.(renscheme.eq.5).or.
     &	    (renscheme.eq.6).or.(renscheme.eq.7).or.
     &	    (renscheme.eq.8)) then
	  dsa = 0d0
	  dtb = 0d0  
	else
	  dsa = ca*(seh0HH_mh02_div+seh0HH_mHH2_div)/2d0/(MHH2-Mh02)
	endif

c beta functions
        Btb   = dtb
	Bta   = dsa/ca**3
	Blam5 = dlam5
	Blam3 = dlam3

	end

**********************************************************************
        subroutine RGE_thdm(tb_1,ta_1,lam5_1,mren2bsm_1,
     &                      tb_2,ta_2,lam5_2,mren2bsm_2)
**********************************************************************
*	Solve RGEs for THDM via Runge-Kutta method
*---------------------------------------------------------------------
*       28.9.16 Stefan Dittmaier
**********************************************************************
        implicit real*8 (a-z)
	real*8 y(3),y0(3)

        include '../COMMON/model.inc'
        include '../COMMON/param.inc'
        include '../COMMON/xparam.inc'
        include '../COMMON/param_thdm.inc'
        include '../COMMON/param_bsm.inc'

c test RK4 routine
c	x0 = 0d0
c	x  = 1d0
c	y0(1) = 1d0
c	y0(2) = 1d0
c	y0(3) = 0d0
c	call RK4(x,y,x0,y0,3)

	x0 = log(mren2bsm_1)
	x  = log(mren2bsm_2)

	y0(1) = tb_1
	if ((renscheme.eq.0).or.(renscheme.eq.1).or.
     &	    (renscheme.eq.4).or.(renscheme.eq.5).or.
     &	    (renscheme.eq.6).or.(renscheme.eq.7).or.
     &	    (renscheme.eq.8)) then
	  y0(2) = ta_1
	elseif ((renscheme.eq.2).or.(renscheme.eq.3)) then
          SB = tb_1/sqrt(1d0+tb_1**2)
          CB = SB/tb_1
	  if (ta_1.eq.0d0) then
            SA = 0d0
            CA = 1d0
	  elseif (ta_1.eq.1d30) then
            SA = 1d0
            CA = 0d0
	  else
            SA = ta_1/sqrt(1d0+ta_1**2)
            CA = SA/ta_1
	  endif
          lam3_1 = - lam5_1 - el**2/(4d0*MW2*sw2)
     &		            *( MA02-2d0*MHp2+(Mh02-MHH2)*CA*SA/CB/SB )
	  y0(2) = lam3_1
	endif
	y0(3) = lam5_1

	call RK4(x,y,x0,y0,3)

	tb_2   = y(1)
	lam5_2 = y(3) 
	if ((renscheme.eq.0).or.(renscheme.eq.1).or.
     &	    (renscheme.eq.4).or.(renscheme.eq.5).or.
     &	    (renscheme.eq.6).or.(renscheme.eq.7).or.
     &	    (renscheme.eq.8)) then
	  ta_2 = y(2)
	elseif ((renscheme.eq.2).or.(renscheme.eq.3)) then
	  lam3_2 = y(2)
          cb     = 1d0/sqrt(1d0+tb_2**2)
	  sb     = sqrt(1d0-cb**2)
	  s2a    = -( MA02-2d0*MHp2
     &	             +4d0*(lam3_2+lam5_2)*MW2*sw2/el**2 )
     &	            *SB*CB*2d0/(Mh02-MHH2)
	  if (abs(s2a).gt.1d0) then
	    write(*,*) 'Running of lam3 leads to s2a = ',s2a
	    write(*,*) '=> Scenario impossible'
	    stop
	  endif
	  c2a    = sqrt(1d0-s2a**2)
	  ca     = sqrt((1d0+c2a)/2d0)
	  sa     = s2a/ca/2d0
	  ta_2   = sa/ca
	endif

	end

**********************************************************************
        subroutine RK4(x,y,x0,y0,d)
**********************************************************************
*	classical Runge-Kutta method for solving
*	y' = f(x,y) with y0 = y(x0)
*	result: y = y(x), y = ( y(1), ... ,y(d) )
*---------------------------------------------------------------------
*       28.9.16 Stefan Dittmaier
**********************************************************************
	implicit none
	integer d,nh,nhmin,nhmax,m,n,r
        real*8 x0,x1,x,y(d),y0(d),dy(d),xa,ya(d),yold(d)
	real*8 f(d),k(4,d),h,acc,aimacc

	aimacc = 1d-14
	acc    = 1d8
	nhmin = 1000
	nhmax = 10**5
	nh    = nhmin

100	continue
	h   = (x-x0)/nh
	if (nh.gt.nhmin) then
	  do n=1,d
	    yold(n) = y(n)
	  enddo
	endif
	do n=1,d
	  y(n) = y0(n)
	enddo

	do r=0,nh-1
	  x1 = x0 + r*h

	do m=1,4

	  if (m.eq.1) then
	    xa = x1
            do n=1,d
	      ya(n) = y(n)
	    enddo
	  elseif (m.eq.2) then
	    xa = x1 + h/2d0
            do n=1,d
	      ya(n) = y(n) + h/2d0*k(1,n)
	    enddo
	  elseif (m.eq.3) then
	    xa = x1 + h/2d0
            do n=1,d
	      ya(n) = y(n) + h/2d0*k(2,n)
	    enddo
	  elseif (m.eq.4) then
	    xa = x1 + h
            do n=1,d
	      ya(n) = y(n) + h*k(3,n)
	    enddo
	  endif

	  call fRK(f,xa,ya,d)

	  do n=1,d
	    k(m,n) = f(n)
	  enddo

	enddo

	do n=1,d
	  y(n) = y(n) + h/6d0*(k(1,n)+2d0*k(2,n)+2d0*k(3,n)+k(4,n))
	enddo

	enddo

	if (nh.gt.nhmin) then
	  acc = 0d0
	  do n=1,d
	    if (y(n).ne.0d0) acc = max(acc,abs(yold(n)/y(n)-1d0))
	  enddo
	endif

c 	write(*,*) nh, y(1),y(2),y(3),acc

	if ((acc.gt.aimacc).and.(nh.lt.nhmax)) then
	  nh = nh * 2
	  goto 100
	endif

c	write(*,*) 'result: ',exp(x)+x, exp(-x), exp(x)*sin(x) 

	end

**********************************************************************
        subroutine fRK(f,x,y,d)
**********************************************************************
*	function f for Runge-Kutta method for solving
*	y' = f(x,y) 
*---------------------------------------------------------------------
*       28.9.16 Stefan Dittmaier
**********************************************************************
	implicit real*8 (a-z)
	integer d
        real*8 x,y(d),f(d)

        include '../COMMON/model.inc'
        include '../COMMON/param.inc'
        include '../COMMON/xparam.inc'
        include '../COMMON/param_thdm.inc'
        include '../COMMON/param_bsm.inc'

c test function y1 = exp(x)+x,      y2 = exp(-x),          y3 = exp(x)*sin(x) 
c	        f1 = y1+1 = 1/y2+1, f2 = -y2 = -1/(y1-1),  f3 = y3+(y1-1)*cos(x)
c	
c	f(1) = 1d0/y(2)+1d0 
c	f(2) = -1d0/(y(1)-x)
c	f(3) = y(3)+(y(1)-x)*cos(x)

	tb   = y(1)
	lam5 = y(3) 
	if ((renscheme.eq.0).or.(renscheme.eq.1).or.
     &	    (renscheme.eq.4).or.(renscheme.eq.5).or.
     &	    (renscheme.eq.6).or.(renscheme.eq.7).or.
     &	    (renscheme.eq.8)) then
	  ta = y(2)
	elseif ((renscheme.eq.2).or.(renscheme.eq.3)) then
	  lam3 = y(2)
          cb     = 1d0/sqrt(1d0+tb**2)
	  sb     = sqrt(1d0-cb**2)
	  s2a    = -( MA02-2d0*MHp2
     &	             +4d0*(lam3+lam5)*MW2*sw2/el**2 )
     &	            *SB*CB*2d0/(Mh02-MHH2)
	  if (abs(s2a).gt.1d0) then
	    write(*,*) 'Running of lam3 leads to s2a = ',s2a
	    write(*,*) '=> Scenario impossible'
	    stop
	  endif
	  c2a    = sqrt(1d0-s2a**2)
	  ca     = sqrt((1d0+c2a)/2d0)
	  sa     = s2a/ca/2d0
	  ta   = sa/ca
	endif

        call beta_thdm(Btb,Bta,Blam5,Blam3,
     &                 Mh0,MHH,MA0,MHp,tb,ta,lam5)

	f(1) = Btb
	f(3) = Blam5
	if ((renscheme.eq.0).or.(renscheme.eq.1).or.
     &	    (renscheme.eq.4).or.(renscheme.eq.5).or.
     &	    (renscheme.eq.6).or.(renscheme.eq.7).or.
     &	    (renscheme.eq.8)) then
	  f(2) = Bta
	elseif ((renscheme.eq.2).or.(renscheme.eq.3)) then
	  f(2) = Blam3
	endif

cxxx	write(*,*) 'yyy ',y
cxxx	write(*,*) 'fff ',f
cxxx	stop

	end
